# Awesome Go

[Awesome]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.4.1/docs/awesome.svg "star > 2000"
[G]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Green.svg "There was an update last week"
[Y]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Yellow.svg "It hasn't been updated in recent three years"
[CN]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Cn.svg "Contains Chinese documents"
[Archived]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.2.1/docs/archived.svg "The project has been archived"
[D]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.3.0/docs/DOC.svg "godoc document links"

**This project is [awesome-go](https://awesome-go.com/) Chinese version, last sync time : 2024-08-12 07:21:41(Synchronize every day)**

[![english](https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.3.0/docs/chinese.svg)](README.md) [![Build Status](https://travis-ci.org/avelino/awesome-go.svg?branch=master)](https://travis-ci.org/avelino/awesome-go) [![Awesome](https://cdn.rawgit.com/sindresorhus/awesome/d7305f38d29fed78fa85652e3a63e154dd8e8829/media/badge.svg)](https://github.com/sindresorhus/awesome) [![Slack Widget](https://img.shields.io/badge/join-us%20on%20slack-gray.svg?longCache=true&logo=slack&colorB=red)](http://gophers.slack.com/messages/awesome) [![Netlify Status](https://api.netlify.com/api/v1/badges/83a6dcbe-0da6-433e-b586-f68109286bd5/deploy-status)](https://app.netlify.com/sites/awesome-go/deploys)

[![patreon avelino](https://c5.patreon.com/external/logo/become_a_patron_button@2x.png)](https://www.patreon.com/avelinosource) financial support to Awesome Go

A curated list of awesome Go frameworks, libraries and software. Inspired by [awesome-python](https://github.com/vinta/awesome-python)。

**Icon** :


Icon | State  
:-:|-
![There was an update last week][G] | There was an update last week。You can basically determine that the current library is in an actively maintained state。
![Not updated in recent three year][Y] | Not updated in recent three year。Reflects that the maintenance of the library is not high enthusiasm, use should be careful。
![Archived][Archived] | The project has been archived。
![Contains Chinese documents][CN] | This project contains Chinese documents。
![godoc document][D] | godoc document links。

### Explain

[中文](README.md)  | [English](README_EN.md)
 
[![Netlify Status](https://api.netlify.com/api/v1/badges/83a6dcbe-0da6-433e-b586-f68109286bd5/deploy-status)](https://app.netlify.com/sites/awesome-go/deploys)
[![Track Awesome List](https://www.trackawesomelist.com/badge.svg)](https://www.trackawesomelist.com/avelino/awesome-go/)

We use the _[Golang Bridge](https://github.com/gobridge/about-us/blob/master/README.md)_ community Slack for instant communication, follow the [form here to join](https://invite.slack.golangbridge.org/).

<a href="https://www.producthunt.com/posts/awesome-go?utm_source=badge-featured&utm_medium=badge&utm_souce=badge-awesome-go" target="_blank"><img src="https://api.producthunt.com/widgets/embed-image/v1/featured.svg?post_id=291535&theme=light" alt="awesome-go - Curated list awesome Go frameworks, libraries and software | Product Hunt" style="width: 250px; height: 54px;" width="250" height="54" /></a>

**Sponsorships:**

_Special thanks to_

<div align="center">
<table cellpadding="5">
<tbody align="center">
<tr>
<td>
<a href="https://bit.ly/awesome-go-workos">
<img src="https://avelino.run/sponsors/workos-logo-white-bg.svg" width="200" alt="WorkOS"><br/>
<b>Your app, enterprise-ready.</b><br/>
<sub>Start selling to enterprise customers with just a few lines of code.</sub><br/>
<sup>Add Single Sign-On (and more) in minutes instead of months.</sup>
</a>
</td>
<td>
<a href="https://bit.ly/awesome-go-keygen">
<img src="https://avelino.run/sponsors/keygen-logo.png" width="200" alt="keygen"><br/>
<b>An open, source-available software licensing and distribution API.</b><br/>
<sub>Securely license and distribute Go applications with a single API.</sub><br>
<sup>Add auto updates with only a few lines of code.</sup>
</a>
</td>
</tr>
<tr>
<td colspan="2">
<a href="https://bit.ly/awesome-go-digitalocean">
<img src="https://avelino.run/sponsors/do_logo_horizontal_blue-210.png" width="200" alt="Digital Ocean">
</a>
</td>
</tr>
</tbody>
</table>
</div>

**Awesome Go has no monthly fee**_, but we have employees who **work hard** to keep it running. With money raised, we can repay the effort of each person involved! You can see how we calculate our billing and distribution as it is open to the entire community. Want to be a supporter of the project click [here](mailto:avelinorun+oss@gmail.com?subject=awesome-go%3A%20project%20support)._

> A curated list of awesome Go frameworks, libraries, and software. Inspired by [awesome-python](https://github.com/vinta/awesome-python).

**Contributing:**

Please take a quick gander at the [contribution guidelines](https://github.com/avelino/awesome-go/blob/main/CONTRIBUTING.md) first. Thanks to all [contributors](https://github.com/avelino/awesome-go/graphs/contributors); you rock!

> _If you see a package or project here that is no longer maintained or is not a good fit, please submit a pull request to improve this file. Thank you!_

## Contents

- [Awesome Go](#awesome-go)
  - [Contents](#contents)
  - [Artificial Intelligence](#artificial-intelligence)
  - [Audio and Music](#audio-and-music)
  - [Authentication and OAuth](#authentication-and-oauth)
  - [Blockchain](#blockchain)
  - [Bot Building](#bot-building)
  - [Build Automation](#build-automation)
  - [Command Line](#command-line)
    - [Advanced Console UIs](#advanced-console-uis)
    - [Standard CLI](#standard-cli)
  - [Configuration](#configuration)
  - [Continuous Integration](#continuous-integration)
  - [CSS Preprocessors](#css-preprocessors)
  - [Data Structures and Algorithms](#data-structures-and-algorithms)
    - [Bit-packing and Compression](#bit-packing-and-compression)
    - [Bit Sets](#bit-sets)
    - [Bloom and Cuckoo Filters](#bloom-and-cuckoo-filters)
    - [Data Structure and Algorithm Collections](#data-structure-and-algorithm-collections)
    - [Iterators](#iterators)
    - [Maps](#maps)
    - [Miscellaneous Data Structures and Algorithms](#miscellaneous-data-structures-and-algorithms)
    - [Nullable Types](#nullable-types)
    - [Queues](#queues)
    - [Sets](#sets)
    - [Text Analysis](#text-analysis)
    - [Trees](#trees)
    - [Pipes](#pipes)
  - [Database](#database)
    - [Caches](#caches)
    - [Databases Implemented in Go](#databases-implemented-in-go)
    - [Database Schema Migration](#database-schema-migration)
    - [Database Tools](#database-tools)
    - [SQL Query Builders](#sql-query-builders)
  - [Database Drivers](#database-drivers)
    - [Interfaces to Multiple Backends](#interfaces-to-multiple-backends)
    - [Relational Database Drivers](#relational-database-drivers)
    - [NoSQL Database Drivers](#nosql-database-drivers)
    - [Search and Analytic Databases](#search-and-analytic-databases)
  - [Date and Time](#date-and-time)
  - [Distributed Systems](#distributed-systems)
  - [Dynamic DNS](#dynamic-dns)
  - [Email](#email)
  - [Embeddable Scripting Languages](#embeddable-scripting-languages)
  - [Error Handling](#error-handling)
  - [File Handling](#file-handling)
  - [Financial](#financial)
  - [Forms](#forms)
  - [Functional](#functional)
  - [Game Development](#game-development)
  - [Generators](#generators)
  - [Geographic](#geographic)
  - [Go Compilers](#go-compilers)
  - [Goroutines](#goroutines)
  - [GUI](#gui)
  - [Hardware](#hardware)
  - [Images](#images)
  - [IoT (Internet of Things)](#iot-internet-of-things)
  - [Job Scheduler](#job-scheduler)
  - [JSON](#json)
  - [Logging](#logging)
  - [Machine Learning](#machine-learning)
  - [Messaging](#messaging)
  - [Microsoft Office](#microsoft-office)
    - [Microsoft Excel](#microsoft-excel)
  - [Miscellaneous](#miscellaneous)
    - [Dependency Injection](#dependency-injection)
    - [Project Layout](#project-layout)
    - [Strings](#strings)
    - [Uncategorized](#uncategorized)
  - [Natural Language Processing](#natural-language-processing)
    - [Language Detection](#language-detection)
    - [Morphological Analyzers](#morphological-analyzers)
    - [Slugifiers](#slugifiers)
    - [Tokenizers](#tokenizers)
    - [Translation](#translation)
    - [Transliteration](#transliteration)
  - [Networking](#networking)
    - [HTTP Clients](#http-clients)
  - [OpenGL](#opengl)
  - [ORM](#orm)
  - [Package Management](#package-management)
  - [Performance](#performance)
  - [Query Language](#query-language)
  - [Resource Embedding](#resource-embedding)
  - [Science and Data Analysis](#science-and-data-analysis)
  - [Security](#security)
  - [Serialization](#serialization)
  - [Server Applications](#server-applications)
  - [Stream Processing](#stream-processing)
  - [Template Engines](#template-engines)
  - [Testing](#testing)
    - [Testing Frameworks](#testing-frameworks)
    - [Mock](#mock)
    - [Fuzzing and delta-debugging/reducing/shrinking](#fuzzing-and-delta-debuggingreducingshrinking)
    - [Selenium and browser control tools](#selenium-and-browser-control-tools)
    - [Fail injection](#fail-injection)
  - [Text Processing](#text-processing)
    - [Formatters](#formatters)
    - [Markup Languages](#markup-languages)
    - [Parsers/Encoders/Decoders](#parsersencodersdecoders)
    - [Regular Expressions](#regular-expressions)
    - [Sanitation](#sanitation)
    - [Scrapers](#scrapers)
    - [RSS](#rss)
    - [Utility/Miscellaneous](#utilitymiscellaneous)
  - [Third-party APIs](#third-party-apis)
  - [Utilities](#utilities)
  - [UUID](#uuid)
  - [Validation](#validation)
  - [Version Control](#version-control)
  - [Video](#video)
  - [Web Frameworks](#web-frameworks)
    - [Middlewares](#middlewares)
      - [Actual middlewares](#actual-middlewares)
      - [Libraries for creating HTTP middlewares](#libraries-for-creating-http-middlewares)
    - [Routers](#routers)
  - [WebAssembly](#webassembly)
  - [Windows](#windows)
  - [XML](#xml)
  - [Zero Trust](#zero-trust)
  - [Code Analysis](#code-analysis)
  - [Editor Plugins](#editor-plugins)
  - [Go Generate Tools](#go-generate-tools)
  - [Go Tools](#go-tools)
  - [Software Packages](#software-packages)
    - [DevOps Tools](#devops-tools)
    - [Other Software](#other-software)
- [Resources](#resources)
  - [Benchmarks](#benchmarks)
  - [Conferences](#conferences)
  - [E-Books](#e-books)
    - [E-books for purchase](#e-books-for-purchase)
    - [Free e-books](#free-e-books)
  - [Gophers](#gophers)
  - [Meetups](#meetups)
  - [Style Guides](#style-guides)
  - [Social Media](#social-media)
    - [Twitter](#twitter)
    - [Reddit](#reddit)
  - [Websites](#websites)
    - [Tutorials](#tutorials)
    - [Guided Learning](#guided-learning)

**[⬆ back to top](#contents)**

## Artificial Intelligence

_Libraries for building programs that leverage AI._

- [Ollama](https://github.com/jmorganca/ollama) **star:84437** Run large language models locally.   [![There was an update last month][G]](https://github.com/jmorganca/ollama)   [![godoc][D]](https://godoc.org/github.com/jmorganca/ollama)
- [LocalAI](https://github.com/mudler/LocalAI) **star:22497** Open Source OpenAI alternative, self-host AI models.   [![There was an update last month][G]](https://github.com/mudler/LocalAI)
- [langchaingo](https://github.com/tmc/langchaingo) **star:3999** LangChainGo is a framework for developing applications powered by language models.   [![There was an update last month][G]](https://github.com/tmc/langchaingo)   [![godoc][D]](https://godoc.org/github.com/tmc/langchaingo)

**[⬆ back to top](#contents)**

## Audio and Music

_Libraries for manipulating audio._

- [Oto](https://github.com/hajimehoshi/oto) **star:1529** A low-level library to play sound on multiple platforms.   [![There was an update last month][G]](https://github.com/hajimehoshi/oto)   [![godoc][D]](https://godoc.org/github.com/hajimehoshi/oto)
- [PortAudio](https://github.com/gordonklaus/portaudio) **star:692** Go bindings for the PortAudio audio I/O library.   [![godoc][D]](https://godoc.org/github.com/gordonklaus/portaudio)
- [GoAudio](https://github.com/DylanMeeus/GoAudio) **star:339** Native Go Audio Processing Library.   [![godoc][D]](https://godoc.org/github.com/DylanMeeus/GoAudio)
- [id3v2](https://github.com/bogem/id3v2) **star:332** ID3 decoding and encoding library for Go.   [![godoc][D]](https://godoc.org/github.com/bogem/id3v2)
- [flac](https://github.com/mewkiz/flac) **star:309** Native Go FLAC encoder/decoder with support for FLAC streams.   [![There was an update last month][G]](https://github.com/mewkiz/flac)   [![godoc][D]](https://godoc.org/github.com/mewkiz/flac)
- [malgo](https://github.com/gen2brain/malgo) **star:283** Mini audio library.
- [minimp3](https://github.com/tosone/minimp3) **star:123** Lightweight MP3 decoder library.
- [gaad](https://github.com/Comcast/gaad) **star:122** Native Go AAC bitstream parser.   [![godoc][D]](https://godoc.org/github.com/Comcast/gaad)
- [gosamplerate](https://github.com/dh1tw/gosamplerate) **star:34** libsamplerate bindings for go.   [![godoc][D]](https://godoc.org/github.com/dh1tw/gosamplerate)

**[⬆ back to top](#contents)**

## Authentication and OAuth

_Libraries for implementing authentication schemes._

- [casbin](https://github.com/casbin/casbin) **star:17330** Authorization library that supports access control models like ACL, RBAC, and ABAC.   [![There was an update last month][G]](https://github.com/casbin/casbin)   [![godoc][D]](https://godoc.org/github.com/casbin/casbin)
- [jwt-go](https://github.com/golang-jwt/jwt) **star:6829** A full featured implementation of JSON Web Tokens (JWT). This library supports the parsing and verification as well as the generation and signing of JWTs.   [![There was an update last month][G]](https://github.com/golang-jwt/jwt)   [![godoc][D]](https://godoc.org/github.com/golang-jwt/jwt)
- [goth](https://github.com/markbates/goth) **star:5315** provides a simple, clean, and idiomatic way to use OAuth and OAuth2. Handles multiple providers out of the box.   [![There was an update last month][G]](https://github.com/markbates/goth)   [![godoc][D]](https://godoc.org/github.com/markbates/goth)
- [oauth2](https://github.com/golang/oauth2) **star:5276** Successor of goauth2. Generic OAuth 2.0 package that comes with JWT, Google APIs, Compute Engine, and App Engine support.   [![There was an update last month][G]](https://github.com/golang/oauth2)   [![godoc][D]](https://godoc.org/github.com/golang/oauth2)
- [keto](https://github.com/ory/keto) **star:4728** Open Source (Go) implementation of "Zanzibar: Google's Consistent, Global Authorization System". Ships gRPC, REST APIs, newSQL, and an easy and granular permission language. Supports ACL, RBAC, and other access models.   [![There was an update last month][G]](https://github.com/ory/keto)   [![godoc][D]](https://godoc.org/github.com/ory/keto)
- [authboss](https://github.com/volatiletech/authboss) **star:3779** Modular authentication system for the web. It tries to remove as much boilerplate and "hard things" as possible so that each time you start a new web project in Go, you can plug it in, configure it, and start building your app without having to build an authentication system each time.   [![godoc][D]](https://godoc.org/github.com/volatiletech/authboss)
- [openfga](https://github.com/openfga/openfga) **star:2588** Implementation of fine-grained authorization based on the "Zanzibar: Google's Consistent, Global Authorization System" paper. Backed by [CNCF](https://www.cncf.io/).   [![There was an update last month][G]](https://github.com/openfga/openfga)   [![godoc][D]](https://godoc.org/github.com/openfga/openfga)
- [scs](https://github.com/alexedwards/scs) **star:2058** Session Manager for HTTP servers.   [![godoc][D]](https://godoc.org/github.com/alexedwards/scs)
- [loginsrv](https://github.com/tarent/loginsrv) **star:1917** JWT login microservice with pluggable backends such as OAuth2 (Github), htpasswd, osiam.   [![It hasn't been updated in recent three years][Y]](https://github.com/tarent/loginsrv)   [![godoc][D]](https://godoc.org/github.com/tarent/loginsrv)
- [osin](https://github.com/openshift/osin) **star:1895** Golang OAuth2 server library.   [![There was an update last month][G]](https://github.com/openshift/osin)   [![godoc][D]](https://godoc.org/github.com/openshift/osin)
- [gologin](https://github.com/dghubble/gologin) **star:1802** chainable handlers for login with OAuth1 and OAuth2 authentication providers.   [![There was an update last month][G]](https://github.com/dghubble/gologin)   [![godoc][D]](https://godoc.org/github.com/dghubble/gologin)
- [gorbac](https://github.com/mikespook/gorbac) **star:1588** provides a lightweight role-based access control (RBAC) implementation in Golang.   [![godoc][D]](https://godoc.org/github.com/mikespook/gorbac)
- [gosession](http://github.com/Kwynto/gosession)  This is quick session for net/http in GoLang. This package is perhaps the best implementation of the session mechanism, or at least it tries to become one.
- [oidc](https://github.com/zitadel/oidc) **star:1291** Easy to use OpenID Connect client and server library written for Go and certified by the OpenID Foundation   [![There was an update last month][G]](https://github.com/zitadel/oidc)   [![godoc][D]](https://godoc.org/github.com/zitadel/oidc)
- [paseto](https://github.com/o1egl/paseto) **star:844** Golang implementation of Platform-Agnostic Security Tokens (PASETO).   [![godoc][D]](https://godoc.org/github.com/o1egl/paseto)
- [jwt](https://github.com/cristalhq/jwt) **star:664** Safe, simple, and fast JSON Web Tokens for Go.   [![godoc][D]](https://godoc.org/github.com/cristalhq/jwt)
- [go-guardian](https://github.com/shaj13/go-guardian) **star:537** Go-Guardian is a golang library that provides a simple, clean, and idiomatic way to create powerful modern API and web authentication that supports LDAP, Basic, Bearer token, and Certificate based authentication.   [![godoc][D]](https://godoc.org/github.com/shaj13/go-guardian)
- [permissions2](https://github.com/xyproto/permissions2) **star:510** Library for keeping track of users, login states, and permissions. Uses secure cookies and bcrypt.   [![There was an update last month][G]](https://github.com/xyproto/permissions2)   [![godoc][D]](https://godoc.org/github.com/xyproto/permissions2)
- [jwt](https://github.com/pascaldekloe/jwt) **star:352** Lightweight JSON Web Token (JWT) library.   [![godoc][D]](https://godoc.org/github.com/pascaldekloe/jwt)
- [go-jose](https://github.com/go-jose/go-jose) **star:294** Fairly complete implementation of the JOSE working group's JSON Web Token, JSON Web Signatures, and JSON Web Encryption specs.   [![godoc][D]](https://godoc.org/github.com/go-jose/go-jose)
- [jeff](https://github.com/abraithwaite/jeff) **star:265** Simple, flexible, secure, and idiomatic web session management with pluggable backends.   [![godoc][D]](https://godoc.org/github.com/abraithwaite/jeff)
- [jwt-auth](https://github.com/adam-hanna/jwt-auth) **star:231** JWT middleware for Golang http servers with many configuration options.   [![It hasn't been updated in recent three years][Y]](https://github.com/adam-hanna/jwt-auth)   [![godoc][D]](https://godoc.org/github.com/adam-hanna/jwt-auth)
- [otpgen](https://github.com/grijul/otpgen) **star:135** Library to generate TOTP/HOTP codes.   [![godoc][D]](https://godoc.org/github.com/grijul/otpgen)
- [sessionup](https://github.com/swithek/sessionup) **star:124** Simple, yet effective HTTP session management and identification package.   [![godoc][D]](https://godoc.org/github.com/swithek/sessionup)
- [sjwt](https://github.com/brianvoe/sjwt) **star:119** Simple jwt generator and parser.   [![godoc][D]](https://godoc.org/github.com/brianvoe/sjwt)
- [session](https://github.com/icza/session) **star:116** Go session management for web servers (including support for Google App Engine - GAE).   [![godoc][D]](https://godoc.org/github.com/icza/session)
- [branca](https://github.com/essentialkaos/branca) **star:83** branca token [specification implementation](https://github.com/tuupola/branca-spec) for Golang 1.15+.   [![There was an update last month][G]](https://github.com/essentialkaos/branca)   [![godoc][D]](https://godoc.org/github.com/essentialkaos/branca)
- [securecookie](https://github.com/chmike/securecookie) **star:78** Efficient secure cookie encoding/decoding.   [![godoc][D]](https://godoc.org/github.com/chmike/securecookie)
- [sessions](https://github.com/adam-hanna/sessions) **star:78** Dead simple, highly performant, highly customizable sessions service for go http servers.   [![godoc][D]](https://godoc.org/github.com/adam-hanna/sessions)
- [otpgo](https://github.com/jltorresm/otpgo) **star:68** Time-Based One-Time Password (TOTP) and HMAC-Based One-Time Password (HOTP) library for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/jltorresm/otpgo)   [![godoc][D]](https://godoc.org/github.com/jltorresm/otpgo)
- [scope](https://github.com/SonicRoshan/scope) **star:37** Easily Manage OAuth2 Scopes In Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/SonicRoshan/scope)   [![godoc][D]](https://godoc.org/github.com/SonicRoshan/scope)
- [cookiestxt](https://github.com/mengzhuo/cookiestxt) **star:16** provides a parser of cookies.txt file format.   [![godoc][D]](https://godoc.org/github.com/mengzhuo/cookiestxt)

**[⬆ back to top](#contents)**

## Blockchain

_Tools for building blockchains._

- [go-ethereum](https://github.com/ethereum/go-ethereum) **star:47260** Official Go implementation of the Ethereum protocol.   [![There was an update last month][G]](https://github.com/ethereum/go-ethereum)   [![godoc][D]](https://godoc.org/github.com/ethereum/go-ethereum)
- [kubo](https://github.com/ipfs/kubo) **star:15951** A blockchain framework implemented in Go. It provides content-addressable storage which can be used for decentralized storage in DApps. It is based on the IPFS protocol.   [![There was an update last month][G]](https://github.com/ipfs/kubo)   [![godoc][D]](https://godoc.org/github.com/ipfs/kubo)
- [cosmos-sdk](https://github.com/cosmos/cosmos-sdk) **star:6125** A Framework for Building Public Blockchains in the Cosmos Ecosystem.   [![There was an update last month][G]](https://github.com/cosmos/cosmos-sdk)   [![godoc][D]](https://godoc.org/github.com/cosmos/cosmos-sdk)
- [tendermint](https://github.com/tendermint/tendermint) **star:5689** High-performance middleware for transforming a state machine written in any programming language into a Byzantine Fault Tolerant replicated state machine using the Tendermint consensus and blockchain protocols.   [![godoc][D]](https://godoc.org/github.com/tendermint/tendermint)
- [solana-go](https://github.com/gagliardetto/solana-go) **star:783** Go library to interface with Solana JSON RPC and WebSocket interfaces.   [![There was an update last month][G]](https://github.com/gagliardetto/solana-go)   [![godoc][D]](https://godoc.org/github.com/gagliardetto/solana-go)
- [cometbft](https://github.com/cometbft/cometbft) **star:599** A distributed, Byzantine fault-tolerant, deterministic state machine replication engine. It is a fork of Tendermint Core and implements the Tendermint consensus algorithm.   [![There was an update last month][G]](https://github.com/cometbft/cometbft)   [![godoc][D]](https://godoc.org/github.com/cometbft/cometbft)
- [gossamer](https://github.com/ChainSafe/gossamer) **star:424** A Go implementation of the Polkadot Host.   [![There was an update last month][G]](https://github.com/ChainSafe/gossamer)   [![godoc][D]](https://godoc.org/github.com/ChainSafe/gossamer)
- [gosemble](https://github.com/LimeChain/gosemble) **star:7** A Go-based framework for building Polkadot/Substrate-compatible runtimes.   [![godoc][D]](https://godoc.org/github.com/LimeChain/gosemble)

**[⬆ back to top](#contents)**

## Bot Building

_Libraries for building and working with bots._

- [telegram-bot-api](https://github.com/Syfaro/telegram-bot-api) **star:5642** Simple and clean Telegram bot client.   [![There was an update last month][G]](https://github.com/Syfaro/telegram-bot-api)   [![godoc][D]](https://godoc.org/github.com/Syfaro/telegram-bot-api)
- [telebot](https://github.com/tucnak/telebot) **star:3851** Telegram bot framework is written in Go.   [![There was an update last month][G]](https://github.com/tucnak/telebot)   [![godoc][D]](https://godoc.org/github.com/tucnak/telebot)
- [olivia](https://github.com/olivia-ai/olivia) **star:3669** A chatbot built with an artificial neural network.   [![godoc][D]](https://godoc.org/github.com/olivia-ai/olivia)   [![Archived][Archived]](https://github.com/olivia-ai/olivia)
- [wayback](https://github.com/wabarc/wayback) **star:1729** A bot for Telegram, Mastodon, Slack, and other messaging platforms archives webpages.   [![There was an update last month][G]](https://github.com/wabarc/wayback)   [![godoc][D]](https://godoc.org/github.com/wabarc/wayback)
- [Kelp](https://github.com/stellar/kelp) **star:1089** official trading and market-making bot for the [Stellar](https://www.stellar.org/) DEX. Works out-of-the-box, written in Golang, compatible with centralized exchanges and custom trading strategies.   [![godoc][D]](https://godoc.org/github.com/stellar/kelp)   [![Archived][Archived]](https://github.com/stellar/kelp)
- [Golang CryptoTrading Bot](https://github.com/saniales/golang-crypto-trading-bot) **star:1053** A golang implementation of a console-based trading bot for cryptocurrency exchanges.   [![godoc][D]](https://godoc.org/github.com/saniales/golang-crypto-trading-bot)
- [go-chat-bot](https://github.com/go-chat-bot/bot) **star:823** IRC, Slack & Telegram bot written in Go.   [![godoc][D]](https://godoc.org/github.com/go-chat-bot/bot)   [![Archived][Archived]](https://github.com/go-chat-bot/bot)
- [go-joe](https://joe-bot.net)  A general-purpose bot library inspired by Hubot but written in Go.
- [slacker](https://github.com/shomali11/slacker) **star:811** Easy to use framework to create Slack bots.   [![godoc][D]](https://godoc.org/github.com/shomali11/slacker)
- [bot](https://github.com/go-telegram/bot) **star:582** Zero-dependencies Telegram Bot library with additional UI components   [![godoc][D]](https://godoc.org/github.com/go-telegram/bot)
- [telego](https://github.com/mymmrac/telego) **star:489** Telegram Bot API library for Golang with full one-to-one API implementation.   [![There was an update last month][G]](https://github.com/mymmrac/telego)   [![godoc][D]](https://godoc.org/github.com/mymmrac/telego)
- [echotron](https://github.com/NicoNex/echotron) **star:354** An elegant and concurrent library for Telegram Bots in Go.   [![There was an update last month][G]](https://github.com/NicoNex/echotron)   [![godoc][D]](https://godoc.org/github.com/NicoNex/echotron)
- [tbot](https://github.com/yanzay/tbot) **star:353** Telegram bot server with API similar to net/http.   [![godoc][D]](https://godoc.org/github.com/yanzay/tbot)
- [go-twitch-irc](https://github.com/gempir/go-twitch-irc) **star:352** Library to write bots for twitch.tv chat   [![godoc][D]](https://godoc.org/github.com/gempir/go-twitch-irc)
- [go-sarah](https://github.com/oklahomer/go-sarah) **star:260** Framework to build a bot for desired chat services including LINE, Slack, Gitter, and more.   [![godoc][D]](https://godoc.org/github.com/oklahomer/go-sarah)
- [Tenyks](https://github.com/kyleterry/tenyks) **star:178** Service oriented IRC bot using Redis and JSON for messaging.   [![godoc][D]](https://godoc.org/github.com/kyleterry/tenyks)
- [slack-bot](https://github.com/innogames/slack-bot) **star:174** Ready to use Slack Bot for lazy developers: Custom commands, Jenkins, Jira, Bitbucket, Github...   [![There was an update last month][G]](https://github.com/innogames/slack-bot)   [![godoc][D]](https://godoc.org/github.com/innogames/slack-bot)
- [larry](https://github.com/ezeoleaf/larry) **star:160** Larry 🐦 is a really simple Twitter bot generator that tweets random repositories from Github built in Go.   [![godoc][D]](https://godoc.org/github.com/ezeoleaf/larry)
- [hanu](https://github.com/sbstjn/hanu) **star:154** Framework for writing Slack bots.   [![godoc][D]](https://godoc.org/github.com/sbstjn/hanu)
- [go-tgbot](https://github.com/olebedev/go-tgbot) **star:120** Pure Golang Telegram Bot API wrapper, generated from swagger file, session-based router, and middleware.   [![It hasn't been updated in recent three years][Y]](https://github.com/olebedev/go-tgbot)   [![godoc][D]](https://godoc.org/github.com/olebedev/go-tgbot)
- [ephemeral-roles](https://github.com/ewohltman/ephemeral-roles) **star:90** A Discord bot for managing ephemeral roles based upon voice channel member presence.   [![godoc][D]](https://godoc.org/github.com/ewohltman/ephemeral-roles)
- [go-tg](https://github.com/mr-linch/go-tg) **star:85** Generated from official docs Go client library for accessing Telegram Bot API, with batteries for building complex bots included.   [![godoc][D]](https://godoc.org/github.com/mr-linch/go-tg)
- [margelet](https://github.com/zhulik/margelet) **star:84** Framework for building Telegram bots.   [![godoc][D]](https://godoc.org/github.com/zhulik/margelet)
- [slackscot](https://github.com/alexandre-normand/slackscot) **star:56** Another framework for building Slack bots.   [![godoc][D]](https://godoc.org/github.com/alexandre-normand/slackscot)
- [govkbot](https://github.com/nikepan/govkbot) **star:49** Simple Go [VK](https://vk.com) bot library.   [![godoc][D]](https://godoc.org/github.com/nikepan/govkbot)
- [teleterm](https://github.com/alfiankan/teleterm) **star:34** Telegram Bot Exec Terminal Command.   [![godoc][D]](https://godoc.org/github.com/alfiankan/teleterm)
- [micha](https://github.com/onrik/micha) **star:28** Go Library for Telegram bot api.   [![godoc][D]](https://godoc.org/github.com/onrik/micha)

**[⬆ back to top](#contents)**

## Build Automation

_Libraries and tools help with build automation._

- [air](https://github.com/cosmtrek/air) **star:16868** Air - Live reload for Go apps.   [![godoc][D]](https://godoc.org/github.com/cosmtrek/air)   [![Contains Chinese documents][CN]](https://github.com/cosmtrek/air)
- [Task](https://github.com/go-task/task) **star:10727** simple "Make" alternative.   [![There was an update last month][G]](https://github.com/go-task/task)   [![godoc][D]](https://godoc.org/github.com/go-task/task)
- [realize](https://github.com/tockins/realize) **star:4454** Go build a system with file watchers and live to reload. Run, build and watch file changes with custom paths.   [![It hasn't been updated in recent three years][Y]](https://github.com/tockins/realize)   [![godoc][D]](https://godoc.org/github.com/tockins/realize)
- [mage](https://github.com/magefile/mage) **star:4061** Mage is a make/rake-like build tool using Go.   [![godoc][D]](https://godoc.org/github.com/magefile/mage)
- [mmake](https://github.com/tj/mmake) **star:1714** Modern Make.   [![godoc][D]](https://godoc.org/github.com/tj/mmake)
- [xc](https://github.com/joerdav/xc) **star:1134** Task runner with README.md defined tasks, executable markdown.   [![godoc][D]](https://godoc.org/github.com/joerdav/xc)
- [goyek](https://github.com/goyek/goyek) **star:551** Create build pipelines in Go.   [![There was an update last month][G]](https://github.com/goyek/goyek)   [![godoc][D]](https://godoc.org/github.com/goyek/goyek)
- [taskctl](https://github.com/taskctl/taskctl) **star:289** Concurrent task runner.   [![godoc][D]](https://godoc.org/github.com/taskctl/taskctl)
- [1build](https://github.com/gopinath-langote/1build) **star:226** Command line tool to frictionlessly manage project-specific commands.   [![godoc][D]](https://godoc.org/github.com/gopinath-langote/1build)
- [gaper](https://github.com/maxcnunes/gaper) **star:80** Builds and restarts a Go project when it crashes or some watched file changes.   [![godoc][D]](https://godoc.org/github.com/maxcnunes/gaper)
- [gilbert](https://go-gilbert.github.io)  Build system and task runner for Go projects.
- [anko](https://github.com/GuilhermeCaruso/anko) **star:36** Simple application watcher for multiple programming languages.   [![It hasn't been updated in recent three years][Y]](https://github.com/GuilhermeCaruso/anko)   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/anko)
- [gob](https://github.com/kcmvp/gob) **star:8** [Gradle](https://docs.gradle.org/)/[Maven](https://maven.apache.org/) like build tool for Go projects.   [![godoc][D]](https://godoc.org/github.com/kcmvp/gob)

**[⬆ back to top](#contents)**

## Command Line

### Advanced Console UIs

_Libraries for building Console Applications and Console User Interfaces._

- [bubbletea](https://github.com/charmbracelet/bubbletea) **star:25980** Go framework to build terminal apps, based on The Elm Architecture.   [![There was an update last month][G]](https://github.com/charmbracelet/bubbletea)   [![godoc][D]](https://godoc.org/github.com/charmbracelet/bubbletea)
- [termui](https://github.com/gizak/termui) **star:13097** Go terminal dashboard based on **termbox-go** and inspired by [blessed-contrib](https://github.com/yaronn/blessed-contrib).   [![godoc][D]](https://godoc.org/github.com/gizak/termui)
- [gocui](https://github.com/jroimartin/gocui) **star:9792** Minimalist Go library aimed at creating Console User Interfaces.   [![godoc][D]](https://godoc.org/github.com/jroimartin/gocui)
- [gommon/color](https://github.com/labstack/gommon/tree/master/color)  Style terminal text.
- [lipgloss](https://github.com/charmbracelet/lipgloss) **star:7757** Declaratively define styles for color, format and layout in the terminal.   [![There was an update last month][G]](https://github.com/charmbracelet/lipgloss)   [![godoc][D]](https://godoc.org/github.com/charmbracelet/lipgloss)
- [go-prompt](https://github.com/c-bata/go-prompt) **star:5254** Library for building a powerful interactive prompt, inspired by [python-prompt-toolkit](https://github.com/jonathanslenders/python-prompt-toolkit).   [![godoc][D]](https://godoc.org/github.com/c-bata/go-prompt)
- [bubbles](https://github.com/charmbracelet/bubbles) **star:5207** TUI components for bubbletea.   [![There was an update last month][G]](https://github.com/charmbracelet/bubbles)   [![godoc][D]](https://godoc.org/github.com/charmbracelet/bubbles)
- [pterm](https://github.com/pterm/pterm) **star:4712** A library to beautify console output on every platform with many combinable components.   [![There was an update last month][G]](https://github.com/pterm/pterm)   [![godoc][D]](https://godoc.org/github.com/pterm/pterm)
- [termbox-go](https://github.com/nsf/termbox-go) **star:4665** Termbox is a library for creating cross-platform text-based interfaces.   [![godoc][D]](https://godoc.org/github.com/nsf/termbox-go)
- [progressbar](https://github.com/schollz/progressbar) **star:3971** Basic thread-safe progress bar that works in every OS.   [![godoc][D]](https://godoc.org/github.com/schollz/progressbar)
- [termdash](https://github.com/mum4k/termdash) **star:2669** Go terminal dashboard based on **termbox-go** and inspired by [termui](https://github.com/gizak/termui).   [![godoc][D]](https://godoc.org/github.com/mum4k/termdash)
- [asciigraph](https://github.com/guptarohit/asciigraph) **star:2603** Go package to make lightweight ASCII line graph ╭┈╯ in command line apps with no other dependencies.   [![There was an update last month][G]](https://github.com/guptarohit/asciigraph)   [![godoc][D]](https://godoc.org/github.com/guptarohit/asciigraph)
- [spinner](https://github.com/briandowns/spinner) **star:2315** Go package to easily provide a terminal spinner with options.   [![godoc][D]](https://godoc.org/github.com/briandowns/spinner)
- [mpb](https://github.com/vbauerster/mpb) **star:2283** Multi progress bar for terminal applications.   [![godoc][D]](https://godoc.org/github.com/vbauerster/mpb)
- [uiprogress](https://github.com/gosuri/uiprogress) **star:2090** Flexible library to render progress bars in terminal applications.   [![godoc][D]](https://godoc.org/github.com/gosuri/uiprogress)
- [termenv](https://github.com/muesli/termenv) **star:1692** Advanced ANSI style & color support for your terminal applications.   [![godoc][D]](https://godoc.org/github.com/muesli/termenv)
- [uilive](https://github.com/gosuri/uilive) **star:1687** Library for updating terminal output in real time.   [![godoc][D]](https://godoc.org/github.com/gosuri/uilive)
- [gookit/color](https://github.com/gookit/color) **star:1490** Terminal color rendering tool library, support 16 colors, 256 colors, RGB color rendering output, compatible with Windows.   [![There was an update last month][G]](https://github.com/gookit/color)   [![godoc][D]](https://godoc.org/github.com/gookit/color)   [![Contains Chinese documents][CN]](https://github.com/gookit/color)
- [aurora](https://github.com/logrusorgru/aurora) **star:1412** ANSI terminal colors that support fmt.Printf/Sprintf.   [![godoc][D]](https://godoc.org/github.com/logrusorgru/aurora)
- [go-isatty](https://github.com/mattn/go-isatty) **star:820** isatty for golang.   [![godoc][D]](https://godoc.org/github.com/mattn/go-isatty)
- [go-colorable](https://github.com/mattn/go-colorable) **star:753** Colorable writer for windows.   [![godoc][D]](https://godoc.org/github.com/mattn/go-colorable)
- [uitable](https://github.com/gosuri/uitable) **star:736** Library to improve readability in terminal apps using tabular data.   [![godoc][D]](https://godoc.org/github.com/gosuri/uitable)
- [box-cli-maker](https://github.com/Delta456/box-cli-maker) **star:520** Make Highly Customized Boxes for your CLI.   [![godoc][D]](https://godoc.org/github.com/Delta456/box-cli-maker)
- [simpletable](https://github.com/alexeyco/simpletable) **star:520** Simple tables in a terminal with Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/alexeyco/simpletable)   [![godoc][D]](https://godoc.org/github.com/alexeyco/simpletable)
- [chalk](https://github.com/ttacon/chalk) **star:447** Intuitive package for prettifying terminal/console output.   [![It hasn't been updated in recent three years][Y]](https://github.com/ttacon/chalk)   [![godoc][D]](https://godoc.org/github.com/ttacon/chalk)
- [yacspin](https://github.com/theckman/yacspin) **star:435** Yet Another CLi Spinner package, for working with terminal spinners.   [![godoc][D]](https://godoc.org/github.com/theckman/yacspin)
- [bubble-table](https://github.com/Evertras/bubble-table) **star:425** An interactive table component for bubbletea.   [![godoc][D]](https://godoc.org/github.com/Evertras/bubble-table)
- [tabby](https://github.com/cheynewallace/tabby) **star:352** A tiny library for super simple Golang tables.   [![It hasn't been updated in recent three years][Y]](https://github.com/cheynewallace/tabby)   [![godoc][D]](https://godoc.org/github.com/cheynewallace/tabby)
- [go-colortext](https://github.com/daviddengcn/go-colortext) **star:215** Go library for color output in terminals.   [![It hasn't been updated in recent three years][Y]](https://github.com/daviddengcn/go-colortext)   [![godoc][D]](https://godoc.org/github.com/daviddengcn/go-colortext)
- [cfmt](https://github.com/mingrammer/cfmt) **star:102** Contextual fmt inspired by bootstrap color classes.   [![It hasn't been updated in recent three years][Y]](https://github.com/mingrammer/cfmt)   [![godoc][D]](https://godoc.org/github.com/mingrammer/cfmt)
- [tabular](https://github.com/InVisionApp/tabular) **star:76** Print ASCII tables from command line utilities without the need to pass large sets of data to the API.   [![godoc][D]](https://godoc.org/github.com/InVisionApp/tabular)
- [cfmt](https://github.com/i582/cfmt) **star:64** Simple and convenient formatted stylized output fully compatible with fmt library.   [![It hasn't been updated in recent three years][Y]](https://github.com/i582/cfmt)   [![godoc][D]](https://godoc.org/github.com/i582/cfmt)
- [table](https://github.com/tomlazar/table) **star:50** Small library for terminal color based tables.   [![godoc][D]](https://godoc.org/github.com/tomlazar/table)
- [marker](https://github.com/cyucelen/marker) **star:47** Easiest way to match and mark strings for colorful terminal outputs.   [![godoc][D]](https://godoc.org/github.com/cyucelen/marker)
- [ctc](https://github.com/wzshiming/ctc) **star:46** The non-invasive cross-platform terminal color library does not need to modify the Print method.   [![godoc][D]](https://godoc.org/github.com/wzshiming/ctc)   [![Contains Chinese documents][CN]](https://github.com/wzshiming/ctc)
- [colourize](https://github.com/TreyBastian/colourize) **star:26** Go library for ANSI colour text in terminals.   [![godoc][D]](https://godoc.org/github.com/TreyBastian/colourize)   [![Archived][Archived]](https://github.com/TreyBastian/colourize)
- [go-ataman](https://github.com/workanator/go-ataman) **star:16** Go library for rendering ANSI colored text templates in terminals.   [![It hasn't been updated in recent three years][Y]](https://github.com/workanator/go-ataman)   [![godoc][D]](https://godoc.org/github.com/workanator/go-ataman)
- [go-palette](https://github.com/abusomani/go-palette) **star:15** Go library that provides elegant and convenient style definitions using ANSI colors. Fully compatible & wraps the [fmt library](https://pkg.go.dev/fmt) for nice terminal layouts.   [![godoc][D]](https://godoc.org/github.com/abusomani/go-palette)
- [crab-config-files-templating](https://github.com/alfiankan/crab-config-files-templating) **star:7** Dynamic configuration file templating tool for kubernetes manifest or general configuration files.   [![godoc][D]](https://godoc.org/github.com/alfiankan/crab-config-files-templating)

**[⬆ back to top](#contents)**

### Standard CLI

_Libraries for building standard or basic Command Line applications._

- [cobra](https://github.com/spf13/cobra) **star:37200** Commander for modern Go CLI interactions.   [![There was an update last month][G]](https://github.com/spf13/cobra)   [![godoc][D]](https://godoc.org/github.com/spf13/cobra)
- [elvish](https://github.com/elves/elvish) **star:5552** An expressive programming language and a versatile interactive shell.   [![There was an update last month][G]](https://github.com/elves/elvish)   [![godoc][D]](https://godoc.org/github.com/elves/elvish)
- [kingpin](https://github.com/alecthomas/kingpin) **star:3472** Command line and flag parser supporting sub commands (superseded by `kong`; see below).   [![There was an update last month][G]](https://github.com/alecthomas/kingpin)   [![godoc][D]](https://godoc.org/github.com/alecthomas/kingpin)
- [Dnote](https://github.com/dnote/dnote) **star:2736** A simple command line notebook with multi-device sync.   [![godoc][D]](https://godoc.org/github.com/dnote/dnote)
- [go-flags](https://github.com/jessevdk/go-flags) **star:2545** go command line option parser.   [![godoc][D]](https://godoc.org/github.com/jessevdk/go-flags)
- [pflag](https://github.com/spf13/pflag) **star:2366** Drop-in replacement for Go's flag package, implementing POSIX/GNU-style --flags.   [![godoc][D]](https://godoc.org/github.com/spf13/pflag)
- [go-arg](https://github.com/alexflint/go-arg) **star:1969** Struct-based argument parsing in Go.   [![godoc][D]](https://godoc.org/github.com/alexflint/go-arg)
- [mitchellh/cli](https://github.com/mitchellh/cli) **star:1732** Go library for implementing command-line interfaces.   [![godoc][D]](https://godoc.org/github.com/mitchellh/cli)   [![Archived][Archived]](https://github.com/mitchellh/cli)
- [ops](https://github.com/nanovms/ops) **star:1257** Unikernel Builder/Orchestrator.   [![There was an update last month][G]](https://github.com/nanovms/ops)   [![godoc][D]](https://godoc.org/github.com/nanovms/ops)
- [liner](https://github.com/peterh/liner) **star:1040** Go readline-like library for command-line interfaces.   [![godoc][D]](https://godoc.org/github.com/peterh/liner)
- [complete](https://github.com/posener/complete) **star:925** Write bash completions in Go + Go command bash completion.   [![godoc][D]](https://godoc.org/github.com/posener/complete)
- [mow.cli](https://github.com/jawher/mow.cli) **star:871** Go library for building CLI applications with sophisticated flag and argument parsing and validation.   [![godoc][D]](https://godoc.org/github.com/jawher/mow.cli)
- [flaggy](https://github.com/integrii/flaggy) **star:855** A robust and idiomatic flags package with excellent subcommand support.   [![godoc][D]](https://godoc.org/github.com/integrii/flaggy)
- [carapace-bin](https://github.com/rsteube/carapace-bin) **star:806** Multi-shell multi-command argument completer.   [![There was an update last month][G]](https://github.com/rsteube/carapace-bin)   [![godoc][D]](https://godoc.org/github.com/rsteube/carapace-bin)
- [cli](https://github.com/mkideal/cli) **star:728** Feature-rich and easy to use command-line package based on golang struct tags.   [![godoc][D]](https://godoc.org/github.com/mkideal/cli)
- [argparse](https://github.com/akamensky/argparse) **star:601** Command line argument parser inspired by Python's argparse module.   [![godoc][D]](https://godoc.org/github.com/akamensky/argparse)
- [carapace](https://github.com/rsteube/carapace) **star:300** Command argument completion generator for spf13/cobra.   [![godoc][D]](https://godoc.org/github.com/rsteube/carapace)
- [climax](https://github.com/tucnak/climax) **star:216** Alternative CLI with "human face", in spirit of Go command.   [![It hasn't been updated in recent three years][Y]](https://github.com/tucnak/climax)   [![godoc][D]](https://godoc.org/github.com/tucnak/climax)
- [clîr](https://github.com/leaanthony/clir) **star:174** A Simple and Clear CLI library. Dependency free.   [![godoc][D]](https://godoc.org/github.com/leaanthony/clir)
- [commandeer](https://github.com/jaffee/commandeer) **star:173** Dev-friendly CLI apps: sets up flags, defaults, and usage based on struct fields and tags.   [![godoc][D]](https://godoc.org/github.com/jaffee/commandeer)
- [job](https://github.com/liujianping/job) **star:145** JOB, make your short-term command as a long-term job.   [![It hasn't been updated in recent three years][Y]](https://github.com/liujianping/job)
- [cmdr](https://github.com/hedzr/cmdr) **star:133** A POSIX/GNU style, getopt-like command-line UI Go library.   [![godoc][D]](https://godoc.org/github.com/hedzr/cmdr)
- [flag](https://github.com/cosiner/flag) **star:131** Simple but powerful command line option parsing library for Go supporting subcommand.   [![It hasn't been updated in recent three years][Y]](https://github.com/cosiner/flag)   [![godoc][D]](https://godoc.org/github.com/cosiner/flag)
- [cli](https://github.com/teris-io/cli) **star:129** Simple and complete API for building command line interfaces in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/teris-io/cli)   [![godoc][D]](https://godoc.org/github.com/teris-io/cli)
- [acmd](https://github.com/cristalhq/acmd) **star:115** Simple, useful, and opinionated CLI package in Go.   [![godoc][D]](https://godoc.org/github.com/cristalhq/acmd)
- [env](https://github.com/codingconcepts/env) **star:113** Tag-based environment configuration for structs.   [![godoc][D]](https://godoc.org/github.com/codingconcepts/env)
- [gocmd](https://github.com/devfacet/gocmd) **star:65** Go library for building command line applications.   [![godoc][D]](https://godoc.org/github.com/devfacet/gocmd)
- [hiboot cli](https://github.com/hidevopsio/hiboot/tree/master/pkg/app/cli)  cli application framework with auto configuration and dependency injection.
- [command-chain](https://github.com/rainu/go-command-chain) **star:58** A go library for configure and run command chains - such as pipelining in unix shells.   [![godoc][D]](https://godoc.org/github.com/rainu/go-command-chain)
- [go-getoptions](https://github.com/DavidGamba/go-getoptions) **star:56** Go option parser inspired by the flexibility of Perl’s GetOpt::Long.   [![godoc][D]](https://godoc.org/github.com/DavidGamba/go-getoptions)
- [flagvar](https://github.com/sgreben/flagvar) **star:43** A collection of flag argument types for Go's standard `flag` package.   [![godoc][D]](https://godoc.org/github.com/sgreben/flagvar)
- [argv](https://github.com/cosiner/argv) **star:41** Go library to split command line string as arguments array using the bash syntax.   [![It hasn't been updated in recent three years][Y]](https://github.com/cosiner/argv)   [![godoc][D]](https://godoc.org/github.com/cosiner/argv)
- [cmd](https://github.com/posener/cmd) **star:41** Extends the standard `flag` package to support sub commands and more in idiomatic way.   [![It hasn't been updated in recent three years][Y]](https://github.com/posener/cmd)   [![godoc][D]](https://godoc.org/github.com/posener/cmd)
- [go-commander](https://github.com/yitsushi/go-commander) **star:35** Go library to simplify CLI workflow.   [![It hasn't been updated in recent three years][Y]](https://github.com/yitsushi/go-commander)   [![godoc][D]](https://godoc.org/github.com/yitsushi/go-commander)   [![Archived][Archived]](https://github.com/yitsushi/go-commander)
- [go-andotp](https://github.com/grijul/go-andotp) **star:30** A CLI program to encrypt/decrypt [andOTP](https://github.com/andOTP/andOTP) files. Can be used as a library as well.   [![godoc][D]](https://godoc.org/github.com/grijul/go-andotp)
- [mcli](https://github.com/jxskiss/mcli) **star:28** A minimal but very powerful cli library for Go.   [![godoc][D]](https://godoc.org/github.com/jxskiss/mcli)
- [carapace-spec](https://github.com/rsteube/carapace-spec) **star:16** Define simple completions using a spec file.   [![godoc][D]](https://godoc.org/github.com/rsteube/carapace-spec)
- [readline](https://github.com/reeflective/readline) Shell library with modern and easy to use UI features.
- [urfave/cli](https://github.com/urfave/cli) **star:22059** Simple, fast, and fun package for building command line apps in Go (formerly codegangsta/cli).   [![There was an update last month][G]](https://github.com/urfave/cli)   [![godoc][D]](https://godoc.org/github.com/urfave/cli)
- [survey](https://github.com/go-survey/survey) **star:4082** Build interactive and accessible prompts with full support for windows and posix terminals.   [![godoc][D]](https://godoc.org/github.com/go-survey/survey)   [![Archived][Archived]](https://github.com/go-survey/survey)
- [wmenu](https://github.com/dixonwille/wmenu) **star:216** Easy to use menu structure for cli applications that prompt users to make choices.   [![godoc][D]](https://godoc.org/github.com/dixonwille/wmenu)
- [sflags](https://github.com/octago/sflags) **star:150** Struct based flags generator for flag, urfave/cli, pflag, cobra, kingpin, and other libraries.   [![It hasn't been updated in recent three years][Y]](https://github.com/octago/sflags)   [![godoc][D]](https://godoc.org/github.com/octago/sflags)
- [ukautz/clif](https://github.com/ukautz/clif) **star:128** Small command line interface framework.   [![It hasn't been updated in recent three years][Y]](https://github.com/ukautz/clif)   [![godoc][D]](https://godoc.org/github.com/ukautz/clif)
- [version](https://github.com/mszostok/version) **star:95** Collects and displays CLI version information in multiple formats along with upgrade notice.   [![godoc][D]](https://godoc.org/github.com/mszostok/version)
- [wlog](https://github.com/dixonwille/wlog) **star:64** Simple logging interface that supports cross-platform color and concurrency.   [![godoc][D]](https://godoc.org/github.com/dixonwille/wlog)
- [strumt](https://github.com/antham/strumt) **star:60** Library to create prompt chain.   [![godoc][D]](https://godoc.org/github.com/antham/strumt)
- [sand](https://github.com/Zaba505/sand) **star:25** Simple API for creating interpreters and so much more.   [![It hasn't been updated in recent three years][Y]](https://github.com/Zaba505/sand)   [![godoc][D]](https://godoc.org/github.com/Zaba505/sand)
- [ts](https://github.com/liujianping/ts) **star:20** Timestamp convert & compare tool.   [![It hasn't been updated in recent three years][Y]](https://github.com/liujianping/ts)   [![godoc][D]](https://godoc.org/github.com/liujianping/ts)
- [subcmd](https://github.com/bobg/subcmd) **star:8** Another approach to parsing and running subcommands. Works alongside the standard `flag` package.   [![godoc][D]](https://godoc.org/github.com/bobg/subcmd)

**[⬆ back to top](#contents)**

## Configuration

_Libraries for configuration parsing._

- [viper](https://github.com/spf13/viper) **star:26576** Go configuration with fangs.   [![There was an update last month][G]](https://github.com/spf13/viper)   [![godoc][D]](https://godoc.org/github.com/spf13/viper)
- [godotenv](https://github.com/joho/godotenv) **star:8021** Go port of Ruby's dotenv library (Loads environment variables from `.env`).   [![godoc][D]](https://godoc.org/github.com/joho/godotenv)
- [kelseyhightower/envconfig](https://github.com/kelseyhightower/envconfig) **star:4986** Go library for managing configuration data from environment variables.   [![godoc][D]](https://godoc.org/github.com/kelseyhightower/envconfig)
- [env](https://github.com/caarlos0/env) **star:4682** Parse environment variables to Go structs (with defaults).   [![There was an update last month][G]](https://github.com/caarlos0/env)   [![godoc][D]](https://godoc.org/github.com/caarlos0/env)
- [ini](https://github.com/go-ini/ini) **star:3432** Go package to read and write INI files.   [![godoc][D]](https://godoc.org/github.com/go-ini/ini)
- [koanf](https://github.com/knadh/koanf) **star:2597** Light weight, extensible library for reading config in Go applications. Built in support for JSON, TOML, YAML, env, command line.   [![godoc][D]](https://godoc.org/github.com/knadh/koanf)
- [kong](https://github.com/alecthomas/kong) **star:2022** Command-line parser with support for arbitrarily complex command-line structures and additional sources of configuration such as YAML, JSON, TOML, etc (successor to `kingpin`).   [![There was an update last month][G]](https://github.com/alecthomas/kong)   [![godoc][D]](https://godoc.org/github.com/alecthomas/kong)
- [cleanenv](https://github.com/ilyakaznacheev/cleanenv) **star:1569** Minimalistic configuration reader (from files, ENV, and wherever you want).   [![There was an update last month][G]](https://github.com/ilyakaznacheev/cleanenv)   [![godoc][D]](https://godoc.org/github.com/ilyakaznacheev/cleanenv)
- [konfig](https://github.com/lalamove/konfig) **star:650** Composable, observable and performant config handling for Go for the distributed processing era.   [![It hasn't been updated in recent three years][Y]](https://github.com/lalamove/konfig)   [![godoc][D]](https://godoc.org/github.com/lalamove/konfig)
- [xdg](https://github.com/adrg/xdg) **star:641** Go implementation of the [XDG Base Directory Specification](https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html) and [XDG user directories](https://wiki.archlinux.org/index.php/XDG_user_directories).   [![There was an update last month][G]](https://github.com/adrg/xdg)   [![godoc][D]](https://godoc.org/github.com/adrg/xdg)
- [aconfig](https://github.com/cristalhq/aconfig) **star:534** Simple, useful and opinionated config loader.   [![godoc][D]](https://godoc.org/github.com/cristalhq/aconfig)
- [gookit/config](https://github.com/gookit/config) **star:532** application config manage(load,get,set). support JSON, YAML, TOML, INI, HCL. multi file load, data override merge.   [![godoc][D]](https://godoc.org/github.com/gookit/config)   [![Contains Chinese documents][CN]](https://github.com/gookit/config)
- [confita](https://github.com/heetch/confita) **star:492** Load configuration in cascade from multiple backends into a struct.   [![godoc][D]](https://godoc.org/github.com/heetch/confita)
- [fig](https://github.com/kkyr/fig) **star:368** Tiny library for reading configuration from a file and from environment variables (with validation & defaults).   [![godoc][D]](https://godoc.org/github.com/kkyr/fig)
- [GoLobby/Config](https://github.com/golobby/config) **star:359** GoLobby Config is a lightweight yet powerful configuration manager for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/golobby/config)
- [gone/jconf](https://github.com/One-com/gone/tree/master/jconf)  Modular JSON configuration. Keep your config structs along with the code they configure and delegate parsing to submodules without sacrificing full config serialization.
- [config](https://github.com/JeremyLoy/config) **star:336** Cloud native application configuration. Bind ENV to structs in only two lines.   [![godoc][D]](https://godoc.org/github.com/JeremyLoy/config)
- [hjson](https://github.com/hjson/hjson-go) **star:328** Human JSON, a configuration file format for humans. Relaxed syntax, fewer mistakes, more comments.   [![godoc][D]](https://godoc.org/github.com/hjson/hjson-go)
- [store](https://github.com/tucnak/store) **star:274** Lightweight configuration manager for Go.   [![godoc][D]](https://godoc.org/github.com/tucnak/store)
- [config](https://github.com/olebedev/config) **star:267** JSON or YAML configuration wrapper with environment variables and flags parsing.   [![godoc][D]](https://godoc.org/github.com/olebedev/config)
- [envconfig](https://github.com/vrischmann/envconfig) **star:240** Read your configuration from environment variables.   [![godoc][D]](https://godoc.org/github.com/vrischmann/envconfig)
- [konf](https://github.com/nil-go/konf) **star:219** The simplest API for reading/watching config from file, env, flag and clouds (e.g. AWS, Azure, GCP).   [![There was an update last month][G]](https://github.com/nil-go/konf)   [![godoc][D]](https://godoc.org/github.com/nil-go/konf)
- [joshbetz/config](https://github.com/joshbetz/config) **star:216** Small configuration library for Go that parses environment variables, JSON files, and reloads automatically on SIGHUP.   [![godoc][D]](https://godoc.org/github.com/joshbetz/config)
- [harvester](https://github.com/beatlabs/harvester) **star:130** Harvester, an easy to use static and dynamic configuration package supporting seeding, env vars and Consul integration.   [![godoc][D]](https://godoc.org/github.com/beatlabs/harvester)
- [onion](https://github.com/goraz/onion) **star:116** Layer based configuration for Go, Supports JSON, TOML, YAML, properties, etcd, env, and encryption using PGP.   [![godoc][D]](https://godoc.org/github.com/goraz/onion)
- [configuration](https://github.com/BoRuDar/configuration) **star:109** Library for initializing configuration structs from env variables, files, flags and 'default' tag.   [![godoc][D]](https://godoc.org/github.com/BoRuDar/configuration)
- [envh](https://github.com/antham/envh) **star:99** Helpers to manage environment variables.   [![godoc][D]](https://godoc.org/github.com/antham/envh)
- [configuro](https://github.com/sherifabdlnaby/configuro) **star:92** opinionated configuration loading & validation framework from ENV and Files focused towards 12-Factor compliant applications.   [![godoc][D]](https://godoc.org/github.com/sherifabdlnaby/configuro)
- [xdg](https://github.com/OpenPeeDeeP/xdg) **star:80** Cross platform package that follows the [XDG Standard](https://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html).   [![It hasn't been updated in recent three years][Y]](https://github.com/OpenPeeDeeP/xdg)   [![godoc][D]](https://godoc.org/github.com/OpenPeeDeeP/xdg)
- [hocon](https://github.com/gurkankaymak/hocon) **star:76** Configuration library for working with the HOCON(a human-friendly JSON superset) format, supports features like environment variables, referencing other values, comments and multiple files.   [![godoc][D]](https://godoc.org/github.com/gurkankaymak/hocon)
- [uConfig](https://github.com/omeid/uconfig) **star:70** Lightweight, zero-dependency, and extendable configuration management.   [![godoc][D]](https://godoc.org/github.com/omeid/uconfig)
- [gofigure](https://github.com/ian-kent/gofigure) **star:69** Go application configuration made easy.   [![It hasn't been updated in recent three years][Y]](https://github.com/ian-kent/gofigure)   [![godoc][D]](https://godoc.org/github.com/ian-kent/gofigure)
- [env](https://github.com/junk1tm/env) **star:58** A lightweight package for loading environment variables into structs.   [![godoc][D]](https://godoc.org/github.com/junk1tm/env)
- [go-aws-ssm](https://github.com/PaddleHQ/go-aws-ssm) **star:57** Go package that fetches parameters from AWS System Manager - Parameter Store.   [![godoc][D]](https://godoc.org/github.com/PaddleHQ/go-aws-ssm)
- [configure](https://github.com/paked/configure) **star:56** Provides configuration through multiple sources, including JSON, flags and environment variables.   [![It hasn't been updated in recent three years][Y]](https://github.com/paked/configure)   [![godoc][D]](https://godoc.org/github.com/paked/configure)
- [config](https://github.com/num30/config) **star:48** configure your app using file, environment variables, or flags in two lines of code   [![godoc][D]](https://godoc.org/github.com/num30/config)
- [go-up](https://github.com/ufoscout/go-up) **star:43** A simple configuration library with recursive placeholders resolution and no magic.   [![It hasn't been updated in recent three years][Y]](https://github.com/ufoscout/go-up)   [![godoc][D]](https://godoc.org/github.com/ufoscout/go-up)
- [go-cfg](https://github.com/dsbasko/go-cfg) **star:38** The library provides a unified way to read configuration data into a structure from various sources, such as env, flags, and configuration files (.json, .yaml, .toml, .env).   [![godoc][D]](https://godoc.org/github.com/dsbasko/go-cfg)
- [genv](https://github.com/sakirsensoy/genv) **star:37** Read environment variables easily with dotenv support.   [![It hasn't been updated in recent three years][Y]](https://github.com/sakirsensoy/genv)   [![godoc][D]](https://godoc.org/github.com/sakirsensoy/genv)
- [ingo](https://github.com/schachmat/ingo) **star:37** Flags persisted in an ini-like config file.   [![It hasn't been updated in recent three years][Y]](https://github.com/schachmat/ingo)   [![godoc][D]](https://godoc.org/github.com/schachmat/ingo)
- [mini](https://github.com/sasbury/mini) **star:35** Golang package for parsing ini-style configuration files.   [![It hasn't been updated in recent three years][Y]](https://github.com/sasbury/mini)   [![godoc][D]](https://godoc.org/github.com/sasbury/mini)
- [confiq](https://github.com/greencoda/confiq) **star:34** Structured data format to config struct decoder library for Go - supporting multiple data formats   [![godoc][D]](https://godoc.org/github.com/greencoda/confiq)
- [conflate](https://github.com/the4thamigo-uk/conflate) **star:32** Library/tool to merge multiple JSON/YAML/TOML files from arbitrary URLs, validation against a JSON schema, and application of default values defined in the schema.   [![godoc][D]](https://godoc.org/github.com/the4thamigo-uk/conflate)
- [go-ssm-config](https://github.com/ianlopshire/go-ssm-config) **star:20** Go utility for loading configuration parameters from AWS SSM (Parameter Store).   [![godoc][D]](https://godoc.org/github.com/ianlopshire/go-ssm-config)
- [nasermirzaei89/env](https://github.com/nasermirzaei89/env) **star:18** Simple useful package for read environment variables.   [![godoc][D]](https://godoc.org/github.com/nasermirzaei89/env)
- [bcl](https://github.com/wkhere/bcl) **star:17** BCL is a configuration language similar to HCL.   [![There was an update last month][G]](https://github.com/wkhere/bcl)   [![godoc][D]](https://godoc.org/github.com/wkhere/bcl)
- [go-array](https://github.com/deatil/go-array) **star:16** A Go package that read or set data from map, slice or json.   [![godoc][D]](https://godoc.org/github.com/deatil/go-array)   [![Contains Chinese documents][CN]](https://github.com/deatil/go-array)
- [ini](https://github.com/wlevene/ini) **star:15** INI Parser & Write Library, Unmarshal to Struct, Marshal to Json, Write File, watch file.   [![godoc][D]](https://godoc.org/github.com/wlevene/ini)
- [yamagiconf](https://github.com/romshark/yamagiconf) **star:15** The "safe subset" of YAML for Go configs.   [![godoc][D]](https://godoc.org/github.com/romshark/yamagiconf)
- [go-ini](https://github.com/subpop/go-ini) **star:14** A Go package that marshals and unmarshals INI-files.   [![There was an update last month][G]](https://github.com/subpop/go-ini)   [![godoc][D]](https://godoc.org/github.com/subpop/go-ini)
- [go-conf](https://github.com/ThomasObenaus/go-conf) **star:10** Simple library for application configuration based on annotated structs. It supports reading the configuration from environment variables, config files and command line parameters.   [![godoc][D]](https://godoc.org/github.com/ThomasObenaus/go-conf)
- [typenv](https://github.com/diegomarangoni/typenv) **star:9** Minimalistic, zero dependency, typed environment variables library.   [![godoc][D]](https://godoc.org/github.com/diegomarangoni/typenv)
- [gonfig](https://github.com/milad-abbasi/gonfig) **star:8** Tag-based configuration parser which loads values from different providers into typesafe struct.   [![It hasn't been updated in recent three years][Y]](https://github.com/milad-abbasi/gonfig)   [![godoc][D]](https://godoc.org/github.com/milad-abbasi/gonfig)
- [swap](https://github.com/oblq/swap) **star:8** Instantiate/configure structs recursively, based on build environment. (YAML, TOML, JSON and env).   [![godoc][D]](https://godoc.org/github.com/oblq/swap)
- [nfigure](https://github.com/muir/nfigure) **star:7** Per-library struct-tag based configuration from command lines (Posix & Go-style); environment, JSON, YAML   [![godoc][D]](https://godoc.org/github.com/muir/nfigure)
- [piper](https://github.com/Yiling-J/piper) **star:7** Viper wrapper with config inheritance and key generation.   [![godoc][D]](https://godoc.org/github.com/Yiling-J/piper)
- [GoCfg](https://github.com/Jagerente/gocfg) **star:5** Config manager with Struct Tags based contracts, custom value providers, parsers, and documentation generation. Customizable yet simple.   [![godoc][D]](https://godoc.org/github.com/Jagerente/gocfg)
- [env](https://github.com/syntaqx/env) **star:4** An environment utility package with support for unmarshaling into structs   [![godoc][D]](https://godoc.org/github.com/syntaqx/env)
- [goConfig](https://github.com/crgimenes/goConfig) **star:3** Parses a struct as input and populates the fields of this struct with parameters from command line, environment variables and configuration file.   [![godoc][D]](https://godoc.org/github.com/crgimenes/goConfig)

**[⬆ back to top](#contents)**

## Continuous Integration

_Tools for help with continuous integration._

- [drone](https://github.com/drone/drone) **star:32007** Drone is a Continuous Integration platform built on Docker, written in Go.   [![There was an update last month][G]](https://github.com/drone/drone)   [![godoc][D]](https://godoc.org/github.com/drone/drone)
- [CDS](https://github.com/ovh/cds) **star:4527** Enterprise-Grade CI/CD and DevOps Automation Open Source Platform.   [![There was an update last month][G]](https://github.com/ovh/cds)   [![godoc][D]](https://godoc.org/github.com/ovh/cds)
- [woodpecker](https://github.com/woodpecker-ci/woodpecker) **star:3978** Woodpecker is a community fork of the Drone CI system.   [![There was an update last month][G]](https://github.com/woodpecker-ci/woodpecker)   [![godoc][D]](https://godoc.org/github.com/woodpecker-ci/woodpecker)
- [goveralls](https://github.com/mattn/goveralls) **star:787** Go integration for Coveralls.io continuous code coverage tracking system.   [![godoc][D]](https://godoc.org/github.com/mattn/goveralls)
- [gotestfmt](https://github.com/GoTestTools/gotestfmt) **star:493** go test output for humans.   [![godoc][D]](https://godoc.org/github.com/GoTestTools/gotestfmt)
- [overalls](https://github.com/go-playground/overalls) **star:114** Multi-Package go project coverprofile for tools like goveralls.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-playground/overalls)   [![godoc][D]](https://godoc.org/github.com/go-playground/overalls)
- [go-test-coverage](https://github.com/vladopajic/go-test-coverage) **star:73** Tool and GitHub action which reports issues when test coverage is below set threshold.   [![godoc][D]](https://godoc.org/github.com/vladopajic/go-test-coverage)
- [gomason](https://github.com/nikogura/gomason) **star:65** Test, Build, Sign, and Publish your go binaries from a clean workspace.   [![godoc][D]](https://godoc.org/github.com/nikogura/gomason)
- [roveralls](https://github.com/LawrenceWoodman/roveralls) **star:20** Recursive coverage testing tool.   [![It hasn't been updated in recent three years][Y]](https://github.com/LawrenceWoodman/roveralls)   [![godoc][D]](https://godoc.org/github.com/LawrenceWoodman/roveralls)
- [Bencher](https://bencher.dev/)  A suite of continuous benchmarking tools designed to catch performance regressions in CI.
- [dot](https://github.com/opnlabs/dot) **star:15** A minimal, local first continuous integration system that uses Docker to run jobs concurrently in stages.   [![godoc][D]](https://godoc.org/github.com/opnlabs/dot)
- [go-fuzz-action](https://github.com/jidicula/go-fuzz-action) **star:15** Use Go 1.18's built-in fuzz testing in GitHub Actions.
- [go-semver-release](https://github.com/s0ders/go-semver-release) **star:8** Automate the semantic versioning of Git repositories.   [![godoc][D]](https://godoc.org/github.com/s0ders/go-semver-release)
- [go-beautiful-html-coverage](https://github.com/gha-common/go-beautiful-html-coverage) **star:7** A GitHub Action to track code coverage in your pull requests, with a beautiful HTML preview, for free.

**[⬆ back to top](#contents)**

## CSS Preprocessors

_Libraries for preprocessing CSS files._

- [gcss](https://github.com/yosssi/gcss) **star:494** Pure Go CSS Preprocessor.   [![godoc][D]](https://godoc.org/github.com/yosssi/gcss)
- [go-libsass](https://github.com/wellington/go-libsass) **star:205** Go wrapper to the 100% Sass compatible libsass project.

**[⬆ back to top](#contents)**

## Data Structures and Algorithms

### Bit-packing and Compression

- [roaring](https://github.com/RoaringBitmap/roaring) **star:2427** Go package implementing compressed bitsets.   [![There was an update last month][G]](https://github.com/RoaringBitmap/roaring)   [![godoc][D]](https://godoc.org/github.com/RoaringBitmap/roaring)
- [binpacker](https://github.com/zhuangsirui/binpacker) **star:220** Binary packer and unpacker helps user build custom binary stream.   [![godoc][D]](https://godoc.org/github.com/zhuangsirui/binpacker)
- [bit](https://github.com/yourbasic/bit) **star:157** Golang set data structure with bonus bit-twiddling functions.   [![godoc][D]](https://godoc.org/github.com/yourbasic/bit)
- [crunch](https://github.com/superwhiskers/crunch) **star:95** Go package implementing buffers for handling various datatypes easily.   [![godoc][D]](https://godoc.org/github.com/superwhiskers/crunch)
- [bingo](https://github.com/iancmcc/bingo) **star:38** Fast, zero-allocation, lexicographical-order-preserving packing of native types to bytes.   [![godoc][D]](https://godoc.org/github.com/iancmcc/bingo)
- [go-ef](https://github.com/amallia/go-ef) **star:31** A Go implementation of the Elias-Fano encoding.   [![godoc][D]](https://godoc.org/github.com/amallia/go-ef)

### Bit Sets

- [bitset](https://github.com/bits-and-blooms/bitset) **star:1303** Go package implementing bitsets.   [![godoc][D]](https://godoc.org/github.com/bits-and-blooms/bitset)
- [bitmap](https://github.com/kelindar/bitmap) **star:294** Dense, zero-allocation, SIMD-enabled bitmap/bitset in Go.

### Bloom and Cuckoo Filters

- [bloom](https://github.com/bits-and-blooms/bloom) **star:2373** Go package implementing Bloom filters.   [![godoc][D]](https://godoc.org/github.com/bits-and-blooms/bloom)
- [boomfilters](https://github.com/tylertreat/BoomFilters) **star:1588** Probabilistic data structures for processing continuous, unbounded streams.   [![It hasn't been updated in recent three years][Y]](https://github.com/tylertreat/BoomFilters)   [![godoc][D]](https://godoc.org/github.com/tylertreat/BoomFilters)
- [cuckoofilter](https://github.com/seiflotfy/cuckoofilter) **star:1100** Cuckoo filter: a good alternative to a counting bloom filter implemented in Go.   [![godoc][D]](https://godoc.org/github.com/seiflotfy/cuckoofilter)
- [cuckoo-filter](https://github.com/linvon/cuckoo-filter) **star:291** Cuckoo filter: a comprehensive cuckoo filter, which is configurable and space optimized compared with other implements, and all features mentioned in original paper are available.   [![godoc][D]](https://godoc.org/github.com/linvon/cuckoo-filter)   [![Contains Chinese documents][CN]](https://github.com/linvon/cuckoo-filter)
- [bloom](https://github.com/zhenjl/bloom) **star:147** Bloom filters implemented in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/zhenjl/bloom)   [![godoc][D]](https://godoc.org/github.com/zhenjl/bloom)
- [ring](https://github.com/TheTannerRyan/ring) **star:138** Go implementation of a high performance, thread safe bloom filter.   [![It hasn't been updated in recent three years][Y]](https://github.com/TheTannerRyan/ring)   [![godoc][D]](https://godoc.org/github.com/TheTannerRyan/ring)
- [bloom](https://github.com/yourbasic/bloom) **star:86** Golang Bloom filter implementation.   [![It hasn't been updated in recent three years][Y]](https://github.com/yourbasic/bloom)   [![godoc][D]](https://godoc.org/github.com/yourbasic/bloom)
- [bloomfilter](https://github.com/OldPanda/bloomfilter) **star:17** Yet another Bloomfilter implementation in Go, compatible with Java's Guava library.   [![There was an update last month][G]](https://github.com/OldPanda/bloomfilter)   [![godoc][D]](https://godoc.org/github.com/OldPanda/bloomfilter)

### Data Structure and Algorithm Collections

- [gods](https://github.com/emirpasic/gods) **star:15950** Go Data Structures. Containers, Sets, Lists, Stacks, Maps, BidiMaps, Trees, HashSet etc.   [![godoc][D]](https://godoc.org/github.com/emirpasic/gods)
- [go-datastructures](https://github.com/Workiva/go-datastructures) **star:7607** Collection of useful, performant, and thread-safe data structures.   [![godoc][D]](https://godoc.org/github.com/Workiva/go-datastructures)
- [gostl](https://github.com/liyue201/gostl) **star:1028** Data structure and algorithm library for go, designed to provide functions similar to C++ STL.   [![godoc][D]](https://godoc.org/github.com/liyue201/gostl)
- [algorithms](https://github.com/shady831213/algorithms) **star:796** Algorithms and data structures.CLRS study.   [![It hasn't been updated in recent three years][Y]](https://github.com/shady831213/algorithms)   [![godoc][D]](https://godoc.org/github.com/shady831213/algorithms)

### Iterators

- [iter](https://github.com/disksing/iter) **star:185** Go implementation of C++ STL iterators and algorithms.   [![godoc][D]](https://godoc.org/github.com/disksing/iter)   [![Contains Chinese documents][CN]](https://github.com/disksing/iter)
- [goterator](https://github.com/yaa110/goterator) **star:16** Iterator implementation to provide map and reduce functionalities.   [![godoc][D]](https://godoc.org/github.com/yaa110/goterator)

### Maps

See also [Database](#database) for more complex key-value stores, and [Trees](#trees) for
additional ordered map implementations.

- [cmap](https://github.com/lrita/cmap) **star:91** a thread-safe concurrent map for go, support using `interface{}` as key and auto scale up shards.   [![godoc][D]](https://godoc.org/github.com/lrita/cmap)
- [dict](https://github.com/srfrog/dict) **star:45** Python-like dictionaries (dict) for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/srfrog/dict)   [![godoc][D]](https://godoc.org/github.com/srfrog/dict)
- [goradd/maps](https://github.com/goradd/maps) **star:38** Go 1.18+ generic map interface for maps; safe maps; ordered maps; ordered, safe maps; etc.   [![godoc][D]](https://godoc.org/github.com/goradd/maps)

### Miscellaneous Data Structures and Algorithms

- [gota](https://github.com/kniren/gota) **star:3002** Implementation of dataframes, series, and data wrangling methods for Go.   [![godoc][D]](https://godoc.org/github.com/kniren/gota)
- [hyperloglog](https://github.com/axiomhq/hyperloglog) **star:921** HyperLogLog implementation with Sparse, LogLog-Beta bias correction and TailCut space reduction.   [![godoc][D]](https://godoc.org/github.com/axiomhq/hyperloglog)
- [plinko](https://github.com/shipt/plinko)  A finite state machine and workflow orchestrator that compiles for fast execution, easy debugging, auto-generated documentation. Includes advanced features such as side-effect hooks.
- [go-geoindex](https://github.com/hailocab/go-geoindex) **star:353** In-memory geo index.   [![It hasn't been updated in recent three years][Y]](https://github.com/hailocab/go-geoindex)   [![godoc][D]](https://godoc.org/github.com/hailocab/go-geoindex)
- [hilbert](https://github.com/google/hilbert) **star:278** Go package for mapping values to and from space-filling curves, such as Hilbert and Peano curves.   [![godoc][D]](https://godoc.org/github.com/google/hilbert)   [![Archived][Archived]](https://github.com/google/hilbert)
- [go-rquad](https://github.com/aurelien-rainone/go-rquad) **star:133** Region quadtrees with efficient point location and neighbour finding.   [![godoc][D]](https://godoc.org/github.com/aurelien-rainone/go-rquad)
- [conjungo](https://github.com/InVisionApp/conjungo) **star:125** A small, powerful and flexible merge library.   [![godoc][D]](https://godoc.org/github.com/InVisionApp/conjungo)
- [go-rampart](https://github.com/francesconi/go-rampart) **star:99** Determine how intervals relate to each other.   [![godoc][D]](https://godoc.org/github.com/francesconi/go-rampart)
- [gogu](https://github.com/esimov/gogu) **star:95** A comprehensive, reusable and efficient concurrent-safe generics utility functions and data structures library.   [![godoc][D]](https://godoc.org/github.com/esimov/gogu)
- [go-tuple](https://github.com/barweiss/go-tuple) **star:80** Generic tuple implementation for Go 1.18+.   [![godoc][D]](https://godoc.org/github.com/barweiss/go-tuple)
- [go-generics](https://github.com/bobg/go-generics) **star:68** Generic slice, map, set, iterator, and goroutine utilities.   [![There was an update last month][G]](https://github.com/bobg/go-generics)   [![godoc][D]](https://godoc.org/github.com/bobg/go-generics)
- [hide](https://github.com/emvi/hide) **star:68** ID type with marshalling to/from hash to prevent sending IDs to clients.   [![godoc][D]](https://godoc.org/github.com/emvi/hide)
- [count-min-log](https://github.com/seiflotfy/count-min-log) **star:66** Go implementation Count-Min-Log sketch: Approximately counting with approximate counters (Like Count-Min sketch but using less memory).   [![It hasn't been updated in recent three years][Y]](https://github.com/seiflotfy/count-min-log)   [![godoc][D]](https://godoc.org/github.com/seiflotfy/count-min-log)
- [fsm](https://github.com/cocoonspace/fsm) **star:61** Finite-State Machine package.   [![godoc][D]](https://godoc.org/github.com/cocoonspace/fsm)
- [concurrent-writer](https://github.com/free/concurrent-writer) **star:54** Highly concurrent drop-in replacement for `bufio.Writer`.   [![It hasn't been updated in recent three years][Y]](https://github.com/free/concurrent-writer)   [![godoc][D]](https://godoc.org/github.com/free/concurrent-writer)
- [genfuncs](https://github.com/nwillc/genfuncs) **star:49** Go 1.18+ generics package inspired by Kotlin's Sequence and Map.   [![godoc][D]](https://godoc.org/github.com/nwillc/genfuncs)
- [go18ds](https://github.com/daichi-m/go18ds) **star:46** Go Data Structures using Go 1.18 generics.   [![godoc][D]](https://godoc.org/github.com/daichi-m/go18ds)
- [quadtree](https://github.com/s0rg/quadtree) **star:34** Generic, zero-alloc, 100%-test covered quadtree.   [![godoc][D]](https://godoc.org/github.com/s0rg/quadtree)
- [gofal](https://github.com/xxjwxc/gofal) **star:18** fractional api for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/xxjwxc/gofal)   [![godoc][D]](https://godoc.org/github.com/xxjwxc/gofal)   [![Contains Chinese documents][CN]](https://github.com/xxjwxc/gofal)
- [slices](https://github.com/twharmon/slices) **star:18** Pure, generic functions for slices.   [![godoc][D]](https://godoc.org/github.com/twharmon/slices)
- [slices](https://github.com/srfrog/slices) **star:16** Functions that operate on slices; like `package strings` but adapted to work with slices.   [![It hasn't been updated in recent three years][Y]](https://github.com/srfrog/slices)   [![godoc][D]](https://godoc.org/github.com/srfrog/slices)

### Nullable Types

- [nan](https://github.com/kak-tus/nan) **star:85** Zero allocation Nullable structures in one library with handy conversion functions, marshallers and unmarshallers.   [![godoc][D]](https://godoc.org/github.com/kak-tus/nan)
- [typ](https://github.com/gurukami/typ) **star:46** Null Types, Safe primitive type conversion and fetching value from complex structures.   [![godoc][D]](https://godoc.org/github.com/gurukami/typ)
- [null](https://github.com/emvi/null) **star:35** Nullable Go types that can be marshalled/unmarshalled to/from JSON.   [![godoc][D]](https://godoc.org/github.com/emvi/null)

### Queues

- [deque](https://github.com/gammazero/deque) **star:556** Fast ring-buffer deque (double-ended queue).   [![godoc][D]](https://godoc.org/github.com/gammazero/deque)
- [goconcurrentqueue](https://github.com/enriquebris/goconcurrentqueue) **star:381** Concurrent FIFO queue.   [![godoc][D]](https://godoc.org/github.com/enriquebris/goconcurrentqueue)
- [queue](https://github.com/adrianbrad/queue) **star:260** Multiple thread-safe, generic queue implementations for Go.   [![godoc][D]](https://godoc.org/github.com/adrianbrad/queue)
- [deque](https://github.com/edwingeng/deque) **star:178** A highly optimized double-ended queue.   [![godoc][D]](https://godoc.org/github.com/edwingeng/deque)
- [memlog](https://github.com/embano1/memlog) **star:115** An easy to use, lightweight, thread-safe and append-only in-memory data structure inspired by Apache Kafka.   [![There was an update last month][G]](https://github.com/embano1/memlog)   [![godoc][D]](https://godoc.org/github.com/embano1/memlog)

### Sets

- [golang-set](https://github.com/deckarep/golang-set) **star:4037** Thread-Safe and Non-Thread-Safe high-performance sets for Go.   [![There was an update last month][G]](https://github.com/deckarep/golang-set)   [![godoc][D]](https://godoc.org/github.com/deckarep/golang-set)
- [goset](https://github.com/zoumo/goset) **star:52** A useful Set collection implementation for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/zoumo/goset)   [![godoc][D]](https://godoc.org/github.com/zoumo/goset)
- [set](https://github.com/StudioSol/set) **star:26** Simple set data structure implementation in Go using LinkedHashMap.   [![godoc][D]](https://godoc.org/github.com/StudioSol/set)
- [dsu](https://github.com/ihebu/dsu) **star:14** Disjoint Set data structure implementation in Go.   [![godoc][D]](https://godoc.org/github.com/ihebu/dsu)

### Text Analysis

- [bleve](https://github.com/blevesearch/bleve) **star:9916** Modern text indexing library for go.   [![There was an update last month][G]](https://github.com/blevesearch/bleve)   [![godoc][D]](https://godoc.org/github.com/blevesearch/bleve)
- [trie](https://github.com/derekparker/trie) **star:747** Trie implementation in Go.   [![godoc][D]](https://godoc.org/github.com/derekparker/trie)
- [go-edlib](https://github.com/hbollon/go-edlib) **star:466** Go string comparison and edit distance algorithms library (Levenshtein, LCS, Hamming, Damerau levenshtein, Jaro-Winkler, etc.) compatible with Unicode.   [![godoc][D]](https://godoc.org/github.com/hbollon/go-edlib)
- [go-adaptive-radix-tree](https://github.com/plar/go-adaptive-radix-tree) **star:350** Go implementation of Adaptive Radix Tree.   [![godoc][D]](https://godoc.org/github.com/plar/go-adaptive-radix-tree)
- [levenshtein](https://github.com/agnivade/levenshtein) **star:337** Implementation to calculate levenshtein distance in Go.   [![godoc][D]](https://godoc.org/github.com/agnivade/levenshtein)
- [levenshtein](https://github.com/agext/levenshtein) **star:85** Levenshtein distance and similarity metrics with customizable edit costs and Winkler-like bonus for common prefix.   [![It hasn't been updated in recent three years][Y]](https://github.com/agext/levenshtein)   [![godoc][D]](https://godoc.org/github.com/agext/levenshtein)
- [ptrie](https://github.com/viant/ptrie) **star:39** An implementation of prefix tree.   [![godoc][D]](https://godoc.org/github.com/viant/ptrie)
- [mspm](https://github.com/BlackRabbitt/mspm) **star:25** Multi-String Pattern Matching Algorithm for information retrieval.   [![It hasn't been updated in recent three years][Y]](https://github.com/BlackRabbitt/mspm)   [![godoc][D]](https://godoc.org/github.com/BlackRabbitt/mspm)
- [parsefields](https://github.com/MonaxGT/parsefields) **star:8** Tools for parse JSON-like logs for collecting unique fields and events.   [![It hasn't been updated in recent three years][Y]](https://github.com/MonaxGT/parsefields)   [![godoc][D]](https://godoc.org/github.com/MonaxGT/parsefields)

### Trees

- [hashsplit](http://github.com/bobg/hashsplit)  Split byte streams into chunks, and arrange chunks into trees, with boundaries determined by content, not position.
- [skiplist](https://github.com/MauriceGit/skiplist) **star:276** Very fast Go Skiplist implementation.   [![godoc][D]](https://godoc.org/github.com/MauriceGit/skiplist)
- [skiplist](https://github.com/gansidui/skiplist) **star:84** Skiplist implementation in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/gansidui/skiplist)   [![godoc][D]](https://godoc.org/github.com/gansidui/skiplist)
- [treemap](https://github.com/igrmk/treemap) **star:58** Generic key-sorted map using a red-black tree under the hood.   [![godoc][D]](https://godoc.org/github.com/igrmk/treemap)
- [treap](https://github.com/perdata/treap) **star:27** Persistent, fast ordered map using tree heaps.   [![It hasn't been updated in recent three years][Y]](https://github.com/perdata/treap)   [![godoc][D]](https://godoc.org/github.com/perdata/treap)
- [merkle](https://github.com/bobg/merkle) **star:16** Space-efficient computation of Merkle root hashes and inclusion proofs.   [![godoc][D]](https://godoc.org/github.com/bobg/merkle)

### Pipes

- [pipeline](https://github.com/hyfather/pipeline) **star:56** An implementation of pipelines with fan-in and fan-out.   [![godoc][D]](https://godoc.org/github.com/hyfather/pipeline)
- [ordered-concurrently](https://github.com/tejzpr/ordered-concurrently) **star:37** Go module that processes work concurrently and returns output in a channel in the order of input.   [![godoc][D]](https://godoc.org/github.com/tejzpr/ordered-concurrently)
- [parapipe](https://github.com/nazar256/parapipe) **star:31** FIFO Pipeline which parallels execution on each stage while maintaining the order of messages and results.   [![It hasn't been updated in recent three years][Y]](https://github.com/nazar256/parapipe)   [![godoc][D]](https://godoc.org/github.com/nazar256/parapipe)

**[⬆ back to top](#contents)**

## Database

### Caches

_Data stores with expiring records, in-memory distributed data stores, or in-memory subsets of file-based databases._

- [BigCache](https://github.com/allegro/bigcache) **star:7403** Efficient key/value cache for gigabytes of data.   [![There was an update last month][G]](https://github.com/allegro/bigcache)   [![godoc][D]](https://godoc.org/github.com/allegro/bigcache)
- [GCache](https://github.com/bluele/gcache) **star:2565** Cache library with support for expirable Cache, LFU, LRU and ARC.   [![godoc][D]](https://godoc.org/github.com/bluele/gcache)
- [cache2go](https://github.com/muesli/cache2go) **star:2107** In-memory key:value cache which supports automatic invalidation based on timeouts.   [![godoc][D]](https://godoc.org/github.com/muesli/cache2go)
- [fastcache](https://github.com/VictoriaMetrics/fastcache) **star:2063** fast thread-safe inmemory cache for big number of entries. Minimizes GC overhead.   [![godoc][D]](https://godoc.org/github.com/VictoriaMetrics/fastcache)
- [cachego](https://github.com/faabiosr/cachego) **star:362** Golang Cache component for multiple drivers.   [![godoc][D]](https://godoc.org/github.com/faabiosr/cachego)
- [EchoVault](https://github.com/EchoVault/EchoVault) **star:313** Embeddable Distributed in-memory data store compatible with Redis clients.   [![godoc][D]](https://godoc.org/github.com/EchoVault/EchoVault)
- [cache](https://github.com/akyoto/cache) **star:182** In-memory key:value store with expiration time, 0 dependencies, <100 LoC, 100% coverage.   [![godoc][D]](https://godoc.org/github.com/akyoto/cache)
- [bcache](https://github.com/iwanbk/bcache) **star:150** Eventually consistent distributed in-memory cache Go library.   [![godoc][D]](https://godoc.org/github.com/iwanbk/bcache)
- [go-cache](https://github.com/viney-shih/go-cache) **star:137** A flexible multi-layer Go caching library to deal with in-memory and shared cache by adopting Cache-Aside pattern.   [![godoc][D]](https://godoc.org/github.com/viney-shih/go-cache)
- [couchcache](https://github.com/codingsince1985/couchcache) **star:63** RESTful caching micro-service backed by Couchbase server.   [![godoc][D]](https://godoc.org/github.com/codingsince1985/couchcache)
- [clusteredBigCache](https://github.com/oaStuff/clusteredBigCache) **star:44** BigCache with clustering support and individual item expiration.   [![It hasn't been updated in recent three years][Y]](https://github.com/oaStuff/clusteredBigCache)   [![godoc][D]](https://godoc.org/github.com/oaStuff/clusteredBigCache)
- [2q](https://github.com/floatdrop/2q) **star:39** 2Q in-memory cache implementation.   [![godoc][D]](https://godoc.org/github.com/floatdrop/2q)
- [gdcache](https://github.com/ulovecode/gdcache) **star:13** A pure non-intrusive cache library implemented by golang, you can use it to implement your own distributed cache.   [![godoc][D]](https://godoc.org/github.com/ulovecode/gdcache)   [![Contains Chinese documents][CN]](https://github.com/ulovecode/gdcache)
- [coherence-go-client](https://github.com/oracle/coherence-go-client) **star:9** Full implementation of Oracle Coherence cache API for Go applications using gRPC as network transport.   [![godoc][D]](https://godoc.org/github.com/oracle/coherence-go-client)
- [go-freelru](https://github.com/elastic/go-freelru) A GC-less, fast and generic LRU hashmap library with optional locking, sharding, eviction and expiration.
- [groupcache](https://github.com/golang/groupcache) **star:12859** Groupcache is a caching and cache-filling library, intended as a replacement for memcached in many cases.   [![godoc][D]](https://godoc.org/github.com/golang/groupcache)
- [gocache](https://github.com/eko/gocache) **star:2380** A complete Go cache library with multiple stores (memory, memcache, redis, ...), chainable, loadable, metrics cache and more.   [![godoc][D]](https://godoc.org/github.com/eko/gocache)
- [otter](https://github.com/maypok86/otter) **star:1604** A high performance lockless cache for Go. Many times faster than Ristretto and friends.   [![There was an update last month][G]](https://github.com/maypok86/otter)   [![godoc][D]](https://godoc.org/github.com/maypok86/otter)
- [ttlcache](https://github.com/jellydator/ttlcache) **star:898** An in-memory cache with item expiration and generics.   [![There was an update last month][G]](https://github.com/jellydator/ttlcache)   [![godoc][D]](https://godoc.org/github.com/jellydator/ttlcache)
- [sturdyc](https://github.com/creativecreature/sturdyc) **star:263** A caching library with advanced concurrency features designed to make I/O heavy applications robust and highly performant.   [![There was an update last month][G]](https://github.com/creativecreature/sturdyc)   [![godoc][D]](https://godoc.org/github.com/creativecreature/sturdyc)
- [theine](https://github.com/Yiling-J/theine-go) **star:243** High performance, near optimal in-memory cache with proactive TTL expiration and generics.   [![There was an update last month][G]](https://github.com/Yiling-J/theine-go)   [![godoc][D]](https://godoc.org/github.com/Yiling-J/theine-go)
- [remember-go](https://github.com/rocketlaunchr/remember-go) **star:139** A universal interface for caching slow database queries (backed by redis, memcached, ristretto, or in-memory).   [![It hasn't been updated in recent three years][Y]](https://github.com/rocketlaunchr/remember-go)   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/remember-go)
- [imcache](https://github.com/erni27/imcache) **star:119** A generic in-memory cache Go library. It supports expiration, sliding expiration, max entries limit, eviction callbacks and sharding.   [![godoc][D]](https://godoc.org/github.com/erni27/imcache)
- [go-mcache](https://github.com/OrlovEvgeny/go-mcache) **star:95** Fast in-memory key:value store/cache library. Pointer caches.   [![It hasn't been updated in recent three years][Y]](https://github.com/OrlovEvgeny/go-mcache)   [![godoc][D]](https://godoc.org/github.com/OrlovEvgeny/go-mcache)
- [timedmap](https://github.com/zekroTJA/timedmap) **star:70** Map with expiring key-value pairs.   [![godoc][D]](https://godoc.org/github.com/zekroTJA/timedmap)
- [icache](https://github.com/mdaliyan/icache) **star:15** A High Performance, Generic, thread-safe, zero-dependency cache package.   [![godoc][D]](https://godoc.org/github.com/mdaliyan/icache)
- [nscache](https://github.com/no-src/nscache) **star:10** A Go caching framework that supports multiple data source drivers.   [![godoc][D]](https://godoc.org/github.com/no-src/nscache)
- [ttlcache](https://github.com/cheshir/ttlcache) **star:9** In-memory key value storage with TTL for each record.   [![godoc][D]](https://godoc.org/github.com/cheshir/ttlcache)
- [gocache](https://github.com/yuseferi/gocache) **star:5** A data race free Go ache library with high performance and auto pruge functionality   [![godoc][D]](https://godoc.org/github.com/yuseferi/gocache)

### Databases Implemented in Go

- [prometheus](https://github.com/prometheus/prometheus) **star:54225** Monitoring system and time series database.   [![There was an update last month][G]](https://github.com/prometheus/prometheus)   [![godoc][D]](https://godoc.org/github.com/prometheus/prometheus)
- [tidb](https://github.com/pingcap/tidb) **star:36721** TiDB is a distributed SQL database. Inspired by the design of Google F1.   [![There was an update last month][G]](https://github.com/pingcap/tidb)   [![godoc][D]](https://godoc.org/github.com/pingcap/tidb)   [![Contains Chinese documents][CN]](https://github.com/pingcap/tidb)
- [cockroach](https://github.com/cockroachdb/cockroach) **star:29665** Scalable, Geo-Replicated, Transactional Datastore.   [![There was an update last month][G]](https://github.com/cockroachdb/cockroach)   [![godoc][D]](https://godoc.org/github.com/cockroachdb/cockroach)
- [Milvus](https://github.com/milvus-io/milvus) **star:28801** Milvus is a vector database for embedding management, analytics and search.   [![There was an update last month][G]](https://github.com/milvus-io/milvus)   [![godoc][D]](https://godoc.org/github.com/milvus-io/milvus)
- [influxdb](https://github.com/influxdb/influxdb) **star:28402** Scalable datastore for metrics, events, and real-time analytics.   [![There was an update last month][G]](https://github.com/influxdb/influxdb)
- [dgraph](https://github.com/dgraph-io/dgraph) **star:20251** Scalable, Distributed, Low Latency, High Throughput Graph Database.   [![There was an update last month][G]](https://github.com/dgraph-io/dgraph)   [![godoc][D]](https://godoc.org/github.com/dgraph-io/dgraph)
- [dolt](https://github.com/dolthub/dolt) **star:17486** Dolt – It's Git for Data.   [![There was an update last month][G]](https://github.com/dolthub/dolt)   [![godoc][D]](https://godoc.org/github.com/dolthub/dolt)
- [rqlite](https://github.com/rqlite/rqlite) **star:15420** The lightweight, distributed, relational database built on SQLite.   [![There was an update last month][G]](https://github.com/rqlite/rqlite)   [![godoc][D]](https://godoc.org/github.com/rqlite/rqlite)
- [badger](https://github.com/dgraph-io/badger) **star:13661** Fast key-value store in Go.   [![There was an update last month][G]](https://github.com/dgraph-io/badger)   [![godoc][D]](https://godoc.org/github.com/dgraph-io/badger)
- [VictoriaMetrics](https://github.com/VictoriaMetrics/VictoriaMetrics) **star:11639** fast, resource-effective and scalable open source time series database. May be used as long-term remote storage for Prometheus. Supports PromQL.   [![There was an update last month][G]](https://github.com/VictoriaMetrics/VictoriaMetrics)   [![godoc][D]](https://godoc.org/github.com/VictoriaMetrics/VictoriaMetrics)
- [immudb](https://github.com/codenotary/immudb) **star:8531** immudb is a lightweight, high-speed immutable database for systems and applications written in Go.   [![There was an update last month][G]](https://github.com/codenotary/immudb)   [![godoc][D]](https://godoc.org/github.com/codenotary/immudb)
- [bbolt](https://github.com/etcd-io/bbolt) **star:8015** An embedded key/value database for Go.   [![There was an update last month][G]](https://github.com/etcd-io/bbolt)   [![godoc][D]](https://godoc.org/github.com/etcd-io/bbolt)
- [Bitcask](https://git.mills.io/prologic/bitcask)  Bitcask is an embeddable, persistent and fast key-value (KV) database written in pure Go with predictable read/write performance, low latency and high throughput thanks to the bitcask on-disk layout (LSM+WAL).
- [goleveldb](https://github.com/syndtr/goleveldb) **star:6096** Implementation of the [LevelDB](https://github.com/google/leveldb) key/value database in Go.   [![godoc][D]](https://godoc.org/github.com/syndtr/goleveldb)
- [pebble](https://github.com/cockroachdb/pebble) **star:4698** RocksDB/LevelDB inspired key-value database in Go.   [![There was an update last month][G]](https://github.com/cockroachdb/pebble)   [![godoc][D]](https://godoc.org/github.com/cockroachdb/pebble)
- [rosedb](https://github.com/roseduan/rosedb) **star:4494** An embedded k-v database based on LSM+WAL, supports string, list, hash, set, zset.   [![godoc][D]](https://godoc.org/github.com/roseduan/rosedb)   [![Contains Chinese documents][CN]](https://github.com/roseduan/rosedb)
- [buntdb](https://github.com/tidwall/buntdb) **star:4480** Fast, embeddable, in-memory key/value database for Go with custom indexing and spatial support.   [![There was an update last month][G]](https://github.com/tidwall/buntdb)   [![godoc][D]](https://godoc.org/github.com/tidwall/buntdb)
- [ledisdb](https://github.com/siddontang/ledisdb) **star:4084** Ledisdb is a high performance NoSQL like Redis based on LevelDB.   [![godoc][D]](https://godoc.org/github.com/siddontang/ledisdb)
- [godis](https://github.com/hdt3213/godis) **star:3436** A Golang implemented high-performance Redis server and cluster.   [![godoc][D]](https://godoc.org/github.com/hdt3213/godis)   [![Contains Chinese documents][CN]](https://github.com/hdt3213/godis)
- [nutsdb](https://github.com/xujiajun/nutsdb) **star:3343** Nutsdb is a simple, fast, embeddable, persistent key/value store written in pure Go. It supports fully serializable transactions and many data structures such as list, set, sorted set.   [![godoc][D]](https://godoc.org/github.com/xujiajun/nutsdb)   [![Contains Chinese documents][CN]](https://github.com/xujiajun/nutsdb)
- [LinDB](https://github.com/lindb/lindb) **star:2968** LinDB is a scalable, high performance, high availability distributed time series database.   [![godoc][D]](https://godoc.org/github.com/lindb/lindb)   [![Contains Chinese documents][CN]](https://github.com/lindb/lindb)
- [tiedot](https://github.com/HouzuoGuo/tiedot) **star:2719** Your NoSQL database powered by Golang.   [![godoc][D]](https://godoc.org/github.com/HouzuoGuo/tiedot)
- [lotusdb](https://github.com/flower-corp/lotusdb) **star:2018** Fast k/v database compatible with lsm and b+tree.   [![godoc][D]](https://godoc.org/github.com/flower-corp/lotusdb)
- [CovenantSQL](https://github.com/CovenantSQL/CovenantSQL) **star:1490** CovenantSQL is a SQL database on blockchain.   [![godoc][D]](https://godoc.org/github.com/CovenantSQL/CovenantSQL)
- [column](https://github.com/kelindar/column) **star:1405** High-performance, columnar, embeddable in-memory store with bitmap indexing and transactions.   [![godoc][D]](https://godoc.org/github.com/kelindar/column)
- [diskv](https://github.com/peterbourgon/diskv) **star:1387** Home-grown disk-backed key-value store.   [![godoc][D]](https://godoc.org/github.com/peterbourgon/diskv)
- [pogreb](https://github.com/akrylysov/pogreb) **star:1274** Embedded key-value store for read-heavy workloads.   [![godoc][D]](https://godoc.org/github.com/akrylysov/pogreb)
- [Databunker](https://github.com/paranoidguy/databunker) **star:1235** Personally identifiable information (PII) storage service built to comply with GDPR and CCPA.   [![There was an update last month][G]](https://github.com/paranoidguy/databunker)   [![godoc][D]](https://godoc.org/github.com/paranoidguy/databunker)
- [objectbox-go](https://github.com/objectbox/objectbox-go) **star:1080** High-performance embedded Object Database (NoSQL) with Go API.   [![godoc][D]](https://godoc.org/github.com/objectbox/objectbox-go)
- [eliasdb](https://github.com/krotik/eliasdb) **star:995** Dependency-free, transactional graph database with REST API, phrase search and SQL-like query language.   [![godoc][D]](https://godoc.org/github.com/krotik/eliasdb)
- [moss](https://github.com/couchbase/moss) **star:951** Moss is a simple LSM key-value storage engine written in 100% Go.   [![godoc][D]](https://godoc.org/github.com/couchbase/moss)
- [clover](https://github.com/ostafen/clover) **star:642** A lightweight document-oriented NoSQL database written in pure Golang.   [![godoc][D]](https://godoc.org/github.com/ostafen/clover)
- [levigo](https://github.com/jmhodges/levigo) **star:414** Levigo is a Go wrapper for LevelDB.   [![godoc][D]](https://godoc.org/github.com/jmhodges/levigo)
- [pudge](https://github.com/recoilme/pudge) **star:367** Fast and simple key/value store written using Go's standard library.   [![It hasn't been updated in recent three years][Y]](https://github.com/recoilme/pudge)   [![godoc][D]](https://godoc.org/github.com/recoilme/pudge)
- [Vasto](https://github.com/chrislusf/vasto) **star:259** A distributed high-performance key-value store. On Disk. Eventual consistent. HA. Able to grow or shrink without service interruption.   [![It hasn't been updated in recent three years][Y]](https://github.com/chrislusf/vasto)   [![godoc][D]](https://godoc.org/github.com/chrislusf/vasto)
- [dtf](https://github.com/dtm-labs/dtf) **star:212** A distributed transaction manager. Support XA, TCC, SAGA, Reliable Messages.   [![godoc][D]](https://godoc.org/github.com/dtm-labs/dtf)   [![Contains Chinese documents][CN]](https://github.com/dtm-labs/dtf)   [![Archived][Archived]](https://github.com/dtm-labs/dtf)
- [piladb](https://github.com/fern4lvarez/piladb) **star:205** Lightweight RESTful database engine based on stack data structures.   [![It hasn't been updated in recent three years][Y]](https://github.com/fern4lvarez/piladb)   [![godoc][D]](https://godoc.org/github.com/fern4lvarez/piladb)
- [libradb](https://github.com/amit-davidson/LibraDB) **star:160** LibraDB is a simple database with less than 1000 lines of code for learning.   [![godoc][D]](https://godoc.org/github.com/amit-davidson/LibraDB)
- [unitdb](https://github.com/unit-io/unitdb) **star:118** Fast timeseries database for IoT, realtime messaging applications. Access unitdb with pubsub over tcp or websocket using github.com/unit-io/unitd application.   [![godoc][D]](https://godoc.org/github.com/unit-io/unitdb)
- [hare](https://github.com/jameycribbs/hare) **star:91** A simple database management system that stores each table as a text file of line-delimited JSON.   [![It hasn't been updated in recent three years][Y]](https://github.com/jameycribbs/hare)   [![godoc][D]](https://godoc.org/github.com/jameycribbs/hare)
- [regatta](https://github.com/jamf/regatta) **star:65** Fast, simple, geo-distributed KV store built for cloud native era.   [![There was an update last month][G]](https://github.com/jamf/regatta)   [![godoc][D]](https://godoc.org/github.com/jamf/regatta)
- [Coffer](https://github.com/claygod/coffer) **star:38** Simple ACID key-value database that supports transactions.   [![godoc][D]](https://godoc.org/github.com/claygod/coffer)
- [rotom](https://github.com/xgzlucario/rotom) **star:32** A tiny Redis server built with Golang, compatible with RESP protocols.   [![There was an update last month][G]](https://github.com/xgzlucario/rotom)   [![godoc][D]](https://godoc.org/github.com/xgzlucario/rotom)
- [tempdb](https://github.com/rafaeljesus/tempdb) **star:19** Key-value store for temporary items.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafaeljesus/tempdb)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/tempdb)

### Database Schema Migration

- [migrate](https://github.com/golang-migrate/migrate) **star:14756** Database migrations. CLI and Golang library.   [![There was an update last month][G]](https://github.com/golang-migrate/migrate)   [![godoc][D]](https://godoc.org/github.com/golang-migrate/migrate)
- [bytebase](https://github.com/bytebase/bytebase) **star:10767** Safe database schema change and version control for DevOps teams.   [![There was an update last month][G]](https://github.com/bytebase/bytebase)   [![godoc][D]](https://godoc.org/github.com/bytebase/bytebase)
- [goose](https://github.com/pressly/goose) **star:6384** Database migration tool. You can manage your database's evolution by creating incremental SQL or Go scripts.   [![There was an update last month][G]](https://github.com/pressly/goose)   [![godoc][D]](https://godoc.org/github.com/pressly/goose)
- [atlas](https://github.com/ariga/atlas) **star:5546** A Database Toolkit. A CLI designed to help companies better work with their data.   [![There was an update last month][G]](https://github.com/ariga/atlas)   [![godoc][D]](https://godoc.org/github.com/ariga/atlas)
- [dbmate](https://github.com/amacneil/dbmate) **star:5056** A lightweight, framework-agnostic database migration tool.   [![godoc][D]](https://godoc.org/github.com/amacneil/dbmate)
- [sql-migrate](https://github.com/rubenv/sql-migrate) **star:3166** Database migration tool. Allows embedding migrations into the application using go-bindata.   [![godoc][D]](https://godoc.org/github.com/rubenv/sql-migrate)
- [skeema](https://github.com/skeema/skeema) **star:1255** Pure-SQL schema management system for MySQL, with support for sharding and external online schema change tools.   [![There was an update last month][G]](https://github.com/skeema/skeema)   [![godoc][D]](https://godoc.org/github.com/skeema/skeema)
- [soda](https://github.com/gobuffalo/pop/tree/master/soda)  Database migration, creation, ORM, etc... for MySQL, PostgreSQL, and SQLite.
- [gormigrate](https://github.com/go-gormigrate/gormigrate) **star:1022** Database schema migration helper for Gorm ORM.   [![godoc][D]](https://godoc.org/github.com/go-gormigrate/gormigrate)
- [goavro](https://github.com/linkedin/goavro) **star:967** A Go package that encodes and decodes Avro data.   [![godoc][D]](https://godoc.org/github.com/linkedin/goavro)
- [migrator](https://github.com/lopezator/migrator) **star:168** Dead simple Go database migration library.   [![godoc][D]](https://godoc.org/github.com/lopezator/migrator)
- [darwin](https://github.com/GuiaBolso/darwin) **star:145** Database schema evolution library for Go.   [![godoc][D]](https://godoc.org/github.com/GuiaBolso/darwin)
- [sqlize](https://github.com/sunary/sqlize) **star:93** Database migration generator. Allows generate sql migration from model and existing sql by differ them.   [![godoc][D]](https://godoc.org/github.com/sunary/sqlize)
- [go-pg-migrations](https://github.com/robinjoseph08/go-pg-migrations) **star:84** A Go package to help write migrations with go-pg/pg.   [![godoc][D]](https://godoc.org/github.com/robinjoseph08/go-pg-migrations)
- [avro](https://github.com/khezen/avro) **star:45** Discover SQL schemas and convert them to AVRO schemas. Query SQL records into AVRO bytes.   [![godoc][D]](https://godoc.org/github.com/khezen/avro)
- [schema](https://github.com/adlio/schema) **star:31** Library to embed schema migrations for database/sql-compatible databases inside your Go binaries.   [![godoc][D]](https://godoc.org/github.com/adlio/schema)
- [go-fixtures](https://github.com/RichardKnop/go-fixtures) **star:29** Django style fixtures for Golang's excellent built-in database/sql library.   [![It hasn't been updated in recent three years][Y]](https://github.com/RichardKnop/go-fixtures)   [![godoc][D]](https://godoc.org/github.com/RichardKnop/go-fixtures)
- [migrator](https://github.com/larapulse/migrator) **star:25** MySQL database migrator designed to run migrations to your features and manage database schema update with intuitive go code.   [![godoc][D]](https://godoc.org/github.com/larapulse/migrator)
- [libschema](https://github.com/muir/libschema) **star:14** Define your migrations separately in each library. Migrations for open source libraries. MySQL & PostgreSQL.   [![There was an update last month][G]](https://github.com/muir/libschema)   [![godoc][D]](https://godoc.org/github.com/muir/libschema)
- [gorm-seeder](https://github.com/Kachit/gorm-seeder) **star:13** Simple database seeder for Gorm ORM.   [![godoc][D]](https://godoc.org/github.com/Kachit/gorm-seeder)
- [go-pg-migrate](https://github.com/lawzava/go-pg-migrate) **star:10** CLI-friendly package for go-pg migrations management.   [![godoc][D]](https://godoc.org/github.com/lawzava/go-pg-migrate)
- [godfish](https://github.com/rafaelespinoza/godfish) **star:7** Database migration manager, works with native query language. Support for cassandra, mysql, postgres, sqlite3.   [![godoc][D]](https://godoc.org/github.com/rafaelespinoza/godfish)

### Database Tools

- [vitess](https://github.com/youtube/vitess) **star:18295** vitess provides servers and tools which facilitate scaling of MySQL databases for large scale web services.   [![There was an update last month][G]](https://github.com/youtube/vitess)   [![godoc][D]](https://godoc.org/github.com/youtube/vitess)
- [pgweb](https://github.com/sosedoff/pgweb) **star:8513** Web-based PostgreSQL database browser.   [![godoc][D]](https://godoc.org/github.com/sosedoff/pgweb)
- [go-mysql](https://github.com/siddontang/go-mysql) **star:4537** Go toolset to handle MySQL protocol and replication.   [![There was an update last month][G]](https://github.com/siddontang/go-mysql)   [![godoc][D]](https://godoc.org/github.com/siddontang/go-mysql)
- [pREST](https://github.com/prest/prest) **star:4169** Simplify and accelerate development, ⚡ instant, realtime, high-performance on any Postgres application, existing or new.   [![godoc][D]](https://godoc.org/github.com/prest/prest)
- [chproxy](https://github.com/Vertamedia/chproxy) **star:1252** HTTP proxy for ClickHouse database.   [![There was an update last month][G]](https://github.com/Vertamedia/chproxy)   [![godoc][D]](https://godoc.org/github.com/Vertamedia/chproxy)
- [pg_timetable](https://github.com/cybertec-postgresql/pg_timetable) **star:1064** Advanced scheduling for PostgreSQL.   [![There was an update last month][G]](https://github.com/cybertec-postgresql/pg_timetable)   [![godoc][D]](https://godoc.org/github.com/cybertec-postgresql/pg_timetable)
- [clickhouse-bulk](https://github.com/nikepan/clickhouse-bulk) **star:471** Collects small inserts and sends big requests to ClickHouse servers.   [![godoc][D]](https://godoc.org/github.com/nikepan/clickhouse-bulk)
- [rdb](https://github.com/HDT3213/rdb) **star:367** Redis RDB file parser for secondary development and memory analysis.   [![godoc][D]](https://godoc.org/github.com/HDT3213/rdb)
- [wescale](https://github.com/wesql/wescale) **star:196** WeScale is a database proxy designed to enhance the scalability, performance, security, and resilience of your applications.   [![There was an update last month][G]](https://github.com/wesql/wescale)   [![godoc][D]](https://godoc.org/github.com/wesql/wescale)
- [octillery](https://github.com/knocknote/octillery) **star:191** Go package for sharding databases ( Supports every ORM or raw SQL ).   [![godoc][D]](https://godoc.org/github.com/knocknote/octillery)
- [dbbench](https://github.com/sj14/dbbench) **star:98** Database benchmarking tool with support for several databases and scripts.   [![There was an update last month][G]](https://github.com/sj14/dbbench)   [![godoc][D]](https://godoc.org/github.com/sj14/dbbench)
- [onedump](https://github.com/liweiyi88/onedump) **star:77** Database backup from different drivers to different destinations with one command and configuration.   [![There was an update last month][G]](https://github.com/liweiyi88/onedump)   [![godoc][D]](https://godoc.org/github.com/liweiyi88/onedump)
- [prep](https://github.com/hexdigest/prep) **star:32** Use prepared SQL statements without changing your code.   [![It hasn't been updated in recent three years][Y]](https://github.com/hexdigest/prep)   [![godoc][D]](https://godoc.org/github.com/hexdigest/prep)
- [dg](https://github.com/codingconcepts/dg) **star:27** A fast data generator that produces CSV files from generated relational data.   [![godoc][D]](https://godoc.org/github.com/codingconcepts/dg)
- [gorm-multitenancy](https://github.com/bartventer/gorm-multitenancy) **star:27** Multi-tenancy support for GORM managed databases.   [![There was an update last month][G]](https://github.com/bartventer/gorm-multitenancy)   [![godoc][D]](https://godoc.org/github.com/bartventer/gorm-multitenancy)
- [hasql](https://golang.yandex/hasql)  Library for accessing multi-host SQL database installations.
- [rwdb](https://github.com/andizzle/rwdb) **star:19** rwdb provides read replica capability for multiple database servers setup.   [![It hasn't been updated in recent three years][Y]](https://github.com/andizzle/rwdb)   [![godoc][D]](https://godoc.org/github.com/andizzle/rwdb)
- [dynago](https://github.com/twharmon/dynago) **star:12** Simplify working with AWS DynamoDB.   [![godoc][D]](https://godoc.org/github.com/twharmon/dynago)

### SQL Query Builders

_Libraries for building and using SQL._

- [sqlc](https://github.com/kyleconroy/sqlc) **star:11864** Generate type-safe code from SQL.   [![There was an update last month][G]](https://github.com/kyleconroy/sqlc)   [![godoc][D]](https://godoc.org/github.com/kyleconroy/sqlc)
- [Squirrel](https://github.com/Masterminds/squirrel) **star:6750** Go library that helps you build SQL queries.   [![godoc][D]](https://godoc.org/github.com/Masterminds/squirrel)
- [xo](https://github.com/knq/xo) **star:3682** Generate idiomatic Go code for databases based on existing schema definitions or custom queries supporting PostgreSQL, MySQL, SQLite, Oracle, and Microsoft SQL Server.   [![godoc][D]](https://godoc.org/github.com/knq/xo)
- [goqu](https://github.com/doug-martin/goqu) **star:2333** Idiomatic SQL builder and query library.   [![godoc][D]](https://godoc.org/github.com/doug-martin/goqu)
- [jet](https://github.com/go-jet/jet) **star:2303** Framework for writing type-safe SQL queries in Go, with ability to easily convert database query result into desired arbitrary object structure.   [![godoc][D]](https://godoc.org/github.com/go-jet/jet)
- [gendry](https://github.com/didi/gendry) **star:1607** Non-invasive SQL builder and powerful data binder.   [![godoc][D]](https://godoc.org/github.com/didi/gendry)   [![Contains Chinese documents][CN]](https://github.com/didi/gendry)
- [Dotsql](https://github.com/gchaincl/dotsql) **star:731** Go library that helps you keep sql files in one place and use them with ease.   [![godoc][D]](https://godoc.org/github.com/gchaincl/dotsql)
- [ozzo-dbx](https://github.com/go-ozzo/ozzo-dbx) **star:632** Powerful data retrieval methods as well as DB-agnostic query building capabilities.   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-dbx)
- [dbq](https://github.com/rocketlaunchr/dbq) **star:402** Zero boilerplate database operations for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/rocketlaunchr/dbq)   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/dbq)
- [sqlingo](https://github.com/lqs/sqlingo) **star:392** A lightweight DSL to build SQL in Go.   [![godoc][D]](https://godoc.org/github.com/lqs/sqlingo)
- [sqrl](https://github.com/elgris/sqrl) **star:274** SQL query builder, fork of Squirrel with improved performance.   [![godoc][D]](https://godoc.org/github.com/elgris/sqrl)
- [Squalus](https://gitlab.com/qosenergy/squalus)  Thin layer over the Go SQL package that makes it easier to perform queries.
- [sq](https://github.com/bokwoon95/go-structured-query) **star:197** Type-safe SQL builder and struct mapper for Go.   [![godoc][D]](https://godoc.org/github.com/bokwoon95/go-structured-query)
- [buildsqlx](https://github.com/arthurkushman/buildsqlx) **star:163** Go database query builder library for PostgreSQL.   [![godoc][D]](https://godoc.org/github.com/arthurkushman/buildsqlx)
- [sqlf](https://github.com/leporo/sqlf) **star:141** Fast SQL query builder.   [![godoc][D]](https://godoc.org/github.com/leporo/sqlf)
- [bqb](https://github.com/nullism/bqb) **star:140** Lightweight and easy to learn query builder.   [![godoc][D]](https://godoc.org/github.com/nullism/bqb)
- [igor](https://github.com/galeone/igor) **star:125** Abstraction layer for PostgreSQL that supports advanced functionality and uses gorm-like syntax.   [![godoc][D]](https://godoc.org/github.com/galeone/igor)
- [builq](https://github.com/cristalhq/builq) **star:89** Easily build SQL queries in Go.   [![godoc][D]](https://godoc.org/github.com/cristalhq/builq)
- [godbal](https://github.com/xujiajun/godbal) **star:59** Database Abstraction Layer (dbal) for go. Support SQL builder and get result easily.   [![It hasn't been updated in recent three years][Y]](https://github.com/xujiajun/godbal)   [![godoc][D]](https://godoc.org/github.com/xujiajun/godbal)
- [qry](https://github.com/HnH/qry) **star:35** Tool that generates constants from files with raw SQL queries.   [![godoc][D]](https://godoc.org/github.com/HnH/qry)
- [gosql](https://github.com/twharmon/gosql) **star:30** SQL Query builder with better null values support.   [![godoc][D]](https://godoc.org/github.com/twharmon/gosql)
- [Hotcoal](https://github.com/motrboat/hotcoal) **star:18** Secure your handcrafted SQL against injection.   [![godoc][D]](https://godoc.org/github.com/motrboat/hotcoal)
- [ormlite](https://github.com/pupizoid/ormlite) **star:13** Lightweight package containing some ORM-like features and helpers for sqlite databases.   [![godoc][D]](https://godoc.org/github.com/pupizoid/ormlite)
- [sg](https://github.com/go-the-way/sg) **star:6** A SQL Gen for generating standard SQLs(supports: CRUD) written in Go.   [![godoc][D]](https://godoc.org/github.com/go-the-way/sg)

**[⬆ back to top](#contents)**

## Database Drivers

### Interfaces to Multiple Backends

- [cayley](https://github.com/google/cayley) **star:14813** Graph database with support for multiple backends.   [![godoc][D]](https://godoc.org/github.com/google/cayley)
- [gokv](https://github.com/philippgille/gokv) **star:716** Simple key-value store abstraction and implementations for Go (Redis, Consul, etcd, bbolt, BadgerDB, LevelDB, Memcached, DynamoDB, S3, PostgreSQL, MongoDB, CockroachDB and many more).   [![godoc][D]](https://godoc.org/github.com/philippgille/gokv)
- [go-transaction-manager](https://github.com/avito-tech/go-transaction-manager) **star:209** Transaction manager with multiple adapters (sql, sqlx, gorm, mongo, ...) controls transaction boundaries.   [![godoc][D]](https://godoc.org/github.com/avito-tech/go-transaction-manager)
- [dsc](https://github.com/viant/dsc) **star:32** Datastore connectivity for SQL, NoSQL, structured files.   [![godoc][D]](https://godoc.org/github.com/viant/dsc)
- [dynamo](https://github.com/fogfish/dynamo) **star:18** A simple key-value abstraction to store algebraic and linked-data data types at AWS storage services: AWS DynamoDB and AWS S3.   [![godoc][D]](https://godoc.org/github.com/fogfish/dynamo)

### Relational Database Drivers

- [go-sql-driver/mysql](https://github.com/go-sql-driver/mysql) **star:14390** MySQL driver for Go.   [![There was an update last month][G]](https://github.com/go-sql-driver/mysql)   [![godoc][D]](https://godoc.org/github.com/go-sql-driver/mysql)
- [pgx](https://github.com/jackc/pgx) **star:10128** PostgreSQL driver supporting features beyond those exposed by database/sql.   [![There was an update last month][G]](https://github.com/jackc/pgx)   [![godoc][D]](https://godoc.org/github.com/jackc/pgx)
- [pq](https://github.com/lib/pq) **star:8950** Pure Go Postgres driver for database/sql.   [![godoc][D]](https://godoc.org/github.com/lib/pq)
- [go-sqlite3](https://github.com/mattn/go-sqlite3) **star:7759** SQLite3 driver for go that uses database/sql.   [![There was an update last month][G]](https://github.com/mattn/go-sqlite3)
- [go-mssqldb](https://github.com/denisenkom/go-mssqldb) **star:1813** Microsoft MSSQL driver for Go.   [![godoc][D]](https://godoc.org/github.com/denisenkom/go-mssqldb)
- [sqlhooks](https://github.com/qustavo/sqlhooks) **star:648** Attach hooks to any database/sql driver.   [![godoc][D]](https://godoc.org/github.com/qustavo/sqlhooks)
- [go-oci8](https://github.com/mattn/go-oci8) **star:628** Oracle driver for go that uses database/sql.   [![godoc][D]](https://godoc.org/github.com/mattn/go-oci8)
- [godror](https://github.com/godror/godror) **star:518** Oracle driver for Go, using the ODPI-C driver.
- [Sqinn-Go](https://github.com/cvilsmeier/sqinn-go) **star:414** SQLite with pure Go.   [![godoc][D]](https://godoc.org/github.com/cvilsmeier/sqinn-go)
- [KSQL](https://github.com/VinGarcia/ksql) **star:296** A Simple and Powerful Golang SQL Library   [![godoc][D]](https://godoc.org/github.com/VinGarcia/ksql)
- [surrealdb.go](https://github.com/surrealdb/surrealdb.go) **star:227** SurrealDB Driver for Go.   [![godoc][D]](https://godoc.org/github.com/surrealdb/surrealdb.go)
- [firebirdsql](https://github.com/nakagami/firebirdsql) **star:222** Firebird RDBMS SQL driver for Go.   [![godoc][D]](https://godoc.org/github.com/nakagami/firebirdsql)
- [go-adodb](https://github.com/mattn/go-adodb) **star:141** Microsoft ActiveX Object DataBase driver for go that uses database/sql.   [![godoc][D]](https://godoc.org/github.com/mattn/go-adodb)
- [ydb-go-sdk](https://github.com/ydb-platform/ydb-go-sdk) **star:134** native and database/sql driver YDB (Yandex Database)   [![There was an update last month][G]](https://github.com/ydb-platform/ydb-go-sdk)   [![godoc][D]](https://godoc.org/github.com/ydb-platform/ydb-go-sdk)
- [avatica](https://github.com/apache/calcite-avatica-go) **star:116** Apache Avatica/Phoenix SQL driver for database/sql.   [![godoc][D]](https://godoc.org/github.com/apache/calcite-avatica-go)
- [gofreetds](https://github.com/minus5/gofreetds) **star:112** Microsoft MSSQL driver. Go wrapper over [FreeTDS](https://www.freetds.org).   [![It hasn't been updated in recent three years][Y]](https://github.com/minus5/gofreetds)   [![godoc][D]](https://godoc.org/github.com/minus5/gofreetds)
- [bgc](https://github.com/viant/bgc) **star:22** Datastore Connectivity for BigQuery for go.   [![godoc][D]](https://godoc.org/github.com/viant/bgc)
- [pig](https://github.com/alexeyco/pig) **star:16** Simple [pgx](https://github.com/jackc/pgx) wrapper to execute and [scan](https://github.com/georgysavva/scany) query results easily.   [![It hasn't been updated in recent three years][Y]](https://github.com/alexeyco/pig)   [![godoc][D]](https://godoc.org/github.com/alexeyco/pig)

### NoSQL Database Drivers

- [redis](https://github.com/redis/go-redis) **star:19749** Redis client for Golang.   [![There was an update last month][G]](https://github.com/redis/go-redis)   [![godoc][D]](https://godoc.org/github.com/redis/go-redis)   [![Contains Chinese documents][CN]](https://github.com/redis/go-redis)
- [rueidis](http://github.com/rueian/rueidis)  Fast Redis RESP3 client with auto pipelining and server-assisted client side caching.
- [redigo](https://github.com/gomodule/redigo) **star:9737** Redigo is a Go client for the Redis database.   [![godoc][D]](https://godoc.org/github.com/gomodule/redigo)
- [mongo-go-driver](https://github.com/mongodb/mongo-go-driver) **star:8054** Official MongoDB driver for the Go language.   [![There was an update last month][G]](https://github.com/mongodb/mongo-go-driver)   [![godoc][D]](https://godoc.org/github.com/mongodb/mongo-go-driver)
- [mgo](https://github.com/globalsign/mgo) **star:1966** (unmaintained) MongoDB driver for the Go language that implements a rich and well tested selection of features under a very simple API following standard Go idioms.   [![godoc][D]](https://godoc.org/github.com/globalsign/mgo)
- [gorethink](https://github.com/dancannon/gorethink) **star:1647** Go language driver for RethinkDB.   [![godoc][D]](https://godoc.org/github.com/dancannon/gorethink)
- [qmgo](https://github.com/qiniu/qmgo) **star:1292** The MongoDB driver for Go. It‘s based on official MongoDB driver but easier to use like Mgo.   [![godoc][D]](https://godoc.org/github.com/qiniu/qmgo)   [![Contains Chinese documents][CN]](https://github.com/qiniu/qmgo)
- [mgm](https://github.com/kamva/mgm) **star:743** MongoDB model-based ODM for Go (based on official MongoDB driver).   [![godoc][D]](https://godoc.org/github.com/kamva/mgm)
- [redeo](https://github.com/bsm/redeo) **star:436** Redis-protocol compatible TCP servers/services.   [![godoc][D]](https://godoc.org/github.com/bsm/redeo)
- [aerospike-client-go](https://github.com/aerospike/aerospike-client-go) **star:430** Aerospike client in Go language.   [![godoc][D]](https://godoc.org/github.com/aerospike/aerospike-client-go)
- [neoism](https://github.com/jmcvetta/neoism) **star:390** Neo4j client for Golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/jmcvetta/neoism)   [![godoc][D]](https://godoc.org/github.com/jmcvetta/neoism)
- [gocb](https://github.com/couchbase/gocb) **star:363** Official Couchbase Go SDK.   [![There was an update last month][G]](https://github.com/couchbase/gocb)   [![godoc][D]](https://godoc.org/github.com/couchbase/gocb)
- [go-rejson](https://github.com/nitishm/go-rejson) **star:342** Golang client for redislabs' ReJSON module using Redigo golang client. Store and manipulate structs as JSON objects in redis with ease.   [![godoc][D]](https://godoc.org/github.com/nitishm/go-rejson)
- [go-couchbase](https://github.com/couchbase/go-couchbase) **star:321** Couchbase client in Go.   [![godoc][D]](https://godoc.org/github.com/couchbase/go-couchbase)
- [Kivik](https://github.com/go-kivik/kivik) **star:310** Kivik provides a common Go and GopherJS client library for CouchDB, PouchDB, and similar databases.   [![godoc][D]](https://godoc.org/github.com/go-kivik/kivik)
- [godis](https://github.com/piaohao/godis) **star:111** redis client implement by golang, inspired by jedis.   [![It hasn't been updated in recent three years][Y]](https://github.com/piaohao/godis)   [![godoc][D]](https://godoc.org/github.com/piaohao/godis)
- [go-mongox](https://github.com/chenmingyong0423/go-mongox) **star:106** A Go Mongo library based on the official driver, featuring streamlined document operations, generic binding of structs to collections, built-in CRUD, aggregation, automated field updates, struct validation, hooks, and plugin-based programming.   [![godoc][D]](https://godoc.org/github.com/chenmingyong0423/go-mongox)   [![Contains Chinese documents][CN]](https://github.com/chenmingyong0423/go-mongox)
- [Neo4j-GO](https://github.com/davemeehan/Neo4j-GO) **star:78** Neo4j REST Client in golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/davemeehan/Neo4j-GO)   [![godoc][D]](https://godoc.org/github.com/davemeehan/Neo4j-GO)   [![Archived][Archived]](https://github.com/davemeehan/Neo4j-GO)
- [arangolite](https://github.com/solher/arangolite) **star:73** Lightweight golang driver for ArangoDB.   [![It hasn't been updated in recent three years][Y]](https://github.com/solher/arangolite)   [![godoc][D]](https://godoc.org/github.com/solher/arangolite)
- [go-pilosa](https://github.com/pilosa/go-pilosa) **star:58** Go client library for Pilosa.   [![godoc][D]](https://godoc.org/github.com/pilosa/go-pilosa)   [![Archived][Archived]](https://github.com/pilosa/go-pilosa)
- [forestdb](https://github.com/couchbase/goforestdb) **star:37** Go bindings for ForestDB.   [![It hasn't been updated in recent three years][Y]](https://github.com/couchbase/goforestdb)   [![godoc][D]](https://godoc.org/github.com/couchbase/goforestdb)
- [goriak](https://github.com/zegl/goriak) **star:30** Go language driver for Riak KV.   [![godoc][D]](https://godoc.org/github.com/zegl/goriak)
- [neo4j](https://github.com/cihangir/neo4j) **star:28** Neo4j Rest API Bindings for Golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/cihangir/neo4j)   [![godoc][D]](https://godoc.org/github.com/cihangir/neo4j)
- [gocosmos](https://github.com/btnguyen2k/gocosmos) **star:22** REST client and standard `database/sql` driver for Azure Cosmos DB.   [![godoc][D]](https://godoc.org/github.com/btnguyen2k/gocosmos)
- [gocql](https://gocql.github.io)  Go language driver for Apache Cassandra.
- [gomemcached](https://github.com/aliexpressru/gomemcached) **star:19** A binary Memcached client for Go with support for sharding using consistent hashing, along with SASL.   [![godoc][D]](https://godoc.org/github.com/aliexpressru/gomemcached)
- [xredis](https://github.com/shomali11/xredis) **star:19** Typesafe, customizable, clean & easy to use Redis client.   [![It hasn't been updated in recent three years][Y]](https://github.com/shomali11/xredis)   [![godoc][D]](https://godoc.org/github.com/shomali11/xredis)
- [godscache](https://github.com/defcronyke/godscache) **star:11** A wrapper for the Google Cloud Platform Go Datastore package that adds caching using memcached.   [![It hasn't been updated in recent three years][Y]](https://github.com/defcronyke/godscache)   [![godoc][D]](https://godoc.org/github.com/defcronyke/godscache)
- [gomemcache](https://github.com/bradfitz/gomemcache/)  memcache client library for the Go programming language.
- [asc](https://github.com/viant/asc) **star:10** Datastore Connectivity for Aerospike for go.   [![There was an update last month][G]](https://github.com/viant/asc)   [![godoc][D]](https://godoc.org/github.com/viant/asc)

### Search and Analytic Databases

- [elastic](https://github.com/olivere/elastic) **star:7357** Elasticsearch client for Go.   [![There was an update last month][G]](https://github.com/olivere/elastic)   [![godoc][D]](https://godoc.org/github.com/olivere/elastic)
- [go-elasticsearch](https://github.com/elastic/go-elasticsearch) **star:5598** Official Elasticsearch client for Go.   [![There was an update last month][G]](https://github.com/elastic/go-elasticsearch)   [![godoc][D]](https://godoc.org/github.com/elastic/go-elasticsearch)
- [elasticsql](https://github.com/cch123/elasticsql) **star:1157** Convert sql to elasticsearch dsl in Go.   [![godoc][D]](https://godoc.org/github.com/cch123/elasticsql)
- [elastigo](https://github.com/mattbaird/elastigo) **star:945** Elasticsearch client library.   [![It hasn't been updated in recent three years][Y]](https://github.com/mattbaird/elastigo)   [![godoc][D]](https://godoc.org/github.com/mattbaird/elastigo)
- [skizze](https://github.com/seiflotfy/skizze) **star:88** probabilistic data-structures service and storage.   [![It hasn't been updated in recent three years][Y]](https://github.com/seiflotfy/skizze)   [![godoc][D]](https://godoc.org/github.com/seiflotfy/skizze)
- [goes](https://github.com/OwnLocal/goes) **star:31** Library to interact with Elasticsearch.   [![It hasn't been updated in recent three years][Y]](https://github.com/OwnLocal/goes)   [![godoc][D]](https://godoc.org/github.com/OwnLocal/goes)
- [clickhouse-go](https://github.com/ClickHouse/clickhouse-go/)  ClickHouse SQL client for Go with a `database/sql` compatibility.

**[⬆ back to top](#contents)**

## Date and Time

_Libraries for working with dates and times._

- [carbon](https://github.com/golang-module/carbon) **star:4641** A simple, semantic and developer-friendly golang package for datetime.   [![godoc][D]](https://godoc.org/github.com/golang-module/carbon)
- [now](https://github.com/jinzhu/now) **star:4416** Now is a time toolkit for golang.   [![godoc][D]](https://godoc.org/github.com/jinzhu/now)
- [dateparse](https://github.com/araddon/dateparse) **star:2022** Parse date's without knowing format in advance.   [![godoc][D]](https://godoc.org/github.com/araddon/dateparse)
- [carbon](https://github.com/uniplaces/carbon) **star:774** Simple Time extension with a lot of util methods, ported from PHP Carbon library.   [![godoc][D]](https://godoc.org/github.com/uniplaces/carbon)
- [durafmt](https://github.com/hako/durafmt) **star:493** Time duration formatting library for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/hako/durafmt)   [![godoc][D]](https://godoc.org/github.com/hako/durafmt)
- [gostradamus](https://github.com/bykof/gostradamus) **star:201** A Go package for working with dates.   [![godoc][D]](https://godoc.org/github.com/bykof/gostradamus)
- [go-persian-calendar](https://github.com/yaa110/go-persian-calendar) **star:200** The implementation of the Persian (Solar Hijri) Calendar in Go (golang).   [![godoc][D]](https://godoc.org/github.com/yaa110/go-persian-calendar)
- [timeutil](https://github.com/leekchan/timeutil) **star:192** Useful extensions (Timedelta, Strftime, ...) to the golang's time package.   [![It hasn't been updated in recent three years][Y]](https://github.com/leekchan/timeutil)   [![godoc][D]](https://godoc.org/github.com/leekchan/timeutil)
- [go-sunrise](https://github.com/nathan-osman/go-sunrise) **star:142** Calculate the sunrise and sunset times for a given location.   [![godoc][D]](https://godoc.org/github.com/nathan-osman/go-sunrise)
- [iso8601](https://github.com/relvacode/iso8601) **star:141** Efficiently parse ISO8601 date-times without regex.   [![godoc][D]](https://godoc.org/github.com/relvacode/iso8601)
- [date](https://github.com/rickb777/date) **star:130** Augments Time for working with dates, date ranges, time spans, periods, and time-of-day.   [![godoc][D]](https://godoc.org/github.com/rickb777/date)
- [go-str2duration](https://github.com/xhit/go-str2duration) **star:100** Convert string to duration. Support time.Duration returned string and more.   [![godoc][D]](https://godoc.org/github.com/xhit/go-str2duration)
- [timespan](https://github.com/SaidinWoT/timespan) **star:83** For interacting with intervals of time, defined as a start time and a duration.   [![It hasn't been updated in recent three years][Y]](https://github.com/SaidinWoT/timespan)   [![godoc][D]](https://godoc.org/github.com/SaidinWoT/timespan)
- [feiertage](https://github.com/wlbr/feiertage) **star:48** Set of functions to calculate public holidays in Germany, incl. specialization on the states of Germany (Bundesländer). Things like Easter, Pentecost, Thanksgiving...   [![godoc][D]](https://godoc.org/github.com/wlbr/feiertage)
- [kair](https://github.com/GuilhermeCaruso/kair) **star:24** Date and Time - Golang Formatting Library.   [![It hasn't been updated in recent three years][Y]](https://github.com/GuilhermeCaruso/kair)   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/kair)
- [go-anytime](https://github.com/ijt/go-anytime) **star:20** Parse dates/times like "next dec 22nd at 3pm" and ranges like "from today until next thursday" without knowing the format in advance.   [![godoc][D]](https://godoc.org/github.com/ijt/go-anytime)
- [cronrange](https://github.com/1set/cronrange) **star:18** Parses Cron-style time range expressions, checks if the given time is within any ranges.   [![godoc][D]](https://godoc.org/github.com/1set/cronrange)
- [NullTime](https://github.com/kirillDanshin/nulltime) **star:14** Nullable `time.Time`.   [![It hasn't been updated in recent three years][Y]](https://github.com/kirillDanshin/nulltime)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/nulltime)
- [approx](https://github.com/goschtalt/approx) **star:12** A Duration extension supporting parsing/printing durations in days, weeks and years.   [![There was an update last month][G]](https://github.com/goschtalt/approx)   [![godoc][D]](https://godoc.org/github.com/goschtalt/approx)
- [strftime](https://github.com/awoodbeck/strftime) **star:12** C99-compatible strftime formatter.   [![It hasn't been updated in recent three years][Y]](https://github.com/awoodbeck/strftime)   [![godoc][D]](https://godoc.org/github.com/awoodbeck/strftime)
- [tuesday](https://github.com/osteele/tuesday) **star:12** Ruby-compatible Strftime function.   [![It hasn't been updated in recent three years][Y]](https://github.com/osteele/tuesday)   [![godoc][D]](https://godoc.org/github.com/osteele/tuesday)
- [go-week](https://github.com/stoewer/go-week) **star:9** An efficient package to work with ISO8601 week dates.   [![godoc][D]](https://godoc.org/github.com/stoewer/go-week)
- [go-datebin](https://github.com/deatil/go-datebin) **star:4** A simple datetime parse pkg.   [![godoc][D]](https://godoc.org/github.com/deatil/go-datebin)   [![Contains Chinese documents][CN]](https://github.com/deatil/go-datebin)

**[⬆ back to top](#contents)**

## Distributed Systems

_Packages that help with building Distributed Systems._

- [go-zero](https://github.com/tal-tech/go-zero) **star:28601** A web and rpc framework. It's born to ensure the stability of the busy sites with resilient design. Builtin goctl greatly improves the development productivity.   [![There was an update last month][G]](https://github.com/tal-tech/go-zero)   [![godoc][D]](https://godoc.org/github.com/tal-tech/go-zero)
- [go-kit](https://github.com/go-kit/kit) **star:26411** Microservice toolkit with support for service discovery, load balancing, pluggable transports, request tracking, etc.   [![godoc][D]](https://godoc.org/github.com/go-kit/kit)
- [Kratos](https://github.com/go-kratos/kratos) **star:22991** A modular-designed and easy-to-use microservices framework in Go.   [![There was an update last month][G]](https://github.com/go-kratos/kratos)   [![godoc][D]](https://godoc.org/github.com/go-kratos/kratos)   [![Contains Chinese documents][CN]](https://github.com/go-kratos/kratos)
- [go-micro](https://github.com/micro/go-micro) **star:21708** A distributed systems development framework.   [![godoc][D]](https://godoc.org/github.com/micro/go-micro)
- [grpc-go](https://github.com/grpc/grpc-go) **star:20661** The Go language implementation of gRPC. HTTP/2 based RPC.   [![There was an update last month][G]](https://github.com/grpc/grpc-go)   [![godoc][D]](https://godoc.org/github.com/grpc/grpc-go)
- [NATS](https://github.com/nats-io/gnatsd) **star:15335** Lightweight, high performance messaging system for microservices, IoT, and cloud native systems.   [![There was an update last month][G]](https://github.com/nats-io/gnatsd)   [![godoc][D]](https://godoc.org/github.com/nats-io/gnatsd)
- [micro](https://github.com/micro/micro) **star:12073** A distributed systems runtime for the cloud and beyond.   [![godoc][D]](https://godoc.org/github.com/micro/micro)
- [raft](https://github.com/hashicorp/raft) **star:8094** Golang implementation of the Raft consensus protocol, by HashiCorp.   [![godoc][D]](https://godoc.org/github.com/hashicorp/raft)
- [rpcx](https://github.com/smallnest/rpcx) **star:8041** Distributed pluggable RPC service framework like alibaba Dubbo.   [![godoc][D]](https://godoc.org/github.com/smallnest/rpcx)
- [Kitex](https://github.com/cloudwego/kitex) **star:6857** A high-performance and strong-extensibility Golang RPC framework that helps developers build microservices. If the performance and extensibility are the main concerns when you develop microservices, Kitex can be a good choice.   [![There was an update last month][G]](https://github.com/cloudwego/kitex)   [![godoc][D]](https://godoc.org/github.com/cloudwego/kitex)   [![Contains Chinese documents][CN]](https://github.com/cloudwego/kitex)
- [lura](https://github.com/luraproject/lura) **star:6257** Ultra performant API Gateway framework with middlewares.   [![godoc][D]](https://godoc.org/github.com/luraproject/lura)
- [torrent](https://github.com/anacrolix/torrent) **star:5426** BitTorrent client package.   [![There was an update last month][G]](https://github.com/anacrolix/torrent)   [![godoc][D]](https://godoc.org/github.com/anacrolix/torrent)
- [dragonboat](https://github.com/lni/dragonboat) **star:5021** A feature complete and high performance multi-group Raft library in Go.   [![godoc][D]](https://godoc.org/github.com/lni/dragonboat)   [![Contains Chinese documents][CN]](https://github.com/lni/dragonboat)
- [evans](https://github.com/ktr0731/evans) **star:4199** Evans: more expressive universal gRPC client.   [![godoc][D]](https://godoc.org/github.com/ktr0731/evans)
- [emitter-io](https://github.com/emitter-io/emitter) **star:3808** High performance, distributed, secure and low latency publish-subscribe platform built with MQTT, Websockets and love.   [![There was an update last month][G]](https://github.com/emitter-io/emitter)   [![godoc][D]](https://godoc.org/github.com/emitter-io/emitter)
- [gleam](https://github.com/chrislusf/gleam) **star:3425** Fast and scalable distributed map/reduce system written in pure Go and Luajit, combining Go's high concurrency with Luajit's high performance, runs standalone or distributed.   [![godoc][D]](https://godoc.org/github.com/chrislusf/gleam)
- [glow](https://github.com/chrislusf/glow) **star:3196** Easy-to-Use scalable distributed big data processing, Map-Reduce, DAG execution, all in pure Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/chrislusf/glow)   [![godoc][D]](https://godoc.org/github.com/chrislusf/glow)
- [liftbridge](https://github.com/liftbridge-io/liftbridge) **star:2554** Lightweight, fault-tolerant message streams for NATS.   [![godoc][D]](https://godoc.org/github.com/liftbridge-io/liftbridge)
- [Dragonfly](https://github.com/dragonflyoss/Dragonfly2) **star:2155** Provide efficient, stable and secure file distribution and image acceleration based on p2p technology to be the best practice and standard solution in cloud native architectures.   [![There was an update last month][G]](https://github.com/dragonflyoss/Dragonfly2)   [![godoc][D]](https://godoc.org/github.com/dragonflyoss/Dragonfly2)
- [redis-lock](https://github.com/bsm/redislock) **star:1412** Simplified distributed locking implementation using Redis.   [![godoc][D]](https://godoc.org/github.com/bsm/redislock)
- [resgate](https://resgate.io/)  Realtime API Gateway for building REST, real time, and RPC APIs, where all clients are synchronized seamlessly.
- [go-doudou](https://github.com/unionj-cloud/go-doudou) **star:1403** A gossip protocol and OpenAPI 3.0 spec based decentralized microservice framework. Built-in go-doudou cli focusing on low-code and rapid dev can power up your productivity.   [![There was an update last month][G]](https://github.com/unionj-cloud/go-doudou)   [![godoc][D]](https://godoc.org/github.com/unionj-cloud/go-doudou)   [![Contains Chinese documents][CN]](https://github.com/unionj-cloud/go-doudou)
- [hprose](https://github.com/hprose/hprose-golang) **star:1260** Very newbility RPC Library, support 25+ languages now.   [![godoc][D]](https://godoc.org/github.com/hprose/hprose-golang)   [![Contains Chinese documents][CN]](https://github.com/hprose/hprose-golang)
- [sponge](https://github.com/zhufuyi/sponge) **star:1155** A distributed development framework that integrates automatic code generation, gin and grpc frameworks, base development frameworks.   [![godoc][D]](https://godoc.org/github.com/zhufuyi/sponge)   [![Contains Chinese documents][CN]](https://github.com/zhufuyi/sponge)
- [rain](https://github.com/cenkalti/rain) **star:947** BitTorrent client and library.   [![There was an update last month][G]](https://github.com/cenkalti/rain)   [![godoc][D]](https://godoc.org/github.com/cenkalti/rain)
- [arpc](https://github.com/lesismal/arpc) **star:926** More effective network communication, support two-way-calling, notify, broadcast.   [![There was an update last month][G]](https://github.com/lesismal/arpc)   [![godoc][D]](https://godoc.org/github.com/lesismal/arpc)
- [ringpop-go](https://github.com/uber/ringpop-go) **star:824** Scalable, fault-tolerant application-layer sharding for Go applications.   [![godoc][D]](https://godoc.org/github.com/uber/ringpop-go)
- [trpc-go](https://github.com/trpc-group/trpc-go) **star:776** The Go language implementation of tRPC, which is a pluggable, high-performance RPC framework.   [![godoc][D]](https://godoc.org/github.com/trpc-group/trpc-go)   [![Contains Chinese documents][CN]](https://github.com/trpc-group/trpc-go)
- [go-health](https://github.com/InVisionApp/go-health) **star:744** Library for enabling asynchronous dependency health checks in your service.   [![godoc][D]](https://godoc.org/github.com/InVisionApp/go-health)
- [gorpc](https://github.com/valyala/gorpc) **star:692** Simple, fast and scalable RPC library for high load.   [![godoc][D]](https://godoc.org/github.com/valyala/gorpc)
- [consistent](https://github.com/buraksezer/consistent) **star:678** Consistent hashing with bounded loads.   [![godoc][D]](https://godoc.org/github.com/buraksezer/consistent)
- [raft](https://github.com/etcd-io/raft) **star:603** Go implementation of the Raft consensus protocol, by CoreOS.   [![There was an update last month][G]](https://github.com/etcd-io/raft)   [![godoc][D]](https://godoc.org/github.com/etcd-io/raft)
- [go-sundheit](https://github.com/AppsFlyer/go-sundheit) **star:530** A library built to provide support for defining async service health checks for golang services.   [![godoc][D]](https://godoc.org/github.com/AppsFlyer/go-sundheit)
- [digota](https://github.com/digota/digota) **star:509** grpc ecommerce microservice.   [![It hasn't been updated in recent three years][Y]](https://github.com/digota/digota)   [![godoc][D]](https://godoc.org/github.com/digota/digota)
- [dot](https://github.com/dotchain/dot/)  distributed sync using operational transformation/OT.
- [Temporal](https://github.com/temporalio/sdk-go) **star:492** Durable execution system for making code fault-tolerant and simple.   [![There was an update last month][G]](https://github.com/temporalio/sdk-go)   [![godoc][D]](https://godoc.org/github.com/temporalio/sdk-go)
- [go-jump](https://github.com/dgryski/go-jump) **star:382** Port of Google's "Jump" Consistent Hash function.   [![godoc][D]](https://godoc.org/github.com/dgryski/go-jump)
- [sleuth](https://github.com/ursiform/sleuth) **star:372** Library for master-less p2p auto-discovery and RPC between HTTP services (using [ZeroMQ](https://github.com/zeromq/libzmq)).   [![godoc][D]](https://godoc.org/github.com/ursiform/sleuth)
- [Tarmac](https://github.com/tarmac-project/tarmac) **star:324** Framework for writing functions, microservices, or monoliths with WebAssembly   [![godoc][D]](https://godoc.org/github.com/tarmac-project/tarmac)
- [jsonrpc](https://github.com/ybbus/jsonrpc) **star:321** JSON-RPC 2.0 HTTP client implementation.   [![There was an update last month][G]](https://github.com/ybbus/jsonrpc)   [![godoc][D]](https://godoc.org/github.com/ybbus/jsonrpc)
- [dht](https://github.com/anacrolix/dht) **star:304** BitTorrent Kademlia DHT implementation.   [![godoc][D]](https://godoc.org/github.com/anacrolix/dht)
- [jsonrpc](https://github.com/osamingo/jsonrpc) **star:189** The jsonrpc package helps implement of JSON-RPC 2.0.   [![godoc][D]](https://godoc.org/github.com/osamingo/jsonrpc)
- [outboxer](https://github.com/italolelis/outboxer) **star:153** Outboxer is a go library that implements the outbox pattern.   [![There was an update last month][G]](https://github.com/italolelis/outboxer)   [![godoc][D]](https://godoc.org/github.com/italolelis/outboxer)
- [pglock](https://cirello.io/pglock)  PostgreSQL-backed distributed locking implementation.
- [pjrpc](https://gitlab.com/pjrpc/pjrpc)  Golang JSON-RPC Server-Client with Protobuf spec.
- [doublejump](https://github.com/edwingeng/doublejump) **star:101** A revamped Google's jump consistent hash.   [![godoc][D]](https://godoc.org/github.com/edwingeng/doublejump)
- [Semaphore](https://github.com/jexia/semaphore) **star:92** A straightforward (micro) service orchestrator.   [![godoc][D]](https://godoc.org/github.com/jexia/semaphore)
- [celeriac](https://github.com/svcavallar/celeriac.v1) **star:72** Library for adding support for interacting and monitoring Celery workers, tasks and events in Go.   [![godoc][D]](https://godoc.org/github.com/svcavallar/celeriac.v1)
- [go-mysql-lock](https://github.com/sanketplus/go-mysql-lock) **star:61** MySQL based distributed lock.   [![godoc][D]](https://godoc.org/github.com/sanketplus/go-mysql-lock)
- [capillaries](https://github.com/capillariesio/capillaries) **star:59** distributed batch data processing framework.   [![There was an update last month][G]](https://github.com/capillariesio/capillaries)   [![godoc][D]](https://godoc.org/github.com/capillariesio/capillaries)
- [flowgraph](https://github.com/vectaport/flowgraph) **star:58** flow-based programming package.   [![It hasn't been updated in recent three years][Y]](https://github.com/vectaport/flowgraph)   [![godoc][D]](https://godoc.org/github.com/vectaport/flowgraph)
- [drmaa](https://github.com/dgruber/drmaa) **star:48** Job submission library for cluster schedulers based on the DRMAA standard.   [![godoc][D]](https://godoc.org/github.com/dgruber/drmaa)
- [dynamolock](https://cirello.io/dynamolock)  DynamoDB-backed distributed locking implementation.
- [go-pdu](https://github.com/pdupub/go-pdu) **star:47** A decentralized identity-based social network.   [![godoc][D]](https://godoc.org/github.com/pdupub/go-pdu)
- [consistenthash](https://github.com/mbrostami/consistenthash) **star:27** Consistent hashing with configurable replicas.   [![godoc][D]](https://godoc.org/github.com/mbrostami/consistenthash)
- [gmsec](https://github.com/gmsec/micro) **star:25** A Go distributed systems development framework.   [![godoc][D]](https://godoc.org/github.com/gmsec/micro)
- [dynatomic](https://github.com/tylfin/dynatomic) **star:17** A library for using DynamoDB as an atomic counter.   [![It hasn't been updated in recent three years][Y]](https://github.com/tylfin/dynatomic)   [![godoc][D]](https://godoc.org/github.com/tylfin/dynatomic)
- [failured](https://github.com/andy2046/failured) **star:12** adaptive accrual failure detector for distributed systems.   [![It hasn't been updated in recent three years][Y]](https://github.com/andy2046/failured)   [![godoc][D]](https://godoc.org/github.com/andy2046/failured)
- [bedrock](https://github.com/z5labs/bedrock) **star:3** Provides a minimal, modular and composable foundation for quickly developing services and more use case specific frameworks in Go.   [![There was an update last month][G]](https://github.com/z5labs/bedrock)   [![godoc][D]](https://godoc.org/github.com/z5labs/bedrock)

**[⬆ back to top](#contents)**

## Dynamic DNS

_Tools for updating dynamic DNS records._

- [GoDNS](https://github.com/timothyye/godns) **star:1487** A dynamic DNS client tool, supports DNSPod & HE.net, written in Go.   [![There was an update last month][G]](https://github.com/timothyye/godns)   [![godoc][D]](https://godoc.org/github.com/timothyye/godns)
- [DDNS](https://github.com/skibish/ddns) **star:249** Personal DDNS client with Digital Ocean Networking DNS as backend.   [![godoc][D]](https://godoc.org/github.com/skibish/ddns)
- [dyndns](https://gitlab.com/alcastle/dyndns)  Background Go process to regularly and automatically check your IP Address and make updates to (one or many) Dynamic DNS records for Google domains whenever your address changes.

**[⬆ back to top](#contents)**

## Email

_Libraries and tools that implement email creation and sending._

- [MailHog](https://github.com/mailhog/MailHog) **star:13738** Email and SMTP testing with web and API interface.   [![godoc][D]](https://godoc.org/github.com/mailhog/MailHog)
- [Mailpit](https://github.com/axllent/mailpit) **star:5167** Email and SMTP testing tool for developers.   [![There was an update last month][G]](https://github.com/axllent/mailpit)   [![godoc][D]](https://godoc.org/github.com/axllent/mailpit)
- [Maddy](https://github.com/foxcpp/maddy) **star:4912** All-in-one (SMTP, IMAP, DKIM, DMARC, MTA-STS, DANE) email server   [![godoc][D]](https://godoc.org/github.com/foxcpp/maddy)
- [hermes](https://github.com/matcornic/hermes) **star:2807** Golang package that generates clean, responsive HTML e-mails.   [![godoc][D]](https://godoc.org/github.com/matcornic/hermes)
- [email](https://github.com/jordan-wright/email) **star:2623** A robust and flexible email library for Go.   [![godoc][D]](https://godoc.org/github.com/jordan-wright/email)
- [go-imap](https://github.com/emersion/go-imap) **star:2045** IMAP library for clients and servers.   [![There was an update last month][G]](https://github.com/emersion/go-imap)   [![godoc][D]](https://godoc.org/github.com/emersion/go-imap)
- [chasquid](https://blitiri.com.ar/p/chasquid)  SMTP server written in Go.
- [email-verifier](https://github.com/AfterShip/email-verifier) **star:1158** A Go library for email verification without sending any emails.   [![godoc][D]](https://godoc.org/github.com/AfterShip/email-verifier)
- [SendGrid](https://github.com/sendgrid/sendgrid-go) **star:972** SendGrid's Go library for sending email.   [![There was an update last month][G]](https://github.com/sendgrid/sendgrid-go)   [![godoc][D]](https://godoc.org/github.com/sendgrid/sendgrid-go)
- [mailgun-go](https://github.com/mailgun/mailgun-go) **star:691** Go library for sending mail with the Mailgun API.   [![There was an update last month][G]](https://github.com/mailgun/mailgun-go)   [![godoc][D]](https://godoc.org/github.com/mailgun/mailgun-go)
- [go-simple-mail](https://github.com/xhit/go-simple-mail) **star:629** Very simple package to send emails with SMTP Keep Alive and two timeouts: Connect and Send.   [![godoc][D]](https://godoc.org/github.com/xhit/go-simple-mail)
- [go-mail](https://github.com/wneessen/go-mail) **star:543** A simple Go library for sending mails in Go.   [![There was an update last month][G]](https://github.com/wneessen/go-mail)   [![godoc][D]](https://godoc.org/github.com/wneessen/go-mail)
- [go-message](https://github.com/emersion/go-message) **star:375** Streaming library for the Internet Message Format and mail messages.   [![godoc][D]](https://godoc.org/github.com/emersion/go-message)
- [douceur](https://github.com/aymerick/douceur) **star:243** CSS inliner for your HTML emails.   [![godoc][D]](https://godoc.org/github.com/aymerick/douceur)
- [Hectane](https://github.com/hectane/hectane) **star:223** Lightweight SMTP client providing an HTTP API.   [![It hasn't been updated in recent three years][Y]](https://github.com/hectane/hectane)   [![godoc][D]](https://godoc.org/github.com/hectane/hectane)
- [mailchain](https://github.com/mailchain/mailchain) **star:142** Send encrypted emails to blockchain addresses written in Go.
- [go-premailer](https://github.com/vanng822/go-premailer) **star:136** Inline styling for HTML mail in Go.   [![godoc][D]](https://godoc.org/github.com/vanng822/go-premailer)
- [smtpmock](https://github.com/mocktools/go-smtp-mock) **star:123** Lightweight configurable multithreaded fake SMTP server. Mimic any SMTP behaviour for your test environment.   [![godoc][D]](https://godoc.org/github.com/mocktools/go-smtp-mock)
- [truemail-go](https://github.com/truemail-rb/truemail-go) **star:96** Configurable Golang email validator/verifier. Verify email via Regex, DNS, SMTP and even more.   [![godoc][D]](https://godoc.org/github.com/truemail-rb/truemail-go)
- [go-dkim](https://github.com/toorop/go-dkim) **star:95** DKIM library, to sign & verify email.   [![godoc][D]](https://godoc.org/github.com/toorop/go-dkim)
- [smtp](https://github.com/mailhog/smtp) **star:74** SMTP server protocol state machine.   [![godoc][D]](https://godoc.org/github.com/mailhog/smtp)
- [go-email-normalizer](https://github.com/dimuska139/go-email-normalizer) **star:62** Golang library for providing a canonical representation of email address.   [![godoc][D]](https://godoc.org/github.com/dimuska139/go-email-normalizer)
- [go-email-validator](https://github.com/go-email-validator/go-email-validator) **star:51** Modular email validator for syntax, disposable, smtp, etc... checking.   [![godoc][D]](https://godoc.org/github.com/go-email-validator/go-email-validator)   [![Archived][Archived]](https://github.com/go-email-validator/go-email-validator)
- [mailx](https://github.com/valord577/mailx) **star:16** Mailx is a library that makes it easier to send email via SMTP. It is an enhancement of the golang standard library `net/smtp`.   [![godoc][D]](https://godoc.org/github.com/valord577/mailx)

**[⬆ back to top](#contents)**

## Embeddable Scripting Languages

_Embedding other languages inside your go code._

- [gopher-lua](https://github.com/yuin/gopher-lua) **star:6162** Lua 5.1 VM and compiler written in Go.   [![godoc][D]](https://godoc.org/github.com/yuin/gopher-lua)
- [expr](https://github.com/antonmedv/expr) **star:5999** Expression evaluation engine for Go: fast, non-Turing complete, dynamic typing, static typing.   [![godoc][D]](https://godoc.org/github.com/antonmedv/expr)
- [goja](https://github.com/dop251/goja) **star:5227** ECMAScript 5.1(+) implementation in Go.   [![There was an update last month][G]](https://github.com/dop251/goja)   [![godoc][D]](https://godoc.org/github.com/dop251/goja)
- [tengo](https://github.com/d5/tengo) **star:3500** Bytecode compiled script language for Go.   [![godoc][D]](https://godoc.org/github.com/d5/tengo)
- [go-lua](https://github.com/Shopify/go-lua) **star:3044** Port of the Lua 5.2 VM to pure Go.   [![godoc][D]](https://godoc.org/github.com/Shopify/go-lua)
- [starlark-go](https://github.com/google/starlark-go) **star:2282** Go implementation of Starlark: Python-like language with deterministic evaluation and hermetic execution.   [![godoc][D]](https://godoc.org/github.com/google/starlark-go)
- [cel-go](https://github.com/google/cel-go) **star:2143** Fast, portable, non-Turing complete expression evaluation with gradual typing.   [![There was an update last month][G]](https://github.com/google/cel-go)   [![godoc][D]](https://godoc.org/github.com/google/cel-go)
- [metacall](https://github.com/metacall/core) **star:1540** Cross-platform Polyglot Runtime which supports NodeJS, JavaScript, TypeScript, Python, Ruby, C#, WebAssembly, Java, Cobol and more.   [![There was an update last month][G]](https://github.com/metacall/core)
- [go-python](https://github.com/sbinet/go-python) **star:1523** naive go bindings to the CPython C-API.   [![godoc][D]](https://godoc.org/github.com/sbinet/go-python)   [![Archived][Archived]](https://github.com/sbinet/go-python)
- [goal](https://codeberg.org/anaseto/goal)  An embeddable scripting array language.
- [anko](https://github.com/mattn/anko) **star:1456** Scriptable interpreter written in Go.   [![godoc][D]](https://godoc.org/github.com/mattn/anko)
- [Wa/凹语言](https://github.com/wa-lang/wa) **star:989** The Wa Programming Language embedded in Go.   [![There was an update last month][G]](https://github.com/wa-lang/wa)   [![godoc][D]](https://godoc.org/github.com/wa-lang/wa)   [![Contains Chinese documents][CN]](https://github.com/wa-lang/wa)
- [go-php](https://github.com/deuill/go-php) **star:923** PHP bindings for Go.   [![godoc][D]](https://godoc.org/github.com/deuill/go-php)
- [go-duktape](https://github.com/olebedev/go-duktape) **star:777** Duktape JavaScript engine bindings for Go.   [![godoc][D]](https://godoc.org/github.com/olebedev/go-duktape)   [![Archived][Archived]](https://github.com/olebedev/go-duktape)
- [gval](https://github.com/PaesslerAG/gval) **star:719** A highly customizable expression language written in Go.   [![godoc][D]](https://godoc.org/github.com/PaesslerAG/gval)
- [golua](https://github.com/aarzilli/golua) **star:637** Go bindings for Lua C API.   [![There was an update last month][G]](https://github.com/aarzilli/golua)
- [prolog](https://github.com/ichiban/prolog) **star:561** Embeddable Prolog.   [![godoc][D]](https://godoc.org/github.com/ichiban/prolog)
- [gisp](https://github.com/jcla1/gisp) **star:510** Simple LISP in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/jcla1/gisp)   [![godoc][D]](https://godoc.org/github.com/jcla1/gisp)
- [gentee](https://github.com/gentee/gentee) **star:132** Embeddable scripting programming language.   [![godoc][D]](https://godoc.org/github.com/gentee/gentee)
- [binder](https://github.com/alexeyco/binder) **star:74** Go to Lua binding library, based on [gopher-lua](https://github.com/yuin/gopher-lua).   [![godoc][D]](https://godoc.org/github.com/alexeyco/binder)
- [ecal](https://github.com/krotik/ecal) **star:41** A simple embeddable scripting language which supports concurrent event processing.   [![It hasn't been updated in recent three years][Y]](https://github.com/krotik/ecal)   [![godoc][D]](https://godoc.org/github.com/krotik/ecal)
- [purl](https://github.com/ian-kent/purl) **star:41** Perl 5.18.2 embedded in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/ian-kent/purl)   [![godoc][D]](https://godoc.org/github.com/ian-kent/purl)
- [ngaro](https://github.com/db47h/ngaro) **star:28** Embeddable Ngaro VM implementation enabling scripting in Retro.   [![It hasn't been updated in recent three years][Y]](https://github.com/db47h/ngaro)   [![godoc][D]](https://godoc.org/github.com/db47h/ngaro)
- [starlet](https://github.com/1set/starlet) **star:16** Go wrapper for [starlark-go](https://github.com/google/starlark-go) that simplifies script execution, offers data conversion, and useful Starlark libraries and extensions.   [![godoc][D]](https://godoc.org/github.com/1set/starlet)

**[⬆ back to top](#contents)**

## Error Handling

_Libraries for handling errors._

- [go-multierror](https://github.com/hashicorp/go-multierror) **star:2274** Go (golang) package for representing a list of errors as a single error.   [![There was an update last month][G]](https://github.com/hashicorp/go-multierror)   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-multierror)
- [errors](https://github.com/cockroachdb/errors) **star:2053** Go error library with error portability over the network.   [![godoc][D]](https://godoc.org/github.com/cockroachdb/errors)
- [eris](https://github.com/rotisserie/eris) **star:1486** A better way to handle, trace, and log errors in Go. Compatible with the standard error library and github.com/pkg/errors.   [![godoc][D]](https://godoc.org/github.com/rotisserie/eris)
- [errorx](https://github.com/joomcode/errorx) **star:1115** A feature rich error package with stack traces, composition of errors and more.   [![godoc][D]](https://godoc.org/github.com/joomcode/errorx)
- [tracerr](https://github.com/ztrue/tracerr) **star:963** Golang errors with stack trace and source fragments.   [![godoc][D]](https://godoc.org/github.com/ztrue/tracerr)
- [errlog](https://github.com/snwfdhmp/errlog) **star:459** Hackable package that determines responsible source code for an error (and some other fast-debugging features). Pluggable to any logger in-place.   [![godoc][D]](https://godoc.org/github.com/snwfdhmp/errlog)
- [emperror](https://github.com/emperror/emperror) **star:335** Error handling tools and best practices for Go libraries and applications.   [![It hasn't been updated in recent three years][Y]](https://github.com/emperror/emperror)   [![godoc][D]](https://godoc.org/github.com/emperror/emperror)
- [oops](https://github.com/samber/oops) **star:328** Error handling with context, stack trace and source fragments.   [![There was an update last month][G]](https://github.com/samber/oops)   [![godoc][D]](https://godoc.org/github.com/samber/oops)
- [errors](https://github.com/emperror/errors) **star:190** Drop-in replacement for the standard library errors package and github.com/pkg/errors. Provides various error handling primitives.   [![godoc][D]](https://godoc.org/github.com/emperror/errors)
- [Fault](https://github.com/Southclaws/fault) **star:158** An ergonomic mechanism for wrapping errors in order to facilitate structured metadata and context for error values.   [![godoc][D]](https://godoc.org/github.com/Southclaws/fault)
- [errors](https://github.com/bnkamalesh/errors) **star:62** Drop-in replacement for builtin Go errors. This is a minimal error handling package with custom error types, user friendly messages, Unwrap & Is. With very easy to use and straightforward helper functions.   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/errors)
- [exception](https://github.com/rbrahul/exception) **star:30** A simple utility package for exception handling with try-catch in Golang.   [![godoc][D]](https://godoc.org/github.com/rbrahul/exception)
- [Falcon](https://github.com/SonicRoshan/falcon) **star:11** A Simple Yet Highly Powerful Package For Error Handling.   [![It hasn't been updated in recent three years][Y]](https://github.com/SonicRoshan/falcon)   [![godoc][D]](https://godoc.org/github.com/SonicRoshan/falcon)
- [errors](https://github.com/PumpkinSeed/errors) **star:7** The most simple error wrapper with awesome performance and minimal memory overhead.   [![godoc][D]](https://godoc.org/github.com/PumpkinSeed/errors)
- [errors](https://gitlab.com/tozd/go/errors)  Providing errors with a stack trace and optional structured details. Compatible with github.com/pkg/errors API but does not use it internally.
- [errors](https://github.com/neuronlabs/errors) **star:6** Simple golang error handling with classification primitives.   [![It hasn't been updated in recent three years][Y]](https://github.com/neuronlabs/errors)   [![godoc][D]](https://godoc.org/github.com/neuronlabs/errors)

**[⬆ back to top](#contents)**

## File Handling

_Libraries for handling files and file systems._

- [pdfcpu](https://github.com/pdfcpu/pdfcpu) **star:6595** PDF processor.   [![There was an update last month][G]](https://github.com/pdfcpu/pdfcpu)   [![godoc][D]](https://godoc.org/github.com/pdfcpu/pdfcpu)
- [afero](https://github.com/spf13/afero) **star:5835** FileSystem Abstraction System for Go.   [![godoc][D]](https://godoc.org/github.com/spf13/afero)
- [gdu](https://github.com/dundee/gdu) **star:3664** Disk usage analyzer with console interface.   [![There was an update last month][G]](https://github.com/dundee/gdu)   [![godoc][D]](https://godoc.org/github.com/dundee/gdu)
- [notify](https://github.com/rjeczalik/notify) **star:900** File system event notification library with simple API, similar to os/signal.   [![godoc][D]](https://godoc.org/github.com/rjeczalik/notify)
- [copy](https://github.com/otiai10/copy) **star:707** Copy directory recursively.   [![There was an update last month][G]](https://github.com/otiai10/copy)   [![godoc][D]](https://godoc.org/github.com/otiai10/copy)
- [gofs](https://github.com/no-src/gofs) **star:452** A cross-platform real-time file synchronization tool out of the box.   [![There was an update last month][G]](https://github.com/no-src/gofs)   [![godoc][D]](https://godoc.org/github.com/no-src/gofs)   [![Contains Chinese documents][CN]](https://github.com/no-src/gofs)
- [afs](https://github.com/viant/afs) **star:301** Abstract File Storage (mem, scp, zip, tar, cloud: s3, gs) for Go.   [![godoc][D]](https://godoc.org/github.com/viant/afs)
- [vfs](https://github.com/C2FO/vfs) **star:291** A pluggable, extensible, and opinionated set of filesystem functionality for Go across a number of filesystem types such as os, S3, and GCS.   [![godoc][D]](https://godoc.org/github.com/C2FO/vfs)
- [iso9660](https://github.com/kdomanski/iso9660) **star:256** A package for reading and creating ISO9660 disk images   [![godoc][D]](https://godoc.org/github.com/kdomanski/iso9660)
- [bigfile](https://github.com/bigfile/bigfile) **star:250** A file transfer system, support to manage files with http api, rpc call and ftp client.   [![godoc][D]](https://godoc.org/github.com/bigfile/bigfile)   [![Contains Chinese documents][CN]](https://github.com/bigfile/bigfile)   [![Archived][Archived]](https://github.com/bigfile/bigfile)
- [go-exiftool](https://github.com/barasher/go-exiftool) **star:240** Go bindings for ExifTool, the well-known library used to extract as much metadata as possible (EXIF, IPTC, ...) from files (pictures, PDF, office, ...).   [![godoc][D]](https://godoc.org/github.com/barasher/go-exiftool)
- [go-csv-tag](https://github.com/artonge/go-csv-tag) **star:119** Load csv file using tag.   [![godoc][D]](https://godoc.org/github.com/artonge/go-csv-tag)
- [parquet](https://github.com/parsyl/parquet) **star:103** Read and write [parquet](https://parquet.apache.org) files.   [![godoc][D]](https://godoc.org/github.com/parsyl/parquet)
- [checksum](https://github.com/codingsince1985/checksum) **star:102** Compute message digest, like MD5, SHA256, SHA1, CRC or BLAKE2s, for large files.   [![godoc][D]](https://godoc.org/github.com/codingsince1985/checksum)
- [skywalker](https://github.com/dixonwille/skywalker) **star:98** Package to allow one to concurrently go through a filesystem with ease.   [![godoc][D]](https://godoc.org/github.com/dixonwille/skywalker)
- [stl](https://gitlab.com/russoj88/stl)  Modules to read and write STL (stereolithography) files. Concurrent algorithm for reading.
- [opc](https://github.com/qmuntal/opc) **star:75** Load Open Packaging Conventions (OPC) files for Go.   [![godoc][D]](https://godoc.org/github.com/qmuntal/opc)
- [baraka](https://github.com/xis/baraka) **star:53** A library to process http file uploads easily.   [![godoc][D]](https://godoc.org/github.com/xis/baraka)
- [go-gtfs](https://github.com/artonge/go-gtfs) **star:45** Load gtfs files in go.   [![godoc][D]](https://godoc.org/github.com/artonge/go-gtfs)
- [flop](https://github.com/homedepot/flop) **star:33** File operations library which aims to mirror feature parity with [GNU cp](https://www.gnu.org/software/coreutils/manual/html_node/cp-invocation.html).   [![godoc][D]](https://godoc.org/github.com/homedepot/flop)
- [gut/yos](https://github.com/1set/gut) **star:27** Simple and reliable package for file operations like copy/move/diff/list on files, directories and symbolic links.   [![It hasn't been updated in recent three years][Y]](https://github.com/1set/gut)   [![godoc][D]](https://godoc.org/github.com/1set/gut)
- [higgs](https://github.com/dastoori/higgs) **star:23** A tiny cross-platform Go library to hide/unhide files and directories.   [![godoc][D]](https://godoc.org/github.com/dastoori/higgs)
- [todotxt](https://github.com/1set/todotxt) **star:23** Go library for Gina Trapani's [_todo.txt_](http://todotxt.org/) files, supports parsing and manipulating of task lists in the [_todo.txt_ format](https://github.com/todotxt/todo.txt).   [![godoc][D]](https://godoc.org/github.com/1set/todotxt)
- [go-decent-copy](https://github.com/hugocarreira/go-decent-copy) **star:22** Copy files for humans.   [![It hasn't been updated in recent three years][Y]](https://github.com/hugocarreira/go-decent-copy)   [![godoc][D]](https://godoc.org/github.com/hugocarreira/go-decent-copy)
- [pathtype](https://github.com/jonchun/pathtype) **star:13** Treat paths as their own type instead of using strings.   [![It hasn't been updated in recent three years][Y]](https://github.com/jonchun/pathtype)   [![godoc][D]](https://godoc.org/github.com/jonchun/pathtype)

**[⬆ back to top](#contents)**

## Financial

_Packages for accounting and finance._

- [decimal](https://github.com/shopspring/decimal) **star:6181** Arbitrary-precision fixed-point decimal numbers.   [![There was an update last month][G]](https://github.com/shopspring/decimal)   [![godoc][D]](https://godoc.org/github.com/shopspring/decimal)
- [ticker](https://github.com/achannarasappa/ticker) **star:4917** Terminal stock watcher and stock position tracker.   [![godoc][D]](https://godoc.org/github.com/achannarasappa/ticker)
- [go-money](https://github.com/rhymond/go-money) **star:1622** Implementation of Fowler's Money pattern.   [![godoc][D]](https://godoc.org/github.com/rhymond/go-money)
- [bbgo](https://github.com/c9s/bbgo) **star:1164** A crypto trading bot framework written in Go. Including common crypto exchange API, standard indicators, back-testing and many built-in strategies.   [![There was an update last month][G]](https://github.com/c9s/bbgo)   [![godoc][D]](https://godoc.org/github.com/c9s/bbgo)
- [accounting](https://github.com/leekchan/accounting) **star:876** money and currency formatting for golang.   [![godoc][D]](https://godoc.org/github.com/leekchan/accounting)
- [techan](https://github.com/sdcoffey/techan) **star:819** Technical analysis library with advanced market analysis and trading strategies.   [![godoc][D]](https://godoc.org/github.com/sdcoffey/techan)
- [currency](https://github.com/bojanz/currency) **star:525** Handles currency amounts, provides currency information and formatting.   [![godoc][D]](https://godoc.org/github.com/bojanz/currency)
- [ach](https://github.com/moov-io/ach) **star:449** A reader, writer, and validator for Automated Clearing House (ACH) files.   [![There was an update last month][G]](https://github.com/moov-io/ach)   [![godoc][D]](https://godoc.org/github.com/moov-io/ach)
- [orderbook](https://github.com/i25959341/orderbook) **star:418** Matching Engine for Limit Order Book in Golang.   [![godoc][D]](https://godoc.org/github.com/i25959341/orderbook)
- [go-finance](https://github.com/alpeb/go-finance) **star:172** Library of financial functions for time value of money (annuities), cash flow, interest rate conversions, bonds and depreciation calculations.   [![godoc][D]](https://godoc.org/github.com/alpeb/go-finance)
- [sleet](https://github.com/BoltApp/sleet) **star:140** One unified interface for multiple Payment Service Providers (PsP) to process online payment.   [![godoc][D]](https://godoc.org/github.com/BoltApp/sleet)   [![Archived][Archived]](https://github.com/BoltApp/sleet)
- [swift](https://code.pfad.fr/swift/)  Offline validity check of IBAN (International Bank Account Number) and retrieval of BIC (for some countries).
- [ofxgo](https://github.com/aclindsa/ofxgo) **star:138** Query OFX servers and/or parse the responses (with example command-line client).   [![godoc][D]](https://godoc.org/github.com/aclindsa/ofxgo)
- [transaction](https://github.com/claygod/transaction) **star:133** Embedded transactional database of accounts, running in multithreaded mode.   [![godoc][D]](https://godoc.org/github.com/claygod/transaction)
- [vat](https://github.com/dannyvankooten/vat) **star:112** VAT number validation & EU VAT rates.   [![godoc][D]](https://godoc.org/github.com/dannyvankooten/vat)
- [go-finnhub](https://github.com/m1/go-finnhub) **star:90** Client for stock market, forex and crypto data from finnhub.io. Access real-time financial market data from 60+ stock exchanges, 10 forex brokers, and 15+ crypto exchanges.   [![It hasn't been updated in recent three years][Y]](https://github.com/m1/go-finnhub)   [![godoc][D]](https://godoc.org/github.com/m1/go-finnhub)   [![Archived][Archived]](https://github.com/m1/go-finnhub)
- [payme](https://github.com/jovandeginste/payme) **star:85** QR code generator (ASCII & PNG) for SEPA payments.   [![There was an update last month][G]](https://github.com/jovandeginste/payme)   [![godoc][D]](https://godoc.org/github.com/jovandeginste/payme)
- [currency](https://github.com/bnkamalesh/currency) **star:60** High performant & accurate currency computation package.   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/currency)
- [decimal](https://github.com/govalues/decimal) **star:57** Immutable decimal numbers with panic-free arithmetic.   [![godoc][D]](https://godoc.org/github.com/govalues/decimal)
- [fpdecimal](https://github.com/nikolaydubina/fpdecimal) **star:29** Fast and precise serialization and arithmetic for small fixed-point decimals   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/fpdecimal)
- [go-finance](https://github.com/pieterclaerhout/go-finance) **star:27** Module to fetch exchange rates, check VAT numbers via VIES and check IBAN bank account numbers.   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-finance)
- [fpmoney](https://github.com/nikolaydubina/fpmoney) **star:26** Fast and simple ISO4217 fixed-point decimal money.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/fpmoney)
- [money](https://github.com/govalues/money) **star:19** Immutable monetary amounts and exchange rates with panic-free arithmetic.   [![godoc][D]](https://godoc.org/github.com/govalues/money)
- [go-nowpayments](https://github.com/matm/go-nowpayments) **star:3** Library for the crypto NOWPayments API.   [![godoc][D]](https://godoc.org/github.com/matm/go-nowpayments)

**[⬆ back to top](#contents)**

## Forms

_Libraries for working with forms._

- [nosurf](https://github.com/justinas/nosurf) **star:1557** CSRF protection middleware for Go.   [![godoc][D]](https://godoc.org/github.com/justinas/nosurf)
- [gorilla/csrf](https://github.com/gorilla/csrf) **star:1028** CSRF protection for Go web applications & services.   [![godoc][D]](https://godoc.org/github.com/gorilla/csrf)
- [binding](https://github.com/mholt/binding) **star:795** Binds form and JSON data from net/http Request to struct.   [![It hasn't been updated in recent three years][Y]](https://github.com/mholt/binding)   [![godoc][D]](https://godoc.org/github.com/mholt/binding)   [![Archived][Archived]](https://github.com/mholt/binding)
- [form](https://github.com/go-playground/form) **star:737** Decodes url.Values into Go value(s) and Encodes Go value(s) into url.Values. Dual Array and Full map support.   [![godoc][D]](https://godoc.org/github.com/go-playground/form)
- [conform](https://github.com/leebenson/conform) **star:316** Keeps user input in check. Trims, sanitizes & scrubs data based on struct tags.   [![godoc][D]](https://godoc.org/github.com/leebenson/conform)
- [httpin](https://github.com/ggicci/httpin) **star:294** Decode an HTTP request into a custom struct, including querystring, forms, HTTP headers, etc.   [![godoc][D]](https://godoc.org/github.com/ggicci/httpin)
- [formam](https://github.com/monoculum/formam) **star:188** decode form's values into a struct.   [![godoc][D]](https://godoc.org/github.com/monoculum/formam)
- [forms](https://github.com/albrow/forms) **star:137** Framework-agnostic library for parsing and validating form/JSON data which supports multipart forms and files.   [![godoc][D]](https://godoc.org/github.com/albrow/forms)
- [qs](https://github.com/sonh/qs) **star:75** Go module for encoding structs into URL query parameters.   [![godoc][D]](https://godoc.org/github.com/sonh/qs)
- [bind](https://github.com/robfig/bind) **star:30** Bind form data to any Go values.   [![It hasn't been updated in recent three years][Y]](https://github.com/robfig/bind)   [![godoc][D]](https://godoc.org/github.com/robfig/bind)
- [queryparam](https://github.com/tomwright/queryparam) **star:19** Decode `url.Values` into usable struct values of standard or custom types.   [![It hasn't been updated in recent three years][Y]](https://github.com/tomwright/queryparam)   [![godoc][D]](https://godoc.org/github.com/tomwright/queryparam)
- [checker](https://github.com/cinar/checker) **star:9** Checker helps validating user input through rules defined in struct tags or directly through functions.   [![godoc][D]](https://godoc.org/github.com/cinar/checker)
- [gbind](https://github.com/bdjimmy/gbind) **star:8** Bind data to any Go value. Can use built-in and custom expression binding capabilities; supports data validation   [![godoc][D]](https://godoc.org/github.com/bdjimmy/gbind)   [![Contains Chinese documents][CN]](https://github.com/bdjimmy/gbind)

**[⬆ back to top](#contents)**

## Functional

_Packages to support functional programming in Go._

- [mo](https://github.com/samber/mo) **star:2514** Monads and popular FP abstractions, based on Go 1.18+ Generics (Option, Result, Either...).   [![godoc][D]](https://godoc.org/github.com/samber/mo)
- [go-underscore](https://github.com/tobyhede/go-underscore) **star:1297** Useful collection of helpfully functional Go collection utilities.   [![godoc][D]](https://godoc.org/github.com/tobyhede/go-underscore)
- [go-functional](https://github.com/BooleanCat/go-functional) **star:357** Functional programming in Go using generics   [![There was an update last month][G]](https://github.com/BooleanCat/go-functional)   [![godoc][D]](https://godoc.org/github.com/BooleanCat/go-functional)
- [fpGo](https://github.com/TeaEntityLab/fpGo) **star:348** Monad, Functional Programming features for Golang.   [![godoc][D]](https://godoc.org/github.com/TeaEntityLab/fpGo)
- [fp-go](https://github.com/repeale/fp-go) **star:296** Collection of Functional Programming helpers powered by Golang 1.18+ generics.   [![godoc][D]](https://godoc.org/github.com/repeale/fp-go)
- [gofp](https://github.com/rbrahul/gofp) **star:144** A lodash like powerful utility library for Golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/rbrahul/gofp)   [![godoc][D]](https://godoc.org/github.com/rbrahul/gofp)
- [fuego](https://github.com/seborama/fuego) **star:141** Functional Experiment in Go.   [![godoc][D]](https://godoc.org/github.com/seborama/fuego)
- [underscore](https://github.com/rjNemo/underscore) **star:109** Functional programming helpers for Go 1.18 and beyond.   [![godoc][D]](https://godoc.org/github.com/rjNemo/underscore)
- [valor](https://github.com/phelmkamp/valor) **star:16** Generic option and result types that optionally contain a value.   [![godoc][D]](https://godoc.org/github.com/phelmkamp/valor)

**[⬆ back to top](#contents)**

## Game Development

_Awesome game development libraries._

- [Ebitengine](https://github.com/hajimehoshi/ebiten) **star:10583** dead simple 2D game engine in Go.   [![There was an update last month][G]](https://github.com/hajimehoshi/ebiten)   [![godoc][D]](https://godoc.org/github.com/hajimehoshi/ebiten)
- [Leaf](https://github.com/name5566/leaf) **star:5228** Lightweight game server framework.   [![godoc][D]](https://godoc.org/github.com/name5566/leaf)   [![Contains Chinese documents][CN]](https://github.com/name5566/leaf)
- [Pixel](https://github.com/faiface/pixel) **star:4440** Hand-crafted 2D game library in Go.   [![godoc][D]](https://godoc.org/github.com/faiface/pixel)
- [nano](https://github.com/lonng/nano) **star:2782** Lightweight, facility, high performance golang based game server framework.   [![godoc][D]](https://godoc.org/github.com/lonng/nano)   [![Contains Chinese documents][CN]](https://github.com/lonng/nano)
- [g3n](https://github.com/g3n/engine) **star:2723** Go 3D Game Engine.   [![There was an update last month][G]](https://github.com/g3n/engine)   [![godoc][D]](https://godoc.org/github.com/g3n/engine)
- [goworld](https://github.com/xiaonanln/goworld) **star:2543** Scalable game server engine, featuring space-entity framework and hot-swapping.   [![godoc][D]](https://godoc.org/github.com/xiaonanln/goworld)   [![Contains Chinese documents][CN]](https://github.com/xiaonanln/goworld)
- [Pitaya](https://github.com/topfreegames/pitaya) **star:2262** Scalable game server framework with clustering support and client libraries for iOS, Android, Unity and others through the C SDK.   [![There was an update last month][G]](https://github.com/topfreegames/pitaya)   [![godoc][D]](https://godoc.org/github.com/topfreegames/pitaya)
- [go-sdl2](https://github.com/veandco/go-sdl2) **star:2186** Go bindings for the [Simple DirectMedia Layer](https://www.libsdl.org/).
- [engo](https://github.com/EngoEngine/engo) **star:1731** Engo is an open-source 2D game engine written in Go. It follows the Entity-Component-System paradigm.   [![godoc][D]](https://godoc.org/github.com/EngoEngine/engo)
- [Oak](https://github.com/oakmound/oak) **star:1534** Pure Go game engine.   [![godoc][D]](https://godoc.org/github.com/oakmound/oak)
- [raylib-go](https://github.com/gen2brain/raylib-go) **star:1491** Go bindings for [raylib](https://www.raylib.com/), a simple and easy-to-use library to learn videogames programming.   [![There was an update last month][G]](https://github.com/gen2brain/raylib-go)
- [termloop](https://github.com/JoelOtter/termloop) **star:1419** Terminal-based game engine for Go, built on top of Termbox.   [![godoc][D]](https://godoc.org/github.com/JoelOtter/termloop)
- [gonet](https://github.com/xtaci/gonet) **star:1255** Game server skeleton implemented with golang.   [![godoc][D]](https://godoc.org/github.com/xtaci/gonet)
- [Azul3D](https://github.com/azul3d/engine) **star:610** 3D game engine written in Go.
- [go-astar](https://github.com/beefsack/go-astar) **star:591** Go implementation of the A\* path finding algorithm.   [![godoc][D]](https://godoc.org/github.com/beefsack/go-astar)
- [Harfang3D](https://github.com/harfang3d/harfang3d) **star:551** 3D engine for the Go language, works on Windows and Linux ([Harfang on Go.dev](https://github.com/harfang3d/harfang-go)).
- [go3d](https://github.com/ungerik/go3d) **star:307** Performance oriented 2D/3D math package for Go.   [![godoc][D]](https://godoc.org/github.com/ungerik/go3d)
- [tile](https://github.com/kelindar/tile) **star:145** Data-oriented and cache-friendly 2D Grid library (TileMap), includes pathfinding, observers and import/export.   [![godoc][D]](https://godoc.org/github.com/kelindar/tile)
- [ecs](https://github.com/andygeiss/ecs) **star:103** Build your own Game-Engine based on the Entity Component System concept in Golang.   [![There was an update last month][G]](https://github.com/andygeiss/ecs)   [![godoc][D]](https://godoc.org/github.com/andygeiss/ecs)
- [prototype](https://github.com/gonutz/prototype) **star:87** Cross-platform (Windows/Linux/Mac) library for creating desktop games using a minimal API.   [![godoc][D]](https://godoc.org/github.com/gonutz/prototype)
- [fantasyname](https://github.com/s0rg/fantasyname) **star:32** Fantasy names generator.   [![godoc][D]](https://godoc.org/github.com/s0rg/fantasyname)

**[⬆ back to top](#contents)**

## Generators

_Tools that generate Go code._

- [oapi-codegen](https://github.com/deepmap/oapi-codegen) **star:5755** This package contains a set of utilities for generating Go boilerplate code for services based on OpenAPI 3.0 API definitions.   [![There was an update last month][G]](https://github.com/deepmap/oapi-codegen)   [![godoc][D]](https://godoc.org/github.com/deepmap/oapi-codegen)
- [go-linq](https://github.com/ahmetalpbalkan/go-linq) **star:3487** .NET LINQ-like query methods for Go.   [![godoc][D]](https://godoc.org/github.com/ahmetalpbalkan/go-linq)
- [jennifer](https://github.com/dave/jennifer) **star:3258** Generate arbitrary Go code without templates.   [![godoc][D]](https://godoc.org/github.com/dave/jennifer)
- [goderive](https://github.com/awalterschulze/goderive) **star:1224** Derives functions from input types.   [![godoc][D]](https://godoc.org/github.com/awalterschulze/goderive)
- [GoWrap](https://github.com/hexdigest/gowrap) **star:1010** Generate decorators for Go interfaces using simple templates.   [![godoc][D]](https://godoc.org/github.com/hexdigest/gowrap)
- [go-enum](https://github.com/abice/go-enum) **star:709** Code generation for enums from code comments.   [![There was an update last month][G]](https://github.com/abice/go-enum)   [![godoc][D]](https://godoc.org/github.com/abice/go-enum)
- [goverter](https://github.com/jmattheis/goverter) **star:483** Generate converters by defining an interface.   [![There was an update last month][G]](https://github.com/jmattheis/goverter)   [![godoc][D]](https://godoc.org/github.com/jmattheis/goverter)
- [interfaces](https://github.com/rjeczalik/interfaces) **star:421** Command line tool for generating interface definitions.   [![godoc][D]](https://godoc.org/github.com/rjeczalik/interfaces)
- [copygen](https://github.com/switchupcb/copygen) **star:342** Generate type-to-type and type-based code without reflection.   [![godoc][D]](https://godoc.org/github.com/switchupcb/copygen)
- [gotype](https://github.com/wzshiming/gotype) **star:60** Golang source code parsing, usage like reflect package.   [![godoc][D]](https://godoc.org/github.com/wzshiming/gotype)   [![Contains Chinese documents][CN]](https://github.com/wzshiming/gotype)
- [generis](https://github.com/senselogic/GENERIS) **star:43** Code generation tool providing generics, free-form macros, conditional compilation and HTML templating.
- [convergen](https://github.com/reedom/convergen) **star:33** Feature rich type-to-type copy code generator.   [![godoc][D]](https://godoc.org/github.com/reedom/convergen)
- [typeregistry](https://github.com/xiaoxin01/typeregistry) **star:23** A library to create type dynamically.   [![It hasn't been updated in recent three years][Y]](https://github.com/xiaoxin01/typeregistry)   [![godoc][D]](https://godoc.org/github.com/xiaoxin01/typeregistry)

**[⬆ back to top](#contents)**

## Geographic

_Geographic tools and servers_

- [Tile38](https://github.com/tidwall/tile38) **star:9025** Geolocation DB with spatial index and realtime geofencing.   [![godoc][D]](https://godoc.org/github.com/tidwall/tile38)
- [S2 geometry](https://github.com/golang/geo) **star:1657** S2 geometry library in Go.   [![godoc][D]](https://godoc.org/github.com/golang/geo)
- [mbtileserver](https://github.com/consbio/mbtileserver) **star:632** A simple Go-based server for map tiles stored in mbtiles format.   [![godoc][D]](https://godoc.org/github.com/consbio/mbtileserver)
- [geoos](https://github.com/spatial-go/geoos) **star:610** A library provides spatial data and geometric algorithms.   [![godoc][D]](https://godoc.org/github.com/spatial-go/geoos)
- [osm](https://github.com/paulmach/osm) **star:359** Library for reading, writing and working with OpenStreetMap data and APIs.   [![godoc][D]](https://godoc.org/github.com/paulmach/osm)
- [H3](https://github.com/uber/h3-go) **star:294** Go bindings for H3, a hierarchical hexagonal geospatial indexing system.   [![There was an update last month][G]](https://github.com/uber/h3-go)   [![godoc][D]](https://godoc.org/github.com/uber/h3-go)
- [simplefeatures](https://github.com/peterstace/simplefeatures) **star:126** simplesfeatures is a 2D geometry library that provides Go types that model geometries, as well as algorithms that operate on them.   [![godoc][D]](https://godoc.org/github.com/peterstace/simplefeatures)
- [godal](https://github.com/airbusgeo/godal) **star:125** Go wrapper for GDAL.   [![godoc][D]](https://godoc.org/github.com/airbusgeo/godal)
- [geoserver](https://github.com/hishamkaram/geoserver) **star:86** geoserver Is a Go Package For Manipulating a GeoServer Instance via the GeoServer REST API.   [![godoc][D]](https://godoc.org/github.com/hishamkaram/geoserver)
- [gismanager](https://github.com/hishamkaram/gismanager) **star:53** Publish Your GIS Data(Vector Data) to PostGIS and Geoserver.   [![It hasn't been updated in recent three years][Y]](https://github.com/hishamkaram/gismanager)   [![godoc][D]](https://godoc.org/github.com/hishamkaram/gismanager)
- [pbf](https://github.com/maguro/pbf) **star:48** OpenStreetMap PBF golang encoder/decoder.   [![godoc][D]](https://godoc.org/github.com/maguro/pbf)
- [S2 geojson](https://github.com/pantrif/s2-geojson) **star:28** Convert geojson to s2 cells & demonstrating some S2 geometry features on map.   [![godoc][D]](https://godoc.org/github.com/pantrif/s2-geojson)
- [H3 GeoJSON](https://github.com/mmadfox/go-geojson2h3) **star:3** Conversion utilities between H3 indexes and GeoJSON.   [![godoc][D]](https://godoc.org/github.com/mmadfox/go-geojson2h3)
- [H3GeoDist](https://github.com/mmadfox/go-h3geo-dist) **star:2** Distribution of Uber H3geo cells by virtual nodes.   [![godoc][D]](https://godoc.org/github.com/mmadfox/go-h3geo-dist)
- [Web-Mercator-Projection](https://github.com/jorelosorio/web-mercator-projection) A project to easily use and convert LonLat, Point and Tile to display info, markers, etc, in a map using the Web Mercator Projection.
- [WGS84](https://github.com/wroge/wgs84) **star:118** Library for Coordinate Conversion and Transformation (ETRS89, OSGB36, NAD83, RGF93, Web Mercator, UTM).   [![godoc][D]](https://godoc.org/github.com/wroge/wgs84)

**[⬆ back to top](#contents)**

## Go Compilers

_Tools for compiling Go to other languages._

- [gopherjs](https://github.com/gopherjs/gopherjs) **star:12633** Compiler from Go to JavaScript.   [![There was an update last month][G]](https://github.com/gopherjs/gopherjs)   [![godoc][D]](https://godoc.org/github.com/gopherjs/gopherjs)
- [tardisgo](https://github.com/tardisgo/tardisgo) **star:432** Golang to Haxe to CPP/CSharp/Java/JavaScript transpiler.   [![It hasn't been updated in recent three years][Y]](https://github.com/tardisgo/tardisgo)   [![godoc][D]](https://godoc.org/github.com/tardisgo/tardisgo)
- [c4go](https://github.com/Konstantin8105/c4go) **star:364** Transpile C code to Go code.
- [c2go](https://github.com/goplus/c2go) **star:307** Convert C code to Go code.   [![godoc][D]](https://godoc.org/github.com/goplus/c2go)   [![Archived][Archived]](https://github.com/goplus/c2go)
- [esp32](https://github.com/andygeiss/esp32-transpiler) **star:80** Transpile Go into Arduino code.   [![There was an update last month][G]](https://github.com/andygeiss/esp32-transpiler)   [![godoc][D]](https://godoc.org/github.com/andygeiss/esp32-transpiler)
- [f4go](https://github.com/Konstantin8105/f4go) **star:43** Transpile FORTRAN 77 code to Go code.   [![godoc][D]](https://godoc.org/github.com/Konstantin8105/f4go)

**[⬆ back to top](#contents)**

## Goroutines

_Tools for managing and working with Goroutines._

- [ants](https://github.com/panjf2000/ants) **star:12579** A high-performance and low-cost goroutine pool in Go.   [![godoc][D]](https://godoc.org/github.com/panjf2000/ants)   [![Contains Chinese documents][CN]](https://github.com/panjf2000/ants)
- [conc](https://github.com/sourcegraph/conc) **star:8827** `conc` is your toolbelt for structured concurrency in go, making common tasks easier and safer.   [![godoc][D]](https://godoc.org/github.com/sourcegraph/conc)
- [tunny](https://github.com/Jeffail/tunny) **star:3861** Goroutine pool for golang.   [![godoc][D]](https://godoc.org/github.com/Jeffail/tunny)
- [goworker](https://github.com/benmanns/goworker) **star:2794** goworker is a Go-based background worker.   [![godoc][D]](https://godoc.org/github.com/benmanns/goworker)
- [pond](https://github.com/alitto/pond) **star:1407** Minimalistic and High-performance goroutine worker pool written in Go.   [![godoc][D]](https://godoc.org/github.com/alitto/pond)
- [workerpool](https://github.com/gammazero/workerpool) **star:1292** Goroutine pool that limits the concurrency of task execution, not the number of tasks queued.   [![godoc][D]](https://godoc.org/github.com/gammazero/workerpool)
- [grpool](https://github.com/ivpusic/grpool) **star:741** Lightweight Goroutine pool.   [![It hasn't been updated in recent three years][Y]](https://github.com/ivpusic/grpool)   [![godoc][D]](https://godoc.org/github.com/ivpusic/grpool)
- [pool](https://github.com/go-playground/pool) **star:725** Limited consumer goroutine or unlimited goroutine pool for easier goroutine handling and cancellation.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-playground/pool)   [![godoc][D]](https://godoc.org/github.com/go-playground/pool)
- [gowp](https://github.com/xxjwxc/gowp) **star:493** gowp is concurrency limiting goroutine pool.   [![godoc][D]](https://godoc.org/github.com/xxjwxc/gowp)   [![Contains Chinese documents][CN]](https://github.com/xxjwxc/gowp)
- [flowmatic](https://github.com/carlmjohnson/flowmatic) **star:352** Structured concurrency made easy.   [![godoc][D]](https://godoc.org/github.com/carlmjohnson/flowmatic)
- [go-floc](https://github.com/workanator/go-floc) **star:270** Orchestrate goroutines with ease.   [![It hasn't been updated in recent three years][Y]](https://github.com/workanator/go-floc)   [![godoc][D]](https://godoc.org/github.com/workanator/go-floc)
- [go-flow](https://github.com/kamildrazkiewicz/go-flow) **star:219** Control goroutines execution order.   [![It hasn't been updated in recent three years][Y]](https://github.com/kamildrazkiewicz/go-flow)   [![godoc][D]](https://godoc.org/github.com/kamildrazkiewicz/go-flow)
- [routine](https://github.com/timandy/routine) **star:211** `routine` is a `ThreadLocal` for go library. It encapsulates and provides some easy-to-use, non-competitive, high-performance `goroutine` context access interfaces, which can help you access coroutine context information more gracefully.   [![godoc][D]](https://godoc.org/github.com/timandy/routine)   [![Contains Chinese documents][CN]](https://github.com/timandy/routine)
- [async](https://github.com/reugn/async) **star:207** An alternative sync library for Go (Future, Promise, Locks).   [![godoc][D]](https://godoc.org/github.com/reugn/async)
- [artifex](https://github.com/borderstech/artifex) **star:197** Simple in-memory job queue for Golang using worker-based dispatching.   [![godoc][D]](https://godoc.org/github.com/borderstech/artifex)
- [semaphore](https://github.com/marusama/semaphore) **star:170** Fast resizable semaphore implementation based on CAS (faster than channel-based semaphore implementations).   [![It hasn't been updated in recent three years][Y]](https://github.com/marusama/semaphore)   [![godoc][D]](https://godoc.org/github.com/marusama/semaphore)
- [go-workers](https://github.com/catmullet/go-workers) **star:164** Easily and safely run workers for large data processing pipelines.   [![godoc][D]](https://godoc.org/github.com/catmullet/go-workers)   [![Archived][Archived]](https://github.com/catmullet/go-workers)
- [neilotoole/errgroup](https://github.com/neilotoole/errgroup) **star:159** Drop-in alternative to `sync/errgroup`, limited to a pool of N worker goroutines.   [![godoc][D]](https://godoc.org/github.com/neilotoole/errgroup)
- [cyclicbarrier](https://github.com/marusama/cyclicbarrier) **star:140** CyclicBarrier for golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/marusama/cyclicbarrier)   [![godoc][D]](https://godoc.org/github.com/marusama/cyclicbarrier)
- [async](https://github.com/studiosol/async) **star:135** A safe way to execute functions asynchronously, recovering them in case of panic.   [![It hasn't been updated in recent three years][Y]](https://github.com/studiosol/async)   [![godoc][D]](https://godoc.org/github.com/studiosol/async)
- [go-actor](https://github.com/vladopajic/go-actor) **star:134** A tiny library for writing concurrent programs using actor model.   [![godoc][D]](https://godoc.org/github.com/vladopajic/go-actor)
- [gollback](https://github.com/vardius/gollback) **star:121** asynchronous simple function utilities, for managing execution of closures and callbacks.   [![godoc][D]](https://godoc.org/github.com/vardius/gollback)
- [threadpool](https://github.com/shettyh/threadpool) **star:102** Golang threadpool implementation.   [![It hasn't been updated in recent three years][Y]](https://github.com/shettyh/threadpool)   [![godoc][D]](https://godoc.org/github.com/shettyh/threadpool)
- [Hunch](https://github.com/AaronJan/Hunch) **star:99** Hunch provides functions like: `All`, `First`, `Retry`, `Waterfall` etc., that makes asynchronous flow control more intuitive.   [![godoc][D]](https://godoc.org/github.com/AaronJan/Hunch)
- [semaphore](https://github.com/kamilsk/semaphore) **star:98** Semaphore pattern implementation with timeout of lock/unlock operations based on channel and context.   [![It hasn't been updated in recent three years][Y]](https://github.com/kamilsk/semaphore)   [![godoc][D]](https://godoc.org/github.com/kamilsk/semaphore)
- [worker-pool](https://github.com/vardius/worker-pool) **star:92** goworker is a Go simple async worker pool.   [![It hasn't been updated in recent three years][Y]](https://github.com/vardius/worker-pool)   [![godoc][D]](https://godoc.org/github.com/vardius/worker-pool)
- [gpool](https://github.com/Sherifabdlnaby/gpool) **star:90** manages a resizeable pool of context-aware goroutines to bound concurrency.   [![It hasn't been updated in recent three years][Y]](https://github.com/Sherifabdlnaby/gpool)   [![godoc][D]](https://godoc.org/github.com/Sherifabdlnaby/gpool)
- [goccm](https://github.com/zenthangplus/goccm) **star:69** Go Concurrency Manager package limits the number of goroutines that allowed to run concurrently.   [![godoc][D]](https://godoc.org/github.com/zenthangplus/goccm)
- [gowl](https://github.com/hamed-yousefi/gowl) **star:69** Gowl is a process management and process monitoring tool at once. An infinite worker pool gives you the ability to control the pool and processes and monitor their status.   [![godoc][D]](https://godoc.org/github.com/hamed-yousefi/gowl)
- [nursery](https://github.com/arunsworld/nursery) **star:64** Structured concurrency in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/arunsworld/nursery)   [![godoc][D]](https://godoc.org/github.com/arunsworld/nursery)
- [oversight](https://pkg.go.dev/cirello.io/oversight)  Oversight is a complete implementation of the Erlang supervision trees.
- [routine](https://github.com/x-mod/routine) **star:61** go routine control with context, support: Main, Go, Pool and some useful Executors.   [![godoc][D]](https://godoc.org/github.com/x-mod/routine)
- [gohive](https://github.com/loveleshsharma/gohive) **star:52** A highly performant and easy to use Goroutine pool for Go.   [![godoc][D]](https://godoc.org/github.com/loveleshsharma/gohive)
- [kyoo](https://github.com/dirkaholic/kyoo) **star:50** Provides an unlimited job queue and concurrent worker pools.   [![godoc][D]](https://godoc.org/github.com/dirkaholic/kyoo)
- [go-waitgroup](https://github.com/pieterclaerhout/go-waitgroup) **star:47** Like `sync.WaitGroup` with error handling and concurrency control.   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-waitgroup)
- [parallel-fn](https://github.com/rafaeljesus/parallel-fn) **star:36** Run functions in parallel.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafaeljesus/parallel-fn)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/parallel-fn)
- [go-trylock](https://github.com/subchen/go-trylock) **star:35** TryLock support on read-write lock for Golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/subchen/go-trylock)   [![godoc][D]](https://godoc.org/github.com/subchen/go-trylock)
- [channelify](https://github.com/ddelizia/channelify) **star:31** Transform your function to return channels for easy and powerful parallel processing.   [![It hasn't been updated in recent three years][Y]](https://github.com/ddelizia/channelify)   [![godoc][D]](https://godoc.org/github.com/ddelizia/channelify)
- [stl](https://github.com/ssgreg/stl) **star:30** Software transactional locks based on Software Transactional Memory (STM) concurrency control mechanism.   [![It hasn't been updated in recent three years][Y]](https://github.com/ssgreg/stl)   [![godoc][D]](https://godoc.org/github.com/ssgreg/stl)
- [execpool](https://github.com/hexdigest/execpool) **star:22** A pool built around exec.Cmd that spins up a given number of processes in advance and attaches stdin and stdout to them when needed. Very similar to FastCGI or Apache Prefork MPM but works for any command.   [![It hasn't been updated in recent three years][Y]](https://github.com/hexdigest/execpool)   [![godoc][D]](https://godoc.org/github.com/hexdigest/execpool)
- [breaker](https://github.com/kamilsk/breaker) **star:18** Flexible mechanism to make execution flow interruptible.   [![It hasn't been updated in recent three years][Y]](https://github.com/kamilsk/breaker)
- [queue](https://github.com/AnikHasibul/queue) **star:18** Gives you a `sync.WaitGroup` like queue group accessibility. Helps you to throttle and limit goroutines, wait for the end of the all goroutines and much more.   [![It hasn't been updated in recent three years][Y]](https://github.com/AnikHasibul/queue)   [![godoc][D]](https://godoc.org/github.com/AnikHasibul/queue)
- [concurrency-limiter](https://github.com/vivek-ng/concurrency-limiter) **star:17** Concurrency limiter with support for timeouts, dynamic priority and context cancellation of goroutines.   [![godoc][D]](https://godoc.org/github.com/vivek-ng/concurrency-limiter)
- [conexec](https://github.com/ITcathyh/conexec) **star:16** A concurrent toolkit to help execute funcs concurrently in an efficient and safe way. It supports specifying the overall timeout to avoid blocking and uses goroutine pool to improve efficiency.   [![It hasn't been updated in recent three years][Y]](https://github.com/ITcathyh/conexec)   [![godoc][D]](https://godoc.org/github.com/ITcathyh/conexec)
- [go-tools/multithreading](https://github.com/nikhilsaraf/go-tools) **star:15** Manage a pool of goroutines using this lightweight library with a simple API.   [![It hasn't been updated in recent three years][Y]](https://github.com/nikhilsaraf/go-tools)   [![godoc][D]](https://godoc.org/github.com/nikhilsaraf/go-tools)
- [go-workerpool](https://github.com/zenthangplus/go-workerpool) **star:12** Inspired from Java Thread Pool, Go WorkerPool aims to control heavy Go Routines.   [![godoc][D]](https://godoc.org/github.com/zenthangplus/go-workerpool)
- [hands](https://github.com/duanckham/hands) **star:10** A process controller used to control the execution and return strategies of multiple goroutines.   [![godoc][D]](https://godoc.org/github.com/duanckham/hands)
- [async-job](https://github.com/lab210-dev/async-job) **star:9** AsyncJob is an asynchronous queue job manager with light code, clear and speed.   [![godoc][D]](https://godoc.org/github.com/lab210-dev/async-job)
- [go-accumulator](https://github.com/nar10z/go-accumulator) **star:7** Solution for accumulation of events and their subsequent processing.   [![godoc][D]](https://godoc.org/github.com/nar10z/go-accumulator)

**[⬆ back to top](#contents)**

## GUI

_Libraries for building GUI Applications._

_Toolkits_

- [fyne](https://github.com/fyne-io/fyne) **star:24246** Cross platform native GUIs designed for Go based on Material Design. Supports: Linux, macOS, Windows, BSD, iOS and Android.   [![There was an update last month][G]](https://github.com/fyne-io/fyne)   [![godoc][D]](https://godoc.org/github.com/fyne-io/fyne)
- [gio](https://gioui.org)  Gio is a library for writing cross-platform immediate mode GUI-s in Go. Gio supports all the major platforms: Linux, macOS, Windows, Android, iOS, FreeBSD, OpenBSD and WebAssembly.
- [go-gtk](https://mattn.github.io/go-gtk/)  Go bindings for GTK.
- [webview](https://github.com/zserge/webview) **star:12414** Cross-platform webview window with simple two-way JavaScript bindings (Windows / macOS / Linux).   [![There was an update last month][G]](https://github.com/zserge/webview)
- [qt](https://github.com/therecipe/qt) **star:10346** Qt binding for Go (support for Windows / macOS / Linux / Android / iOS / Sailfish OS / Raspberry Pi).   [![godoc][D]](https://godoc.org/github.com/therecipe/qt)
- [ui](https://github.com/andlabs/ui) **star:8333** Platform-native GUI library for Go. Cross platform.   [![godoc][D]](https://godoc.org/github.com/andlabs/ui)
- [app](https://github.com/murlokswarm/app) **star:7829** Package to create apps with GO, HTML and CSS. Supports: MacOS, Windows in progress.   [![godoc][D]](https://godoc.org/github.com/murlokswarm/app)
- [walk](https://github.com/lxn/walk) **star:6810** Windows application library kit for Go.   [![godoc][D]](https://godoc.org/github.com/lxn/walk)
- [DarwinKit](https://github.com/progrium/darwinkit) **star:4901** Build native macOS applications using Go.   [![godoc][D]](https://godoc.org/github.com/progrium/darwinkit)
- [go-sciter](https://github.com/sciter-sdk/go-sciter) **star:2571** Go bindings for Sciter: the Embeddable HTML/CSS/script engine for modern desktop UI development. Cross platform.
- [Goey](https://bitbucket.org/rj/goey/src/master/)  Cross platform UI toolkit aggregator for Windows / Linux / Mac. GTK, Cocoa, Windows API
- [gotk3](https://github.com/gotk3/gotk3) **star:2072** Go bindings for GTK3.   [![There was an update last month][G]](https://github.com/gotk3/gotk3)   [![godoc][D]](https://godoc.org/github.com/gotk3/gotk3)
- [Spot](https://github.com/roblillack/spot) **star:1059** Reactive, cross-platform desktop GUI toolkit.   [![godoc][D]](https://godoc.org/github.com/roblillack/spot)
- [gowd](https://github.com/dtylman/gowd) **star:426** Rapid and simple desktop UI development with GO, HTML, CSS and NW.js. Cross platform.   [![godoc][D]](https://godoc.org/github.com/dtylman/gowd)
- [energy](https://github.com/energye/energy) **star:346** Cross-platform based on LCL(Native System UI Control Library) and CEF(Chromium Embedded Framework) (Windows/ macOS / Linux)   [![There was an update last month][G]](https://github.com/energye/energy)   [![godoc][D]](https://godoc.org/github.com/energye/energy)   [![Contains Chinese documents][CN]](https://github.com/energye/energy)
- [unison](https://github.com/richardwilkes/unison) **star:174** A unified graphical user experience toolkit for Go desktop applications. macOS, Windows, and Linux are supported.   [![godoc][D]](https://godoc.org/github.com/richardwilkes/unison)
- [Wails](https://wails.io)  Mac, Windows, Linux desktop apps with HTML UI using built-in OS HTML renderer.
- [goradd/html5tag](https://github.com/goradd/html5tag) **star:10** Library for outputting HTML5 tags.   [![godoc][D]](https://godoc.org/github.com/goradd/html5tag)

_Interaction_

- [robotgo](https://github.com/go-vgo/robotgo) **star:9505** Go Native cross-platform GUI system automation. Control the mouse, keyboard and other.   [![There was an update last month][G]](https://github.com/go-vgo/robotgo)   [![godoc][D]](https://godoc.org/github.com/go-vgo/robotgo)
- [systray](https://github.com/getlantern/systray) **star:3220** Cross platform Go library to place an icon and menu in the notification area.   [![godoc][D]](https://godoc.org/github.com/getlantern/systray)
- [zenity](https://github.com/ncruces/zenity) **star:687** Cross-platform Go library and CLI to create simple dialogs that interact graphically with the user.   [![There was an update last month][G]](https://github.com/ncruces/zenity)   [![godoc][D]](https://godoc.org/github.com/ncruces/zenity)
- [gosx-notifier](https://github.com/deckarep/gosx-notifier) **star:586** OSX Desktop Notifications library for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/deckarep/gosx-notifier)   [![godoc][D]](https://godoc.org/github.com/deckarep/gosx-notifier)
- [trayhost](https://github.com/shurcooL/trayhost) **star:251** Cross-platform Go library to place an icon in the host operating system's taskbar.   [![godoc][D]](https://godoc.org/github.com/shurcooL/trayhost)
- [mac-sleep-notifier](https://github.com/prashantgupta24/mac-sleep-notifier) **star:32** OSX Sleep/Wake notifications in golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/prashantgupta24/mac-sleep-notifier)   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/mac-sleep-notifier)
- [mac-activity-tracker](https://github.com/prashantgupta24/activity-tracker) **star:28** OSX library to notify about any (pluggable) activity on your machine.   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/activity-tracker)
- [AppIndicator Go](https://github.com/gopherlibs/appindicator) **star:5** Go bindings for libappindicator3 C library.   [![godoc][D]](https://godoc.org/github.com/gopherlibs/appindicator)

**[⬆ back to top](#contents)**

## Hardware

_Libraries, tools, and tutorials for interacting with hardware._

- [arduino-cli](https://github.com/arduino/arduino-cli) **star:4260** Official Arduino CLI and library. Can run standalone, or be incorporated into larger Go projects.   [![There was an update last month][G]](https://github.com/arduino/arduino-cli)   [![godoc][D]](https://godoc.org/github.com/arduino/arduino-cli)
- [go-rpio](https://github.com/stianeikeland/go-rpio) **star:2168** GPIO for Go, doesn't require cgo.   [![godoc][D]](https://godoc.org/github.com/stianeikeland/go-rpio)
- [ghw](https://github.com/jaypipes/ghw) **star:1620** Golang hardware discovery/inspection library.   [![godoc][D]](https://godoc.org/github.com/jaypipes/ghw)
- [emgo](https://github.com/ziutek/emgo) **star:1066** Go-like language for programming embedded systems (e.g. STM32 MCU).
- [sysinfo](https://github.com/zcalusic/sysinfo) **star:513** A pure Go library providing Linux OS / kernel / hardware system information.   [![godoc][D]](https://godoc.org/github.com/zcalusic/sysinfo)
- [goroslib](https://github.com/aler9/goroslib) **star:319** Robot Operating System (ROS) library for Go.   [![godoc][D]](https://godoc.org/github.com/aler9/goroslib)
- [go-osc](https://github.com/hypebeast/go-osc) **star:197** Open Sound Control (OSC) bindings for Go.   [![godoc][D]](https://godoc.org/github.com/hypebeast/go-osc)
- [joystick](https://github.com/0xcafed00d/joystick) **star:59** a polled API to read the state of an attached joystick.   [![godoc][D]](https://godoc.org/github.com/0xcafed00d/joystick)

**[⬆ back to top](#contents)**

## Images

_Libraries for manipulating images._

- [gocv](https://github.com/hybridgroup/gocv) **star:6511** Go package for computer vision using OpenCV 3.3+.   [![There was an update last month][G]](https://github.com/hybridgroup/gocv)   [![godoc][D]](https://godoc.org/github.com/hybridgroup/gocv)
- [imaginary](https://github.com/h2non/imaginary) **star:5444** Fast and simple HTTP microservice for image resizing.   [![godoc][D]](https://godoc.org/github.com/h2non/imaginary)
- [imaging](https://github.com/disintegration/imaging) **star:5184** Simple Go image processing package.   [![godoc][D]](https://godoc.org/github.com/disintegration/imaging)
- [gg](https://github.com/fogleman/gg) **star:4355** 2D rendering in pure Go.   [![godoc][D]](https://godoc.org/github.com/fogleman/gg)
- [bild](https://github.com/anthonynsimon/bild) **star:3950** Collection of image processing algorithms in pure Go.   [![godoc][D]](https://godoc.org/github.com/anthonynsimon/bild)
- [ln](https://github.com/fogleman/ln) **star:3261** 3D line art rendering in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/fogleman/ln)   [![godoc][D]](https://godoc.org/github.com/fogleman/ln)
- [gowitness](https://github.com/sensepost/gowitness) **star:2827** Screenshoting webpages using go and headless chrome on command line.   [![godoc][D]](https://godoc.org/github.com/sensepost/gowitness)
- [bimg](https://github.com/h2non/bimg) **star:2636** Small package for fast and efficient image processing using libvips.   [![godoc][D]](https://godoc.org/github.com/h2non/bimg)
- [svgo](https://github.com/ajstarks/svgo) **star:2134** Go Language Library for SVG generation.   [![godoc][D]](https://godoc.org/github.com/ajstarks/svgo)
- [picfit](https://github.com/thoas/picfit) **star:2085** An image resizing server written in Go.   [![There was an update last month][G]](https://github.com/thoas/picfit)   [![godoc][D]](https://godoc.org/github.com/thoas/picfit)
- [pt](https://github.com/fogleman/pt) **star:2074** Path tracing engine written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/fogleman/pt)   [![godoc][D]](https://godoc.org/github.com/fogleman/pt)
- [smartcrop](https://github.com/muesli/smartcrop) **star:1808** Finds good crops for arbitrary images and crop sizes.   [![godoc][D]](https://godoc.org/github.com/muesli/smartcrop)
- [imagick](https://github.com/gographics/imagick) **star:1742** Go binding to ImageMagick's MagickWand C API.   [![godoc][D]](https://godoc.org/github.com/gographics/imagick)
- [gift](https://github.com/disintegration/gift) **star:1736** Package of image processing filters.   [![godoc][D]](https://godoc.org/github.com/disintegration/gift)
- [canvas](https://github.com/tdewolff/canvas) **star:1467** Vector graphics to PDF, SVG or rasterized image.   [![godoc][D]](https://godoc.org/github.com/tdewolff/canvas)
- [geopattern](https://github.com/pravj/geopattern) **star:1266** Create beautiful generative image patterns from a string.   [![It hasn't been updated in recent three years][Y]](https://github.com/pravj/geopattern)   [![godoc][D]](https://godoc.org/github.com/pravj/geopattern)
- [govips](https://github.com/davidbyttow/govips) **star:1226** A lightning fast image processing and resizing library for Go.   [![godoc][D]](https://godoc.org/github.com/davidbyttow/govips)
- [stegify](https://github.com/DimitarPetrov/stegify) **star:1188** Go tool for LSB steganography, capable of hiding any file within an image.   [![godoc][D]](https://godoc.org/github.com/DimitarPetrov/stegify)
- [image2ascii](https://github.com/qeesung/image2ascii) **star:849** Convert image to ASCII.   [![godoc][D]](https://godoc.org/github.com/qeesung/image2ascii)
- [goimagehash](https://github.com/corona10/goimagehash) **star:729** Go Perceptual image hashing package.   [![godoc][D]](https://godoc.org/github.com/corona10/goimagehash)
- [govatar](https://github.com/o1egl/govatar) **star:584** Library and CMD tool for generating funny avatars.   [![godoc][D]](https://godoc.org/github.com/o1egl/govatar)
- [draft](https://github.com/lucasepe/draft) **star:578** Generate High Level Microservice Architecture diagrams for GraphViz using simple YAML syntax.   [![godoc][D]](https://godoc.org/github.com/lucasepe/draft)
- [mort](https://github.com/aldor007/mort) **star:506** Storage and image processing server written in Go.   [![godoc][D]](https://godoc.org/github.com/aldor007/mort)
- [go-nude](https://github.com/koyachi/go-nude) **star:410** Nudity detection with Go.   [![godoc][D]](https://godoc.org/github.com/koyachi/go-nude)
- [steganography](https://github.com/auyer/steganography) **star:308** Pure Go Library for LSB steganography.   [![godoc][D]](https://godoc.org/github.com/auyer/steganography)
- [gltf](https://github.com/qmuntal/gltf) **star:241** Efficient and robust glTF 2.0 reader, writer and validator.   [![godoc][D]](https://godoc.org/github.com/qmuntal/gltf)
- [mergi](https://github.com/noelyahan/mergi) **star:230** Tool & Go library for image manipulation (Merge, Crop, Resize, Watermark, Animate).   [![It hasn't been updated in recent three years][Y]](https://github.com/noelyahan/mergi)   [![godoc][D]](https://godoc.org/github.com/noelyahan/mergi)
- [darkroom](https://github.com/gojek/darkroom) **star:223** An image proxy with changeable storage backends and image processing engines with focus on speed and resiliency.   [![godoc][D]](https://godoc.org/github.com/gojek/darkroom)
- [go-webp](https://github.com/kolesa-team/go-webp) **star:213** Library for encode and decode webp pictures, using libwebp.   [![godoc][D]](https://godoc.org/github.com/kolesa-team/go-webp)
- [rez](https://github.com/bamiaux/rez) **star:212** Image resizing in pure Go and SIMD.   [![It hasn't been updated in recent three years][Y]](https://github.com/bamiaux/rez)   [![godoc][D]](https://godoc.org/github.com/bamiaux/rez)   [![Archived][Archived]](https://github.com/bamiaux/rez)
- [transformimgs](https://github.com/Pixboost/transformimgs) **star:206** Transformimgs resizes and optimises images for Web using next-generation formats.   [![godoc][D]](https://godoc.org/github.com/Pixboost/transformimgs)
- [img](https://github.com/hawx/img) **star:153** Selection of image manipulation tools.   [![It hasn't been updated in recent three years][Y]](https://github.com/hawx/img)   [![godoc][D]](https://godoc.org/github.com/hawx/img)
- [go-cairo](https://github.com/ungerik/go-cairo) **star:141** Go binding for the cairo graphics library.   [![godoc][D]](https://godoc.org/github.com/ungerik/go-cairo)
- [cameron](https://github.com/aofei/cameron) **star:119** An avatar generator for Go.   [![godoc][D]](https://godoc.org/github.com/aofei/cameron)
- [color-extractor](https://github.com/marekm4/color-extractor) **star:91** Dominant color extractor with no external dependencies.   [![godoc][D]](https://godoc.org/github.com/marekm4/color-extractor)
- [gridder](https://github.com/shomali11/gridder) **star:77** A Grid based 2D Graphics library.   [![godoc][D]](https://godoc.org/github.com/shomali11/gridder)
- [webp-server](https://github.com/mehdipourfar/webp-server) **star:72** Simple and minimal image server capable of storing, resizing, converting and caching images.   [![It hasn't been updated in recent three years][Y]](https://github.com/mehdipourfar/webp-server)   [![godoc][D]](https://godoc.org/github.com/mehdipourfar/webp-server)
- [go-gd](https://github.com/bolknote/go-gd) **star:58** Go binding for GD library.   [![It hasn't been updated in recent three years][Y]](https://github.com/bolknote/go-gd)   [![godoc][D]](https://godoc.org/github.com/bolknote/go-gd)
- [goimghdr](https://github.com/corona10/goimghdr) **star:40** The imghdr module determines the type of image contained in a file for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/corona10/goimghdr)   [![godoc][D]](https://godoc.org/github.com/corona10/goimghdr)
- [tga](https://github.com/ftrvxmtrx/tga) **star:33** Package tga is a TARGA image format decoder/encoder.   [![It hasn't been updated in recent three years][Y]](https://github.com/ftrvxmtrx/tga)   [![godoc][D]](https://godoc.org/github.com/ftrvxmtrx/tga)   [![Archived][Archived]](https://github.com/ftrvxmtrx/tga)
- [go-webcolors](https://github.com/jyotiska/go-webcolors) **star:27** Port of webcolors library from Python to Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/jyotiska/go-webcolors)   [![godoc][D]](https://godoc.org/github.com/jyotiska/go-webcolors)
- [mpo](https://github.com/donatj/mpo) **star:16** Decoder and conversion tool for MPO 3D Photos.   [![godoc][D]](https://godoc.org/github.com/donatj/mpo)
- [scout](https://github.com/jonoton/scout) **star:15** Scout is a standalone open source software solution for DIY video security.   [![godoc][D]](https://godoc.org/github.com/jonoton/scout)

**[⬆ back to top](#contents)**

## IoT (Internet of Things)

_Libraries for programming devices of the IoT._

- [flogo](https://github.com/tibcosoftware/flogo) **star:2398** Project Flogo is an Open Source Framework for IoT Edge Apps & Integration.
- [ekuiper](https://github.com/lf-edge/ekuiper) **star:1433** Lightweight data stream processing engine for IoT edge.   [![There was an update last month][G]](https://github.com/lf-edge/ekuiper)   [![godoc][D]](https://godoc.org/github.com/lf-edge/ekuiper)   [![Contains Chinese documents][CN]](https://github.com/lf-edge/ekuiper)
- [gatt](https://github.com/paypal/gatt) **star:1124** Gatt is a Go package for building Bluetooth Low Energy peripherals.   [![godoc][D]](https://godoc.org/github.com/paypal/gatt)
- [gobot](https://github.com/hybridgroup/gobot/)  Gobot is a framework for robotics, physical computing, and the Internet of Things.
- [connectordb](https://github.com/connectordb/connectordb) **star:399** Open-Source Platform for Quantified Self & IoT.   [![godoc][D]](https://godoc.org/github.com/connectordb/connectordb)
- [devices](https://github.com/goiot/devices) **star:263** Suite of libraries for IoT devices, experimental for x/exp/io.   [![It hasn't been updated in recent three years][Y]](https://github.com/goiot/devices)   [![godoc][D]](https://godoc.org/github.com/goiot/devices)
- [huego](https://github.com/amimof/huego) **star:249** An extensive Philips Hue client library for Go.   [![godoc][D]](https://godoc.org/github.com/amimof/huego)
- [iot](https://github.com/vaelen/iot/)  IoT is a simple framework for implementing a Google IoT Core device.
- [sensorbee](https://github.com/sensorbee/sensorbee) **star:230** Lightweight stream processing engine for IoT.   [![It hasn't been updated in recent three years][Y]](https://github.com/sensorbee/sensorbee)   [![godoc][D]](https://godoc.org/github.com/sensorbee/sensorbee)
- [smart-home](https://github.com/e154/smart-home) **star:76** Software package for IoT automation.   [![There was an update last month][G]](https://github.com/e154/smart-home)   [![godoc][D]](https://godoc.org/github.com/e154/smart-home)
- [eywa](https://github.com/xcodersun/eywa) **star:62** Project Eywa is essentially a connection manager that keeps track of connected devices.   [![It hasn't been updated in recent three years][Y]](https://github.com/xcodersun/eywa)   [![godoc][D]](https://godoc.org/github.com/xcodersun/eywa)
- [mainflux](https://github.com/Mainflux/mainflux) **star:39** Industrial IoT Messaging and Device Management Server.   [![There was an update last month][G]](https://github.com/Mainflux/mainflux)   [![godoc][D]](https://godoc.org/github.com/Mainflux/mainflux)   [![Archived][Archived]](https://github.com/Mainflux/mainflux)
- [periph](https://periph.io/)  Peripherals I/O to interface with low-level board facilities.

**[⬆ back to top](#contents)**

## Job Scheduler

_Libraries for scheduling jobs._

- [gocron](https://github.com/go-co-op/gocron) **star:5321** Easy and fluent Go job scheduling. This is an actively maintained fork of [jasonlvhit/gocron](https://github.com/jasonlvhit/gocron).   [![There was an update last month][G]](https://github.com/go-co-op/gocron)   [![godoc][D]](https://godoc.org/github.com/go-co-op/gocron)
- [go-quartz](https://github.com/reugn/go-quartz) **star:1753** Simple, zero-dependency scheduling library for Go.   [![godoc][D]](https://godoc.org/github.com/reugn/go-quartz)
- [Dagu](https://github.com/dagu-go/dagu) **star:1362** No-code workflow executor. it executes DAGs defined in a simple YAML format.   [![There was an update last month][G]](https://github.com/dagu-go/dagu)   [![godoc][D]](https://godoc.org/github.com/dagu-go/dagu)
- [JobRunner](https://github.com/bamzi/jobrunner) **star:1036** Smart and featureful cron job scheduler with job queuing and live monitoring built in.   [![It hasn't been updated in recent three years][Y]](https://github.com/bamzi/jobrunner)   [![godoc][D]](https://godoc.org/github.com/bamzi/jobrunner)
- [gron](https://github.com/roylee0704/gron) **star:1022** Define time-based tasks using a simple Go API and Gron’s scheduler will run them accordingly.   [![godoc][D]](https://godoc.org/github.com/roylee0704/gron)
- [jobs](https://github.com/albrow/jobs) **star:499** Persistent and flexible background jobs library.   [![It hasn't been updated in recent three years][Y]](https://github.com/albrow/jobs)   [![godoc][D]](https://godoc.org/github.com/albrow/jobs)   [![Archived][Archived]](https://github.com/albrow/jobs)
- [scheduler](https://github.com/carlescere/scheduler) **star:446** Cronjobs scheduling made easy.   [![godoc][D]](https://godoc.org/github.com/carlescere/scheduler)
- [gronx](https://github.com/adhocore/gronx) **star:389** Cron expression parser, task runner and daemon consuming crontab like task list.   [![godoc][D]](https://godoc.org/github.com/adhocore/gronx)
- [goflow](https://github.com/fieldryand/goflow) **star:324** A simple but powerful DAG scheduler and dashboard.   [![godoc][D]](https://godoc.org/github.com/fieldryand/goflow)
- [tasks](https://github.com/madflojo/tasks) **star:283** An easy to use in-process scheduler for recurring tasks in Go.   [![godoc][D]](https://godoc.org/github.com/madflojo/tasks)
- [go-cron](https://github.com/rk/go-cron) **star:227** Simple Cron library for go that can execute closures or functions at varying intervals, from once a second to once a year on a specific date and time. Primarily for web applications and long running daemons.   [![It hasn't been updated in recent three years][Y]](https://github.com/rk/go-cron)   [![godoc][D]](https://godoc.org/github.com/rk/go-cron)
- [clockwerk](https://github.com/onatm/clockwerk) **star:144** Go package to schedule periodic jobs using a simple, fluent syntax.   [![It hasn't been updated in recent three years][Y]](https://github.com/onatm/clockwerk)   [![godoc][D]](https://godoc.org/github.com/onatm/clockwerk)
- [cheek](https://github.com/datarootsio/cheek) **star:135** A simple crontab like scheduler that aims to offer a KISS approach to job scheduling.   [![There was an update last month][G]](https://github.com/datarootsio/cheek)   [![godoc][D]](https://godoc.org/github.com/datarootsio/cheek)
- [leprechaun](https://github.com/kilgaloon/leprechaun) **star:103** Job scheduler that supports webhooks, crons and classic scheduling.   [![godoc][D]](https://godoc.org/github.com/kilgaloon/leprechaun)
- [cdule](https://github.com/deepaksinghvi/cdule) **star:48** Job scheduler library with database support   [![godoc][D]](https://godoc.org/github.com/deepaksinghvi/cdule)
- [sched](https://github.com/romshark/sched) **star:28** A job scheduler with the ability to fast-forward time.   [![It hasn't been updated in recent three years][Y]](https://github.com/romshark/sched)   [![godoc][D]](https://godoc.org/github.com/romshark/sched)
- [cronticker](https://github.com/krayzpipes/cronticker) **star:16** A ticker implementation to support cron schedules.   [![It hasn't been updated in recent three years][Y]](https://github.com/krayzpipes/cronticker)   [![godoc][D]](https://godoc.org/github.com/krayzpipes/cronticker)
- [go-dag](https://github.com/rhosocial/go-dag) **star:13** A framework developed in Go that manages the execution of workflows described by directed acyclic graphs.   [![godoc][D]](https://godoc.org/github.com/rhosocial/go-dag)

**[⬆ back to top](#contents)**

## JSON

_Libraries for working with JSON._

- [GJSON](https://github.com/tidwall/gjson) **star:13997** Get a JSON value with one line of code.   [![There was an update last month][G]](https://github.com/tidwall/gjson)   [![godoc][D]](https://godoc.org/github.com/tidwall/gjson)
- [gabs](https://github.com/Jeffail/gabs) **star:3426** For parsing, creating and editing unknown or dynamic JSON in Go.   [![godoc][D]](https://godoc.org/github.com/Jeffail/gabs)
- [gojson](https://github.com/ChimeraCoder/gojson) **star:2657** Automatically generate Go (golang) struct definitions from example JSON.   [![It hasn't been updated in recent three years][Y]](https://github.com/ChimeraCoder/gojson)   [![godoc][D]](https://godoc.org/github.com/ChimeraCoder/gojson)
- [fastjson](https://github.com/valyala/fastjson) **star:2232** Fast JSON parser and validator for Go. No custom structs, no code generation, no reflection.   [![godoc][D]](https://godoc.org/github.com/valyala/fastjson)
- [OjG](https://github.com/ohler55/ojg) **star:821** Optimized JSON for Go is a high performance parser with a variety of additional JSON tools including JSONPath.   [![There was an update last month][G]](https://github.com/ohler55/ojg)   [![godoc][D]](https://godoc.org/github.com/ohler55/ojg)
- [jsondiff](https://github.com/wI2L/jsondiff) **star:506** JSON diff library for Go based on RFC6902 (JSON Patch).   [![There was an update last month][G]](https://github.com/wI2L/jsondiff)   [![godoc][D]](https://godoc.org/github.com/wI2L/jsondiff)
- [marshmallow](https://github.com/PerimeterX/marshmallow) **star:365** Performant JSON unmarshalling for flexible use cases.   [![godoc][D]](https://godoc.org/github.com/PerimeterX/marshmallow)
- [kazaam](https://github.com/Qntfy/kazaam) **star:275** API for arbitrary transformation of JSON documents.   [![godoc][D]](https://godoc.org/github.com/Qntfy/kazaam)
- [ajson](https://github.com/spyzhov/ajson) **star:225** Abstract JSON for golang with JSONPath support.   [![godoc][D]](https://godoc.org/github.com/spyzhov/ajson)
- [gojq](https://github.com/elgs/gojq) **star:190** JSON query in Golang.   [![godoc][D]](https://godoc.org/github.com/elgs/gojq)
- [jsonvalue](https://github.com/Andrew-M-C/go.jsonvalue) **star:183** A fast and convenient library for unstructured JSON data, replacing `encoding/json`.   [![There was an update last month][G]](https://github.com/Andrew-M-C/go.jsonvalue)   [![godoc][D]](https://godoc.org/github.com/Andrew-M-C/go.jsonvalue)   [![Contains Chinese documents][CN]](https://github.com/Andrew-M-C/go.jsonvalue)
- [jettison](https://github.com/wI2L/jettison) **star:171** Fast and flexible JSON encoder for Go.   [![godoc][D]](https://godoc.org/github.com/wI2L/jettison)
- [json2go](https://github.com/m-zajac/json2go) **star:129** Advanced JSON to Go struct conversion. Provides package that can parse multiple JSON documents and create struct to fit them all.   [![godoc][D]](https://godoc.org/github.com/m-zajac/json2go)
- [gjo](https://github.com/skanehira/gjo) **star:123** Small utility to create JSON objects.   [![It hasn't been updated in recent three years][Y]](https://github.com/skanehira/gjo)   [![godoc][D]](https://godoc.org/github.com/skanehira/gjo)
- [jsongo](https://github.com/ricardolonga/jsongo) **star:109** Fluent API to make it easier to create Json objects.   [![godoc][D]](https://godoc.org/github.com/ricardolonga/jsongo)
- [JayDiff](https://github.com/yazgazan/jaydiff) **star:106** JSON diff utility written in Go.   [![godoc][D]](https://godoc.org/github.com/yazgazan/jaydiff)
- [jscan](https://github.com/romshark/jscan) **star:87** High performance zero-allocation JSON iterator.   [![godoc][D]](https://godoc.org/github.com/romshark/jscan)
- [JSON-to-Go](https://mholt.github.io/json-to-go/)  Convert JSON to Go struct.
- [JSON-to-Proto](https://json-to-proto.github.io/)  Convert JSON to Protobuf online.
- [ujson](https://github.com/olvrng/ujson) **star:76** Fast and minimal JSON parser and transformer that works on unstructured JSON.   [![godoc][D]](https://godoc.org/github.com/olvrng/ujson)
- [jsonf](https://github.com/miolini/jsonf) **star:65** Console tool for highlighted formatting and struct query fetching JSON.   [![It hasn't been updated in recent three years][Y]](https://github.com/miolini/jsonf)   [![godoc][D]](https://godoc.org/github.com/miolini/jsonf)
- [go-respond](https://github.com/nicklaw5/go-respond) **star:53** Go package for handling common HTTP JSON responses.   [![godoc][D]](https://godoc.org/github.com/nicklaw5/go-respond)
- [mp](https://github.com/sanbornm/mp) **star:47** Simple cli email parser. It currently takes stdin and outputs JSON.   [![It hasn't been updated in recent three years][Y]](https://github.com/sanbornm/mp)   [![godoc][D]](https://godoc.org/github.com/sanbornm/mp)
- [ask](https://github.com/simonnilsson/ask) **star:44** Easy access to nested values in maps and slices. Works in combination with encoding/json and other packages that "Unmarshal" arbitrary data into Go data-types.   [![godoc][D]](https://godoc.org/github.com/simonnilsson/ask)
- [jsoncolor](https://github.com/neilotoole/jsoncolor) **star:44** Drop-in replacement for `encoding/json` that outputs colorized JSON.   [![godoc][D]](https://godoc.org/github.com/neilotoole/jsoncolor)
- [vjson](https://github.com/miladibra10/vjson) **star:40** Go package for validating JSON objects with declaring a JSON schema with fluent API.   [![godoc][D]](https://godoc.org/github.com/miladibra10/vjson)
- [gojmapr](https://github.com/limiu82214/gojmapr) **star:22** Get simple struct from complex json by json path.   [![godoc][D]](https://godoc.org/github.com/limiu82214/gojmapr)   [![Contains Chinese documents][CN]](https://github.com/limiu82214/gojmapr)
- [mapslice-json](https://github.com/mickep76/mapslice-json) **star:19** Go MapSlice for ordered marshal/ unmarshal of maps in JSON.   [![godoc][D]](https://godoc.org/github.com/mickep76/mapslice-json)
- [dynjson](https://github.com/cocoonspace/dynjson) **star:16** Client-customizable JSON formats for dynamic APIs.   [![godoc][D]](https://godoc.org/github.com/cocoonspace/dynjson)
- [go-jsonerror](https://github.com/ddymko/go-jsonerror) **star:15** Go-JsonError is meant to allow us to easily create json response errors that follow the JsonApi spec.   [![It hasn't been updated in recent three years][Y]](https://github.com/ddymko/go-jsonerror)   [![godoc][D]](https://godoc.org/github.com/ddymko/go-jsonerror)
- [epoch](https://github.com/vtopc/epoch) **star:14** Contains primitives for marshaling/unmarshalling Unix timestamp/epoch to/from build-in time.Time type in JSON.   [![godoc][D]](https://godoc.org/github.com/vtopc/epoch)
- [jsonapi-errors](https://github.com/AmuzaTkts/jsonapi-errors) **star:14** Go bindings based on the JSON API errors reference.   [![It hasn't been updated in recent three years][Y]](https://github.com/AmuzaTkts/jsonapi-errors)   [![godoc][D]](https://godoc.org/github.com/AmuzaTkts/jsonapi-errors)
- [jsonhal](https://github.com/RichardKnop/jsonhal) **star:14** Simple Go package to make custom structs marshal into HAL compatible JSON responses.   [![It hasn't been updated in recent three years][Y]](https://github.com/RichardKnop/jsonhal)   [![godoc][D]](https://godoc.org/github.com/RichardKnop/jsonhal)
- [jsonic](https://github.com/sinhashubham95/jsonic) **star:11** Utilities to handle and query JSON without defining structs in a type safe manner.   [![It hasn't been updated in recent three years][Y]](https://github.com/sinhashubham95/jsonic)   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/jsonic)
- [jzon](https://github.com/zerosnake0/jzon) **star:11** JSON library with standard compatible API/behavior.   [![godoc][D]](https://godoc.org/github.com/zerosnake0/jzon)
- [ej](https://github.com/lucassscaravelli/ej) **star:10** Write and read JSON from different sources succinctly.   [![It hasn't been updated in recent three years][Y]](https://github.com/lucassscaravelli/ej)   [![godoc][D]](https://godoc.org/github.com/lucassscaravelli/ej)
- [htmljson](https://github.com/nikolaydubina/htmljson) **star:7** Rich rendering of JSON as HTML in Go.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/htmljson)
- [omg.jsonparser](https://github.com/dedalqq/omg.jsonparser) **star:6** Simple JSON parser with validation by condition via golang struct fields tags.   [![godoc][D]](https://godoc.org/github.com/dedalqq/omg.jsonparser)
- [jsonhandlers](https://github.com/abusomani/jsonhandlers) **star:2** JSON library to expose simple handlers that lets you easily read and write json from various sources.   [![godoc][D]](https://godoc.org/github.com/abusomani/jsonhandlers)

**[⬆ back to top](#contents)**

## Logging

_Libraries for generating and working with log files._

- [logrus](https://github.com/Sirupsen/logrus) **star:24417** Structured logger for Go.   [![godoc][D]](https://godoc.org/github.com/Sirupsen/logrus)
- [zap](https://github.com/uber-go/zap) **star:21487** Fast, structured, leveled logging in Go.   [![godoc][D]](https://godoc.org/github.com/uber-go/zap)
- [zerolog](https://github.com/rs/zerolog) **star:10240** Zero-allocation JSON logger.   [![godoc][D]](https://godoc.org/github.com/rs/zerolog)
- [spew](https://github.com/davecgh/go-spew) **star:6009** Implements a deep pretty printer for Go data structures to aid in debugging.   [![godoc][D]](https://godoc.org/github.com/davecgh/go-spew)
- [lumberjack](https://github.com/natefinch/lumberjack) **star:4747** Simple rolling logger, implements io.WriteCloser.   [![There was an update last month][G]](https://github.com/natefinch/lumberjack)   [![godoc][D]](https://godoc.org/github.com/natefinch/lumberjack)
- [glog](https://github.com/golang/glog) **star:3518** Leveled execution logs for Go.   [![godoc][D]](https://godoc.org/github.com/golang/glog)
- [tail](https://github.com/hpcloud/tail) **star:2696** Go package striving to emulate the features of the BSD tail program.   [![godoc][D]](https://godoc.org/github.com/hpcloud/tail)
- [pp](https://github.com/k0kubun/pp) **star:1819** Colored pretty printer for Go language.   [![godoc][D]](https://godoc.org/github.com/k0kubun/pp)
- [seelog](https://github.com/cihub/seelog) **star:1640** Logging functionality with flexible dispatching, filtering, and formatting.   [![It hasn't been updated in recent three years][Y]](https://github.com/cihub/seelog)   [![godoc][D]](https://godoc.org/github.com/cihub/seelog)
- [log](https://github.com/apex/log) **star:1357** Structured logging package for Go.   [![godoc][D]](https://godoc.org/github.com/apex/log)
- [log15](https://github.com/inconshreveable/log15) **star:1104** Simple, powerful logging for Go.   [![godoc][D]](https://godoc.org/github.com/inconshreveable/log15)
- [tint](https://github.com/lmittmann/tint) **star:688** A slog.Handler that writes tinted logs.   [![godoc][D]](https://godoc.org/github.com/lmittmann/tint)
- [phuslu/log](https://github.com/phuslu/log) **star:646** High performance structured logging.   [![godoc][D]](https://godoc.org/github.com/phuslu/log)
- [onelog](https://github.com/francoispqt/onelog) **star:414** Onelog is a dead simple but very efficient JSON logger. It is the fastest JSON logger out there in all scenarios. Also, it is one of the logger with the lowest allocation.   [![It hasn't been updated in recent three years][Y]](https://github.com/francoispqt/onelog)   [![godoc][D]](https://godoc.org/github.com/francoispqt/onelog)
- [httpretty](https://github.com/henvic/httpretty) **star:390** Pretty-prints your regular HTTP requests on your terminal for debugging (similar to http.DumpRequest).   [![godoc][D]](https://godoc.org/github.com/henvic/httpretty)
- [slog](https://github.com/gookit/slog) **star:375** Lightweight, configurable, extensible logger for Go.   [![godoc][D]](https://godoc.org/github.com/gookit/slog)   [![Contains Chinese documents][CN]](https://github.com/gookit/slog)
- [logutils](https://github.com/hashicorp/logutils) **star:367** Utilities for slightly better logging in Go (Golang) extending the standard logger.   [![godoc][D]](https://godoc.org/github.com/hashicorp/logutils)
- [logxi](https://github.com/mgutz/logxi) **star:358** 12-factor app logger that is fast and makes you happy.   [![It hasn't been updated in recent three years][Y]](https://github.com/mgutz/logxi)   [![godoc][D]](https://godoc.org/github.com/mgutz/logxi)
- [sqldb-logger](https://github.com/simukti/sqldb-logger) **star:347** A logger for Go SQL database driver without modify existing \*sql.DB stdlib usage.   [![godoc][D]](https://godoc.org/github.com/simukti/sqldb-logger)
- [slog-multi](https://github.com/samber/slog-multi) **star:325** Chain of slog.Handler (pipeline, fanout...).   [![godoc][D]](https://godoc.org/github.com/samber/slog-multi)
- [slogor](https://gitlab.com/greyxor/slogor)  A colorful slog handler.
- [rollingwriter](https://github.com/arthurkiller/rollingWriter) **star:295** RollingWriter is an auto-rotate `io.Writer` implementation with multi policies to provide log file rotation.   [![godoc][D]](https://godoc.org/github.com/arthurkiller/rollingWriter)
- [log](https://github.com/go-playground/log) **star:292** Simple, configurable and scalable Structured Logging for Go.   [![godoc][D]](https://godoc.org/github.com/go-playground/log)
- [go-logger](https://github.com/apsdehal/go-logger) **star:286** Simple logger of Go Programs, with level handlers.   [![It hasn't been updated in recent three years][Y]](https://github.com/apsdehal/go-logger)   [![godoc][D]](https://godoc.org/github.com/apsdehal/go-logger)
- [logur](https://github.com/logur/logur) **star:200** An opinionated logger interface and collection of logging best practices with adapters and integrations for well-known libraries ([logrus](https://github.com/sirupsen/logrus), [go-kit log](https://github.com/go-kit/kit/tree/master/log), [zap](https://github.com/uber-go/zap), [zerolog](https://github.com/rs/zerolog), etc).   [![It hasn't been updated in recent three years][Y]](https://github.com/logur/logur)   [![godoc][D]](https://godoc.org/github.com/logur/logur)
- [glg](https://github.com/kpango/glg) **star:189** glg is simple and fast leveled logging library for Go.   [![godoc][D]](https://godoc.org/github.com/kpango/glg)
- [logger](https://github.com/azer/logger) **star:158** Minimalistic logging library for Go.   [![godoc][D]](https://godoc.org/github.com/azer/logger)
- [xlog](https://github.com/rs/xlog) **star:138** Structured logger for `net/context` aware HTTP handlers with flexible dispatching.   [![godoc][D]](https://godoc.org/github.com/rs/xlog)
- [ozzo-log](https://github.com/go-ozzo/ozzo-log) **star:122** High performance logging supporting log severity, categorization, and filtering. Can send filtered log messages to various targets (e.g. console, network, mail).   [![It hasn't been updated in recent three years][Y]](https://github.com/go-ozzo/ozzo-log)   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-log)   [![Contains Chinese documents][CN]](https://github.com/go-ozzo/ozzo-log)
- [slog-formatter](https://github.com/samber/slog-formatter) **star:99** Common formatters for slog and helpers to build your own.   [![godoc][D]](https://godoc.org/github.com/samber/slog-formatter)
- [log-voyage](https://github.com/firstrow/logvoyage) **star:94** Full-featured logging saas written in golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/firstrow/logvoyage)   [![godoc][D]](https://godoc.org/github.com/firstrow/logvoyage)
- [go-cronowriter](https://github.com/utahta/go-cronowriter) **star:56** Simple writer that rotate log files automatically based on current date and time, like cronolog.   [![It hasn't been updated in recent three years][Y]](https://github.com/utahta/go-cronowriter)   [![godoc][D]](https://godoc.org/github.com/utahta/go-cronowriter)
- [stdlog](https://github.com/alexcesaro/log) **star:47** Stdlog is an object-oriented library providing leveled logging. It is very useful for cron jobs.   [![It hasn't been updated in recent three years][Y]](https://github.com/alexcesaro/log)   [![godoc][D]](https://godoc.org/github.com/alexcesaro/log)
- [noodlog](https://github.com/gyozatech/noodlog) **star:44** Parametrized JSON logging library which lets you obfuscate sensitive data and marshal any kind of content. No more printed pointers instead of values, nor escape chars for the JSON strings.   [![godoc][D]](https://godoc.org/github.com/gyozatech/noodlog)
- [go-log](https://github.com/ian-kent/go-log) **star:43** Log4j implementation in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/ian-kent/go-log)   [![godoc][D]](https://godoc.org/github.com/ian-kent/go-log)
- [logex](https://github.com/chzyer/logex) **star:43** Golang log lib, supports tracking and level, wrap by standard log lib.   [![godoc][D]](https://godoc.org/github.com/chzyer/logex)
- [journald](https://github.com/ssgreg/journald) **star:38** Go implementation of systemd Journal's native API for logging.   [![It hasn't been updated in recent three years][Y]](https://github.com/ssgreg/journald)   [![godoc][D]](https://godoc.org/github.com/ssgreg/journald)
- [go-log](https://github.com/siddontang/go-log) **star:34** Log lib supports level and multi handlers.   [![It hasn't been updated in recent three years][Y]](https://github.com/siddontang/go-log)   [![godoc][D]](https://godoc.org/github.com/siddontang/go-log)
- [mlog](https://github.com/jbrodriguez/mlog) **star:34** Simple logging module for go, with 5 levels, an optional rotating logfile feature and stdout/stderr output.   [![It hasn't been updated in recent three years][Y]](https://github.com/jbrodriguez/mlog)   [![godoc][D]](https://godoc.org/github.com/jbrodriguez/mlog)
- [distillog](https://github.com/amoghe/distillog) **star:31** distilled levelled logging (think of it as stdlib + log levels).   [![It hasn't been updated in recent three years][Y]](https://github.com/amoghe/distillog)   [![godoc][D]](https://godoc.org/github.com/amoghe/distillog)
- [logrusly](https://github.com/sebest/logrusly) **star:28** [logrus](https://github.com/sirupsen/logrus) plug-in to send errors to a [Loggly](https://www.loggly.com/).   [![It hasn't been updated in recent three years][Y]](https://github.com/sebest/logrusly)   [![godoc][D]](https://godoc.org/github.com/sebest/logrusly)
- [log](https://github.com/teris-io/log) **star:26** Structured log interface for Go cleanly separates logging facade from its implementation.   [![It hasn't been updated in recent three years][Y]](https://github.com/teris-io/log)   [![godoc][D]](https://godoc.org/github.com/teris-io/log)
- [zkits-logger](https://github.com/edoger/zkits-logger) **star:26** A powerful zero-dependency JSON logger.   [![godoc][D]](https://godoc.org/github.com/edoger/zkits-logger)
- [zax](https://github.com/yuseferi/zax) **star:20** Integrate Context with Zap logger, which leads to more flexibility in Go logging.   [![godoc][D]](https://godoc.org/github.com/yuseferi/zax)
- [gomol](https://github.com/aphistic/gomol) **star:19** Multiple-output, structured logging for Go with extensible logging outputs.   [![It hasn't been updated in recent three years][Y]](https://github.com/aphistic/gomol)   [![godoc][D]](https://godoc.org/github.com/aphistic/gomol)   [![Archived][Archived]](https://github.com/aphistic/gomol)
- [gone/log](https://github.com/One-com/gone/tree/master/log)  Fast, extendable, full-featured, std-lib source compatible log library.
- [log](https://github.com/heartwilltell/log) **star:16** Simple leveled logging wrapper around standard log package.   [![godoc][D]](https://godoc.org/github.com/heartwilltell/log)
- [logrusiowriter](https://github.com/cabify/logrusiowriter) **star:16** `io.Writer` implementation using [logrus](https://github.com/sirupsen/logrus) logger.   [![It hasn't been updated in recent three years][Y]](https://github.com/cabify/logrusiowriter)   [![godoc][D]](https://godoc.org/github.com/cabify/logrusiowriter)
- [xylog](https://github.com/xybor-x/xylog) **star:16** Leveled and structured logging, dynamic fields, high performance, zone management, simple configuration, and readable syntax.   [![godoc][D]](https://godoc.org/github.com/xybor-x/xylog)
- [glo](https://github.com/lajosbencz/glo) **star:15** PHP Monolog inspired logging facility with identical severity levels.   [![It hasn't been updated in recent three years][Y]](https://github.com/lajosbencz/glo)   [![godoc][D]](https://godoc.org/github.com/lajosbencz/glo)
- [go-log](https://github.com/subchen/go-log) **star:14** Simple and configurable Logging in Go, with level, formatters and writers.   [![It hasn't been updated in recent three years][Y]](https://github.com/subchen/go-log)   [![godoc][D]](https://godoc.org/github.com/subchen/go-log)
- [kemba](https://github.com/clok/kemba) **star:13** A tiny debug logging tool inspired by [debug](https://github.com/visionmedia/debug), great for CLI tools and applications.   [![godoc][D]](https://godoc.org/github.com/clok/kemba)
- [logdump](https://github.com/ewwwwwqm/logdump) **star:11** Package for multi-level logging.   [![It hasn't been updated in recent three years][Y]](https://github.com/ewwwwwqm/logdump)   [![godoc][D]](https://godoc.org/github.com/ewwwwwqm/logdump)
- [logo](https://github.com/mbndr/logo) **star:11** Golang logger to different configurable writers.   [![It hasn't been updated in recent three years][Y]](https://github.com/mbndr/logo)   [![godoc][D]](https://godoc.org/github.com/mbndr/logo)
- [go-log](https://github.com/pieterclaerhout/go-log) **star:10** A logging library with stack traces, object dumping and optional timestamps.   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-log)
- [log](https://github.com/aerogo/log) **star:10** An O(1) logging system that allows you to connect one log to multiple writers (e.g. stdout, a file and a TCP connection).   [![It hasn't been updated in recent three years][Y]](https://github.com/aerogo/log)   [![godoc][D]](https://godoc.org/github.com/aerogo/log)
- [xlog](https://github.com/xfxdev/xlog) **star:8** Plugin architecture and flexible log system for Go, with level ctrl, multiple log target and custom log format.   [![It hasn't been updated in recent three years][Y]](https://github.com/xfxdev/xlog)   [![godoc][D]](https://godoc.org/github.com/xfxdev/xlog)
- [structy/log](https://github.com/structy/log) **star:5** A simple to use log system, minimalist but with features for debugging and differentiation of messages.   [![godoc][D]](https://godoc.org/github.com/structy/log)
- [zl](https://github.com/nkmr-jp/zl) **star:5** High Developer Experience, zap based logger. It offers rich functionality but is easy to configure.   [![godoc][D]](https://godoc.org/github.com/nkmr-jp/zl)
- [log](https://github.com/no-src/log) **star:3** A simple logging framework out of the box.   [![godoc][D]](https://godoc.org/github.com/no-src/log)
- [slf4g](https://github.com/echocat/slf4g) **star:3** Simple Logging Facade for Golang: Simple structured logging; but powerful, extendable and customizable, with huge amount of learnings from decades of past logging frameworks.   [![There was an update last month][G]](https://github.com/echocat/slf4g)   [![godoc][D]](https://godoc.org/github.com/echocat/slf4g)
- [yell](https://github.com/jfcg/yell) **star:1** Yet another minimalistic logging library.   [![godoc][D]](https://godoc.org/github.com/jfcg/yell)

**[⬆ back to top](#contents)**

## Machine Learning

_Libraries for Machine Learning._

- [GoLearn](https://github.com/sjwhitworth/golearn) **star:9248** General Machine Learning library for Go.   [![godoc][D]](https://godoc.org/github.com/sjwhitworth/golearn)   [![Contains Chinese documents][CN]](https://github.com/sjwhitworth/golearn)
- [gorse](https://github.com/zhenghaoz/gorse) **star:8389** An offline recommender system backend based on collaborative filtering written in Go.   [![godoc][D]](https://godoc.org/github.com/zhenghaoz/gorse)   [![Contains Chinese documents][CN]](https://github.com/zhenghaoz/gorse)
- [gorgonia](https://github.com/gorgonia/gorgonia) **star:5449** graph-based computational library like Theano for Go that provides primitives for building various machine learning and neural network algorithms.   [![godoc][D]](https://godoc.org/github.com/gorgonia/gorgonia)
- [m2cgen](https://github.com/BayesWitnesses/m2cgen) **star:2762** A CLI tool to transpile trained classic ML models into a native Go code with zero dependencies, written in Python with Go language support.
- [gosseract](https://github.com/otiai10/gosseract) **star:2620** Go package for OCR (Optical Character Recognition), by using Tesseract C++ library.   [![godoc][D]](https://godoc.org/github.com/otiai10/gosseract)
- [tfgo](https://github.com/galeone/tfgo) **star:2403** Easy to use Tensorflow bindings: simplifies the usage of the official Tensorflow Go bindings. Define computational graphs in Go, load and execute models trained in Python.   [![godoc][D]](https://godoc.org/github.com/galeone/tfgo)
- [goml](https://github.com/cdipaolo/goml) **star:1553** On-line Machine Learning in Go.   [![godoc][D]](https://godoc.org/github.com/cdipaolo/goml)
- [eaopt](https://github.com/MaxHalford/eaopt) **star:881** An evolutionary optimization library.   [![godoc][D]](https://godoc.org/github.com/MaxHalford/eaopt)
- [bayesian](https://github.com/jbrukh/bayesian) **star:796** Naive Bayesian Classification for Golang.   [![godoc][D]](https://godoc.org/github.com/jbrukh/bayesian)
- [CloudForest](https://github.com/ryanbressler/CloudForest) **star:737** Fast, flexible, multi-threaded ensembles of decision trees for machine learning in pure Go.   [![godoc][D]](https://godoc.org/github.com/ryanbressler/CloudForest)
- [ocrserver](https://github.com/otiai10/ocrserver) **star:680** A simple OCR API server, seriously easy to be deployed by Docker and Heroku.   [![It hasn't been updated in recent three years][Y]](https://github.com/otiai10/ocrserver)   [![godoc][D]](https://godoc.org/github.com/otiai10/ocrserver)
- [onnx-go](https://github.com/owulveryck/onnx-go) **star:661** Go Interface to Open Neural Network Exchange (ONNX).   [![godoc][D]](https://godoc.org/github.com/owulveryck/onnx-go)   [![Archived][Archived]](https://github.com/owulveryck/onnx-go)
- [gobrain](https://github.com/goml/gobrain) **star:556** Neural Networks written in go.   [![It hasn't been updated in recent three years][Y]](https://github.com/goml/gobrain)   [![godoc][D]](https://godoc.org/github.com/goml/gobrain)
- [go-deep](https://github.com/patrikeh/go-deep) **star:530** A feature-rich neural network library in Go.   [![godoc][D]](https://godoc.org/github.com/patrikeh/go-deep)
- [regommend](https://github.com/muesli/regommend) **star:313** Recommendation & collaborative filtering engine.   [![It hasn't been updated in recent three years][Y]](https://github.com/muesli/regommend)   [![godoc][D]](https://godoc.org/github.com/muesli/regommend)
- [Goptuna](https://github.com/c-bata/goptuna) **star:256** Bayesian optimization framework for black-box functions written in Go. Everything will be optimized.   [![godoc][D]](https://godoc.org/github.com/c-bata/goptuna)
- [hugot](https://github.com/knights-analytics/hugot) **star:229** Huggingface transformer pipelines for golang with onnxruntime.   [![There was an update last month][G]](https://github.com/knights-analytics/hugot)   [![godoc][D]](https://godoc.org/github.com/knights-analytics/hugot)
- [goga](https://github.com/tomcraven/goga) **star:217** Genetic algorithm library for Go.   [![godoc][D]](https://godoc.org/github.com/tomcraven/goga)
- [goRecommend](https://github.com/timkaye11/goRecommend) **star:204** Recommendation Algorithms library written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/timkaye11/goRecommend)   [![godoc][D]](https://godoc.org/github.com/timkaye11/goRecommend)
- [go-galib](https://github.com/thoj/go-galib) **star:199** Genetic Algorithms library written in Go / golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/thoj/go-galib)   [![godoc][D]](https://godoc.org/github.com/thoj/go-galib)
- [shield](https://github.com/eaigner/shield) **star:157** Bayesian text classifier with flexible tokenizers and storage backends for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/eaigner/shield)   [![godoc][D]](https://godoc.org/github.com/eaigner/shield)
- [go-featureprocessing](https://github.com/nikolaydubina/go-featureprocessing) **star:116** Fast and convenient feature processing for low latency machine learning in Go.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/go-featureprocessing)
- [go-fann](https://github.com/white-pony/go-fann) **star:115** Go bindings for Fast Artificial Neural Networks(FANN) library.   [![It hasn't been updated in recent three years][Y]](https://github.com/white-pony/go-fann)   [![godoc][D]](https://godoc.org/github.com/white-pony/go-fann)
- [goscore](https://github.com/asafschers/goscore) **star:97** Go Scoring API for PMML.   [![It hasn't been updated in recent three years][Y]](https://github.com/asafschers/goscore)   [![godoc][D]](https://godoc.org/github.com/asafschers/goscore)
- [fonet](https://github.com/Fontinalis/fonet) **star:82** A Deep Neural Network library written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/Fontinalis/fonet)   [![godoc][D]](https://godoc.org/github.com/Fontinalis/fonet)
- [gonet](https://github.com/dathoangnd/gonet) **star:82** Neural Network for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/dathoangnd/gonet)   [![godoc][D]](https://godoc.org/github.com/dathoangnd/gonet)
- [GoMind](https://github.com/surenderthakran/gomind) **star:81** A simplistic Neural Network Library in Go.   [![godoc][D]](https://godoc.org/github.com/surenderthakran/gomind)
- [libsvm](https://github.com/datastream/libsvm) **star:73** libsvm golang version derived work based on LIBSVM 3.14.   [![It hasn't been updated in recent three years][Y]](https://github.com/datastream/libsvm)   [![godoc][D]](https://godoc.org/github.com/datastream/libsvm)
- [neat](https://github.com/jinyeom/neat) **star:72** Plug-and-play, parallel Go framework for NeuroEvolution of Augmenting Topologies (NEAT).   [![It hasn't been updated in recent three years][Y]](https://github.com/jinyeom/neat)   [![godoc][D]](https://godoc.org/github.com/jinyeom/neat)   [![Archived][Archived]](https://github.com/jinyeom/neat)
- [neural-go](https://github.com/schuyler/neural-go) **star:68** Multilayer perceptron network implemented in Go, with training via backpropagation.   [![It hasn't been updated in recent three years][Y]](https://github.com/schuyler/neural-go)   [![godoc][D]](https://godoc.org/github.com/schuyler/neural-go)
- [go-pr](https://github.com/daviddengcn/go-pr) **star:63** Pattern recognition package in Go lang.   [![It hasn't been updated in recent three years][Y]](https://github.com/daviddengcn/go-pr)   [![godoc][D]](https://godoc.org/github.com/daviddengcn/go-pr)
- [Varis](https://github.com/Xamber/Varis) **star:55** Golang Neural Network.   [![It hasn't been updated in recent three years][Y]](https://github.com/Xamber/Varis)   [![godoc][D]](https://godoc.org/github.com/Xamber/Varis)
- [golinear](https://github.com/danieldk/golinear) **star:45** liblinear bindings for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/danieldk/golinear)   [![godoc][D]](https://godoc.org/github.com/danieldk/golinear)   [![Archived][Archived]](https://github.com/danieldk/golinear)
- [randomforest](https://github.com/malaschitz/randomForest) **star:44** Easy to use Random Forest library for Go.   [![godoc][D]](https://godoc.org/github.com/malaschitz/randomForest)
- [go-cluster](https://github.com/e-XpertSolutions/go-cluster) **star:41** Go implementation of the k-modes and k-prototypes clustering algorithms.   [![godoc][D]](https://godoc.org/github.com/e-XpertSolutions/go-cluster)
- [godist](https://github.com/e-dard/godist) **star:37** Various probability distributions, and associated methods.   [![It hasn't been updated in recent three years][Y]](https://github.com/e-dard/godist)   [![godoc][D]](https://godoc.org/github.com/e-dard/godist)
- [ddt](https://github.com/sgrodriguez/ddt) **star:35** Dynamic decision tree, create trees defining customizable rules.   [![It hasn't been updated in recent three years][Y]](https://github.com/sgrodriguez/ddt)   [![godoc][D]](https://godoc.org/github.com/sgrodriguez/ddt)
- [evoli](https://github.com/khezen/evoli) **star:31** Genetic Algorithm and Particle Swarm Optimization library.   [![godoc][D]](https://godoc.org/github.com/khezen/evoli)
- [probab](https://github.com/ThePaw/probab) **star:20** Probability distribution functions. Bayesian inference. Written in pure Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/ThePaw/probab)   [![godoc][D]](https://godoc.org/github.com/ThePaw/probab)

**[⬆ back to top](#contents)**

## Messaging

_Libraries that implement messaging systems._

- [sarama](https://github.com/Shopify/sarama) **star:11316** Go library for Apache Kafka.   [![There was an update last month][G]](https://github.com/Shopify/sarama)   [![godoc][D]](https://godoc.org/github.com/Shopify/sarama)
- [Asynq](https://github.com/hibiken/asynq) **star:9243** A simple, reliable, and efficient distributed task queue for Go built on top of Redis.   [![godoc][D]](https://godoc.org/github.com/hibiken/asynq)
- [Centrifugo](https://github.com/centrifugal/centrifugo) **star:8210** Real-time messaging (Websockets or SockJS) server in Go.   [![There was an update last month][G]](https://github.com/centrifugal/centrifugo)   [![godoc][D]](https://godoc.org/github.com/centrifugal/centrifugo)
- [Benthos](https://github.com/Jeffail/benthos) **star:8037** A message streaming bridge between a range of protocols.   [![There was an update last month][G]](https://github.com/Jeffail/benthos)   [![godoc][D]](https://godoc.org/github.com/Jeffail/benthos)
- [gorush](https://github.com/appleboy/gorush) **star:7907** Push notification server using [APNs2](https://github.com/sideshow/apns2) and google [GCM](https://github.com/google/go-gcm).   [![There was an update last month][G]](https://github.com/appleboy/gorush)   [![godoc][D]](https://godoc.org/github.com/appleboy/gorush)
- [machinery](https://github.com/RichardKnop/machinery) **star:7454** Asynchronous task queue/job queue based on distributed message passing.   [![godoc][D]](https://godoc.org/github.com/RichardKnop/machinery)
- [Watermill](https://github.com/ThreeDotsLabs/watermill) **star:7151** Working efficiently with message streams. Building event driven applications, enabling event sourcing, RPC over messages, sagas. Can use conventional pub/sub implementations like Kafka or RabbitMQ, but also HTTP or MySQL binlog.   [![There was an update last month][G]](https://github.com/ThreeDotsLabs/watermill)   [![godoc][D]](https://godoc.org/github.com/ThreeDotsLabs/watermill)
- [go-socket.io](https://github.com/googollee/go-socket.io) **star:5677** socket.io library for golang, a realtime application framework.   [![godoc][D]](https://godoc.org/github.com/googollee/go-socket.io)
- [NATS Go Client](https://github.com/nats-io/nats) **star:5370** Lightweight and high performance publish-subscribe and distributed queueing messaging system - this is the Go library.   [![There was an update last month][G]](https://github.com/nats-io/nats)   [![godoc][D]](https://godoc.org/github.com/nats-io/nats)
- [Confluent Kafka Golang Client](https://github.com/confluentinc/confluent-kafka-go) **star:4546** confluent-kafka-go is Confluent's Golang client for Apache Kafka and the Confluent Platform.   [![There was an update last month][G]](https://github.com/confluentinc/confluent-kafka-go)
- [Mercure](https://github.com/dunglas/mercure) **star:3857** Server and library to dispatch server-sent updates using the Mercure protocol (built on top of Server-Sent Events).   [![There was an update last month][G]](https://github.com/dunglas/mercure)   [![godoc][D]](https://godoc.org/github.com/dunglas/mercure)
- [melody](https://github.com/olahol/melody) **star:3662** Minimalist framework for dealing with websocket sessions, includes broadcasting and automatic ping/pong handling.   [![godoc][D]](https://godoc.org/github.com/olahol/melody)
- [APNs2](https://github.com/sideshow/apns2) **star:2969** HTTP/2 Apple Push Notification provider for Go — Send push notifications to iOS, tvOS, Safari and OSX apps.   [![There was an update last month][G]](https://github.com/sideshow/apns2)   [![godoc][D]](https://godoc.org/github.com/sideshow/apns2)
- [go-nsq](https://github.com/nsqio/go-nsq) **star:2570** the official Go package for NSQ.   [![There was an update last month][G]](https://github.com/nsqio/go-nsq)   [![godoc][D]](https://godoc.org/github.com/nsqio/go-nsq)
- [gopush-cluster](https://github.com/Terry-Mao/gopush-cluster) **star:2083** gopush-cluster is a go push server cluster.   [![It hasn't been updated in recent three years][Y]](https://github.com/Terry-Mao/gopush-cluster)   [![godoc][D]](https://godoc.org/github.com/Terry-Mao/gopush-cluster)   [![Contains Chinese documents][CN]](https://github.com/Terry-Mao/gopush-cluster)
- [EventBus](https://github.com/asaskevich/EventBus) **star:1692** The lightweight event bus with async compatibility.   [![godoc][D]](https://godoc.org/github.com/asaskevich/EventBus)
- [Uniqush-Push](https://github.com/uniqush/uniqush-push) **star:1533** Redis backed unified push service for server-side notifications to mobile devices.   [![It hasn't been updated in recent three years][Y]](https://github.com/uniqush/uniqush-push)   [![godoc][D]](https://godoc.org/github.com/uniqush/uniqush-push)
- [Beaver](https://github.com/Clivern/Beaver) **star:1530** A real time messaging server to build a scalable in-app notifications, multiplayer games, chat apps in web and mobile apps.   [![godoc][D]](https://godoc.org/github.com/Clivern/Beaver)
- [amqp](https://github.com/rabbitmq/amqp091-go) **star:1429** Go RabbitMQ Client Library.   [![godoc][D]](https://godoc.org/github.com/rabbitmq/amqp091-go)
- [Chanify](https://github.com/chanify/chanify) **star:1247** A push notification server send message to your iOS devices.   [![godoc][D]](https://godoc.org/github.com/chanify/chanify)   [![Contains Chinese documents][CN]](https://github.com/chanify/chanify)
- [zmq4](https://github.com/pebbe/zmq4) **star:1157** Go interface to ZeroMQ version 4. Also available for [version 3](https://github.com/pebbe/zmq3) and [version 2](https://github.com/pebbe/zmq2).   [![godoc][D]](https://godoc.org/github.com/pebbe/zmq4)
- [dbus](https://github.com/godbus/dbus) **star:965** Native Go bindings for D-Bus.   [![godoc][D]](https://godoc.org/github.com/godbus/dbus)
- [Gollum](https://github.com/trivago/gollum) **star:938** A n:m multiplexer that gathers messages from different sources and broadcasts them to a set of destinations.   [![godoc][D]](https://godoc.org/github.com/trivago/gollum)
- [mangos](https://github.com/nanomsg/mangos) **star:665** Pure go implementation of the Nanomsg ("Scalability Protocols") with transport interoperability.   [![godoc][D]](https://godoc.org/github.com/nanomsg/mangos)
- [golongpoll](https://github.com/jcuga/golongpoll) **star:655** HTTP longpoll server library that makes web pub-sub simple.   [![godoc][D]](https://godoc.org/github.com/jcuga/golongpoll)
- [emitter](https://github.com/olebedev/emitter) **star:500** Emits events using Go way, with wildcard, predicates, cancellation possibilities and many other good wins.   [![godoc][D]](https://godoc.org/github.com/olebedev/emitter)
- [pubsub](https://github.com/tuxychandru/pubsub) **star:424** Simple pubsub package for go.   [![godoc][D]](https://godoc.org/github.com/tuxychandru/pubsub)
- [Glue](https://github.com/desertbit/glue) **star:415** Robust Go and Javascript Socket Library (Alternative to Socket.io).   [![It hasn't been updated in recent three years][Y]](https://github.com/desertbit/glue)   [![godoc][D]](https://godoc.org/github.com/desertbit/glue)
- [Quamina](https://github.com/timbray/quamina) **star:375** Fast pattern-matching for filtering messages and events.   [![There was an update last month][G]](https://github.com/timbray/quamina)   [![godoc][D]](https://godoc.org/github.com/timbray/quamina)
- [Bus](https://github.com/mustafaturan/bus) **star:334** Minimalist message bus implementation for internal communication.   [![godoc][D]](https://godoc.org/github.com/mustafaturan/bus)
- [messagebus](https://github.com/vardius/message-bus) **star:270** messagebus is a Go simple async message bus, perfect for using as event bus when doing event sourcing, CQRS, DDD.   [![It hasn't been updated in recent three years][Y]](https://github.com/vardius/message-bus)
- [rabtap](https://github.com/jandelgado/rabtap) **star:257** RabbitMQ swiss army knife cli app.   [![godoc][D]](https://godoc.org/github.com/jandelgado/rabtap)
- [Go-MediatR](https://github.com/mehdihadeli/Go-MediatR) **star:197** A library for handling mediator patterns and simplified CQRS patterns within an event-driven architecture, inspired by csharp MediatR library.   [![godoc][D]](https://godoc.org/github.com/mehdihadeli/Go-MediatR)
- [guble](https://github.com/smancke/guble) **star:158** Messaging server using push notifications (Google Firebase Cloud Messaging, Apple Push Notification services, SMS) as well as websockets, a REST API, featuring distributed operation and message-persistence.   [![It hasn't been updated in recent three years][Y]](https://github.com/smancke/guble)   [![godoc][D]](https://godoc.org/github.com/smancke/guble)
- [hub](https://github.com/leandro-lugaresi/hub) **star:145** A Message/Event Hub for Go applications, using publish/subscribe pattern with support for alias like rabbitMQ exchanges.   [![It hasn't been updated in recent three years][Y]](https://github.com/leandro-lugaresi/hub)   [![godoc][D]](https://godoc.org/github.com/leandro-lugaresi/hub)
- [redisqueue](https://github.com/robinjoseph08/redisqueue) **star:127** redisqueue provides a producer and consumer of a queue that uses Redis streams.   [![godoc][D]](https://godoc.org/github.com/robinjoseph08/redisqueue)
- [oplog](https://github.com/dailymotion/oplog) **star:111** Generic oplog/replication system for REST APIs.   [![It hasn't been updated in recent three years][Y]](https://github.com/dailymotion/oplog)   [![godoc][D]](https://godoc.org/github.com/dailymotion/oplog)
- [Ratus](https://github.com/hyperonym/ratus) **star:106** Ratus is a RESTful asynchronous task queue server.   [![There was an update last month][G]](https://github.com/hyperonym/ratus)   [![godoc][D]](https://godoc.org/github.com/hyperonym/ratus)
- [rabbus](https://github.com/rafaeljesus/rabbus) **star:97** A tiny wrapper over amqp exchanges and queues.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafaeljesus/rabbus)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/rabbus)
- [go-mq](https://github.com/cheshir/go-mq) **star:91** RabbitMQ client with declarative configuration.   [![godoc][D]](https://godoc.org/github.com/cheshir/go-mq)
- [drone-line](https://github.com/appleboy/drone-line) **star:80** Sending [Line](https://at.line.me/en) notifications using a binary, docker or Drone CI.   [![godoc][D]](https://godoc.org/github.com/appleboy/drone-line)
- [nsq-event-bus](https://github.com/rafaeljesus/nsq-event-bus) **star:79** A tiny wrapper around NSQ topic and channel.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafaeljesus/nsq-event-bus)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/nsq-event-bus)
- [go-notify](https://github.com/TheCreeper/go-notify) **star:69** Native implementation of the freedesktop notification spec.   [![It hasn't been updated in recent three years][Y]](https://github.com/TheCreeper/go-notify)   [![godoc][D]](https://godoc.org/github.com/TheCreeper/go-notify)
- [RapidMQ](https://github.com/sybrexsys/RapidMQ) **star:68** RapidMQ is a lightweight and reliable library for managing of the local messages queue.   [![It hasn't been updated in recent three years][Y]](https://github.com/sybrexsys/RapidMQ)   [![godoc][D]](https://godoc.org/github.com/sybrexsys/RapidMQ)
- [Commander](https://github.com/jeroenrinzema/commander) **star:64** A high-level event driven consumer/producer supporting various "dialects" such as Apache Kafka.   [![It hasn't been updated in recent three years][Y]](https://github.com/jeroenrinzema/commander)   [![godoc][D]](https://godoc.org/github.com/jeroenrinzema/commander)
- [go-res](https://github.com/jirenius/go-res) **star:62** Package for building REST/real-time services where clients are synchronized seamlessly, using NATS and Resgate.   [![godoc][D]](https://godoc.org/github.com/jirenius/go-res)
- [event](https://github.com/agoalofalife/event) **star:57** Implementation of the pattern observer.   [![It hasn't been updated in recent three years][Y]](https://github.com/agoalofalife/event)   [![godoc][D]](https://godoc.org/github.com/agoalofalife/event)
- [hare](https://github.com/leozz37/hare) **star:52** A user friendly library for sending messages and listening to TCP sockets.   [![godoc][D]](https://godoc.org/github.com/leozz37/hare)
- [ami](https://github.com/kak-tus/ami) **star:28** Go client to reliable queues based on Redis Cluster Streams.   [![It hasn't been updated in recent three years][Y]](https://github.com/kak-tus/ami)   [![godoc][D]](https://godoc.org/github.com/kak-tus/ami)
- [gosd](https://github.com/alexsniffin/gosd) **star:24** A library for scheduling when to dispatch a message to a channel.   [![godoc][D]](https://godoc.org/github.com/alexsniffin/gosd)
- [go-vitotrol](https://github.com/maxatome/go-vitotrol) **star:23** Client library to Viessmann Vitotrol web service.   [![godoc][D]](https://godoc.org/github.com/maxatome/go-vitotrol)
- [rmqconn](https://github.com/sbabiv/rmqconn) **star:22** RabbitMQ Reconnection. Wrapper over amqp.Connection and amqp.Dial. Allowing to do a reconnection when the connection is broken before forcing the call to the Close () method to be closed.   [![It hasn't been updated in recent three years][Y]](https://github.com/sbabiv/rmqconn)   [![godoc][D]](https://godoc.org/github.com/sbabiv/rmqconn)
- [jazz](https://github.com/socifi/jazz) **star:18** A simple RabbitMQ abstraction layer for queue administration and publishing and consuming of messages.   [![It hasn't been updated in recent three years][Y]](https://github.com/socifi/jazz)   [![godoc][D]](https://godoc.org/github.com/socifi/jazz)
- [gaurun-client](https://github.com/osamingo/gaurun-client) **star:11** Gaurun Client written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/osamingo/gaurun-client)   [![godoc][D]](https://godoc.org/github.com/osamingo/gaurun-client)
- [go-eventbus](https://github.com/stanipetrosyan/go-eventbus) **star:3** Simple Event Bus package for Go.   [![There was an update last month][G]](https://github.com/stanipetrosyan/go-eventbus)   [![godoc][D]](https://godoc.org/github.com/stanipetrosyan/go-eventbus)

**[⬆ back to top](#contents)**

## Microsoft Office

- [unioffice](https://github.com/unidoc/unioffice) **star:4304** Pure go library for creating and processing Office Word (.docx), Excel (.xlsx) and Powerpoint (.pptx) documents.   [![godoc][D]](https://godoc.org/github.com/unidoc/unioffice)

### Microsoft Excel

_Libraries for working with Microsoft Excel._

- [excelize](https://github.com/xuri/excelize) **star:17841** Golang library for reading and writing Microsoft Excel&trade; (XLSX) files.   [![There was an update last month][G]](https://github.com/xuri/excelize)   [![godoc][D]](https://godoc.org/github.com/xuri/excelize)
- [xlsx](https://github.com/tealeg/xlsx) **star:5827** Library to simplify reading the XML format used by recent version of Microsoft Excel in Go programs.   [![There was an update last month][G]](https://github.com/tealeg/xlsx)   [![godoc][D]](https://godoc.org/github.com/tealeg/xlsx)
- [go-excel](https://github.com/szyhf/go-excel) **star:191** A simple and light reader to read a relate-db-like excel as a table.   [![godoc][D]](https://godoc.org/github.com/szyhf/go-excel)
- [xlsx](https://github.com/plandem/xlsx) **star:173** Fast and safe way to read/update your existing Microsoft Excel files in Go programs.   [![It hasn't been updated in recent three years][Y]](https://github.com/plandem/xlsx)   [![godoc][D]](https://godoc.org/github.com/plandem/xlsx)
- [exl](https://github.com/go-the-way/exl) **star:29** Excel binding to struct written in Go.(Only supports Go1.18+)   [![godoc][D]](https://godoc.org/github.com/go-the-way/exl)
- [goxlsxwriter](https://github.com/fterrag/goxlsxwriter) **star:21** Golang bindings for libxlsxwriter for writing XLSX (Microsoft Excel) files.   [![godoc][D]](https://godoc.org/github.com/fterrag/goxlsxwriter)   [![Archived][Archived]](https://github.com/fterrag/goxlsxwriter)

**[⬆ back to top](#contents)**

## Miscellaneous

### Dependency Injection

_Libraries for working with dependency injection._

- [google/wire](https://github.com/google/wire) **star:12750** Automated Initialization in Go.   [![godoc][D]](https://godoc.org/github.com/google/wire)
- [fx](https://github.com/uber-go/fx) **star:5550** A dependency injection based application framework for Go (built on top of dig).   [![There was an update last month][G]](https://github.com/uber-go/fx)   [![godoc][D]](https://godoc.org/github.com/uber-go/fx)
- [dig](https://github.com/uber-go/dig) **star:3815** A reflection based dependency injection toolkit for Go.   [![There was an update last month][G]](https://github.com/uber-go/dig)   [![godoc][D]](https://godoc.org/github.com/uber-go/dig)
- [do](https://github.com/samber/do) **star:1749** A dependency injection framework based on Generics.   [![godoc][D]](https://godoc.org/github.com/samber/do)
- [GoLobby/Container](https://github.com/golobby/container) **star:552** GoLobby Container is a lightweight yet powerful IoC dependency injection container for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/golobby/container)
- [goioc/di](https://github.com/goioc/di) **star:352** Spring-inspired Dependency Injection Container.   [![godoc][D]](https://godoc.org/github.com/goioc/di)
- [di](https://github.com/goava/di) **star:232** A dependency injection container for go programming language.   [![godoc][D]](https://godoc.org/github.com/goava/di)
- [dingo](https://github.com/i-love-flamingo/dingo) **star:179** A dependency injection toolkit for Go, based on Guice.   [![godoc][D]](https://godoc.org/github.com/i-love-flamingo/dingo)
- [kod](https://github.com/go-kod/kod) **star:121** A generics based dependency injection framework for Go.   [![There was an update last month][G]](https://github.com/go-kod/kod)   [![godoc][D]](https://godoc.org/github.com/go-kod/kod)   [![Contains Chinese documents][CN]](https://github.com/go-kod/kod)
- [alice](https://github.com/magic003/alice) **star:50** Additive dependency injection container for Golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/magic003/alice)   [![godoc][D]](https://godoc.org/github.com/magic003/alice)
- [boot-go](http://github.com/boot-go/boot)  Component-based development with dependency injection using reflections for Go developers.
- [cosban/di](https://gitlab.com/cosban/di)  A code generation based dependency injection wiring tool.
- [wire](https://github.com/Fs02/wire) **star:37** Strict Runtime Dependency Injection for Golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/Fs02/wire)   [![godoc][D]](https://godoc.org/github.com/Fs02/wire)
- [linker](https://github.com/logrange/linker) **star:35** A reflection based dependency injection and inversion of control library with components lifecycle support.   [![godoc][D]](https://godoc.org/github.com/logrange/linker)
- [gontainer](https://github.com/NVIDIA/gontainer) **star:33** A dependency injection service container for Go projects.   [![There was an update last month][G]](https://github.com/NVIDIA/gontainer)   [![godoc][D]](https://godoc.org/github.com/NVIDIA/gontainer)
- [nject](https://github.com/muir/nject) **star:28** A type safe, reflective framework for libraries, tests, http endpoints, and service startup.   [![godoc][D]](https://godoc.org/github.com/muir/nject)
- [gocontainer](https://github.com/vardius/gocontainer) **star:19** Simple Dependency Injection Container.   [![It hasn't been updated in recent three years][Y]](https://github.com/vardius/gocontainer)   [![godoc][D]](https://godoc.org/github.com/vardius/gocontainer)
- [gontainer/gontainer](https://github.com/gontainer/gontainer) **star:15** A YAML-based Dependency Injection container for GO. It supports dependencies' scopes, and auto-detection of circular dependencies. Gontainer is concurrent-safe.   [![There was an update last month][G]](https://github.com/gontainer/gontainer)   [![godoc][D]](https://godoc.org/github.com/gontainer/gontainer)
- [kinit](https://github.com/go-kata/kinit) **star:10** Customizable dependency injection container with the global mode, cascade initialization and panic-safe finalization.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-kata/kinit)   [![godoc][D]](https://godoc.org/github.com/go-kata/kinit)
- [HnH/di](https://github.com/HnH/di) **star:7** DI container library that is focused on clean API and flexibility.   [![godoc][D]](https://godoc.org/github.com/HnH/di)
- [ore](https://github.com/firasdarwish/ore) **star:5** Lightweight, generic & simple dependency injection (DI) container.   [![godoc][D]](https://godoc.org/github.com/firasdarwish/ore)

**[⬆ back to top](#contents)**

### Project Layout

_**Unofficial** set of patterns for structuring projects._

- [golang-standards/project-layout](https://github.com/golang-standards/project-layout) **star:47798** Set of common historical and emerging project layout patterns in the Go ecosystem. Note: despite the org-name they do not represent official golang standards, see [this issue](https://github.com/golang-standards/project-layout/issues/117) for more information. Nonetheless, some may find the layout useful.
- [ardanlabs/service](https://github.com/ardanlabs/service) **star:3508** A [starter kit](https://github.com/ardanlabs/service/wiki) for building production grade scalable web service applications.   [![There was an update last month][G]](https://github.com/ardanlabs/service)   [![godoc][D]](https://godoc.org/github.com/ardanlabs/service)
- [go-blueprint](https://github.com/Melkeydev/go-blueprint) **star:3317** Allows users to spin up a quick Go project using a popular framework.   [![There was an update last month][G]](https://github.com/Melkeydev/go-blueprint)   [![godoc][D]](https://godoc.org/github.com/Melkeydev/go-blueprint)
- [nunu](https://github.com/go-nunu/nunu) **star:1823** Nunu is a scaffolding tool for building Go applications.   [![There was an update last month][G]](https://github.com/go-nunu/nunu)   [![godoc][D]](https://godoc.org/github.com/go-nunu/nunu)   [![Contains Chinese documents][CN]](https://github.com/go-nunu/nunu)
- [modern-go-application](https://github.com/sagikazarmark/modern-go-application) **star:1805** Go application boilerplate and example applying modern practices.   [![godoc][D]](https://godoc.org/github.com/sagikazarmark/modern-go-application)
- [pagoda](https://github.com/mikestefanello/pagoda) **star:1440** Rapid, easy full-stack web development starter kit built in Go.   [![godoc][D]](https://godoc.org/github.com/mikestefanello/pagoda)
- [cookiecutter-golang](https://github.com/lacion/cookiecutter-golang) **star:686** A Go application boilerplate template for quick starting projects following production best practices.   [![godoc][D]](https://godoc.org/github.com/lacion/cookiecutter-golang)
- [go-starter](https://github.com/allaboutapps/go-starter) **star:482** An opinionated production-ready RESTful JSON backend template, highly integrated with VSCode DevContainers.   [![godoc][D]](https://godoc.org/github.com/allaboutapps/go-starter)
- [golang-templates/seed](https://github.com/golang-templates/seed) **star:456** Go application GitHub repository template.   [![There was an update last month][G]](https://github.com/golang-templates/seed)
- [go-todo-backend](https://github.com/Fs02/go-todo-backend) **star:315** Go Todo Backend example using modular project layout for product microservice.   [![godoc][D]](https://godoc.org/github.com/Fs02/go-todo-backend)
- [scaffold](https://github.com/catchplay/scaffold) **star:149** Scaffold generates a starter Go project layout. Lets you focus on business logic implemented.   [![It hasn't been updated in recent three years][Y]](https://github.com/catchplay/scaffold)   [![godoc][D]](https://godoc.org/github.com/catchplay/scaffold)
- [go-sample](https://github.com/zitryss/go-sample) **star:130** A sample layout for Go application projects with the real code.   [![It hasn't been updated in recent three years][Y]](https://github.com/zitryss/go-sample)   [![godoc][D]](https://godoc.org/github.com/zitryss/go-sample)
- [gobase](https://github.com/wajox/gobase) **star:60** A simple skeleton for golang application with basic setup for real golang application.   [![godoc][D]](https://godoc.org/github.com/wajox/gobase)
- [go-module](https://github.com/octomation/go-module) **star:30** Template for a typical module written on Go.   [![There was an update last month][G]](https://github.com/octomation/go-module)
- [wangyoucao577/go-project-layout](https://github.com/wangyoucao577/go-project-layout) **star:25** Set of practices and discussions on how to structure Go project layout.   [![It hasn't been updated in recent three years][Y]](https://github.com/wangyoucao577/go-project-layout)   [![godoc][D]](https://godoc.org/github.com/wangyoucao577/go-project-layout)
- [insidieux/inizio](https://github.com/insidieux/inizio) **star:18** Golang project layout generator with plugins.   [![godoc][D]](https://godoc.org/github.com/insidieux/inizio)

**[⬆ back to top](#contents)**

### Strings

_Libraries for working with strings._

- [xstrings](https://github.com/huandu/xstrings) **star:1392** Collection of useful string functions ported from other languages.   [![godoc][D]](https://godoc.org/github.com/huandu/xstrings)
- [sttr](https://github.com/abhimanyu003/sttr) **star:910** cross-platform, cli app to perform various operations on string.   [![godoc][D]](https://godoc.org/github.com/abhimanyu003/sttr)
- [gobeam/Stringy](https://github.com/gobeam/Stringy) **star:226** String manipulation library to convert string to camel case, snake case, kebab case / slugify etc.   [![godoc][D]](https://godoc.org/github.com/gobeam/Stringy)
- [strutil](https://github.com/ozgio/strutil) **star:205** String utilities.   [![godoc][D]](https://godoc.org/github.com/ozgio/strutil)
- [caps](https://github.com/chanced/caps) **star:53** A case conversion library.   [![godoc][D]](https://godoc.org/github.com/chanced/caps)
- [go-formatter](https://gitlab.com/tymonx/go-formatter)  Implements **replacement fields** surrounded by curly braces `{}` format strings.
- [bexp](https://github.com/happy-sdk/happy/tree/main/pkg/strings/bexp)  Go implementation of Brace Expansion mechanism to generate arbitrary strings.

**[⬆ back to top](#contents)**

### Uncategorized

_These libraries were placed here because none of the other categories seemed to fit._

- [gopsutil](https://github.com/shirou/gopsutil) **star:10385** Cross-platform library for retrieving process and system utilization(CPU, Memory, Disks, etc).   [![There was an update last month][G]](https://github.com/shirou/gopsutil)   [![godoc][D]](https://godoc.org/github.com/shirou/gopsutil)
- [gatus](https://github.com/TwinProduction/gatus) **star:5862** Automated service health dashboard.   [![There was an update last month][G]](https://github.com/TwinProduction/gatus)   [![godoc][D]](https://godoc.org/github.com/TwinProduction/gatus)
- [gofakeit](https://github.com/brianvoe/gofakeit) **star:4405** Random data generator written in go.   [![godoc][D]](https://godoc.org/github.com/brianvoe/gofakeit)
- [archiver](https://github.com/mholt/archiver) **star:4310** Library and command for making and extracting .zip and .tar.gz archives.   [![godoc][D]](https://godoc.org/github.com/mholt/archiver)
- [go-resiliency](https://github.com/eapache/go-resiliency) **star:2154** Resiliency patterns for golang.   [![godoc][D]](https://godoc.org/github.com/eapache/go-resiliency)
- [base64Captcha](https://github.com/mojocn/base64Captcha) **star:2074** Base64captch supports digit, number, alphabet, arithmetic, audio and digit-alphabet captcha.   [![godoc][D]](https://godoc.org/github.com/mojocn/base64Captcha)   [![Contains Chinese documents][CN]](https://github.com/mojocn/base64Captcha)
- [gosms](https://github.com/haxpax/gosms) **star:1448** Your own local SMS gateway in Go that can be used to send SMS.   [![It hasn't been updated in recent three years][Y]](https://github.com/haxpax/gosms)   [![godoc][D]](https://godoc.org/github.com/haxpax/gosms)
- [go-commons-pool](https://github.com/jolestar/go-commons-pool) **star:1218** Generic object pool for Golang.   [![godoc][D]](https://godoc.org/github.com/jolestar/go-commons-pool)   [![Contains Chinese documents][CN]](https://github.com/jolestar/go-commons-pool)
- [go-openapi](https://github.com/go-openapi)  Collection of packages to parse and utilize open-api schemas.
- [llvm](https://github.com/llir/llvm) **star:1174** Library for interacting with LLVM IR in pure Go.   [![godoc][D]](https://godoc.org/github.com/llir/llvm)
- [shoutrrr](https://github.com/containrrr/shoutrrr) **star:935** Notification library providing easy access to various messaging services like slack, mattermost, gotify and smtp among others.   [![godoc][D]](https://godoc.org/github.com/containrrr/shoutrrr)
- [shortid](https://github.com/teris-io/shortid) **star:931** Distributed generation of super short, unique, non-sequential, URL friendly IDs.   [![godoc][D]](https://godoc.org/github.com/teris-io/shortid)
- [stateless](https://github.com/qmuntal/stateless) **star:915** A fluent library for creating state machines.   [![godoc][D]](https://godoc.org/github.com/qmuntal/stateless)
- [health](https://github.com/alexliesenfeld/health) **star:771** A simple and flexible health check library for Go.   [![There was an update last month][G]](https://github.com/alexliesenfeld/health)   [![godoc][D]](https://godoc.org/github.com/alexliesenfeld/health)
- [xz](https://github.com/ulikunitz/xz) **star:470** Pure golang package for reading and writing xz-compressed files.   [![godoc][D]](https://godoc.org/github.com/ulikunitz/xz)
- [health](https://github.com/dimiro1/health) **star:452** Easy to use, extensible health check library.   [![godoc][D]](https://godoc.org/github.com/dimiro1/health)
- [banner](https://github.com/dimiro1/banner) **star:447** Add beautiful banners into your Go applications.   [![It hasn't been updated in recent three years][Y]](https://github.com/dimiro1/banner)   [![godoc][D]](https://godoc.org/github.com/dimiro1/banner)
- [gountries](https://github.com/pariz/gountries) **star:408** Package that exposes country and subdivision data.   [![godoc][D]](https://godoc.org/github.com/pariz/gountries)
- [conv](https://github.com/cstockton/go-conv) **star:385** Package conv provides fast and intuitive conversions across Go types.   [![It hasn't been updated in recent three years][Y]](https://github.com/cstockton/go-conv)   [![godoc][D]](https://godoc.org/github.com/cstockton/go-conv)
- [lk](https://github.com/hyperboloide/lk) **star:365** A simple licensing library for golang.   [![godoc][D]](https://godoc.org/github.com/hyperboloide/lk)
- [ffmt](https://github.com/go-ffmt/ffmt) **star:305** Beautify data display for Humans.   [![godoc][D]](https://godoc.org/github.com/go-ffmt/ffmt)   [![Contains Chinese documents][CN]](https://github.com/go-ffmt/ffmt)
- [go-unarr](https://github.com/gen2brain/go-unarr) **star:281** Decompression library for RAR, TAR, ZIP and 7z archives.   [![godoc][D]](https://godoc.org/github.com/gen2brain/go-unarr)
- [healthcheck](https://github.com/etherlabsio/healthcheck) **star:267** An opinionated and concurrent health-check HTTP handler for RESTful services.   [![godoc][D]](https://godoc.org/github.com/etherlabsio/healthcheck)
- [antch](https://github.com/antchfx/antch) **star:258** A fast, powerful and extensible web crawling & scraping framework.   [![It hasn't been updated in recent three years][Y]](https://github.com/antchfx/antch)   [![godoc][D]](https://godoc.org/github.com/antchfx/antch)   [![Contains Chinese documents][CN]](https://github.com/antchfx/antch)
- [battery](https://github.com/distatus/battery) **star:245** Cross-platform, normalized battery information library.   [![godoc][D]](https://godoc.org/github.com/distatus/battery)
- [bitio](https://github.com/icza/bitio) **star:238** Highly optimized bit-level Reader and Writer for Go.   [![godoc][D]](https://godoc.org/github.com/icza/bitio)
- [gtree](https://github.com/ddddddO/gtree) **star:212** Provide CLI, Package and Web for tree output and directories creation from Markdown or programmatically.   [![There was an update last month][G]](https://github.com/ddddddO/gtree)   [![godoc][D]](https://godoc.org/github.com/ddddddO/gtree)
- [stats](https://github.com/go-playground/stats) **star:170** Monitors Go MemStats + System stats such as Memory, Swap and CPU and sends via UDP anywhere you want for logging etc...   [![It hasn't been updated in recent three years][Y]](https://github.com/go-playground/stats)   [![godoc][D]](https://godoc.org/github.com/go-playground/stats)
- [turtle](https://github.com/hackebrot/turtle) **star:158** Emojis for Go.   [![godoc][D]](https://godoc.org/github.com/hackebrot/turtle)
- [captcha](https://github.com/steambap/captcha) **star:151** Package captcha provides an easy to use, unopinionated API for captcha generation.   [![godoc][D]](https://godoc.org/github.com/steambap/captcha)
- [gommit](https://github.com/antham/gommit) **star:111** Analyze git commit messages to ensure they follow defined patterns.   [![There was an update last month][G]](https://github.com/antham/gommit)   [![godoc][D]](https://godoc.org/github.com/antham/gommit)
- [gotoprom](https://github.com/cabify/gotoprom) **star:109** Type-safe metrics builder wrapper library for the official Prometheus client.   [![godoc][D]](https://godoc.org/github.com/cabify/gotoprom)
- [indigo](https://github.com/osamingo/indigo) **star:109** Distributed unique ID generator of using Sonyflake and encoded by Base58.   [![godoc][D]](https://godoc.org/github.com/osamingo/indigo)
- [faker](https://github.com/pioz/faker) **star:90** Random fake data and struct generator for Go.   [![godoc][D]](https://godoc.org/github.com/pioz/faker)
- [persian](https://github.com/mavihq/persian) **star:84** Some utilities for Persian language in go.   [![godoc][D]](https://godoc.org/github.com/mavihq/persian)
- [morse](https://github.com/alwindoss/morse) **star:81** Library to convert to and from morse code.   [![godoc][D]](https://godoc.org/github.com/alwindoss/morse)
- [pdfgen](https://github.com/hyperboloide/pdfgen) **star:70** HTTP service to generate PDF from Json requests.   [![It hasn't been updated in recent three years][Y]](https://github.com/hyperboloide/pdfgen)   [![godoc][D]](https://godoc.org/github.com/hyperboloide/pdfgen)
- [xkg](https://github.com/go-xkg/xkg) **star:56** X Keyboard Grabber.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-xkg/xkg)   [![godoc][D]](https://godoc.org/github.com/go-xkg/xkg)
- [browscap_go](https://github.com/digitalcrab/browscap_go) **star:48** GoLang Library for [Browser Capabilities Project](https://browscap.org/).   [![godoc][D]](https://godoc.org/github.com/digitalcrab/browscap_go)
- [datacounter](https://github.com/miolini/datacounter) **star:48** Go counters for readers/writer/http.ResponseWriter.   [![godoc][D]](https://godoc.org/github.com/miolini/datacounter)
- [url-shortener](https://github.com/pantrif/url-shortener) **star:48** A modern, powerful, and robust URL shortener microservice with mysql support.   [![godoc][D]](https://godoc.org/github.com/pantrif/url-shortener)
- [VarHandler](https://github.com/azr/generators/tree/master/varhandler)  Generate boilerplate http input and output handling.
- [sandid](https://github.com/aofei/sandid) **star:47** Every grain of sand on earth has its own ID.   [![godoc][D]](https://godoc.org/github.com/aofei/sandid)
- [xdg](https://github.com/rkoesters/xdg) **star:41** FreeDesktop.org (xdg) Specs implemented in Go.   [![godoc][D]](https://godoc.org/github.com/rkoesters/xdg)
- [autoflags](https://github.com/artyom/autoflags) **star:39** Go package to automatically define command line flags from struct fields.   [![godoc][D]](https://godoc.org/github.com/artyom/autoflags)
- [gosh](https://github.com/osamingo/gosh) **star:36** Provide Go Statistics Handler, Struct, Measure Method.   [![godoc][D]](https://godoc.org/github.com/osamingo/gosh)
- [numa](https://github.com/lrita/numa) **star:28** NUMA is a utility library, which is written in go. It help us to write some NUMA-AWARED code.   [![godoc][D]](https://godoc.org/github.com/lrita/numa)
- [metrics](https://github.com/pascaldekloe/metrics) **star:27** Library for metrics instrumentation and Prometheus exposition.   [![godoc][D]](https://godoc.org/github.com/pascaldekloe/metrics)
- [shellwords](https://github.com/Wing924/shellwords) **star:24** A Golang library to manipulate strings according to the word parsing rules of the UNIX Bourne shell.   [![godoc][D]](https://godoc.org/github.com/Wing924/shellwords)
- [avgRating](https://github.com/kirillDanshin/avgRating) **star:16** Calculate average score and rating based on Wilson Score Equation.   [![It hasn't been updated in recent three years][Y]](https://github.com/kirillDanshin/avgRating)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/avgRating)
- [anagent](https://github.com/mudler/anagent) **star:15** Minimalistic, pluggable Golang evloop/timer handler with dependency-injection.   [![It hasn't been updated in recent three years][Y]](https://github.com/mudler/anagent)   [![godoc][D]](https://godoc.org/github.com/mudler/anagent)
- [varint](https://github.com/chmike/varint) **star:13** A faster varying length integer encoder/decoder than the one provided in the standard library.   [![godoc][D]](https://godoc.org/github.com/chmike/varint)
- [go-commandbus](https://github.com/lana/go-commandbus) **star:12** A slight and pluggable command-bus for Go.   [![godoc][D]](https://godoc.org/github.com/lana/go-commandbus)
- [hostutils](https://github.com/Wing924/hostutils) **star:12** A golang library for packing and unpacking FQDNs list.   [![godoc][D]](https://godoc.org/github.com/Wing924/hostutils)
- [faker](https://github.com/neotoolkit/faker) **star:10** Fake data generator.   [![godoc][D]](https://godoc.org/github.com/neotoolkit/faker)   [![Archived][Archived]](https://github.com/neotoolkit/faker)
- [openapi](https://github.com/neotoolkit/openapi) **star:10** OpenAPI 3.x parser.   [![godoc][D]](https://godoc.org/github.com/neotoolkit/openapi)   [![Archived][Archived]](https://github.com/neotoolkit/openapi)
- [basexx](https://github.com/bobg/basexx) **star:5** Convert to, from, and between digit strings in various number bases.   [![godoc][D]](https://godoc.org/github.com/bobg/basexx)
- [sitemap-format](https://github.com/mingard/sitemap-format) **star:5** A simple sitemap generator, with a little syntactic sugar.   [![godoc][D]](https://godoc.org/github.com/mingard/sitemap-format)
- [common](https://github.com/kubeservice-stack/common) **star:4** A library for server framework.   [![godoc][D]](https://godoc.org/github.com/kubeservice-stack/common)

**[⬆ back to top](#contents)**

## Natural Language Processing

_Libraries for working with human languages._

See also [Text Processing](#text-processing) and [Text Analysis](#text-analysis).

### Language Detection

- [whatlanggo](https://github.com/abadojack/whatlanggo) **star:637** Natural language detection package for Go. Supports 84 languages and 24 scripts (writing systems e.g. Latin, Cyrillic, etc).   [![godoc][D]](https://godoc.org/github.com/abadojack/whatlanggo)
- [getlang](https://github.com/rylans/getlang) **star:169** Fast natural language detection package.   [![It hasn't been updated in recent three years][Y]](https://github.com/rylans/getlang)   [![godoc][D]](https://godoc.org/github.com/rylans/getlang)
- [guesslanguage](https://github.com/endeveit/guesslanguage) **star:58** Functions to determine the natural language of a unicode text.   [![It hasn't been updated in recent three years][Y]](https://github.com/endeveit/guesslanguage)   [![godoc][D]](https://godoc.org/github.com/endeveit/guesslanguage)
- [detectlanguage](https://github.com/detectlanguage/detectlanguage-go) **star:25** Language Detection API Go Client. Supports batch requests, short phrase or single word language detection.   [![godoc][D]](https://godoc.org/github.com/detectlanguage/detectlanguage-go)

### Morphological Analyzers

- [spaGO](https://github.com/nlpodyssey/spago) **star:1734** Self-contained Machine Learning and Natural Language Processing library in Go.   [![godoc][D]](https://godoc.org/github.com/nlpodyssey/spago)
- [kagome](https://github.com/ikawaha/kagome) **star:811** JP morphological analyzer written in pure Go.   [![godoc][D]](https://godoc.org/github.com/ikawaha/kagome)
- [nlp](https://github.com/james-bowman/nlp) **star:445** Go Natural Language Processing library supporting LSA (Latent Semantic Analysis).   [![It hasn't been updated in recent three years][Y]](https://github.com/james-bowman/nlp)   [![godoc][D]](https://godoc.org/github.com/james-bowman/nlp)
- [nlp](https://github.com/Shixzie/nlp) **star:389** Extract values from strings and fill your structs with nlp.   [![It hasn't been updated in recent three years][Y]](https://github.com/Shixzie/nlp)   [![godoc][D]](https://godoc.org/github.com/Shixzie/nlp)   [![Archived][Archived]](https://github.com/Shixzie/nlp)
- [RAKE.go](https://github.com/afjoseph/RAKE.Go) **star:114** Go port of the Rapid Automatic Keyword Extraction Algorithm (RAKE).   [![It hasn't been updated in recent three years][Y]](https://github.com/afjoseph/RAKE.Go)   [![godoc][D]](https://godoc.org/github.com/afjoseph/RAKE.Go)
- [go-stem](https://github.com/agonopol/go-stem) **star:78** Implementation of the porter stemming algorithm.   [![It hasn't been updated in recent three years][Y]](https://github.com/agonopol/go-stem)   [![godoc][D]](https://godoc.org/github.com/agonopol/go-stem)
- [go2vec](https://github.com/danieldk/go2vec) **star:56** Reader and utility functions for word2vec embeddings.   [![It hasn't been updated in recent three years][Y]](https://github.com/danieldk/go2vec)   [![godoc][D]](https://godoc.org/github.com/danieldk/go2vec)
- [porter2](https://github.com/zhenjl/porter2) **star:46** Really fast Porter 2 stemmer.   [![It hasn't been updated in recent three years][Y]](https://github.com/zhenjl/porter2)   [![godoc][D]](https://godoc.org/github.com/zhenjl/porter2)
- [govader](https://github.com/jonreiter/govader) **star:39** Go implementation of [VADER Sentiment Analysis](https://github.com/cjhutto/vaderSentiment).   [![godoc][D]](https://godoc.org/github.com/jonreiter/govader)
- [snowball](https://github.com/goodsign/snowball) **star:38** Snowball stemmer port (cgo wrapper) for Go. Provides word stem extraction functionality [Snowball native](http://snowball.tartarus.org/).   [![It hasn't been updated in recent three years][Y]](https://github.com/goodsign/snowball)
- [paicehusk](https://github.com/rookii/paicehusk) **star:29** Golang implementation of the Paice/Husk Stemming Algorithm.   [![It hasn't been updated in recent three years][Y]](https://github.com/rookii/paicehusk)   [![godoc][D]](https://godoc.org/github.com/rookii/paicehusk)
- [golibstemmer](https://github.com/rjohnsondev/golibstemmer) **star:20** Go bindings for the snowball libstemmer library including porter 2.   [![It hasn't been updated in recent three years][Y]](https://github.com/rjohnsondev/golibstemmer)   [![godoc][D]](https://godoc.org/github.com/rjohnsondev/golibstemmer)
- [libtextcat](https://github.com/goodsign/libtextcat) **star:13** Cgo binding for libtextcat C library. Guaranteed compatibility with version 2.2.   [![It hasn't been updated in recent three years][Y]](https://github.com/goodsign/libtextcat)   [![godoc][D]](https://godoc.org/github.com/goodsign/libtextcat)
- [porter](https://github.com/a2800276/porter) **star:12** This is a fairly straightforward port of Martin Porter's C implementation of the Porter stemming algorithm.   [![It hasn't been updated in recent three years][Y]](https://github.com/a2800276/porter)   [![godoc][D]](https://godoc.org/github.com/a2800276/porter)
- [gosentiwordnet](https://github.com/dinopuguh/gosentiwordnet) **star:10** Sentiment analyzer using sentiwordnet lexicon in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/dinopuguh/gosentiwordnet)   [![godoc][D]](https://godoc.org/github.com/dinopuguh/gosentiwordnet)
- [govader-backend](https://github.com/PIMPfiction/govader_backend) **star:6** Microservice implementation of [GoVader](https://github.com/jonreiter/govader).   [![godoc][D]](https://godoc.org/github.com/PIMPfiction/govader_backend)
- [spelling-corrector](https://github.com/jorelosorio/spellingcorrector) **star:2** A spelling corrector for the Spanish language or create your own.   [![godoc][D]](https://godoc.org/github.com/jorelosorio/spellingcorrector)

### Slugifiers

- [slug](https://github.com/gosimple/slug) **star:1129** URL-friendly slugify with multiple languages support.   [![godoc][D]](https://godoc.org/github.com/gosimple/slug)
- [go-slugify](https://github.com/mozillazg/go-slugify) **star:93** Make pretty slug with multiple languages support.   [![It hasn't been updated in recent three years][Y]](https://github.com/mozillazg/go-slugify)   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-slugify)
- [Slugify](https://github.com/avelino/slugify) **star:33** Go slugify application that handles string.   [![It hasn't been updated in recent three years][Y]](https://github.com/avelino/slugify)   [![godoc][D]](https://godoc.org/github.com/avelino/slugify)

### Tokenizers

- [prose](https://github.com/jdkato/prose) **star:3046** Library for text processing that supports tokenization, part-of-speech tagging, named-entity extraction, and more. English only.   [![godoc][D]](https://godoc.org/github.com/jdkato/prose)   [![Archived][Archived]](https://github.com/jdkato/prose)
- [gse](https://github.com/go-ego/gse) **star:2523** Go efficient text segmentation; support english, chinese, japanese and other.   [![godoc][D]](https://godoc.org/github.com/go-ego/gse)   [![Contains Chinese documents][CN]](https://github.com/go-ego/gse)
- [gojieba](https://github.com/yanyiwu/gojieba) **star:2378** This is a Go implementation of [jieba](https://github.com/fxsjy/jieba) which a Chinese word splitting algorithm.   [![There was an update last month][G]](https://github.com/yanyiwu/gojieba)   [![godoc][D]](https://godoc.org/github.com/yanyiwu/gojieba)   [![Contains Chinese documents][CN]](https://github.com/yanyiwu/gojieba)
- [sentences](https://github.com/neurosnap/sentences) **star:435** Sentence tokenizer: converts text into a list of sentences.   [![godoc][D]](https://godoc.org/github.com/neurosnap/sentences)
- [segment](https://github.com/blevesearch/segment) **star:87** Go library for performing Unicode Text Segmentation as described in [Unicode Standard Annex #29](https://www.unicode.org/reports/tr29/)   [![godoc][D]](https://godoc.org/github.com/blevesearch/segment)
- [textcat](https://github.com/pebbe/textcat) **star:72** Go package for n-gram based text categorization, with support for utf-8 and raw text.   [![It hasn't been updated in recent three years][Y]](https://github.com/pebbe/textcat)   [![godoc][D]](https://godoc.org/github.com/pebbe/textcat)
- [MMSEGO](https://github.com/awsong/MMSEGO) **star:63** This is a GO implementation of [MMSEG](http://technology.chtsai.org/mmseg/) which a Chinese word splitting algorithm.   [![It hasn't been updated in recent three years][Y]](https://github.com/awsong/MMSEGO)   [![godoc][D]](https://godoc.org/github.com/awsong/MMSEGO)
- [stemmer](https://github.com/dchest/stemmer) **star:52** Stemmer packages for Go programming language. Includes English and German stemmers.   [![It hasn't been updated in recent three years][Y]](https://github.com/dchest/stemmer)   [![godoc][D]](https://godoc.org/github.com/dchest/stemmer)
- [gotokenizer](https://github.com/xujiajun/gotokenizer) **star:19** A tokenizer based on the dictionary and Bigram language models for Golang. (Now only support chinese segmentation)   [![It hasn't been updated in recent three years][Y]](https://github.com/xujiajun/gotokenizer)   [![godoc][D]](https://godoc.org/github.com/xujiajun/gotokenizer)
- [shamoji](https://github.com/osamingo/shamoji) **star:13** The shamoji is word filtering package written in Go.   [![godoc][D]](https://godoc.org/github.com/osamingo/shamoji)

### Translation

- [go-pinyin](https://github.com/mozillazg/go-pinyin) **star:1598** CN Hanzi to Hanyu Pinyin converter.   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-pinyin)
- [gotext](https://github.com/leonelquinteros/gotext) **star:431** GNU gettext utilities for Go.   [![godoc][D]](https://godoc.org/github.com/leonelquinteros/gotext)
- [ctxi18n](https://github.com/invopop/ctxi18n/)  Context aware i18n with a short and consise API, pluralization, interpolation, and `fs.FS` support. YAML locale definitions are based on [Rails i18n](https://guides.rubyonrails.org/i18n.html).
- [go-i18n](https://github.com/nicksnyder/go-i18n/)  Package and an accompanying tool to work with localized text.
- [spreak](https://github.com/vorlif/spreak) **star:53** Flexible translation and humanization library for Go, based on the concepts behind gettext.   [![godoc][D]](https://godoc.org/github.com/vorlif/spreak)
- [iuliia-go](https://github.com/mehanizm/iuliia-go) **star:48** Transliterate Cyrillic → Latin in every possible way.   [![It hasn't been updated in recent three years][Y]](https://github.com/mehanizm/iuliia-go)   [![godoc][D]](https://godoc.org/github.com/mehanizm/iuliia-go)
- [go-mystem](https://github.com/dveselov/mystem) **star:32** CGo bindings to Yandex.Mystem - russian morphology analyzer.   [![It hasn't been updated in recent three years][Y]](https://github.com/dveselov/mystem)   [![godoc][D]](https://godoc.org/github.com/dveselov/mystem)
- [t](https://github.com/youthlin/t) **star:19** Another i18n pkg for golang, which follows GNU gettext style and supports .po/.mo files: `t.T (gettext)`, `t.N (ngettext)`, etc. And it contains a cmd tool [xtemplate](https://github.com/youthlin/t/blob/main/cmd/xtemplate), which can extract messages as a pot file from text/html template.   [![godoc][D]](https://godoc.org/github.com/youthlin/t)   [![Contains Chinese documents][CN]](https://github.com/youthlin/t)
- [go-words](https://github.com/saleh-rahimzadeh/go-words) **star:6** A words table and text resource library for Golang projects.   [![godoc][D]](https://godoc.org/github.com/saleh-rahimzadeh/go-words)

### Transliteration

- [go-unidecode](https://github.com/mozillazg/go-unidecode) **star:126** ASCII transliterations of Unicode text.   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-unidecode)
- [gounidecode](https://github.com/fiam/gounidecode) **star:79** Unicode transliterator (also known as unidecode) for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/fiam/gounidecode)   [![godoc][D]](https://godoc.org/github.com/fiam/gounidecode)
- [transliterator](https://github.com/alexsergivan/transliterator) **star:41** Provides one-way string transliteration with supporting of language-specific transliteration rules.   [![godoc][D]](https://godoc.org/github.com/alexsergivan/transliterator)
- [enca](https://github.com/endeveit/enca) **star:16** Minimal cgo bindings for [libenca](https://cihar.com/software/enca/), which detects character encodings.   [![It hasn't been updated in recent three years][Y]](https://github.com/endeveit/enca)   [![godoc][D]](https://godoc.org/github.com/endeveit/enca)

**[⬆ back to top](#contents)**

## Networking

_Libraries for working with various layers of the network._

- [fasthttp](https://github.com/valyala/fasthttp) **star:21502** Package fasthttp is a fast HTTP implementation for Go, up to 10 times faster than net/http.   [![There was an update last month][G]](https://github.com/valyala/fasthttp)   [![godoc][D]](https://godoc.org/github.com/valyala/fasthttp)
- [kcptun](https://github.com/xtaci/kcptun) **star:13838** Extremely simple & fast udp tunnel based on KCP protocol.   [![There was an update last month][G]](https://github.com/xtaci/kcptun)   [![godoc][D]](https://godoc.org/github.com/xtaci/kcptun)
- [webrtc](https://github.com/pions/webrtc) **star:13252** A pure Go implementation of the WebRTC API.   [![There was an update last month][G]](https://github.com/pions/webrtc)   [![godoc][D]](https://godoc.org/github.com/pions/webrtc)
- [quic-go](https://github.com/lucas-clemente/quic-go) **star:9864** An implementation of the QUIC protocol in pure Go.   [![There was an update last month][G]](https://github.com/lucas-clemente/quic-go)   [![godoc][D]](https://godoc.org/github.com/lucas-clemente/quic-go)
- [gnet](https://github.com/panjf2000/gnet) **star:9423** `gnet` is a high-performance, lightweight, non-blocking, event-driven networking framework written in pure Go.   [![There was an update last month][G]](https://github.com/panjf2000/gnet)   [![godoc][D]](https://godoc.org/github.com/panjf2000/gnet)   [![Contains Chinese documents][CN]](https://github.com/panjf2000/gnet)
- [dns](https://github.com/miekg/dns) **star:7910** Go library for working with DNS.   [![There was an update last month][G]](https://github.com/miekg/dns)   [![godoc][D]](https://godoc.org/github.com/miekg/dns)
- [gopacket](https://github.com/google/gopacket) **star:6238** Go library for packet processing with libpcap bindings.   [![godoc][D]](https://godoc.org/github.com/google/gopacket)
- [kcp-go](https://github.com/xtaci/kcp-go) **star:4032** KCP - Fast and Reliable ARQ Protocol.   [![godoc][D]](https://godoc.org/github.com/xtaci/kcp-go)
- [HTTPLab](https://github.com/gchaincl/httplab) **star:4009** HTTPLabs let you inspect HTTP requests and forge responses.   [![godoc][D]](https://godoc.org/github.com/gchaincl/httplab)
- [netpoll](https://github.com/cloudwego/netpoll) **star:3996** A high-performance non-blocking I/O networking framework, which focused on RPC scenarios, developed by ByteDance.   [![There was an update last month][G]](https://github.com/cloudwego/netpoll)   [![godoc][D]](https://godoc.org/github.com/cloudwego/netpoll)   [![Contains Chinese documents][CN]](https://github.com/cloudwego/netpoll)
- [ssh](https://github.com/gliderlabs/ssh) **star:3614** Higher-level API for building SSH servers (wraps crypto/ssh).   [![godoc][D]](https://godoc.org/github.com/gliderlabs/ssh)
- [gobgp](https://github.com/osrg/gobgp) **star:3567** BGP implemented in the Go Programming Language.   [![There was an update last month][G]](https://github.com/osrg/gobgp)   [![godoc][D]](https://godoc.org/github.com/osrg/gobgp)
- [fortio](https://github.com/fortio/fortio) **star:3278** Load testing library and command line tool, advanced echo server and web UI. Allows to specify a set query-per-second load and record latency histograms and other useful stats and graph them. Tcp, Http, gRPC.   [![There was an update last month][G]](https://github.com/fortio/fortio)   [![godoc][D]](https://godoc.org/github.com/fortio/fortio)
- [nbio](https://github.com/lesismal/nbio) **star:2126** Pure Go 1000k+ connections solution, support tls/http1.x/websocket and basically compatible with net/http, with high-performance and low memory cost, non-blocking, event-driven, easy-to-use.   [![godoc][D]](https://godoc.org/github.com/lesismal/nbio)
- [net](https://golang.org/x/net)  This repository holds supplementary Go networking libraries.
- [water](https://github.com/songgao/water) **star:1912** Simple TUN/TAP library.   [![godoc][D]](https://godoc.org/github.com/songgao/water)
- [gev](https://github.com/Allenxuxu/gev) **star:1722** gev is a lightweight, fast non-blocking TCP network library based on Reactor mode.   [![godoc][D]](https://godoc.org/github.com/Allenxuxu/gev)
- [go-getter](https://github.com/hashicorp/go-getter) **star:1629** Go library for downloading files or directories from various sources using a URL.   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-getter)
- [sftp](https://github.com/pkg/sftp) **star:1490** Package sftp implements the SSH File Transfer Protocol as described in <https://filezilla-project.org/specs/draft-ietf-secsh-filexfer-02.txt>.   [![godoc][D]](https://godoc.org/github.com/pkg/sftp)
- [grab](https://github.com/cavaliercoder/grab) **star:1387** Go package for managing file downloads.   [![godoc][D]](https://godoc.org/github.com/cavaliercoder/grab)
- [NFF-Go](https://github.com/intel-go/nff-go) **star:1377** Framework for rapid development of performant network functions for cloud and bare-metal (former YANFF).   [![godoc][D]](https://godoc.org/github.com/intel-go/nff-go)
- [gws](https://github.com/lxzan/gws) **star:1305** High-Performance WebSocket Server & Client With AsyncIO Supporting .   [![There was an update last month][G]](https://github.com/lxzan/gws)   [![godoc][D]](https://godoc.org/github.com/lxzan/gws)
- [ftp](https://github.com/jlaffaye/ftp) **star:1268** Package ftp implements a FTP client as described in [RFC 959](https://tools.ietf.org/html/rfc959).   [![godoc][D]](https://godoc.org/github.com/jlaffaye/ftp)
- [mdns](https://github.com/hashicorp/mdns) **star:1166** Simple mDNS (Multicast DNS) client/server library in Golang.   [![There was an update last month][G]](https://github.com/hashicorp/mdns)   [![godoc][D]](https://godoc.org/github.com/hashicorp/mdns)
- [mqttPaho](https://eclipse.org/paho/clients/golang/)  The Paho Go Client provides an MQTT client library for connection to MQTT brokers via TCP, TLS or WebSockets.
- [gosnmp](https://github.com/soniah/gosnmp) **star:1105** Native Go library for performing SNMP actions.   [![There was an update last month][G]](https://github.com/soniah/gosnmp)   [![godoc][D]](https://godoc.org/github.com/soniah/gosnmp)
- [gmqtt](https://github.com/DrmagicE/gmqtt) **star:978** Gmqtt is a flexible, high-performance MQTT broker library that fully implements the MQTT protocol V3.1.1.   [![godoc][D]](https://godoc.org/github.com/DrmagicE/gmqtt)   [![Contains Chinese documents][CN]](https://github.com/DrmagicE/gmqtt)
- [vssh](https://github.com/yahoo/vssh) **star:952** Go library for building network and server automation over SSH protocol.   [![godoc][D]](https://godoc.org/github.com/yahoo/vssh)
- [cidranger](https://github.com/yl2chen/cidranger) **star:896** Fast IP to CIDR lookup for Go.   [![godoc][D]](https://godoc.org/github.com/yl2chen/cidranger)
- [easytcp](https://github.com/DarthPestilane/easytcp) **star:799** A light-weight TCP framework written in Go (Golang), built with message router. EasyTCP helps you build a TCP server easily fast and less painful.   [![godoc][D]](https://godoc.org/github.com/DarthPestilane/easytcp)
- [lhttp](https://github.com/fanux/lhttp) **star:693** Powerful websocket framework, build your IM server more easily.   [![It hasn't been updated in recent three years][Y]](https://github.com/fanux/lhttp)   [![godoc][D]](https://godoc.org/github.com/fanux/lhttp)   [![Contains Chinese documents][CN]](https://github.com/fanux/lhttp)
- [go-stun](https://github.com/ccding/go-stun) **star:656** Go implementation of the STUN client (RFC 3489 and RFC 5389).   [![godoc][D]](https://godoc.org/github.com/ccding/go-stun)
- [peerdiscovery](https://github.com/schollz/peerdiscovery) **star:633** Pure Go library for cross-platform local peer discovery using UDP multicast.   [![godoc][D]](https://godoc.org/github.com/schollz/peerdiscovery)
- [gaio](https://github.com/xtaci/gaio) **star:582** High performance async-io networking for Golang in proactor mode.   [![There was an update last month][G]](https://github.com/xtaci/gaio)   [![godoc][D]](https://godoc.org/github.com/xtaci/gaio)
- [gotcp](https://github.com/gansidui/gotcp) **star:512** Go package for quickly writing tcp applications.   [![godoc][D]](https://godoc.org/github.com/gansidui/gotcp)
- [stun](https://github.com/go-rtc/stun) **star:493** Go implementation of RFC 5389 STUN protocol.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-rtc/stun)   [![godoc][D]](https://godoc.org/github.com/go-rtc/stun)   [![Archived][Archived]](https://github.com/go-rtc/stun)
- [gopcap](https://github.com/akrennmair/gopcap) **star:487** Go wrapper for libpcap.   [![It hasn't been updated in recent three years][Y]](https://github.com/akrennmair/gopcap)   [![godoc][D]](https://godoc.org/github.com/akrennmair/gopcap)
- [tcp_server](https://github.com/firstrow/tcp_server) **star:426** Go library for building tcp servers faster.   [![godoc][D]](https://godoc.org/github.com/firstrow/tcp_server)   [![Archived][Archived]](https://github.com/firstrow/tcp_server)
- [raw](https://github.com/mdlayher/raw) **star:424** Package raw enables reading and writing data at the device driver level for a network interface.   [![godoc][D]](https://godoc.org/github.com/mdlayher/raw)   [![Archived][Archived]](https://github.com/mdlayher/raw)
- [winrm](https://github.com/masterzen/winrm) **star:422** Go WinRM client to remotely execute commands on Windows machines.   [![godoc][D]](https://godoc.org/github.com/masterzen/winrm)
- [ftpserverlib](https://github.com/fclairamb/ftpserverlib) **star:412** Fully featured FTP server library.   [![There was an update last month][G]](https://github.com/fclairamb/ftpserverlib)   [![godoc][D]](https://godoc.org/github.com/fclairamb/ftpserverlib)
- [arp](https://github.com/mdlayher/arp) **star:358** Package arp implements the ARP protocol, as described in RFC 826.   [![godoc][D]](https://godoc.org/github.com/mdlayher/arp)
- [dnsmonster](https://github.com/mosajjal/dnsmonster) **star:315** Passive DNS Capture/Monitoring Framework.   [![godoc][D]](https://godoc.org/github.com/mosajjal/dnsmonster)
- [ethernet](https://github.com/mdlayher/ethernet) **star:273** Package ethernet implements marshaling and unmarshalling of IEEE 802.3 Ethernet II frames and IEEE 802.1Q VLAN tags.   [![godoc][D]](https://godoc.org/github.com/mdlayher/ethernet)
- [gNxI](https://github.com/google/gnxi) **star:255** A collection of tools for Network Management that use the gNMI and gNOI protocols.   [![There was an update last month][G]](https://github.com/google/gnxi)
- [buffstreams](https://github.com/stabbycutyou/buffstreams) **star:253** Streaming protocolbuffer data over TCP made easy.   [![It hasn't been updated in recent three years][Y]](https://github.com/stabbycutyou/buffstreams)   [![godoc][D]](https://godoc.org/github.com/stabbycutyou/buffstreams)
- [jazigo](https://github.com/udhos/jazigo) **star:212** Jazigo is a tool written in Go for retrieving configuration for multiple network devices.   [![godoc][D]](https://godoc.org/github.com/udhos/jazigo)
- [tcpack](https://github.com/lim-yoona/tcpack) **star:174** tcpack is an application protocol based on TCP to Pack and Unpack bytes stream in go program.   [![godoc][D]](https://godoc.org/github.com/lim-yoona/tcpack)   [![Contains Chinese documents][CN]](https://github.com/lim-yoona/tcpack)
- [utp](https://github.com/anacrolix/utp) **star:173** Go uTP micro transport protocol implementation.   [![godoc][D]](https://godoc.org/github.com/anacrolix/utp)
- [canopus](https://github.com/zubairhamed/canopus) **star:154** CoAP Client/Server implementation (RFC 7252).   [![It hasn't been updated in recent three years][Y]](https://github.com/zubairhamed/canopus)   [![godoc][D]](https://godoc.org/github.com/zubairhamed/canopus)
- [event](https://github.com/cheng-zhongliang/event) **star:154** Simple I/O event notification library written in Golang.   [![godoc][D]](https://godoc.org/github.com/cheng-zhongliang/event)
- [xtcp](https://github.com/xfxdev/xtcp) **star:151** TCP Server Framework with simultaneous full duplex communication, graceful shutdown, and custom protocol.   [![It hasn't been updated in recent three years][Y]](https://github.com/xfxdev/xtcp)   [![godoc][D]](https://godoc.org/github.com/xfxdev/xtcp)
- [sslb](https://github.com/eduardonunesp/sslb) **star:148** It's a Super Simples Load Balancer, just a little project to achieve some kind of performance.   [![godoc][D]](https://godoc.org/github.com/eduardonunesp/sslb)
- [iplib](https://github.com/c-robinson/iplib) **star:139** Library for working with IP addresses (net.IP, net.IPNet), inspired by python [ipaddress](https://docs.python.org/3/library/ipaddress.html) and ruby [ipaddr](https://ruby-doc.org/stdlib-2.5.1/libdoc/ipaddr/rdoc/IPAddr.html)   [![godoc][D]](https://godoc.org/github.com/c-robinson/iplib)
- [gldap](https://github.com/jimlambrt/gldap) **star:107** gldap provides an ldap server implementation and you provide handlers for its ldap operations.   [![godoc][D]](https://godoc.org/github.com/jimlambrt/gldap)
- [go-powerdns](https://github.com/joeig/go-powerdns) **star:86** PowerDNS API bindings for Golang.   [![godoc][D]](https://godoc.org/github.com/joeig/go-powerdns)
- [natiu-mqtt](https://github.com/soypat/natiu-mqtt) **star:83** A dead-simple, non-allocating, low level implementation of MQTT well suited for embedded systems.   [![godoc][D]](https://godoc.org/github.com/soypat/natiu-mqtt)
- [ether](https://github.com/songgao/ether) **star:80** Cross-platform Go package for sending and receiving ethernet frames.   [![It hasn't been updated in recent three years][Y]](https://github.com/songgao/ether)   [![godoc][D]](https://godoc.org/github.com/songgao/ether)
- [packet](https://github.com/aerogo/packet) **star:78** Send packets over TCP and UDP. It can buffer messages and hot-swap connections if needed.   [![It hasn't been updated in recent three years][Y]](https://github.com/aerogo/packet)   [![godoc][D]](https://godoc.org/github.com/aerogo/packet)
- [dhcp6](https://github.com/mdlayher/dhcp6) **star:77** Package dhcp6 implements a DHCPv6 server, as described in RFC 3315.   [![godoc][D]](https://godoc.org/github.com/mdlayher/dhcp6)
- [fullproxy](https://github.com/shoriwe/fullproxy) **star:76** A fully featured scriptable and daemon configurable proxy and pivoting toolkit with SOCKS5, HTTP, raw ports and reverse proxy protocols.   [![godoc][D]](https://godoc.org/github.com/shoriwe/fullproxy)
- [portproxy](https://github.com/aybabtme/portproxy) **star:56** Simple TCP proxy which adds CORS support to API's which don't support it.   [![It hasn't been updated in recent three years][Y]](https://github.com/aybabtme/portproxy)   [![godoc][D]](https://godoc.org/github.com/aybabtme/portproxy)
- [linkio](https://github.com/ian-kent/linkio) **star:53** Network link speed simulation for Reader/Writer interfaces.   [![It hasn't been updated in recent three years][Y]](https://github.com/ian-kent/linkio)   [![godoc][D]](https://godoc.org/github.com/ian-kent/linkio)
- [fwdctl](https://github.com/alegrey91/fwdctl) **star:50** A simple and intuitive CLI to manage IPTables forwards in your Linux server.   [![There was an update last month][G]](https://github.com/alegrey91/fwdctl)   [![godoc][D]](https://godoc.org/github.com/alegrey91/fwdctl)
- [golibwireshark](https://github.com/sunwxg/golibwireshark) **star:29** Package golibwireshark use libwireshark library to decode pcap file and analyse dissection data.   [![It hasn't been updated in recent three years][Y]](https://github.com/sunwxg/golibwireshark)   [![godoc][D]](https://godoc.org/github.com/sunwxg/golibwireshark)
- [graval](https://github.com/koofr/graval) **star:28** Experimental FTP server framework.   [![It hasn't been updated in recent three years][Y]](https://github.com/koofr/graval)   [![godoc][D]](https://godoc.org/github.com/koofr/graval)
- [publicip](https://github.com/polera/publicip) **star:28** Package publicip returns your public facing IPv4 address (internet egress).   [![It hasn't been updated in recent three years][Y]](https://github.com/polera/publicip)   [![godoc][D]](https://godoc.org/github.com/polera/publicip)
- [httpproxy](https://github.com/wzshiming/httpproxy) **star:27** HTTP proxy handler and dialer.   [![godoc][D]](https://godoc.org/github.com/wzshiming/httpproxy)
- [goshark](https://github.com/sunwxg/goshark) **star:19** Package goshark use tshark to decode IP packet and create data struct to analyse packet.   [![It hasn't been updated in recent three years][Y]](https://github.com/sunwxg/goshark)   [![godoc][D]](https://godoc.org/github.com/sunwxg/goshark)
- [gnet](https://github.com/fish-tennis/gnet) **star:15** `gnet` is a high-performance networking framework,especially for game servers.   [![godoc][D]](https://godoc.org/github.com/fish-tennis/gnet)   [![Contains Chinese documents][CN]](https://github.com/fish-tennis/gnet)
- [llb](https://github.com/kirillDanshin/llb) **star:15** It's a very simple but quick backend for proxy servers. Can be useful for fast redirection to predefined domain with zero memory allocation and fast response.   [![It hasn't been updated in recent three years][Y]](https://github.com/kirillDanshin/llb)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/llb)
- [tspool](https://github.com/two/tspool) **star:14** A TCP Library use worker pool to improve performance and protect your server.   [![It hasn't been updated in recent three years][Y]](https://github.com/two/tspool)   [![godoc][D]](https://godoc.org/github.com/two/tspool)
- [go-sse](https://github.com/lampctl/go-sse) **star:10** Go client and server implementation of HTML server-sent events.   [![godoc][D]](https://godoc.org/github.com/lampctl/go-sse)

**[⬆ back to top](#contents)**

### HTTP Clients

_Libraries for making HTTP requests._

- [resty](https://github.com/go-resty/resty) **star:9780** Simple HTTP and REST client for Go inspired by Ruby rest-client.   [![There was an update last month][G]](https://github.com/go-resty/resty)   [![godoc][D]](https://godoc.org/github.com/go-resty/resty)
- [req](https://github.com/imroc/req) **star:4177** Simple Go HTTP client with Black Magic (Less code and More efficiency).   [![godoc][D]](https://godoc.org/github.com/imroc/req)
- [heimdall](https://github.com/gojektech/heimdall) **star:2596** An enhanced http client with retry and hystrix capabilities.   [![godoc][D]](https://godoc.org/github.com/gojektech/heimdall)
- [grequests](https://github.com/levigross/grequests) **star:2120** A Go "clone" of the great and famous Requests library.   [![godoc][D]](https://godoc.org/github.com/levigross/grequests)
- [go-retryablehttp](https://github.com/hashicorp/go-retryablehttp) **star:1935** Retryable HTTP client in Go.   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-retryablehttp)
- [sling](https://github.com/dghubble/sling) **star:1667** Sling is a Go HTTP client library for creating and sending API requests.   [![godoc][D]](https://godoc.org/github.com/dghubble/sling)
- [requests](https://github.com/carlmjohnson/requests) **star:1445** HTTP requests for Gophers. Uses context.Context and doesn't hide the underlying net/http.Client, making it compatible with standard Go APIs. Also includes testing tools.   [![There was an update last month][G]](https://github.com/carlmjohnson/requests)   [![godoc][D]](https://godoc.org/github.com/carlmjohnson/requests)
- [gentleman](https://github.com/h2non/gentleman) **star:1070** Full-featured plugin-driven HTTP client library.   [![godoc][D]](https://godoc.org/github.com/h2non/gentleman)
- [pester](https://github.com/sethgrid/pester) **star:643** Go HTTP client calls with retries, backoff, and concurrency.   [![godoc][D]](https://godoc.org/github.com/sethgrid/pester)
- [go-cleanhttp](https://github.com/hashicorp/go-cleanhttp) **star:364** Get easily stdlib HTTP client, which does not share any state with other clients.   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-cleanhttp)
- [request](https://github.com/monaco-io/request) **star:289** HTTP client for golang. If you have experience about axios or requests, you will love it. No 3rd dependency.   [![godoc][D]](https://godoc.org/github.com/monaco-io/request)
- [go-http-client](https://github.com/bozd4g/go-http-client) **star:76** Make http calls simply and easily.   [![godoc][D]](https://godoc.org/github.com/bozd4g/go-http-client)
- [go-otelroundtripper](https://github.com/NdoleStudio/go-otelroundtripper) **star:76** Go http.RoundTripper that emits open telemetry metrics for HTTP requests.   [![godoc][D]](https://godoc.org/github.com/NdoleStudio/go-otelroundtripper)
- [go-zoox/fetch](https://github.com/go-zoox/fetch) **star:72** A Powerful, Lightweight, Easy Http Client, inspired by Web Fetch API.   [![godoc][D]](https://godoc.org/github.com/go-zoox/fetch)
- [rq](https://github.com/ddo/rq) **star:51** A nicer interface for golang stdlib HTTP client.   [![It hasn't been updated in recent three years][Y]](https://github.com/ddo/rq)   [![godoc][D]](https://godoc.org/github.com/ddo/rq)
- [httpretry](https://github.com/ybbus/httpretry) **star:44** Enriches the default go HTTP client with retry functionality.   [![godoc][D]](https://godoc.org/github.com/ybbus/httpretry)
- [fast-shot](https://github.com/opus-domini/fast-shot) **star:43** Hit your API targets with rapid-fire precision using Go's fastest and simple HTTP Client.   [![godoc][D]](https://godoc.org/github.com/opus-domini/fast-shot)
- [go-req](https://github.com/wenerme/go-req) **star:22** Declarative golang HTTP client.   [![godoc][D]](https://godoc.org/github.com/wenerme/go-req)

**[⬆ back to top](#contents)**

## OpenGL

_Libraries for using OpenGL in Go._

- [glfw](https://github.com/go-gl/glfw) **star:1547** Go bindings for GLFW 3.
- [gl](https://github.com/go-gl/gl) **star:1061** Go bindings for OpenGL (generated via glow).
- [mathgl](https://github.com/go-gl/mathgl) **star:540** Pure Go math package specialized for 3D math, with inspiration from GLM.   [![godoc][D]](https://godoc.org/github.com/go-gl/mathgl)
- [goxjs/gl](https://github.com/goxjs/gl) **star:175** Go cross-platform OpenGL bindings (OS X, Linux, Windows, browsers, iOS, Android).   [![godoc][D]](https://godoc.org/github.com/goxjs/gl)
- [goxjs/glfw](https://github.com/goxjs/glfw) **star:81** Go cross-platform glfw library for creating an OpenGL context and receiving events.   [![godoc][D]](https://godoc.org/github.com/goxjs/glfw)
- [go-glmatrix](https://github.com/technohippy/go-glmatrix) **star:9** Go port of [glMatrix](https://glmatrix.net/) library.   [![It hasn't been updated in recent three years][Y]](https://github.com/technohippy/go-glmatrix)   [![godoc][D]](https://godoc.org/github.com/technohippy/go-glmatrix)

**[⬆ back to top](#contents)**

## ORM

_Libraries that implement Object-Relational Mapping or datamapping techniques._

- [GORM](https://github.com/go-gorm/gorm) **star:36313** The fantastic ORM library for Golang, aims to be developer friendly.   [![There was an update last month][G]](https://github.com/go-gorm/gorm)   [![godoc][D]](https://godoc.org/github.com/go-gorm/gorm)
- [ent](https://github.com/facebook/ent) **star:15291** An entity framework for Go. Simple, yet powerful ORM for modeling and querying data.   [![There was an update last month][G]](https://github.com/facebook/ent)   [![godoc][D]](https://godoc.org/github.com/facebook/ent)
- [SQLBoiler](https://github.com/volatiletech/sqlboiler) **star:6618** ORM generator. Generate a featureful and blazing-fast ORM tailored to your database schema.   [![godoc][D]](https://godoc.org/github.com/volatiletech/sqlboiler)
- [gorp](https://github.com/go-gorp/gorp) **star:3727** Go Relational Persistence, ORM-ish library for Go.   [![godoc][D]](https://godoc.org/github.com/go-gorp/gorp)
- [bun](https://github.com/uptrace/bun) **star:3535** SQL-first Golang ORM. Successor of go-pg.   [![There was an update last month][G]](https://github.com/uptrace/bun)   [![godoc][D]](https://godoc.org/github.com/uptrace/bun)
- [upper.io/db](https://github.com/upper/db) **star:3512** Single interface for interacting with different data sources through the use of adapters that wrap mature database drivers.   [![godoc][D]](https://godoc.org/github.com/upper/db)
- [XORM](https://gitea.com/xorm/xorm)  Simple and powerful ORM for Go. (Support: MySQL, MyMysql, PostgreSQL, Tidb, SQLite3, MsSql and Oracle).
- [gormt](https://github.com/xxjwxc/gormt) **star:2341** Mysql database to golang gorm struct.   [![godoc][D]](https://godoc.org/github.com/xxjwxc/gormt)
- [Prisma](https://github.com/prisma/prisma-client-go) **star:2063** Prisma Client Go, Typesafe database access for Go.   [![There was an update last month][G]](https://github.com/prisma/prisma-client-go)   [![godoc][D]](https://godoc.org/github.com/prisma/prisma-client-go)
- [reform](https://github.com/go-reform/reform) **star:1442** Better ORM for Go, based on non-empty interfaces and code generation.   [![godoc][D]](https://godoc.org/github.com/go-reform/reform)
- [pop/soda](https://github.com/gobuffalo/pop) **star:1425** Database migration, creation, ORM, etc... for MySQL, PostgreSQL, and SQLite.   [![godoc][D]](https://godoc.org/github.com/gobuffalo/pop)
- [go-sqlbuilder](https://github.com/huandu/go-sqlbuilder) **star:1363** A flexible and powerful SQL string builder library plus a zero-config ORM.   [![godoc][D]](https://godoc.org/github.com/huandu/go-sqlbuilder)
- [rel](https://github.com/go-rel/rel) **star:749** Modern Database Access Layer for Golang - Testable, Extendable and Crafted Into a Clean and Elegant API.   [![godoc][D]](https://godoc.org/github.com/go-rel/rel)
- [bob](https://github.com/stephenafamo/bob) **star:725** SQL query builder and ORM/Factory generator for Go. Successor of SQLBoiler.   [![There was an update last month][G]](https://github.com/stephenafamo/bob)   [![godoc][D]](https://godoc.org/github.com/stephenafamo/bob)
- [Zoom](https://github.com/albrow/zoom) **star:307** Blazing-fast datastore and querying engine built on Redis.   [![godoc][D]](https://godoc.org/github.com/albrow/zoom)
- [go-sql](https://github.com/rushteam/gosql) **star:178** A easy ORM for mysql.   [![godoc][D]](https://godoc.org/github.com/rushteam/gosql)
- [grimoire](https://github.com/Fs02/grimoire) **star:163** Grimoire is a database access layer and validation for golang. (Support: MySQL, PostgreSQL and SQLite3).   [![godoc][D]](https://godoc.org/github.com/Fs02/grimoire)
- [golobby/orm](https://github.com/golobby/orm) **star:158** Simple, fast, type-safe, generic orm for developer happiness.   [![godoc][D]](https://godoc.org/github.com/golobby/orm)
- [go-store](https://github.com/gosuri/go-store) **star:112** Simple and fast Redis backed key-value store library for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/gosuri/go-store)   [![godoc][D]](https://godoc.org/github.com/gosuri/go-store)
- [go-firestorm](https://github.com/jschoedt/go-firestorm) **star:51** A simple ORM for Google/Firebase Cloud Firestore.   [![godoc][D]](https://godoc.org/github.com/jschoedt/go-firestorm)
- [cacheme](https://github.com/Yiling-J/cacheme-go) **star:23** Schema based, typed Redis caching/memoize framework for Go.   [![godoc][D]](https://godoc.org/github.com/Yiling-J/cacheme-go)   [![Contains Chinese documents][CN]](https://github.com/Yiling-J/cacheme-go)
- [CQL](https://github.com/FrancoLiberali/cql) **star:16** Built on top of GORM, adds compile-time verified queries based on auto-generated code.   [![godoc][D]](https://godoc.org/github.com/FrancoLiberali/cql)
- [lore](https://github.com/abrahambotros/lore) **star:14** Simple and lightweight pseudo-ORM/pseudo-struct-mapping environment for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/abrahambotros/lore)   [![godoc][D]](https://godoc.org/github.com/abrahambotros/lore)
- [marlow](https://github.com/marlow/marlow) **star:14** Generated ORM from project structs for compile time safety assurances.   [![It hasn't been updated in recent three years][Y]](https://github.com/marlow/marlow)   [![godoc][D]](https://godoc.org/github.com/marlow/marlow)
- [go-dbw](https://github.com/hashicorp/go-dbw) **star:13** A simple package that encapsulates database operations.   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-dbw)

**[⬆ back to top](#contents)**

## Package Management

_Official tooling for dependency and package management_

- [go modules](https://golang.org/cmd/go/#hdr-Modules__module_versions__and_more)  Modules are the unit of source code interchange and versioning. The go command has direct support for working with modules, including recording and resolving dependencies on other modules.

_Official experimental tooling for package management_

- [dep](https://github.com/golang/dep) **star:12862** Go dependency tool.   [![It hasn't been updated in recent three years][Y]](https://github.com/golang/dep)   [![godoc][D]](https://godoc.org/github.com/golang/dep)   [![Archived][Archived]](https://github.com/golang/dep)
- [vgo](https://go.googlesource.com/vgo/)  Versioned Go.

_Unofficial libraries for package and dependency management._

- [glide](https://github.com/Masterminds/glide) **star:8155** Manage your golang vendor and vendored packages with ease. Inspired by tools like Maven, Bundler, and Pip.   [![godoc][D]](https://godoc.org/github.com/Masterminds/glide)
- [godep](https://github.com/tools/godep) **star:5547** dependency tool for go, godep helps build packages reproducibly by fixing their dependencies.   [![It hasn't been updated in recent three years][Y]](https://github.com/tools/godep)   [![godoc][D]](https://godoc.org/github.com/tools/godep)   [![Archived][Archived]](https://github.com/tools/godep)
- [govendor](https://github.com/kardianos/govendor) **star:4936** Go Package Manager. Go vendor tool that works with the standard vendor file.   [![It hasn't been updated in recent three years][Y]](https://github.com/kardianos/govendor)   [![godoc][D]](https://godoc.org/github.com/kardianos/govendor)   [![Archived][Archived]](https://github.com/kardianos/govendor)
- [gopm](https://github.com/gpmgo/gopm) **star:2470** Go Package Manager.   [![It hasn't been updated in recent three years][Y]](https://github.com/gpmgo/gopm)   [![godoc][D]](https://godoc.org/github.com/gpmgo/gopm)   [![Archived][Archived]](https://github.com/gpmgo/gopm)
- [gom](https://github.com/mattn/gom) **star:1383** Go Manager - bundle for go.   [![It hasn't been updated in recent three years][Y]](https://github.com/mattn/gom)   [![godoc][D]](https://godoc.org/github.com/mattn/gom)   [![Archived][Archived]](https://github.com/mattn/gom)
- [gpm](https://github.com/pote/gpm) **star:1190** Barebones dependency manager for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/pote/gpm)
- [goop](https://github.com/nitrous-io/goop) **star:780** Simple dependency manager for Go (golang), inspired by Bundler.   [![It hasn't been updated in recent three years][Y]](https://github.com/nitrous-io/goop)   [![godoc][D]](https://godoc.org/github.com/nitrous-io/goop)
- [modgv](https://github.com/lucasepe/modgv) **star:484** Converts 'go mod graph' output into Graphviz's DOT language.   [![godoc][D]](https://godoc.org/github.com/lucasepe/modgv)
- [gup](https://github.com/nao1215/gup) **star:305** Update binaries installed by "go install".   [![There was an update last month][G]](https://github.com/nao1215/gup)   [![godoc][D]](https://godoc.org/github.com/nao1215/gup)
- [nut](https://github.com/jingweno/nut) **star:232** Vendor Go dependencies.   [![It hasn't been updated in recent three years][Y]](https://github.com/jingweno/nut)   [![godoc][D]](https://godoc.org/github.com/jingweno/nut)
- [johnny-deps](https://github.com/VividCortex/johnny-deps) **star:214** Minimal dependency version using Git.   [![It hasn't been updated in recent three years][Y]](https://github.com/VividCortex/johnny-deps)   [![Archived][Archived]](https://github.com/VividCortex/johnny-deps)
- [mvn-golang](https://github.com/raydac/mvn-golang) **star:161** plugin that provides way for auto-loading of Golang SDK, dependency management and start build environment in Maven project infrastructure.
- [VenGO](https://github.com/DamnWidget/VenGO) **star:124** create and manage exportable isolated go virtual environments.   [![It hasn't been updated in recent three years][Y]](https://github.com/DamnWidget/VenGO)   [![godoc][D]](https://godoc.org/github.com/DamnWidget/VenGO)
- [gop](https://github.com/lunny/gop) **star:49** Build and manage your Go applications out of GOPATH.   [![It hasn't been updated in recent three years][Y]](https://github.com/lunny/gop)   [![godoc][D]](https://godoc.org/github.com/lunny/gop)   [![Contains Chinese documents][CN]](https://github.com/lunny/gop)   [![Archived][Archived]](https://github.com/lunny/gop)

**[⬆ back to top](#contents)**

## Performance

- [jaeger](https://github.com/jaegertracing/jaeger) **star:20012** A distributed tracing system.   [![There was an update last month][G]](https://github.com/jaegertracing/jaeger)   [![godoc][D]](https://godoc.org/github.com/jaegertracing/jaeger)
- [pixie](https://github.com/pixie-labs/pixie) **star:5439** No instrumentation tracing for Golang applications via eBPF.   [![There was an update last month][G]](https://github.com/pixie-labs/pixie)
- [statsviz](https://github.com/arl/statsviz) **star:3175** Live visualization of your Go application runtime statistics.   [![godoc][D]](https://godoc.org/github.com/arl/statsviz)
- [profile](https://github.com/pkg/profile) **star:1984** Simple profiling support package for Go.   [![godoc][D]](https://godoc.org/github.com/pkg/profile)
- [go-instrument](https://github.com/nikolaydubina/go-instrument) **star:166** Automatically add spans to all methods and functions.   [![There was an update last month][G]](https://github.com/nikolaydubina/go-instrument)   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/go-instrument)
- [tracer](https://github.com/kamilsk/tracer) **star:85** Simple, lightweight tracing.   [![It hasn't been updated in recent three years][Y]](https://github.com/kamilsk/tracer)   [![godoc][D]](https://godoc.org/github.com/kamilsk/tracer)

**[⬆ back to top](#contents)**

## Query Language

- [graphql-go](https://github.com/graphql-go/graphql) **star:9841** Implementation of GraphQL for Go.   [![godoc][D]](https://godoc.org/github.com/graphql-go/graphql)
- [gqlgen](https://github.com/99designs/gqlgen) **star:9827** go generate based graphql server library.   [![There was an update last month][G]](https://github.com/99designs/gqlgen)   [![godoc][D]](https://godoc.org/github.com/99designs/gqlgen)
- [dasel](https://github.com/tomwright/dasel) **star:5044** Query and update data structures using selectors from the command line. Comparable to jq/yq but supports JSON, YAML, TOML and XML with zero runtime dependencies.   [![godoc][D]](https://godoc.org/github.com/tomwright/dasel)
- [graphql](https://github.com/neelance/graphql-go) **star:4631** GraphQL server with a focus on ease of use.   [![godoc][D]](https://godoc.org/github.com/neelance/graphql-go)
- [gojsonq](https://github.com/thedevsaddam/gojsonq) **star:2174** A simple Go package to Query over JSON Data.   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/gojsonq)
- [rql](https://github.com/a8m/rql) **star:337** Resource Query Language for REST API.   [![godoc][D]](https://godoc.org/github.com/a8m/rql)
- [jsonql](https://github.com/elgs/jsonql) **star:274** JSON query expression library in Golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/elgs/jsonql)   [![godoc][D]](https://godoc.org/github.com/elgs/jsonql)
- [jsonslice](https://github.com/bhmj/jsonslice) **star:85** Jsonpath queries with advanced filters.   [![There was an update last month][G]](https://github.com/bhmj/jsonslice)   [![godoc][D]](https://godoc.org/github.com/bhmj/jsonslice)
- [rqp](https://github.com/timsolov/rest-query-parser) **star:73** Query Parser for REST API. Filtering, validations, both `AND`, `OR` operations are supported directly in the query.   [![godoc][D]](https://godoc.org/github.com/timsolov/rest-query-parser)
- [goven](https://github.com/SeldonIO/goven) **star:59** A drop-in query language for any database schema.   [![godoc][D]](https://godoc.org/github.com/SeldonIO/goven)
- [graphql](https://github.com/tmc/graphql) **star:57** graphql parser + utilities.   [![It hasn't been updated in recent three years][Y]](https://github.com/tmc/graphql)   [![godoc][D]](https://godoc.org/github.com/tmc/graphql)   [![Archived][Archived]](https://github.com/tmc/graphql)
- [api-fu](https://github.com/ccbrown/api-fu) **star:55** Comprehensive GraphQL implementation.   [![There was an update last month][G]](https://github.com/ccbrown/api-fu)   [![godoc][D]](https://godoc.org/github.com/ccbrown/api-fu)
- [mql](https://github.com/hashicorp/mql) **star:41** Model Query Language (mql) is a query language for your database models.   [![godoc][D]](https://godoc.org/github.com/hashicorp/mql)
- [straf](https://github.com/SonicRoshan/straf) **star:38** Easily Convert Golang structs to GraphQL objects.   [![It hasn't been updated in recent three years][Y]](https://github.com/SonicRoshan/straf)   [![godoc][D]](https://godoc.org/github.com/SonicRoshan/straf)
- [jsonpath](https://github.com/AsaiYusuke/jsonpath) **star:25** A query library for retrieving part of JSON based on JSONPath syntax.   [![godoc][D]](https://godoc.org/github.com/AsaiYusuke/jsonpath)
- [gws](https://github.com/Zaba505/gws) **star:7** Apollos' "GraphQL over Websocket" client and server implementation.   [![It hasn't been updated in recent three years][Y]](https://github.com/Zaba505/gws)   [![godoc][D]](https://godoc.org/github.com/Zaba505/gws)
- [grapher](https://github.com/reaganiwadha/grapher) **star:3** A GraphQL field builder utilizing Go generics with extra utilities and features.   [![godoc][D]](https://godoc.org/github.com/reaganiwadha/grapher)

**[⬆ back to top](#contents)**

## Resource Embedding

- [statik](https://github.com/rakyll/statik) **star:3751** Embeds static files into a Go executable.   [![godoc][D]](https://godoc.org/github.com/rakyll/statik)
- [packr](https://github.com/gobuffalo/packr) **star:3411** The simple and easy way to embed static files into Go binaries.   [![godoc][D]](https://godoc.org/github.com/gobuffalo/packr)   [![Archived][Archived]](https://github.com/gobuffalo/packr)
- [go.rice](https://github.com/GeertJohan/go.rice) **star:2410** go.rice is a Go package that makes working with resources such as HTML, JS, CSS, images, and templates very easy.   [![godoc][D]](https://godoc.org/github.com/GeertJohan/go.rice)
- [vfsgen](https://github.com/shurcooL/vfsgen) **star:982** Generates a vfsdata.go file that statically implements the given virtual filesystem.   [![godoc][D]](https://godoc.org/github.com/shurcooL/vfsgen)
- [esc](https://github.com/mjibson/esc) **star:639** Embeds files into Go programs and provides http.FileSystem interfaces to them.   [![godoc][D]](https://godoc.org/github.com/mjibson/esc)   [![Archived][Archived]](https://github.com/mjibson/esc)
- [fileb0x](https://github.com/UnnoTed/fileb0x) **star:634** Simple tool to embed files in go with focus on "customization" and ease to use.   [![godoc][D]](https://godoc.org/github.com/UnnoTed/fileb0x)
- [go-resources](https://github.com/omeid/go-resources) **star:176** Unfancy resources embedding with Go.   [![godoc][D]](https://godoc.org/github.com/omeid/go-resources)
- [statics](https://github.com/go-playground/statics) **star:68** Embeds static resources into go files for single binary compilation + works with http.FileSystem + symlinks.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-playground/statics)   [![godoc][D]](https://godoc.org/github.com/go-playground/statics)
- [debme](https://github.com/leaanthony/debme) **star:31** Create an `embed.FS` from an existing `embed.FS` subdirectory.   [![It hasn't been updated in recent three years][Y]](https://github.com/leaanthony/debme)   [![godoc][D]](https://godoc.org/github.com/leaanthony/debme)
- [templify](https://github.com/wlbr/templify) **star:30** Embed external template files into Go code to create single file binaries.   [![It hasn't been updated in recent three years][Y]](https://github.com/wlbr/templify)   [![godoc][D]](https://godoc.org/github.com/wlbr/templify)
- [rebed](https://github.com/soypat/rebed) **star:29** Recreate folder structures and files from Go 1.16's `embed.FS` type   [![godoc][D]](https://godoc.org/github.com/soypat/rebed)
- [mule](https://github.com/wlbr/mule) **star:15** Embed external resources like images, movies ... into Go source code to create single file binaries using `go generate`. Focused on simplicity.   [![It hasn't been updated in recent three years][Y]](https://github.com/wlbr/mule)   [![godoc][D]](https://godoc.org/github.com/wlbr/mule)

**[⬆ back to top](#contents)**

## Science and Data Analysis

_Libraries for scientific computing and data analyzing._

- [gonum](https://github.com/gonum/gonum) **star:7463** Gonum is a set of numeric libraries for the Go programming language. It contains libraries for matrices, statistics, optimization, and more.   [![godoc][D]](https://godoc.org/github.com/gonum/gonum)
- [stats](https://github.com/montanaflynn/stats) **star:2910** Statistics package with common functions missing from the Golang standard library.   [![godoc][D]](https://godoc.org/github.com/montanaflynn/stats)
- [gonum/plot](https://github.com/gonum/plot) **star:2695** gonum/plot provides an API for building and drawing plots in Go.   [![godoc][D]](https://godoc.org/github.com/gonum/plot)
- [gosl](https://github.com/cpmech/gosl) **star:1826** Go scientific library for linear algebra, FFT, geometry, NURBS, numerical methods, probabilities, optimisation, differential equations, and more.   [![godoc][D]](https://godoc.org/github.com/cpmech/gosl)
- [streamtools](https://github.com/nytlabs/streamtools) **star:1311** general purpose, graphical tool for dealing with streams of data.   [![godoc][D]](https://godoc.org/github.com/nytlabs/streamtools)
- [dataframe-go](https://github.com/rocketlaunchr/dataframe-go) **star:1156** Dataframes for machine-learning and statistics (similar to pandas).   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/dataframe-go)
- [orb](https://github.com/paulmach/orb) **star:877** 2D geometry types with clipping, GeoJSON and Mapbox Vector Tile support.   [![There was an update last month][G]](https://github.com/paulmach/orb)   [![godoc][D]](https://godoc.org/github.com/paulmach/orb)
- [go-dsp](https://github.com/mjibson/go-dsp) **star:851** Digital Signal Processing for Go.   [![godoc][D]](https://godoc.org/github.com/mjibson/go-dsp)
- [chart](https://github.com/vdobler/chart) **star:772** Simple Chart Plotting library for Go. Supports many graphs types.   [![It hasn't been updated in recent three years][Y]](https://github.com/vdobler/chart)   [![godoc][D]](https://godoc.org/github.com/vdobler/chart)
- [goraph](https://github.com/gyuho/goraph) **star:734** Pure Go graph theory library(data structure, algorithm visualization).   [![godoc][D]](https://godoc.org/github.com/gyuho/goraph)
- [graph](https://github.com/yourbasic/graph) **star:698** Library of basic graph algorithms.   [![godoc][D]](https://godoc.org/github.com/yourbasic/graph)
- [ewma](https://github.com/VividCortex/ewma) **star:432** Exponentially-weighted moving averages.   [![godoc][D]](https://godoc.org/github.com/VividCortex/ewma)
- [calendarheatmap](https://github.com/nikolaydubina/calendarheatmap) **star:394** Calendar heatmap in plain Go inspired by Github contribution activity.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/calendarheatmap)
- [TextRank](https://github.com/DavidBelicza/TextRank) **star:202** TextRank implementation in Golang with extendable features (summarization, weighting, phrase extraction) and multithreading (goroutine) support.   [![It hasn't been updated in recent three years][Y]](https://github.com/DavidBelicza/TextRank)   [![godoc][D]](https://godoc.org/github.com/DavidBelicza/TextRank)
- [gohistogram](https://github.com/VividCortex/gohistogram) **star:174** Approximate histograms for data streams.   [![It hasn't been updated in recent three years][Y]](https://github.com/VividCortex/gohistogram)   [![godoc][D]](https://godoc.org/github.com/VividCortex/gohistogram)   [![Archived][Archived]](https://github.com/VividCortex/gohistogram)
- [sparse](https://github.com/james-bowman/sparse) **star:157** Go Sparse matrix formats for linear algebra supporting scientific and machine learning applications, compatible with gonum matrix libraries.   [![It hasn't been updated in recent three years][Y]](https://github.com/james-bowman/sparse)   [![godoc][D]](https://godoc.org/github.com/james-bowman/sparse)
- [go-estimate](https://github.com/milosgajdos/go-estimate) **star:112** State estimation and filtering algorithms in Go.   [![godoc][D]](https://godoc.org/github.com/milosgajdos/go-estimate)
- [pagerank](https://github.com/alixaxel/pagerank) **star:83** Weighted PageRank algorithm implemented in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/alixaxel/pagerank)   [![godoc][D]](https://godoc.org/github.com/alixaxel/pagerank)
- [jsonl-graph](https://github.com/nikolaydubina/jsonl-graph) **star:72** Tool to manipulate JSONL graphs with graphviz support.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/jsonl-graph)
- [gograph](https://github.com/hmdsefi/gograph) **star:58** A golang generic graph library that provides mathematical graph-theory and algorithms.   [![godoc][D]](https://godoc.org/github.com/hmdsefi/gograph)
- [geom](https://github.com/skelterjohn/geom) **star:55** 2D geometry for golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/skelterjohn/geom)   [![godoc][D]](https://godoc.org/github.com/skelterjohn/geom)
- [evaler](https://github.com/soniah/evaler) **star:52** Simple floating point arithmetic expression evaluator.   [![It hasn't been updated in recent three years][Y]](https://github.com/soniah/evaler)   [![godoc][D]](https://godoc.org/github.com/soniah/evaler)
- [decimal](https://github.com/db47h/decimal) **star:40** Package decimal implements arbitrary-precision decimal floating-point arithmetic.   [![godoc][D]](https://godoc.org/github.com/db47h/decimal)
- [triangolatte](https://github.com/tchayen/triangolatte) **star:36** 2D triangulation library. Allows translating lines and polygons (both based on points) to the language of GPUs.   [![It hasn't been updated in recent three years][Y]](https://github.com/tchayen/triangolatte)   [![godoc][D]](https://godoc.org/github.com/tchayen/triangolatte)
- [goent](https://github.com/kzahedi/goent) **star:34** GO Implementation of Entropy Measures.   [![It hasn't been updated in recent three years][Y]](https://github.com/kzahedi/goent)   [![godoc][D]](https://godoc.org/github.com/kzahedi/goent)
- [piecewiselinear](https://github.com/sgreben/piecewiselinear) **star:26** Tiny linear interpolation library.   [![godoc][D]](https://godoc.org/github.com/sgreben/piecewiselinear)
- [godesim](https://github.com/soypat/godesim) **star:23** Extended/multivariable ODE solver framework for event-based simulations with simple API.   [![godoc][D]](https://godoc.org/github.com/soypat/godesim)
- [ode](https://github.com/ChristopherRabotin/ode) **star:22** Ordinary differential equation (ODE) solver which supports extended states and channel-based iteration stop conditions.   [![It hasn't been updated in recent three years][Y]](https://github.com/ChristopherRabotin/ode)   [![godoc][D]](https://godoc.org/github.com/ChristopherRabotin/ode)
- [GoStats](https://github.com/OGFris/GoStats) **star:20** GoStats is an Open Source GoLang library for math statistics mostly used in Machine Learning domains, it covers most of the Statistical measures functions.   [![It hasn't been updated in recent three years][Y]](https://github.com/OGFris/GoStats)   [![godoc][D]](https://godoc.org/github.com/OGFris/GoStats)
- [PiHex](https://github.com/claygod/PiHex) **star:20** Implementation of the "Bailey-Borwein-Plouffe" algorithm for the hexadecimal number Pi.   [![godoc][D]](https://godoc.org/github.com/claygod/PiHex)
- [assocentity](https://github.com/ndabAP/assocentity) **star:14** Package assocentity returns the average distance from words to a given entity.   [![godoc][D]](https://godoc.org/github.com/ndabAP/assocentity)
- [go-gt](https://github.com/ThePaw/go-gt) **star:11** Graph theory algorithms written in "Go" language.   [![It hasn't been updated in recent three years][Y]](https://github.com/ThePaw/go-gt)   [![godoc][D]](https://godoc.org/github.com/ThePaw/go-gt)
- [rootfinding](https://github.com/khezen/rootfinding) **star:11** root-finding algorithms library for finding roots of quadratic functions.   [![It hasn't been updated in recent three years][Y]](https://github.com/khezen/rootfinding)   [![godoc][D]](https://godoc.org/github.com/khezen/rootfinding)
- [bradleyterry](https://github.com/seanhagen/bradleyterry) **star:10** Provides a Bradley-Terry Model for pairwise comparisons.   [![It hasn't been updated in recent three years][Y]](https://github.com/seanhagen/bradleyterry)   [![godoc][D]](https://godoc.org/github.com/seanhagen/bradleyterry)

**[⬆ back to top](#contents)**

## Security

_Libraries that are used to help make your application more secure._

- [age](https://github.com/FiloSottile/age) **star:16505** A simple, modern and secure encryption tool (and Go library) with small explicit keys, no config options, and UNIX-style composability.   [![godoc][D]](https://godoc.org/github.com/FiloSottile/age)
- [lego](https://github.com/go-acme/lego) **star:7614** Pure Go ACME client library and CLI tool (for use with Let's Encrypt).   [![There was an update last month][G]](https://github.com/go-acme/lego)   [![godoc][D]](https://godoc.org/github.com/go-acme/lego)
- [CertMagic](https://github.com/caddyserver/certmagic) **star:4945** Mature, robust, and powerful ACME client integration for fully-managed TLS certificate issuance and renewal.   [![There was an update last month][G]](https://github.com/caddyserver/certmagic)   [![godoc][D]](https://godoc.org/github.com/caddyserver/certmagic)
- [Cameradar](https://github.com/Ullaakut/cameradar) **star:3998** Tool and library to remotely hack RTSP streams from surveillance cameras.   [![godoc][D]](https://godoc.org/github.com/Ullaakut/cameradar)
- [memguard](https://github.com/awnumar/memguard) **star:2528** A pure Go library for handling sensitive values in memory.   [![godoc][D]](https://godoc.org/github.com/awnumar/memguard)
- [secure](https://github.com/unrolled/secure) **star:2248** HTTP middleware for Go that facilitates some quick security wins.   [![godoc][D]](https://godoc.org/github.com/unrolled/secure)
- [Coraza](https://github.com/corazawaf/coraza) **star:2058** Enterprise-ready, modsecurity and OWASP CRS compatible WAF library.   [![There was an update last month][G]](https://github.com/corazawaf/coraza)   [![godoc][D]](https://godoc.org/github.com/corazawaf/coraza)
- [acmetool](https://github.com/hlandau/acme) **star:2042** ACME (Let's Encrypt) client tool with automatic renewal.   [![godoc][D]](https://godoc.org/github.com/hlandau/acme)
- [acopw-go](https://sr.ht/~jamesponddotco/acopw-go/)  Small cryptographically secure password generator package for Go.
- [themis](https://github.com/cossacklabs/themis) **star:1838** high-level cryptographic library for solving typical data security tasks (secure data storage, secure messaging, zero-knowledge proof authentication), available for 14 languages, best fit for multi-platform apps.
- [acra](https://github.com/cossacklabs/acra) **star:1331** Network encryption proxy to protect database-based applications from data leaks: strong selective encryption, SQL injections prevention, intrusion detection system.   [![godoc][D]](https://godoc.org/github.com/cossacklabs/acra)
- [dongle](https://github.com/golang-module/dongle) **star:871** A simple, semantic and developer-friendly golang package for encoding&decoding and encryption&decryption.   [![godoc][D]](https://godoc.org/github.com/golang-module/dongle)   [![Contains Chinese documents][CN]](https://github.com/golang-module/dongle)
- [beelzebub](https://github.com/mariocandela/beelzebub) **star:635** A secure low code honeypot framework, leveraging AI for System Virtualization.   [![There was an update last month][G]](https://github.com/mariocandela/beelzebub)   [![godoc][D]](https://godoc.org/github.com/mariocandela/beelzebub)
- [nacl](https://github.com/kevinburke/nacl) **star:545** Go implementation of the NaCL set of API's.   [![godoc][D]](https://godoc.org/github.com/kevinburke/nacl)
- [go-password-validator](https://github.com/lane-c-wagner/go-password-validator) **star:490** Password validator based on raw cryptographic entropy values.   [![godoc][D]](https://godoc.org/github.com/lane-c-wagner/go-password-validator)
- [booster](https://github.com/anatol/booster) **star:487** Fast initramfs generator with full-disk encryption support.   [![godoc][D]](https://godoc.org/github.com/anatol/booster)
- [ssh-vault](https://github.com/ssh-vault/ssh-vault) **star:436** encrypt/decrypt using ssh keys.
- [optimus-go](https://github.com/pjebs/optimus-go) **star:360** ID hashing and Obfuscation using Knuth's Algorithm.   [![It hasn't been updated in recent three years][Y]](https://github.com/pjebs/optimus-go)   [![godoc][D]](https://godoc.org/github.com/pjebs/optimus-go)
- [go-yara](https://github.com/hillu/go-yara) **star:354** Go Bindings for [YARA](https://github.com/plusvic/yara), the "pattern matching swiss knife for malware researchers (and everyone else)".   [![godoc][D]](https://godoc.org/github.com/hillu/go-yara)
- [firewalld-rest](https://github.com/prashantgupta24/firewalld-rest) **star:338** A rest application to dynamically update firewalld rules on a linux server.   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/firewalld-rest)
- [teler-waf](https://github.com/kitabisa/teler-waf) **star:326** teler-waf is a Go HTTP middleware that provide teler IDS functionality to protect against web-based attacks and improve the security of Go-based web applications. It is highly configurable and easy to integrate into existing Go applications.   [![There was an update last month][G]](https://github.com/kitabisa/teler-waf)   [![godoc][D]](https://godoc.org/github.com/kitabisa/teler-waf)
- [BadActor](https://github.com/jaredfolkins/badactor) **star:322** In-memory, application-driven jailer built in the spirit of fail2ban.   [![It hasn't been updated in recent three years][Y]](https://github.com/jaredfolkins/badactor)   [![godoc][D]](https://godoc.org/github.com/jaredfolkins/badactor)
- [passlib](https://github.com/hlandau/passlib) **star:289** Futureproof password hashing library.   [![It hasn't been updated in recent three years][Y]](https://github.com/hlandau/passlib)   [![godoc][D]](https://godoc.org/github.com/hlandau/passlib)
- [go-peer](https://github.com/number571/go-peer) **star:237** A software library for creating secure and anonymous decentralized systems.   [![There was an update last month][G]](https://github.com/number571/go-peer)   [![godoc][D]](https://godoc.org/github.com/number571/go-peer)
- [simple-scrypt](https://github.com/elithrar/simple-scrypt) **star:196** Scrypt package with a simple, obvious API and automatic cost calibration built-in.   [![It hasn't been updated in recent three years][Y]](https://github.com/elithrar/simple-scrypt)   [![godoc][D]](https://godoc.org/github.com/elithrar/simple-scrypt)
- [argon2pw](https://github.com/raja/argon2pw) **star:89** Argon2 password hash generation with constant-time password comparison.   [![godoc][D]](https://godoc.org/github.com/raja/argon2pw)
- [autocert](https://pkg.go.dev/golang.org/x/crypto/acme/autocert)  Auto provision Let's Encrypt certificates and start a TLS server.
- [goSecretBoxPassword](https://github.com/dwin/goSecretBoxPassword) **star:59** A probably paranoid package for securely hashing and encrypting passwords.   [![godoc][D]](https://godoc.org/github.com/dwin/goSecretBoxPassword)
- [go-generate-password](https://github.com/m1/go-generate-password) **star:52** Password generator that can be used on the cli or as a library.   [![godoc][D]](https://godoc.org/github.com/m1/go-generate-password)
- [certificates](https://github.com/mvmaasakkers/certificates) **star:38** An opinionated tool for generating tls certificates.   [![godoc][D]](https://godoc.org/github.com/mvmaasakkers/certificates)
- [go-htpasswd](https://github.com/tg123/go-htpasswd) **star:37** Apache htpasswd Parser for Go.   [![godoc][D]](https://godoc.org/github.com/tg123/go-htpasswd)
- [passwap](https://github.com/zitadel/passwap) **star:37** Provides a unified implementation between different password hashing algorithms   [![There was an update last month][G]](https://github.com/zitadel/passwap)   [![godoc][D]](https://godoc.org/github.com/zitadel/passwap)
- [secureio](https://github.com/xaionaro-go/secureio) **star:33** An keyexchanging+authenticating+encrypting wrapper and multiplexer for `io.ReadWriteCloser` based on XChaCha20-poly1305, ECDH and ED25519.   [![It hasn't been updated in recent three years][Y]](https://github.com/xaionaro-go/secureio)   [![godoc][D]](https://godoc.org/github.com/xaionaro-go/secureio)
- [secret](https://github.com/rsjethani/secret) **star:28** Prevent your secrets from leaking into logs, std\* etc.   [![godoc][D]](https://godoc.org/github.com/rsjethani/secret)
- [sslmgr](https://github.com/adrianosela/sslmgr) **star:26** SSL certificates made easy with a high level wrapper around acme/autocert.   [![There was an update last month][G]](https://github.com/adrianosela/sslmgr)   [![godoc][D]](https://godoc.org/github.com/adrianosela/sslmgr)
- [argon2-hashing](https://github.com/andskur/argon2-hashing) **star:20** light wrapper around Go's argon2 package that closely mirrors with Go's standard library Bcrypt and simple-scrypt package.   [![godoc][D]](https://godoc.org/github.com/andskur/argon2-hashing)
- [goArgonPass](https://github.com/dwin/goArgonPass) **star:18** Argon2 password hash and verification designed to be compatible with existing Python and PHP implementations.   [![It hasn't been updated in recent three years][Y]](https://github.com/dwin/goArgonPass)   [![godoc][D]](https://godoc.org/github.com/dwin/goArgonPass)
- [multikey](https://github.com/adrianosela/multikey) **star:5** An n-out-of-N keys encryption/decryption framework based on Shamir's Secret Sharing algorithm.   [![godoc][D]](https://godoc.org/github.com/adrianosela/multikey)
- [Interpol](https://github.com/avahidi/interpol) **star:4** Rule-based data generator for fuzzing and penetration testing.   [![godoc][D]](https://godoc.org/github.com/avahidi/interpol)
- [encid](https://github.com/bobg/encid) **star:2** Encode and decode encrypted integer IDs.   [![godoc][D]](https://godoc.org/github.com/bobg/encid)

**[⬆ back to top](#contents)**

## Serialization

_Libraries and tools for binary serialization._

- [jsoniter](https://github.com/json-iterator/go) **star:13298** High-performance 100% compatible drop-in replacement of "encoding/json".   [![godoc][D]](https://godoc.org/github.com/json-iterator/go)
- [goprotobuf](https://github.com/golang/protobuf) **star:9681** Go support, in the form of a library and protocol compiler plugin, for Google's protocol buffers.   [![There was an update last month][G]](https://github.com/golang/protobuf)   [![godoc][D]](https://godoc.org/github.com/golang/protobuf)
- [mapstructure](https://github.com/mitchellh/mapstructure) **star:7873** Go library for decoding generic map values into native Go structures.   [![godoc][D]](https://godoc.org/github.com/mitchellh/mapstructure)   [![Archived][Archived]](https://github.com/mitchellh/mapstructure)
- [gogoprotobuf](https://github.com/gogo/protobuf) **star:5654** Protocol Buffers for Go with Gadgets.   [![godoc][D]](https://godoc.org/github.com/gogo/protobuf)
- [go-codec](https://github.com/ugorji/go) **star:1835** High Performance, feature-Rich, idiomatic encode, decode and rpc library for msgpack, cbor and json, with runtime-based OR code-generation support.   [![godoc][D]](https://godoc.org/github.com/ugorji/go)
- [csvutil](https://github.com/jszwec/csvutil) **star:913** High Performance, idiomatic CSV record encoding and decoding to native Go structures.   [![godoc][D]](https://godoc.org/github.com/jszwec/csvutil)
- [colfer](https://github.com/pascaldekloe/colfer) **star:740** Code generation for the Colfer binary format.   [![There was an update last month][G]](https://github.com/pascaldekloe/colfer)
- [cbor](https://github.com/fxamacker/cbor) **star:696** Small, safe, and easy CBOR encoding and decoding library.   [![There was an update last month][G]](https://github.com/fxamacker/cbor)   [![godoc][D]](https://godoc.org/github.com/fxamacker/cbor)
- [go-capnproto](https://github.com/glycerine/go-capnproto) **star:288** Cap'n Proto library and parser for go.   [![It hasn't been updated in recent three years][Y]](https://github.com/glycerine/go-capnproto)   [![godoc][D]](https://godoc.org/github.com/glycerine/go-capnproto)
- [php_session_decoder](https://github.com/yvasiyarov/php_session_decoder) **star:162** GoLang library for working with PHP session format and PHP Serialize/Unserialize functions.   [![It hasn't been updated in recent three years][Y]](https://github.com/yvasiyarov/php_session_decoder)   [![godoc][D]](https://godoc.org/github.com/yvasiyarov/php_session_decoder)
- [structomap](https://github.com/tuvistavie/structomap) **star:144** Library to easily and dynamically generate maps from static structures.   [![It hasn't been updated in recent three years][Y]](https://github.com/tuvistavie/structomap)   [![godoc][D]](https://godoc.org/github.com/tuvistavie/structomap)
- [binstruct](https://github.com/ghostiam/binstruct) **star:93** Golang binary decoder for mapping data into the structure.   [![godoc][D]](https://godoc.org/github.com/ghostiam/binstruct)
- [bambam](https://github.com/glycerine/bambam) **star:65** generator for Cap'n Proto schemas from go.   [![It hasn't been updated in recent three years][Y]](https://github.com/glycerine/bambam)   [![godoc][D]](https://godoc.org/github.com/glycerine/bambam)
- [asn1](https://github.com/PromonLogicalis/asn1) **star:54** Asn.1 BER and DER encoding library for golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/PromonLogicalis/asn1)   [![godoc][D]](https://godoc.org/github.com/PromonLogicalis/asn1)   [![Archived][Archived]](https://github.com/PromonLogicalis/asn1)
- [bel](https://github.com/32leaves/bel) **star:38** Generate TypeScript interfaces from Go structs/interfaces. Useful for JSON RPC.   [![godoc][D]](https://godoc.org/github.com/32leaves/bel)
- [fwencoder](https://github.com/o1egl/fwencoder) **star:27** Fixed width file parser (encoding and decoding library) for Go.   [![godoc][D]](https://godoc.org/github.com/o1egl/fwencoder)
- [elastic](https://github.com/epiclabs-io/elastic) **star:24** Convert slices, maps or any other unknown value across different types at run-time, no matter what.   [![It hasn't been updated in recent three years][Y]](https://github.com/epiclabs-io/elastic)   [![godoc][D]](https://godoc.org/github.com/epiclabs-io/elastic)
- [pletter](https://github.com/vimeda/pletter) **star:19** A standard way to wrap a proto message for message brokers.   [![godoc][D]](https://godoc.org/github.com/vimeda/pletter)
- [gotiny](https://github.com/raszia/gotiny) **star:17** Efficient Go serialization library, gotiny is almost as fast as serialization libraries that generate code.   [![godoc][D]](https://godoc.org/github.com/raszia/gotiny)
- [go-csvlib](https://github.com/tiendc/go-csvlib) **star:12** High level and rich functionalities CSV serialization/deserialization library.   [![godoc][D]](https://godoc.org/github.com/tiendc/go-csvlib)
- [fixedwidth](https://github.com/huydang284/fixedwidth) **star:9** Fixed-width text formatting (UTF-8 supported).   [![It hasn't been updated in recent three years][Y]](https://github.com/huydang284/fixedwidth)   [![godoc][D]](https://godoc.org/github.com/huydang284/fixedwidth)
- [unitpacking](https://github.com/recolude/unitpacking) **star:6** Library to pack unit vectors into as fewest bytes as possible.   [![godoc][D]](https://godoc.org/github.com/recolude/unitpacking)
- [go-lctree](https://github.com/sbourlon/go-lctree) **star:4** Provides a CLI and primitives to serialize and deserialize [LeetCode binary trees](https://support.leetcode.com/hc/en-us/articles/360011883654-What-does-1-null-2-3-mean-in-binary-tree-representation).   [![It hasn't been updated in recent three years][Y]](https://github.com/sbourlon/go-lctree)   [![godoc][D]](https://godoc.org/github.com/sbourlon/go-lctree)

**[⬆ back to top](#contents)**

## Server Applications

- [Caddy](https://github.com/caddyserver/caddy) **star:56160** Caddy is an alternative, HTTP/2 web server that's easy to configure and use.   [![There was an update last month][G]](https://github.com/caddyserver/caddy)   [![godoc][D]](https://godoc.org/github.com/caddyserver/caddy)
- [consul](https://www.consul.io/)  Consul is a tool for service discovery, monitoring and configuration.
- [etcd](https://github.com/etcd-io/etcd) **star:47043** Highly-available key value store for shared configuration and service discovery.   [![There was an update last month][G]](https://github.com/etcd-io/etcd)   [![godoc][D]](https://godoc.org/github.com/etcd-io/etcd)
- [minio](https://github.com/minio/minio) **star:46003** Minio is a distributed object storage server.   [![There was an update last month][G]](https://github.com/minio/minio)   [![godoc][D]](https://godoc.org/github.com/minio/minio)
- [pocketbase](https://github.com/pocketbase/pocketbase) **star:37871** PocketBase is a realtime backend in 1 file consisting of embedded database (SQLite) with realtime subscriptions, built-in auth management and much more.   [![godoc][D]](https://godoc.org/github.com/pocketbase/pocketbase)
- [SFTPGo](https://github.com/drakkan/sftpgo) **star:8737** Fully featured and highly configurable SFTP server with optional FTP/S and WebDAV support. It can serve local filesystem and Cloud Storage backends such as S3 and Google Cloud Storage.   [![There was an update last month][G]](https://github.com/drakkan/sftpgo)   [![godoc][D]](https://godoc.org/github.com/drakkan/sftpgo)
- [RoadRunner](https://github.com/spiral/roadrunner) **star:7800** High-performance PHP application server, load-balancer and process manager.   [![godoc][D]](https://godoc.org/github.com/spiral/roadrunner)
- [Easegress](https://github.com/megaease/easegress) **star:5748** A cloud native high availability/performance traffic orchestration system with observability and extensibility.   [![godoc][D]](https://godoc.org/github.com/megaease/easegress)
- [flipt](https://github.com/markphelps/flipt) **star:3484** A self contained feature flag solution written in Go and Vue.js   [![There was an update last month][G]](https://github.com/markphelps/flipt)   [![godoc][D]](https://godoc.org/github.com/markphelps/flipt)
- [devd](https://github.com/cortesi/devd) **star:3409** Local webserver for developers.   [![godoc][D]](https://godoc.org/github.com/cortesi/devd)
- [Wish](https://github.com/charmbracelet/wish) **star:3390** Make SSH apps, just like that!   [![There was an update last month][G]](https://github.com/charmbracelet/wish)   [![godoc][D]](https://godoc.org/github.com/charmbracelet/wish)
- [Fider](https://github.com/getfider/fider) **star:2787** Fider is an open platform to collect and organize customer feedback.   [![godoc][D]](https://godoc.org/github.com/getfider/fider)
- [algernon](https://github.com/xyproto/algernon) **star:2718** HTTP/2 web server with built-in support for Lua, Markdown, GCSS and Amber.   [![There was an update last month][G]](https://github.com/xyproto/algernon)   [![godoc][D]](https://godoc.org/github.com/xyproto/algernon)
- [Flagr](https://github.com/checkr/flagr) **star:2400** Flagr is an open-source feature flagging and A/B testing service.   [![There was an update last month][G]](https://github.com/checkr/flagr)   [![godoc][D]](https://godoc.org/github.com/checkr/flagr)
- [Trickster](https://github.com/tricksterproxy/trickster) **star:1974** HTTP reverse proxy cache and time series accelerator.   [![godoc][D]](https://godoc.org/github.com/tricksterproxy/trickster)
- [discovery](https://github.com/Bilibili/discovery) **star:1774** A registry for resilient mid-tier load balancing and failover.   [![godoc][D]](https://godoc.org/github.com/Bilibili/discovery)
- [jackal](https://github.com/ortuman/jackal) **star:1437** An XMPP server written in Go.   [![godoc][D]](https://godoc.org/github.com/ortuman/jackal)   [![Archived][Archived]](https://github.com/ortuman/jackal)
- [go-feature-flag](https://github.com/thomaspoignant/go-feature-flag) **star:1215** A simple, complete and lightweight self-hosted feature flag solution 100% Open Source.   [![There was an update last month][G]](https://github.com/thomaspoignant/go-feature-flag)   [![godoc][D]](https://godoc.org/github.com/thomaspoignant/go-feature-flag)
- [Euterpe](https://github.com/ironsmile/euterpe) **star:527** Self-hosted music streaming server with built-in web UI and REST API.   [![There was an update last month][G]](https://github.com/ironsmile/euterpe)   [![godoc][D]](https://godoc.org/github.com/ironsmile/euterpe)
- [dummy](https://github.com/neotoolkit/dummy) **star:178** Run mock server based off an API contract with one command.   [![godoc][D]](https://godoc.org/github.com/neotoolkit/dummy)   [![Archived][Archived]](https://github.com/neotoolkit/dummy)
- [dudeldu](https://github.com/krotik/dudeldu) **star:144** A simple SHOUTcast server.   [![It hasn't been updated in recent three years][Y]](https://github.com/krotik/dudeldu)   [![godoc][D]](https://godoc.org/github.com/krotik/dudeldu)
- [go-proxy-cache](https://github.com/fabiocicerchia/go-proxy-cache) **star:124** Simple Reverse Proxy with Caching, written in Go, using Redis.   [![godoc][D]](https://godoc.org/github.com/fabiocicerchia/go-proxy-cache)
- [cortex-tenant](https://github.com/blind-oracle/cortex-tenant) **star:105** Prometheus remote write proxy that adds add Cortex tenant ID header based on metric labels.   [![godoc][D]](https://godoc.org/github.com/blind-oracle/cortex-tenant)
- [lets-proxy2](https://github.com/rekby/lets-proxy2) **star:95** Reverse proxy for handle https with issue certificates in fly from lets-encrypt.   [![godoc][D]](https://godoc.org/github.com/rekby/lets-proxy2)
- [psql-streamer](https://github.com/blind-oracle/psql-streamer) **star:59** Stream database events from PostgreSQL to Kafka.   [![It hasn't been updated in recent three years][Y]](https://github.com/blind-oracle/psql-streamer)   [![godoc][D]](https://godoc.org/github.com/blind-oracle/psql-streamer)
- [nginx-prometheus](https://github.com/blind-oracle/nginx-prometheus) **star:41** Nginx log parser and exporter to Prometheus.   [![It hasn't been updated in recent three years][Y]](https://github.com/blind-oracle/nginx-prometheus)   [![godoc][D]](https://godoc.org/github.com/blind-oracle/nginx-prometheus)
- [nsq](https://nsq.io/)  A realtime distributed messaging platform.
- [simple-jwt-provider](https://github.com/leberKleber/simple-jwt-provider) **star:39** Simple and lightweight provider which exhibits JWTs, supports login, password-reset (via mail) and user management.   [![godoc][D]](https://godoc.org/github.com/leberKleber/simple-jwt-provider)
- [protoxy](https://github.com/camgraff/protoxy) **star:35** A proxy server that converts JSON request bodies to Protocol Buffers.   [![It hasn't been updated in recent three years][Y]](https://github.com/camgraff/protoxy)   [![godoc][D]](https://godoc.org/github.com/camgraff/protoxy)
- [Moxy](https://github.com/sinhashubham95/moxy) **star:12** Moxy is a simple mocker and proxy application server, you can create mock endpoints as well as proxy requests in case no mock exists for the endpoint.   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/moxy)
- [gondola](https://github.com/bmf-san/gondola) **star:5** A YAML based golang reverse proxy.   [![godoc][D]](https://godoc.org/github.com/bmf-san/gondola)
- [riemann-relay](https://github.com/blind-oracle/riemann-relay) **star:2** Relay to load-balance Riemann events and/or convert them to Carbon.   [![It hasn't been updated in recent three years][Y]](https://github.com/blind-oracle/riemann-relay)   [![godoc][D]](https://godoc.org/github.com/blind-oracle/riemann-relay)

**[⬆ back to top](#contents)**

## Stream Processing

_Libraries and tools for stream processing and reactive programming._

- [go-streams](https://github.com/reugn/go-streams) **star:1824** Go stream processing library.   [![godoc][D]](https://godoc.org/github.com/reugn/go-streams)
- [machine](https://github.com/whitaker-io/machine) **star:152** Go library for writing and generating stream workers with built in metrics and traceability.   [![godoc][D]](https://godoc.org/github.com/whitaker-io/machine)
- [stream](https://github.com/youthlin/stream) **star:89** Go Stream, like Java 8 Stream: Filter/Map/FlatMap/Peek/Sorted/ForEach/Reduce...   [![godoc][D]](https://godoc.org/github.com/youthlin/stream)
- [goio](https://github.com/primetalk/goio) **star:81** An implementation of IO, Stream, Fiber for Golang, inspired by awesome Scala libraries cats and fs2.   [![godoc][D]](https://godoc.org/github.com/primetalk/goio)

**[⬆ back to top](#contents)**

## Template Engines

_Libraries and tools for templating and lexing._

- [templ](https://github.com/a-h/templ) **star:7619** A HTML templating language that has great developer tooling.   [![There was an update last month][G]](https://github.com/a-h/templ)   [![godoc][D]](https://godoc.org/github.com/a-h/templ)
- [sprig](https://github.com/Masterminds/sprig) **star:4108** Useful template functions for Go templates.   [![godoc][D]](https://godoc.org/github.com/Masterminds/sprig)
- [quicktemplate](https://github.com/valyala/quicktemplate) **star:3066** Fast, powerful, yet easy to use template engine. Converts templates into Go code and then compiles it.   [![godoc][D]](https://godoc.org/github.com/valyala/quicktemplate)
- [pongo2](https://github.com/flosch/pongo2) **star:2834** Django-like template-engine for Go.   [![There was an update last month][G]](https://github.com/flosch/pongo2)   [![godoc][D]](https://godoc.org/github.com/flosch/pongo2)
- [maroto](https://github.com/johnfercher/maroto) **star:1531** A maroto way to create PDFs. Maroto is inspired in Bootstrap and uses gofpdf. Fast and simple.   [![godoc][D]](https://godoc.org/github.com/johnfercher/maroto)
- [jet](https://github.com/CloudyKit/jet) **star:1210** Jet template engine.   [![godoc][D]](https://godoc.org/github.com/CloudyKit/jet)
- [Razor](https://github.com/sipin/gorazor) **star:851** Razor view engine for Golang.   [![godoc][D]](https://godoc.org/github.com/sipin/gorazor)
- [fasttemplate](https://github.com/valyala/fasttemplate) **star:816** Simple and fast template engine. Substitutes template placeholders up to 10x faster than [text/template](https://golang.org/pkg/text/template/).   [![godoc][D]](https://godoc.org/github.com/valyala/fasttemplate)
- [gomponents](https://www.gomponents.com)  HTML 5 components in pure Go, that look something like this: `func(name string) g.Node { return Div(Class("headline"), g.Textf("Hi %v!", name)) }`.
- [raymond](https://github.com/aymerick/raymond) **star:596** Complete handlebars implementation in Go.   [![There was an update last month][G]](https://github.com/aymerick/raymond)   [![godoc][D]](https://godoc.org/github.com/aymerick/raymond)
- [ego](https://github.com/benbjohnson/ego) **star:578** Lightweight templating language that lets you write templates in Go. Templates are translated into Go and compiled.   [![godoc][D]](https://godoc.org/github.com/benbjohnson/ego)
- [goview](https://github.com/foolin/goview) **star:416** Goview is a lightweight, minimalist and idiomatic template library based on golang html/template for building Go web application.   [![godoc][D]](https://godoc.org/github.com/foolin/goview)
- [liquid](https://github.com/osteele/liquid) **star:281** Go implementation of Shopify Liquid templates.   [![There was an update last month][G]](https://github.com/osteele/liquid)   [![godoc][D]](https://godoc.org/github.com/osteele/liquid)
- [Soy](https://github.com/robfig/soy) **star:171** Closure templates (aka Soy templates) for Go, following the [official spec](https://developers.google.com/closure/templates/).   [![godoc][D]](https://godoc.org/github.com/robfig/soy)
- [extemplate](https://github.com/dannyvankooten/extemplate) **star:56** Tiny wrapper around html/template to allow for easy file-based template inheritance.   [![godoc][D]](https://godoc.org/github.com/dannyvankooten/extemplate)   [![Archived][Archived]](https://github.com/dannyvankooten/extemplate)
- [gospin](https://github.com/m1/gospin) **star:56** Article spinning and spintax/spinning syntax engine, useful for A/B, testing pieces of text/articles and creating more natural conversations.   [![It hasn't been updated in recent three years][Y]](https://github.com/m1/gospin)   [![godoc][D]](https://godoc.org/github.com/m1/gospin)
- [got](https://github.com/goradd/got) **star:29** A Go code generator inspired by Hero and Fasttemplate. Has include files, custom tag definitions, injected Go code, language translation, and more.   [![godoc][D]](https://godoc.org/github.com/goradd/got)
- [tbd](https://github.com/lucasepe/tbd) **star:25** A really simple way to create text templates with placeholders - exposes extra builtin Git repo metadata.   [![godoc][D]](https://godoc.org/github.com/lucasepe/tbd)

**[⬆ back to top](#contents)**

## Testing

_Libraries for testing codebases and generating test data._

### Testing Frameworks

- [Testify](https://github.com/stretchr/testify) **star:22832** Sacred extension to the standard go testing package.   [![godoc][D]](https://godoc.org/github.com/stretchr/testify)
- [apitest](https://apitest.dev)  Simple and extensible behavioural testing library for REST based services or HTTP handlers that supports mocking external http calls and rendering of sequence diagrams.
- [go-cmp](https://github.com/google/go-cmp) **star:4127** Package for comparing Go values in tests.   [![godoc][D]](https://godoc.org/github.com/google/go-cmp)
- [testcontainers-go](https://github.com/testcontainers/testcontainers-go) **star:3392** A Go package that makes it simple to create and clean up container-based dependencies for automated integration/smoke tests. The clean, easy-to-use API enables developers to programmatically define containers that should be run as part of a test and clean up those resources when the test is done.   [![There was an update last month][G]](https://github.com/testcontainers/testcontainers-go)   [![godoc][D]](https://godoc.org/github.com/testcontainers/testcontainers-go)
- [httpexpect](https://github.com/gavv/httpexpect) **star:2512** Concise, declarative, and easy to use end-to-end HTTP and REST API testing.   [![godoc][D]](https://godoc.org/github.com/gavv/httpexpect)
- [godog](https://github.com/cucumber/godog) **star:2251** Cucumber BDD framework for Go.   [![There was an update last month][G]](https://github.com/cucumber/godog)   [![godoc][D]](https://godoc.org/github.com/cucumber/godog)
- [is](https://github.com/matryer/is) **star:1752** Professional lightweight testing mini-framework for Go.   [![godoc][D]](https://godoc.org/github.com/matryer/is)
- [gnomock](https://github.com/orlangure/gnomock) **star:1350** integration testing with real dependencies (database, cache, even Kubernetes or AWS) running in Docker, without mocks.   [![There was an update last month][G]](https://github.com/orlangure/gnomock)   [![godoc][D]](https://godoc.org/github.com/orlangure/gnomock)
- [go-vcr](https://github.com/dnaeon/go-vcr) **star:1129** Record and replay your HTTP interactions for fast, deterministic and accurate tests.   [![There was an update last month][G]](https://github.com/dnaeon/go-vcr)   [![godoc][D]](https://godoc.org/github.com/dnaeon/go-vcr)
- [testfixtures](https://github.com/go-testfixtures/testfixtures) **star:1082** A helper for Rails' like test fixtures to test database applications.   [![There was an update last month][G]](https://github.com/go-testfixtures/testfixtures)   [![godoc][D]](https://godoc.org/github.com/go-testfixtures/testfixtures)
- [goblin](https://github.com/franela/goblin) **star:884** Mocha like testing framework of Go.   [![godoc][D]](https://godoc.org/github.com/franela/goblin)
- [embedded-postgres](https://github.com/fergusstrange/embedded-postgres) **star:803** Run a real Postgres database locally on Linux, OSX or Windows as part of another Go application or test.   [![godoc][D]](https://godoc.org/github.com/fergusstrange/embedded-postgres)
- [goc](https://github.com/qiniu/goc) **star:794** Goc is a comprehensive coverage testing system for The Go Programming Language.   [![godoc][D]](https://godoc.org/github.com/qiniu/goc)
- [gocheck](https://labix.org/gocheck)  More advanced testing framework alternative to gotest.
- [GoConvey](https://github.com/smartystreets/goconvey/)  BDD-style framework with web UI and live reload.
- [baloo](https://github.com/h2non/baloo) **star:775** Expressive and versatile end-to-end HTTP API testing made easy.   [![godoc][D]](https://godoc.org/github.com/h2non/baloo)
- [go-mutesting](https://github.com/zimmski/go-mutesting) **star:635** Mutation testing for Go source code.   [![godoc][D]](https://godoc.org/github.com/zimmski/go-mutesting)
- [gotest.tools](https://github.com/gotestyourself/gotest.tools) **star:506** A collection of packages to augment the go testing package and support common patterns.   [![godoc][D]](https://godoc.org/github.com/gotestyourself/gotest.tools)
- [gofight](https://github.com/appleboy/gofight) **star:441** API Handler Testing for Golang Router framework.   [![It hasn't been updated in recent three years][Y]](https://github.com/appleboy/gofight)   [![godoc][D]](https://godoc.org/github.com/appleboy/gofight)
- [go-testdeep](https://github.com/maxatome/go-testdeep) **star:429** Extremely flexible golang deep comparison, extends the go testing package.   [![godoc][D]](https://godoc.org/github.com/maxatome/go-testdeep)
- [testza](https://github.com/MarvinJWendt/testza) **star:417** Full-featured test framework with nice colorized output.   [![godoc][D]](https://godoc.org/github.com/MarvinJWendt/testza)
- [cupaloy](https://github.com/bradleyjkemp/cupaloy) **star:296** Simple snapshot testing addon for your test framework.   [![godoc][D]](https://godoc.org/github.com/bradleyjkemp/cupaloy)
- [frisby](https://github.com/verdverm/frisby) **star:277** REST API testing framework.   [![It hasn't been updated in recent three years][Y]](https://github.com/verdverm/frisby)   [![godoc][D]](https://godoc.org/github.com/verdverm/frisby)
- [got](https://github.com/ysmood/got) **star:264** An enjoyable golang test framework.   [![godoc][D]](https://godoc.org/github.com/ysmood/got)
- [endly](https://github.com/viant/endly) **star:262** Declarative end to end functional testing.   [![There was an update last month][G]](https://github.com/viant/endly)   [![godoc][D]](https://godoc.org/github.com/viant/endly)
- [go-hit](https://github.com/Eun/go-hit) **star:253** Hit is an http integration test framework written in golang.   [![godoc][D]](https://godoc.org/github.com/Eun/go-hit)
- [go-carpet](https://github.com/msoap/go-carpet) **star:245** Tool for viewing test coverage in terminal.   [![godoc][D]](https://godoc.org/github.com/msoap/go-carpet)
- [commander](https://github.com/SimonBaeumer/commander) **star:224** Tool for testing cli applications on windows, linux and osx.   [![godoc][D]](https://godoc.org/github.com/SimonBaeumer/commander)
- [charlatan](https://github.com/percolate/charlatan) **star:202** Tool to generate fake interface implementations for tests.   [![godoc][D]](https://godoc.org/github.com/percolate/charlatan)
- [dbcleaner](https://github.com/khaiql/dbcleaner) **star:160** Clean database for testing purpose, inspired by `database_cleaner` in Ruby.   [![godoc][D]](https://godoc.org/github.com/khaiql/dbcleaner)
- [jsonassert](https://github.com/kinbiko/jsonassert) **star:122** Package for verifying that your JSON payloads are serialized correctly.   [![godoc][D]](https://godoc.org/github.com/kinbiko/jsonassert)
- [testcase](https://github.com/adamluzsi/testcase) **star:118** Idiomatic testing framework for Behavior Driven Development.   [![There was an update last month][G]](https://github.com/adamluzsi/testcase)   [![godoc][D]](https://godoc.org/github.com/adamluzsi/testcase)
- [gocrest](https://github.com/corbym/gocrest) **star:103** Composable hamcrest-like matchers for Go assertions.   [![godoc][D]](https://godoc.org/github.com/corbym/gocrest)
- [wstest](https://github.com/posener/wstest) **star:102** Websocket client for unit-testing a websocket http.Handler.   [![It hasn't been updated in recent three years][Y]](https://github.com/posener/wstest)   [![godoc][D]](https://godoc.org/github.com/posener/wstest)
- [be](https://github.com/carlmjohnson/be) **star:100** The minimalist generic test assertion library.   [![godoc][D]](https://godoc.org/github.com/carlmjohnson/be)
- [Gont](https://github.com/stv0g/gont) **star:76** Go network testing toolkit for testing building complex network topologies using Linux namespaces.   [![There was an update last month][G]](https://github.com/stv0g/gont)   [![godoc][D]](https://godoc.org/github.com/stv0g/gont)
- [gherkingen](https://github.com/hedhyw/gherkingen) **star:73** BDD boilerplate generator and framework.   [![godoc][D]](https://godoc.org/github.com/hedhyw/gherkingen)
- [ginkgo](https://onsi.github.io/ginkgo/)  BDD Testing Framework for Go.
- [testcerts](https://github.com/madflojo/testcerts) **star:63** Dynamically generate self-signed certificates and certificate authorities within your test functions.   [![godoc][D]](https://godoc.org/github.com/madflojo/testcerts)
- [assert](https://github.com/go-playground/assert) **star:62** Basic Assertion Library used along side native go testing, with building blocks for custom assertions.   [![godoc][D]](https://godoc.org/github.com/go-playground/assert)
- [restit](https://github.com/yookoala/restit) **star:55** Go micro framework to help writing RESTful API integration test.   [![godoc][D]](https://godoc.org/github.com/yookoala/restit)
- [gospecify](https://github.com/stesla/gospecify) **star:52** This provides a BDD syntax for testing your Go code. It should be familiar to anybody who has used libraries such as rspec.   [![It hasn't been updated in recent three years][Y]](https://github.com/stesla/gospecify)   [![godoc][D]](https://godoc.org/github.com/stesla/gospecify)
- [gomatch](https://github.com/jfilipczyk/gomatch) **star:46** library created for testing JSON against patterns.   [![It hasn't been updated in recent three years][Y]](https://github.com/jfilipczyk/gomatch)   [![godoc][D]](https://godoc.org/github.com/jfilipczyk/gomatch)
- [gomega](https://onsi.github.io/gomega/)  Rspec like matcher/assertion library.
- [dsunit](https://github.com/viant/dsunit) **star:44** Datastore testing for SQL, NoSQL, structured files.   [![godoc][D]](https://godoc.org/github.com/viant/dsunit)
- [fluentassert](https://github.com/fluentassert/verify) **star:40** Extensible, type-safe, fluent assertion Go library.   [![godoc][D]](https://godoc.org/github.com/fluentassert/verify)
- [Hamcrest](https://github.com/rdrdr/hamcrest) **star:30** fluent framework for declarative Matcher objects that, when applied to input values, produce self-describing results.   [![It hasn't been updated in recent three years][Y]](https://github.com/rdrdr/hamcrest)   [![godoc][D]](https://godoc.org/github.com/rdrdr/hamcrest)
- [fixenv](https://github.com/rekby/fixenv) **star:28** Fixture manage engine, inspired by pytest fixtures.   [![There was an update last month][G]](https://github.com/rekby/fixenv)   [![godoc][D]](https://godoc.org/github.com/rekby/fixenv)
- [schema](https://github.com/jgroeneveld/schema) **star:21** Quick and easy expression matching for JSON schemas used in requests and responses.   [![It hasn't been updated in recent three years][Y]](https://github.com/jgroeneveld/schema)   [![godoc][D]](https://godoc.org/github.com/jgroeneveld/schema)
- [flute](https://github.com/suzuki-shunsuke/flute) **star:19** HTTP client testing framework.   [![There was an update last month][G]](https://github.com/suzuki-shunsuke/flute)   [![godoc][D]](https://godoc.org/github.com/suzuki-shunsuke/flute)
- [testsql](https://github.com/zhulongcheng/testsql) **star:17** Generate test data from SQL files before testing and clear it after finished.   [![It hasn't been updated in recent three years][Y]](https://github.com/zhulongcheng/testsql)   [![godoc][D]](https://godoc.org/github.com/zhulongcheng/testsql)
- [biff](https://github.com/fulldump/biff) **star:14** Bifurcation testing framework, BDD compatible.   [![godoc][D]](https://godoc.org/github.com/fulldump/biff)
- [gogiven](https://github.com/corbym/gogiven) **star:14** YATSPEC-like BDD testing framework for Go.   [![godoc][D]](https://godoc.org/github.com/corbym/gogiven)
- [badio](https://github.com/cavaliercoder/badio) **star:12** Extensions to Go's `testing/iotest` package.   [![It hasn't been updated in recent three years][Y]](https://github.com/cavaliercoder/badio)   [![godoc][D]](https://godoc.org/github.com/cavaliercoder/badio)
- [gosuite](https://github.com/pavlo/gosuite) **star:12** Brings lightweight test suites with setup/teardown facilities to `testing` by leveraging Go1.7's Subtests.   [![It hasn't been updated in recent three years][Y]](https://github.com/pavlo/gosuite)   [![godoc][D]](https://godoc.org/github.com/pavlo/gosuite)
- [stop-and-go](https://github.com/elgohr/stop-and-go) **star:10** Testing helper for concurrency.   [![godoc][D]](https://godoc.org/github.com/elgohr/stop-and-go)
- [Tt](https://github.com/vcaesar/tt) **star:8** Simple and colorful test tools.   [![godoc][D]](https://godoc.org/github.com/vcaesar/tt)
- [trial](https://github.com/jgroeneveld/trial) **star:6** Quick and easy extendable assertions without introducing much boilerplate.   [![godoc][D]](https://godoc.org/github.com/jgroeneveld/trial)
- [go-testpredicate](https://github.com/maargenton/go-testpredicate) **star:5** Test predicate style assertions library with extensive diagnostics output.   [![godoc][D]](https://godoc.org/github.com/maargenton/go-testpredicate)
- [go-mysql-test-container](https://github.com/arikama/go-mysql-test-container) **star:2** Golang MySQL testcontainer to help with MySQL integration testing.   [![godoc][D]](https://godoc.org/github.com/arikama/go-mysql-test-container)
- [go-snaps](http://github.com/gkampitakis/go-snaps)  Jest-like snapshot testing in Golang.
- [omg.testingtools](https://github.com/dedalqq/omg.testingtools) **star:1** The simple library for change a values of private fields for testing.   [![godoc][D]](https://godoc.org/github.com/dedalqq/omg.testingtools)

### Mock

- [gomock](https://github.com/golang/mock) **star:9276** Mocking framework for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/golang/mock)   [![Archived][Archived]](https://github.com/golang/mock)
- [go-sqlmock](https://github.com/DATA-DOG/go-sqlmock) **star:5998** Mock SQL driver for testing database interactions.   [![godoc][D]](https://godoc.org/github.com/DATA-DOG/go-sqlmock)
- [mockery](https://github.com/vektra/mockery) **star:5875** Tool to generate Go interfaces.   [![godoc][D]](https://godoc.org/github.com/vektra/mockery)
- [hoverfly](https://github.com/SpectoLabs/hoverfly) **star:2336** HTTP(S) proxy for recording and simulating REST/SOAP APIs with extensible middleware and easy-to-use CLI.   [![godoc][D]](https://godoc.org/github.com/SpectoLabs/hoverfly)
- [gock](https://github.com/h2non/gock) **star:2064** Versatile HTTP mocking made easy.   [![godoc][D]](https://godoc.org/github.com/h2non/gock)
- [httpmock](https://github.com/jarcoal/httpmock) **star:1901** Easy mocking of HTTP responses from external resources.   [![godoc][D]](https://godoc.org/github.com/jarcoal/httpmock)
- [moq](https://github.com/matryer/moq) **star:1882** Utility that generates a struct from any interface. The struct can be used in test code as a mock of the interface.   [![godoc][D]](https://godoc.org/github.com/matryer/moq)
- [counterfeiter](https://github.com/maxbrunsfeld/counterfeiter) **star:933** Tool for generating self-contained mock objects.   [![There was an update last month][G]](https://github.com/maxbrunsfeld/counterfeiter)   [![godoc][D]](https://godoc.org/github.com/maxbrunsfeld/counterfeiter)
- [genmock](https://gitlab.com/so_literate/genmock)  Go mocking system with code generator for building calls of the interface methods.
- [go-txdb](https://github.com/DATA-DOG/go-txdb) **star:639** Single transaction based database driver mainly for testing purposes.   [![godoc][D]](https://godoc.org/github.com/DATA-DOG/go-txdb)
- [minimock](https://github.com/gojuno/minimock) **star:622** Mock generator for Go interfaces.   [![There was an update last month][G]](https://github.com/gojuno/minimock)   [![godoc][D]](https://godoc.org/github.com/gojuno/minimock)
- [xgo](https://github.com/xhd2015/xgo) **star:306** A general pureposed function mocking library.   [![There was an update last month][G]](https://github.com/xhd2015/xgo)   [![godoc][D]](https://godoc.org/github.com/xhd2015/xgo)   [![Contains Chinese documents][CN]](https://github.com/xhd2015/xgo)
- [govcr](https://github.com/seborama/govcr) **star:169** HTTP mock for Golang: record and replay HTTP interactions for offline testing.   [![godoc][D]](https://godoc.org/github.com/seborama/govcr)
- [go-localstack](https://github.com/elgohr/go-localstack) **star:76** Tool for using localstack in AWS testing.   [![There was an update last month][G]](https://github.com/elgohr/go-localstack)   [![godoc][D]](https://godoc.org/github.com/elgohr/go-localstack)
- [timex](https://github.com/cabify/timex) **star:70** A test-friendly replacement for the native `time` package.   [![It hasn't been updated in recent three years][Y]](https://github.com/cabify/timex)   [![godoc][D]](https://godoc.org/github.com/cabify/timex)
- [mockhttp](https://github.com/tv42/mockhttp) **star:23** Mock object for Go http.ResponseWriter.   [![It hasn't been updated in recent three years][Y]](https://github.com/tv42/mockhttp)   [![godoc][D]](https://godoc.org/github.com/tv42/mockhttp)
- [mooncake](https://github.com/GuilhermeCaruso/mooncake) **star:18** A simple way to generate mocks for multiple purposes.   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/mooncake)

## Fuzzing and delta-debugging/reducing/shrinking

- [go-fuzz](https://github.com/dvyukov/go-fuzz) **star:4741** Randomized testing system.   [![godoc][D]](https://godoc.org/github.com/dvyukov/go-fuzz)
- [gofuzz](https://github.com/google/gofuzz) **star:1492** Library for populating go objects with random values.   [![godoc][D]](https://godoc.org/github.com/google/gofuzz)   [![Archived][Archived]](https://github.com/google/gofuzz)
- [Tavor](https://github.com/zimmski/tavor) **star:245** Generic fuzzing and delta-debugging framework.   [![It hasn't been updated in recent three years][Y]](https://github.com/zimmski/tavor)   [![godoc][D]](https://godoc.org/github.com/zimmski/tavor)

## Selenium and browser control tools

- [chromedp](https://github.com/knq/chromedp) **star:10727** a way to drive/test Chrome, Safari, Edge, Android Webviews, and other browsers supporting the Chrome Debugging Protocol.   [![godoc][D]](https://godoc.org/github.com/knq/chromedp)
- [rod](https://github.com/go-rod/rod) **star:5125** A Devtools driver to make web automation and scraping easy.   [![godoc][D]](https://godoc.org/github.com/go-rod/rod)
- [selenoid](https://github.com/aerokube/selenoid) **star:2552** alternative Selenium hub server that launches browsers within containers.   [![There was an update last month][G]](https://github.com/aerokube/selenoid)   [![godoc][D]](https://godoc.org/github.com/aerokube/selenoid)
- [playwright-go](https://github.com/mxschmitt/playwright-go) **star:2005** browser automation library to control Chromium, Firefox and WebKit with a single API.   [![godoc][D]](https://godoc.org/github.com/mxschmitt/playwright-go)
- [cdp](https://github.com/mafredri/cdp) **star:722** Type-safe bindings for the Chrome Debugging Protocol that can be used with browsers or other debug targets that implement it.   [![godoc][D]](https://godoc.org/github.com/mafredri/cdp)
- [ggr](https://github.com/aerokube/ggr) **star:313** a lightweight server that routes and proxies Selenium WebDriver requests to multiple Selenium hubs.   [![godoc][D]](https://godoc.org/github.com/aerokube/ggr)

### Fail injection
- [failpoint](https://github.com/pingcap/failpoint) **star:812** An implementation of [failpoints](https://www.freebsd.org/cgi/man.cgi?query=fail) for Golang.   [![godoc][D]](https://godoc.org/github.com/pingcap/failpoint)

**[⬆ back to top](#contents)**

## Text Processing

_Libraries for parsing and manipulating texts._

See also [Natural Language Processing](#natural-language-processing) and [Text Analysis](#text-analysis).

### Formatters

- [go-humanize](https://github.com/dustin/go-humanize) **star:4261** Formatters for time, numbers, and memory size to human readable format.   [![godoc][D]](https://godoc.org/github.com/dustin/go-humanize)
- [gotabulate](https://github.com/bndr/gotabulate) **star:323** Easily pretty-print your tabular data with Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/bndr/gotabulate)   [![godoc][D]](https://godoc.org/github.com/bndr/gotabulate)
- [align](https://github.com/Guitarbum722/align) **star:84** A general purpose application that aligns text.   [![godoc][D]](https://godoc.org/github.com/Guitarbum722/align)
- [bytes](https://github.com/labstack/gommon/tree/master/bytes)  Formats and parses numeric byte values (10K, 2M, 3G, etc.).
- [go-fixedwidth](https://github.com/ianlopshire/go-fixedwidth) **star:80** Fixed-width text formatting (encoder/decoder with reflection).   [![godoc][D]](https://godoc.org/github.com/ianlopshire/go-fixedwidth)
- [address](https://github.com/bojanz/address) **star:71** Handles address representation, validation and formatting.   [![godoc][D]](https://godoc.org/github.com/bojanz/address)
- [textwrap](https://github.com/isbm/textwrap) **star:5** Wraps text at end of lines. Implementation of `textwrap` module from Python.   [![It hasn't been updated in recent three years][Y]](https://github.com/isbm/textwrap)   [![godoc][D]](https://godoc.org/github.com/isbm/textwrap)

### Markup Languages

- [blackfriday](https://github.com/russross/blackfriday) **star:5412** Markdown processor in Go.   [![godoc][D]](https://godoc.org/github.com/russross/blackfriday)
- [toml](https://github.com/BurntSushi/toml) **star:4516** TOML configuration format (encoder/decoder with reflection).   [![godoc][D]](https://godoc.org/github.com/BurntSushi/toml)
- [goldmark](https://github.com/yuin/goldmark) **star:3522** A Markdown parser written in Go. Easy to extend, standard (CommonMark) compliant, well structured.   [![There was an update last month][G]](https://github.com/yuin/goldmark)   [![godoc][D]](https://godoc.org/github.com/yuin/goldmark)
- [go-toml](https://github.com/pelletier/go-toml) **star:1681** Go library for the TOML format with query support and handy cli tools.   [![There was an update last month][G]](https://github.com/pelletier/go-toml)   [![godoc][D]](https://godoc.org/github.com/pelletier/go-toml)
- [html-to-markdown](https://github.com/JohannesKaufmann/html-to-markdown) **star:795** Convert HTML to Markdown. Even works with entire websites and can be extended through rules.   [![There was an update last month][G]](https://github.com/JohannesKaufmann/html-to-markdown)   [![godoc][D]](https://godoc.org/github.com/JohannesKaufmann/html-to-markdown)
- [htmlquery](https://github.com/antchfx/htmlquery) **star:717** An XPath query package for HTML, lets you extract data or evaluate from HTML documents by an XPath expression.   [![godoc][D]](https://godoc.org/github.com/antchfx/htmlquery)
- [mxj](https://github.com/clbanning/mxj) **star:620** Encode / decode XML as JSON or map[string]interface{}; extract values with dot-notation paths and wildcards. Replaces x2j and j2x packages.   [![godoc][D]](https://godoc.org/github.com/clbanning/mxj)
- [goq](https://github.com/andrewstuart/goq) **star:256** Declarative unmarshalling of HTML using struct tags with jQuery syntax (uses GoQuery).   [![godoc][D]](https://godoc.org/github.com/andrewstuart/goq)
- [bafi](https://github.com/mmalcek/bafi) **star:102** Universal JSON, BSON, YAML, XML translator to ANY format using templates.   [![godoc][D]](https://godoc.org/github.com/mmalcek/bafi)
- [go-output-format](https://github.com/drewstinnett/go-output-format) **star:15** Output go structures into multiple formats (YAML/JSON/etc) in your command line app.   [![godoc][D]](https://godoc.org/github.com/drewstinnett/go-output-format)
- [bbConvert](https://github.com/CalebQ42/bbConvert) **star:12** Converts bbCode to HTML that allows you to add support for custom bbCode tags.   [![There was an update last month][G]](https://github.com/CalebQ42/bbConvert)   [![godoc][D]](https://godoc.org/github.com/CalebQ42/bbConvert)
- [htmlyaml](https://github.com/nikolaydubina/htmlyaml) **star:4**  Rich rendering of YAML as HTML in Go   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/htmlyaml)
- [htree](https://github.com/bobg/htree) **star:4** Traverse, navigate, filter, and otherwise process trees of [html.Node](https://pkg.go.dev/golang.org/x/net/html#Node) objects.

### Parsers/Encoders/Decoders

- [sh](https://github.com/mvdan/sh) **star:7065** Shell parser and formatter.   [![There was an update last month][G]](https://github.com/mvdan/sh)   [![godoc][D]](https://godoc.org/github.com/mvdan/sh)
- [gofeed](https://github.com/mmcdole/gofeed) **star:2543** Parse RSS and Atom feeds in Go.   [![godoc][D]](https://godoc.org/github.com/mmcdole/gofeed)
- [when](https://github.com/olebedev/when) **star:1324** Natural EN and RU language date/time parser with pluggable rules.   [![godoc][D]](https://godoc.org/github.com/olebedev/when)
- [omniparser](https://github.com/jf-tech/omniparser) **star:902** A versatile ETL library that parses text input (CSV/txt/JSON/XML/EDI/X12/EDIFACT/etc) in streaming fashion and transforms data into JSON output using data-driven schema.   [![godoc][D]](https://godoc.org/github.com/jf-tech/omniparser)
- [commonregex](https://github.com/mingrammer/commonregex) **star:889** A collection of common regular expressions for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/mingrammer/commonregex)   [![godoc][D]](https://godoc.org/github.com/mingrammer/commonregex)
- [gographviz](https://github.com/awalterschulze/gographviz) **star:548** Parses the Graphviz DOT language.   [![godoc][D]](https://godoc.org/github.com/awalterschulze/gographviz)
- [go-nmea](https://github.com/adrianmo/go-nmea) **star:219** NMEA parser library for the Go language.   [![There was an update last month][G]](https://github.com/adrianmo/go-nmea)   [![godoc][D]](https://godoc.org/github.com/adrianmo/go-nmea)
- [editorconfig-core-go](https://github.com/editorconfig/editorconfig-core-go) **star:140** Editorconfig file parser and manipulator for Go.   [![There was an update last month][G]](https://github.com/editorconfig/editorconfig-core-go)   [![godoc][D]](https://godoc.org/github.com/editorconfig/editorconfig-core-go)
- [godump](https://github.com/yassinebenaid/godump) **star:134** Pretty print any GO variable with ease, an alternative to Go's `fmt.Printf("%#v")`.   [![godoc][D]](https://godoc.org/github.com/yassinebenaid/godump)
- [sdp](https://github.com/gortc/sdp) **star:113** SDP: Session Description Protocol [[RFC 4566](https://tools.ietf.org/html/rfc4566)].   [![It hasn't been updated in recent three years][Y]](https://github.com/gortc/sdp)   [![godoc][D]](https://godoc.org/github.com/gortc/sdp)   [![Archived][Archived]](https://github.com/gortc/sdp)
- [go-vcard](https://github.com/emersion/go-vcard) **star:104** Parse and format vCard.   [![godoc][D]](https://godoc.org/github.com/emersion/go-vcard)
- [tokenizer](https://github.com/bzick/tokenizer) **star:89** Parse any string, slice or infinite buffer to any tokens.   [![godoc][D]](https://godoc.org/github.com/bzick/tokenizer)
- [did](https://github.com/ockam-network/did) **star:88** DID (Decentralized Identifiers) Parser and Stringer in Go.   [![godoc][D]](https://godoc.org/github.com/ockam-network/did)
- [allot](https://github.com/sbstjn/allot) **star:59** Placeholder and wildcard text parsing for CLI tools and bots.   [![godoc][D]](https://godoc.org/github.com/sbstjn/allot)
- [normalize](https://github.com/avito-tech/normalize) **star:46** Sanitize, normalize and compare fuzzy text.   [![It hasn't been updated in recent three years][Y]](https://github.com/avito-tech/normalize)   [![godoc][D]](https://godoc.org/github.com/avito-tech/normalize)
- [gonameparts](https://github.com/polera/gonameparts) **star:42** Parses human names into individual name parts.   [![It hasn't been updated in recent three years][Y]](https://github.com/polera/gonameparts)   [![godoc][D]](https://godoc.org/github.com/polera/gonameparts)
- [xj2go](https://github.com/stackerzzq/xj2go) **star:34** Convert xml or json to go struct.   [![godoc][D]](https://godoc.org/github.com/stackerzzq/xj2go)
- [go-fasttld](https://github.com/elliotwutingfeng/go-fasttld) **star:33** High performance effective top level domains (eTLD) extraction module.   [![There was an update last month][G]](https://github.com/elliotwutingfeng/go-fasttld)   [![godoc][D]](https://godoc.org/github.com/elliotwutingfeng/go-fasttld)
- [codetree](https://github.com/aerogo/codetree) **star:24** Parses indented code (python, pixy, scarlet, etc.) and returns a tree structure.   [![It hasn't been updated in recent three years][Y]](https://github.com/aerogo/codetree)   [![godoc][D]](https://godoc.org/github.com/aerogo/codetree)
- [parseargs-go](https://github.com/nproc/parseargs-go) **star:10** string argument parser that understands quotes and backslashes.   [![It hasn't been updated in recent three years][Y]](https://github.com/nproc/parseargs-go)   [![godoc][D]](https://godoc.org/github.com/nproc/parseargs-go)
- [parth](https://github.com/codemodus/parth)  URL path segmentation parsing.
- [encdec](https://github.com/mickep76/encdec) **star:9** Package provides a generic interface to encoders and decoders.   [![It hasn't been updated in recent three years][Y]](https://github.com/mickep76/encdec)   [![godoc][D]](https://godoc.org/github.com/mickep76/encdec)
- [ltsv](https://github.com/Wing924/ltsv) **star:9** High performance [LTSV (Labeled Tab Separated Value)](http://ltsv.org/) reader for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/Wing924/ltsv)   [![godoc][D]](https://godoc.org/github.com/Wing924/ltsv)
- [doi](https://github.com/hscells/doi) **star:8** Document object identifier (doi) parser in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/hscells/doi)   [![godoc][D]](https://godoc.org/github.com/hscells/doi)
- [prattle](https://github.com/askeladdk/prattle) **star:6** Scan and parse LL(1) grammars simply and efficiently.   [![godoc][D]](https://godoc.org/github.com/askeladdk/prattle)

### Regular Expressions

- [rex](https://github.com/hedhyw/rex) **star:191** Regular expressions builder.   [![godoc][D]](https://godoc.org/github.com/hedhyw/rex)
- [regroup](https://github.com/oriser/regroup) **star:143** Match regex expression named groups into go struct using struct tags and automatic parsing.   [![godoc][D]](https://godoc.org/github.com/oriser/regroup)
- [goregen](https://github.com/zach-klippenstein/goregen) **star:90** Library for generating random strings from regular expressions.   [![godoc][D]](https://godoc.org/github.com/zach-klippenstein/goregen)
- [genex](https://github.com/alixaxel/genex) **star:77** Count and expand Regular Expressions into all matching Strings.   [![It hasn't been updated in recent three years][Y]](https://github.com/alixaxel/genex)   [![godoc][D]](https://godoc.org/github.com/alixaxel/genex)
- [go-wildcard](https://github.com/IGLOU-EU/go-wildcard) **star:73** Simple and lightweight wildcard pattern matching.   [![godoc][D]](https://godoc.org/github.com/IGLOU-EU/go-wildcard)

### Sanitation

- [bluemonday](https://github.com/microcosm-cc/bluemonday) **star:3107** HTML Sanitizer.   [![godoc][D]](https://godoc.org/github.com/microcosm-cc/bluemonday)
- [gofuckyourself](https://github.com/JoshuaDoes/gofuckyourself) **star:64** A sanitization-based swear filter for Go.   [![godoc][D]](https://godoc.org/github.com/JoshuaDoes/gofuckyourself)

### Scrapers

- [colly](https://github.com/asciimoo/colly) **star:22819** Fast and Elegant Scraping Framework for Gophers.   [![godoc][D]](https://godoc.org/github.com/asciimoo/colly)
- [GoQuery](https://github.com/PuerkitoBio/goquery) **star:13838** GoQuery brings a syntax and a set of features similar to jQuery to the Go language.   [![There was an update last month][G]](https://github.com/PuerkitoBio/goquery)   [![godoc][D]](https://godoc.org/github.com/PuerkitoBio/goquery)
- [gospider](https://github.com/zhshch2002/gospider)  A simple golang spider/scraping framework,build a spider in 3 lines. migrated from [goribot](https://github.com/zhshch2002/goribot)
- [xurls](https://github.com/mvdan/xurls) **star:1174** Extract urls from text.   [![godoc][D]](https://godoc.org/github.com/mvdan/xurls)
- [dataflowkit](https://github.com/slotix/dataflowkit) **star:654** Web scraping Framework to turn websites into structured data.   [![godoc][D]](https://godoc.org/github.com/slotix/dataflowkit)
- [pagser](https://github.com/foolin/pagser) **star:103** Pagser is a simple, extensible, configurable parse and deserialize html page to struct based on goquery and struct tags for golang crawler.   [![godoc][D]](https://godoc.org/github.com/foolin/pagser)
- [Tagify](https://github.com/zoomio/tagify) **star:36** Produces a set of tags from given source.
- [go-recipe](https://github.com/kkyr/go-recipe) **star:25** A package for scraping recipes from websites.   [![godoc][D]](https://godoc.org/github.com/kkyr/go-recipe)
- [walker](https://github.com/cyucelen/walker) **star:9** Seamlessly fetch paginated data from any source. Simple and high performance API scraping included.   [![godoc][D]](https://godoc.org/github.com/cyucelen/walker)

### RSS

- [podcast](https://github.com/eduncan911/podcast) **star:131** iTunes Compliant and RSS 2.0 Podcast Generator in Golang   [![It hasn't been updated in recent three years][Y]](https://github.com/eduncan911/podcast)   [![godoc][D]](https://godoc.org/github.com/eduncan911/podcast)

### Utility/Miscellaneous

- [go-runewidth](https://github.com/mattn/go-runewidth) **star:602** Functions to get fixed width of the character or string.   [![godoc][D]](https://godoc.org/github.com/mattn/go-runewidth)
- [radix](https://github.com/yourbasic/radix) **star:192** Fast string sorting algorithm.   [![It hasn't been updated in recent three years][Y]](https://github.com/yourbasic/radix)   [![godoc][D]](https://godoc.org/github.com/yourbasic/radix)
- [go-zero-width](https://github.com/trubitsyn/go-zero-width) **star:109** Zero-width character detection and removal for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/trubitsyn/go-zero-width)   [![godoc][D]](https://godoc.org/github.com/trubitsyn/go-zero-width)   [![Archived][Archived]](https://github.com/trubitsyn/go-zero-width)
- [petrovich](https://github.com/striker2000/petrovich) **star:46** Petrovich is the library which inflects Russian names to given grammatical case.   [![godoc][D]](https://godoc.org/github.com/striker2000/petrovich)
- [kace](https://github.com/codemodus/kace) **star:19** Common case conversions covering common initialisms.   [![It hasn't been updated in recent three years][Y]](https://github.com/codemodus/kace)   [![godoc][D]](https://godoc.org/github.com/codemodus/kace)
- [TySug](https://github.com/Dynom/TySug) **star:18** Alternative suggestions with respect to keyboard layouts.   [![godoc][D]](https://godoc.org/github.com/Dynom/TySug)

**[⬆ back to top](#contents)**

## Third-party APIs

_Libraries for accessing third party APIs._

- [github](https://github.com/google/go-github) **star:10236** Go library for accessing the GitHub REST API v3.   [![There was an update last month][G]](https://github.com/google/go-github)   [![godoc][D]](https://godoc.org/github.com/google/go-github)
- [go-openai](https://github.com/sashabaranov/go-openai) **star:8811** OpenAI ChatGPT, DALL·E, Whisper API library for Go.   [![There was an update last month][G]](https://github.com/sashabaranov/go-openai)   [![godoc][D]](https://godoc.org/github.com/sashabaranov/go-openai)
- [discordgo](https://github.com/bwmarrin/discordgo) **star:4947** Go bindings for the Discord Chat API.   [![godoc][D]](https://godoc.org/github.com/bwmarrin/discordgo)
- [slack](https://github.com/slack-go/slack) **star:4622** Slack API in Go.   [![There was an update last month][G]](https://github.com/slack-go/slack)   [![godoc][D]](https://godoc.org/github.com/slack-go/slack)
- [google](https://github.com/google/google-api-go-client) **star:3921** Auto-generated Google APIs for Go.   [![There was an update last month][G]](https://github.com/google/google-api-go-client)   [![godoc][D]](https://godoc.org/github.com/google/google-api-go-client)
- [google-cloud](https://github.com/GoogleCloudPlatform/gcloud-golang) **star:3674** Google Cloud APIs Go Client Library.   [![There was an update last month][G]](https://github.com/GoogleCloudPlatform/gcloud-golang)   [![godoc][D]](https://godoc.org/github.com/GoogleCloudPlatform/gcloud-golang)
- [aws-sdk-go](https://github.com/aws/aws-sdk-go-v2) **star:2530** The official AWS SDK for the Go programming language.   [![There was an update last month][G]](https://github.com/aws/aws-sdk-go-v2)   [![godoc][D]](https://godoc.org/github.com/aws/aws-sdk-go-v2)
- [minio-go](https://github.com/minio/minio-go) **star:2403** Minio Go Library for Amazon S3 compatible cloud storage.   [![There was an update last month][G]](https://github.com/minio/minio-go)   [![godoc][D]](https://godoc.org/github.com/minio/minio-go)
- [stripe](https://github.com/stripe/stripe-go) **star:2081** Go client for the Stripe API.   [![There was an update last month][G]](https://github.com/stripe/stripe-go)   [![godoc][D]](https://godoc.org/github.com/stripe/stripe-go)
- [go-twitter](https://github.com/dghubble/go-twitter) **star:1588** Go client library for the Twitter v1.1 APIs.   [![godoc][D]](https://godoc.org/github.com/dghubble/go-twitter)   [![Archived][Archived]](https://github.com/dghubble/go-twitter)
- [go-jira](https://github.com/andygrunwald/go-jira) **star:1452** Go client library for [Atlassian JIRA](https://www.atlassian.com/software/jira)   [![There was an update last month][G]](https://github.com/andygrunwald/go-jira)   [![godoc][D]](https://godoc.org/github.com/andygrunwald/go-jira)
- [facebook](https://github.com/huandu/facebook) **star:1302** Go Library that supports the Facebook Graph API.   [![godoc][D]](https://godoc.org/github.com/huandu/facebook)
- [anaconda](https://github.com/ChimeraCoder/anaconda) **star:1142** Go client library for the Twitter 1.1 API.   [![godoc][D]](https://godoc.org/github.com/ChimeraCoder/anaconda)
- [githubql](https://github.com/shurcooL/githubql) **star:1098** Go library for accessing the GitHub GraphQL API v4.   [![godoc][D]](https://godoc.org/github.com/shurcooL/githubql)
- [webhooks](https://github.com/go-playground/webhooks) **star:946** Webhook receiver for GitHub and Bitbucket.   [![There was an update last month][G]](https://github.com/go-playground/webhooks)   [![godoc][D]](https://godoc.org/github.com/go-playground/webhooks)
- [twitter-scraper](https://github.com/n0madic/twitter-scraper) **star:878** Scrape the Twitter Frontend API without authentication and limits.   [![godoc][D]](https://godoc.org/github.com/n0madic/twitter-scraper)   [![Archived][Archived]](https://github.com/n0madic/twitter-scraper)
- [paypal](https://github.com/logpacker/PayPal-Go-SDK) **star:670** Wrapper for PayPal payment API.   [![godoc][D]](https://godoc.org/github.com/logpacker/PayPal-Go-SDK)
- [geo-golang](https://github.com/codingsince1985/geo-golang) **star:509** Go Library to access [Google Maps](https://developers.google.com/maps/documentation/geocoding/intro), [MapQuest](https://developer.mapquest.com/documentation/geocoding-api/), [Nominatim](https://developer.mapquest.com/documentation/open/nominatim-search), [OpenCage](https://opencagedata.com/api), [Bing](https://msdn.microsoft.com/en-us/library/ff701715.aspx), [Mapbox](https://www.mapbox.com/developers/api/geocoding/), and [OpenStreetMap](https://wiki.openstreetmap.org/wiki/Nominatim) geocoding / reverse geocoding APIs.   [![godoc][D]](https://godoc.org/github.com/codingsince1985/geo-golang)
- [lark](https://github.com/chyroc/lark) **star:406** [Feishu](https://open.feishu.cn/)/[Lark](https://open.larksuite.com/) Open API Go SDK, Support ALL Open API and Event Callback.   [![godoc][D]](https://godoc.org/github.com/chyroc/lark)   [![Contains Chinese documents][CN]](https://github.com/chyroc/lark)
- [openaigo](https://github.com/otiai10/openaigo) **star:289** OpenAI GPT3/GPT3.5 ChatGPT API client library for Go.   [![godoc][D]](https://godoc.org/github.com/otiai10/openaigo)
- [ethrpc](https://github.com/onrik/ethrpc) **star:265** Go bindings for Ethereum JSON RPC API.   [![godoc][D]](https://godoc.org/github.com/onrik/ethrpc)
- [Trello](https://github.com/adlio/trello) **star:218** Go wrapper for the Trello API.   [![godoc][D]](https://godoc.org/github.com/adlio/trello)
- [go-marathon](https://github.com/gambol99/go-marathon) **star:199** Go library for interacting with Mesosphere's Marathon PAAS.   [![It hasn't been updated in recent three years][Y]](https://github.com/gambol99/go-marathon)   [![godoc][D]](https://godoc.org/github.com/gambol99/go-marathon)
- [go-lark](https://github.com/go-lark/lark) **star:197** An easy-to-use unofficial SDK for [Feishu](https://open.feishu.cn/) and [Lark](https://open.larksuite.com/) Open Platform.   [![godoc][D]](https://godoc.org/github.com/go-lark/lark)   [![Contains Chinese documents][CN]](https://github.com/go-lark/lark)
- [wit-go](https://github.com/wit-ai/wit-go) **star:153** Go client for wit.ai HTTP API.   [![godoc][D]](https://godoc.org/github.com/wit-ai/wit-go)
- [simples3](https://github.com/rhnvrm/simples3) **star:146** Simple no frills AWS S3 Library using REST with V4 Signing written in Go.   [![godoc][D]](https://godoc.org/github.com/rhnvrm/simples3)
- [go-trending](https://github.com/andygrunwald/go-trending) **star:140** Go library for accessing [trending repositories](https://github.com/trending) and [developers](https://github.com/trending/developers) at Github.   [![godoc][D]](https://godoc.org/github.com/andygrunwald/go-trending)
- [pushover](https://github.com/gregdel/pushover) **star:140** Go wrapper for the Pushover API.   [![godoc][D]](https://godoc.org/github.com/gregdel/pushover)
- [Medium](https://github.com/Medium/medium-sdk-go) **star:139** Golang SDK for Medium's OAuth2 API.   [![It hasn't been updated in recent three years][Y]](https://github.com/Medium/medium-sdk-go)   [![godoc][D]](https://godoc.org/github.com/Medium/medium-sdk-go)
- [gosip](https://github.com/koltyakov/gosip) **star:137** Client library for SharePoint.   [![godoc][D]](https://godoc.org/github.com/koltyakov/gosip)
- [gostorm](https://github.com/jsgilmore/gostorm) **star:129** GoStorm is a Go library that implements the communications protocol required to write Storm spouts and Bolts in Go that communicate with the Storm shells.   [![It hasn't been updated in recent three years][Y]](https://github.com/jsgilmore/gostorm)   [![godoc][D]](https://godoc.org/github.com/jsgilmore/gostorm)
- [go-atlassian](https://github.com/ctreminiom/go-atlassian) **star:119** Go library for accessing the [Atlassian Cloud](https://www.atlassian.com/enterprise/cloud) services (Jira, Jira Service Management, Jira Agile, Confluence, Admin Cloud)   [![There was an update last month][G]](https://github.com/ctreminiom/go-atlassian)   [![godoc][D]](https://godoc.org/github.com/ctreminiom/go-atlassian)
- [golang-tmdb](https://github.com/cyruzin/golang-tmdb) **star:111** Golang wrapper for The Movie Database API v3.   [![godoc][D]](https://godoc.org/github.com/cyruzin/golang-tmdb)
- [hipchat (xmpp)](https://github.com/daneharrigan/hipchat) **star:111** A golang package to communicate with HipChat over XMPP.   [![It hasn't been updated in recent three years][Y]](https://github.com/daneharrigan/hipchat)   [![godoc][D]](https://godoc.org/github.com/daneharrigan/hipchat)
- [hipchat](https://github.com/andybons/hipchat) **star:104** This project implements a golang client library for the Hipchat API.   [![It hasn't been updated in recent three years][Y]](https://github.com/andybons/hipchat)   [![godoc][D]](https://godoc.org/github.com/andybons/hipchat)
- [cachet](https://github.com/andygrunwald/cachet) **star:91** Go client library for [Cachet (open source status page system)](https://cachethq.io/).   [![It hasn't been updated in recent three years][Y]](https://github.com/andygrunwald/cachet)   [![godoc][D]](https://godoc.org/github.com/andygrunwald/cachet)
- [disgo](https://github.com/switchupcb/disgo) **star:88** Go API Wrapper for the Discord API.   [![godoc][D]](https://godoc.org/github.com/switchupcb/disgo)
- [gogtrends](https://github.com/groovili/gogtrends) **star:80** Google Trends Unofficial API.   [![godoc][D]](https://godoc.org/github.com/groovili/gogtrends)
- [igdb](https://github.com/Henry-Sarabia/igdb) **star:80** Go client for the [Internet Game Database API](https://api.igdb.com/).   [![godoc][D]](https://godoc.org/github.com/Henry-Sarabia/igdb)
- [google-play-scraper](https://github.com/n0madic/google-play-scraper) **star:79** Get data from Google Play Store.   [![godoc][D]](https://godoc.org/github.com/n0madic/google-play-scraper)
- [go-postman-collection](https://github.com/rbretecher/go-postman-collection) **star:76** Go module to work with [Postman Collections](https://learning.getpostman.com/docs/postman/collections/creating-collections/) (compatible with Insomnia).   [![godoc][D]](https://godoc.org/github.com/rbretecher/go-postman-collection)
- [go-unsplash](https://github.com/hbagdi/go-unsplash) **star:74** Go client library for the [Unsplash.com](https://unsplash.com) API.   [![godoc][D]](https://godoc.org/github.com/hbagdi/go-unsplash)
- [airtable](https://github.com/mehanizm/airtable) **star:73** Go client library for the [Airtable API](https://airtable.com/api).   [![godoc][D]](https://godoc.org/github.com/mehanizm/airtable)
- [ynab](https://github.com/brunomvsouza/ynab.go) **star:69** Go wrapper for the YNAB API.   [![godoc][D]](https://godoc.org/github.com/brunomvsouza/ynab.go)
- [go-redoc](https://github.com/mvrilo/go-redoc) **star:66** Embedded OpenAPI/Swagger documentation ui for Go using [ReDoc](https://redocly.com/).   [![godoc][D]](https://godoc.org/github.com/mvrilo/go-redoc)
- [circleci](https://github.com/jszwedko/go-circleci) **star:65** Go client library for interacting with CircleCI's API.   [![godoc][D]](https://godoc.org/github.com/jszwedko/go-circleci)
- [mixpanel](https://github.com/dukex/mixpanel) **star:60** Mixpanel is a library for tracking events and sending Mixpanel profile updates to Mixpanel from your go applications.   [![godoc][D]](https://godoc.org/github.com/dukex/mixpanel)
- [amazon-product-advertising-api](https://github.com/ngs/go-amazon-product-advertising-api) **star:57** Go Client Library for [Amazon Product Advertising API](https://affiliate-program.amazon.com/gp/advertising/api/detail/main.html).   [![It hasn't been updated in recent three years][Y]](https://github.com/ngs/go-amazon-product-advertising-api)   [![godoc][D]](https://godoc.org/github.com/ngs/go-amazon-product-advertising-api)
- [GoMusicBrainz](https://github.com/michiwend/gomusicbrainz) **star:57** Go MusicBrainz WS2 client library.   [![godoc][D]](https://godoc.org/github.com/michiwend/gomusicbrainz)
- [uptimerobot](https://github.com/bitfield/uptimerobot) **star:57** Go wrapper and command-line client for the Uptime Robot v2 API.   [![godoc][D]](https://godoc.org/github.com/bitfield/uptimerobot)
- [clarifai](https://github.com/samuelcouch/clarifai) **star:55** Go client library for interfacing with the Clarifai API.   [![It hasn't been updated in recent three years][Y]](https://github.com/samuelcouch/clarifai)   [![godoc][D]](https://godoc.org/github.com/samuelcouch/clarifai)
- [megos](https://github.com/andygrunwald/megos) **star:54** Client library for accessing an [Apache Mesos](https://mesos.apache.org/) cluster.   [![It hasn't been updated in recent three years][Y]](https://github.com/andygrunwald/megos)   [![godoc][D]](https://godoc.org/github.com/andygrunwald/megos)
- [fcm](https://github.com/maddevsio/fcm) **star:51** Go library for Firebase Cloud Messaging.   [![It hasn't been updated in recent three years][Y]](https://github.com/maddevsio/fcm)   [![godoc][D]](https://godoc.org/github.com/maddevsio/fcm)
- [go-xkcd](https://github.com/nishanths/go-xkcd) **star:51** Go client for the xkcd API.   [![godoc][D]](https://godoc.org/github.com/nishanths/go-xkcd)
- [go-yapla](https://git.iglou.eu/Production/go-yapla)  Go client library for the Yapla v2.0 API.
- [gads](https://github.com/emiddleton/gads) **star:50** Google Adwords Unofficial API.   [![godoc][D]](https://godoc.org/github.com/emiddleton/gads)
- [spotify](https://github.com/rapito/go-spotify) **star:50** Go Library to access Spotify WEB API.   [![godoc][D]](https://godoc.org/github.com/rapito/go-spotify)
- [swag](https://github.com/zc2638/swag) **star:46** No comments, simple go wrapper to create swagger 2.0 compatible APIs. Support most routing frameworks, such as built-in, gin, chi, mux, echo, httprouter, fasthttp and more.   [![godoc][D]](https://godoc.org/github.com/zc2638/swag)   [![Contains Chinese documents][CN]](https://github.com/zc2638/swag)
- [golyrics](https://github.com/mamal72/golyrics) **star:42** Golyrics is a Go library to fetch music lyrics data from the Wikia website.   [![It hasn't been updated in recent three years][Y]](https://github.com/mamal72/golyrics)   [![godoc][D]](https://godoc.org/github.com/mamal72/golyrics)
- [patreon-go](https://github.com/mxpv/patreon-go) **star:41** Go library for Patreon API.   [![godoc][D]](https://godoc.org/github.com/mxpv/patreon-go)
- [go-myanimelist](https://github.com/nstratos/go-myanimelist) **star:39** Go client library for accessing the [MyAnimeList API](https://myanimelist.net/apiconfig/references/api/v2).   [![godoc][D]](https://godoc.org/github.com/nstratos/go-myanimelist)
- [GoFreeDB](https://github.com/FreeLeh/GoFreeDB) **star:34** Golang library providing common and simple database abstractions on top of Google Sheets.   [![godoc][D]](https://godoc.org/github.com/FreeLeh/GoFreeDB)
- [lastpass-go](https://github.com/ansd/lastpass-go) **star:34** Go client library for the [LastPass](https://www.lastpass.com/) API.   [![godoc][D]](https://godoc.org/github.com/ansd/lastpass-go)
- [gami](https://github.com/bit4bit/gami) **star:33** Go library for Asterisk Manager Interface.   [![It hasn't been updated in recent three years][Y]](https://github.com/bit4bit/gami)   [![godoc][D]](https://godoc.org/github.com/bit4bit/gami)   [![Archived][Archived]](https://github.com/bit4bit/gami)
- [translate](https://github.com/poorny/translate) **star:33** Go online translation package.   [![It hasn't been updated in recent three years][Y]](https://github.com/poorny/translate)   [![godoc][D]](https://godoc.org/github.com/poorny/translate)   [![Archived][Archived]](https://github.com/poorny/translate)
- [steam](https://github.com/sostronk/go-steam) **star:32** Go Library to interact with Steam game servers.   [![godoc][D]](https://godoc.org/github.com/sostronk/go-steam)
- [gcm](https://github.com/Aorioli/gcm) **star:31** Go library for Google Cloud Messaging.   [![It hasn't been updated in recent three years][Y]](https://github.com/Aorioli/gcm)   [![godoc][D]](https://godoc.org/github.com/Aorioli/gcm)
- [device-check-go](https://github.com/rinchsan/device-check-go) **star:25** Go client library for interacting with [iOS DeviceCheck API](https://developer.apple.com/documentation/devicecheck) v1.   [![There was an update last month][G]](https://github.com/rinchsan/device-check-go)   [![godoc][D]](https://godoc.org/github.com/rinchsan/device-check-go)
- [shopify](https://github.com/rapito/go-shopify) **star:25** Go Library to make CRUD request to the Shopify API.   [![It hasn't been updated in recent three years][Y]](https://github.com/rapito/go-shopify)   [![godoc][D]](https://godoc.org/github.com/rapito/go-shopify)
- [go-imgur](https://github.com/koffeinsource/go-imgur) **star:24** Go client library for [imgur](https://imgur.com)   [![godoc][D]](https://godoc.org/github.com/koffeinsource/go-imgur)
- [coinpaprika-go](https://github.com/coinpaprika/coinpaprika-api-go-client) **star:23** Go client library for interacting with Coinpaprika's API.   [![godoc][D]](https://godoc.org/github.com/coinpaprika/coinpaprika-api-go-client)
- [jokeapi-go](https://github.com/icelain/jokeapi) **star:23** Go client for [JokeAPI](https://sv443.net/jokeapi/v2/).   [![godoc][D]](https://godoc.org/github.com/icelain/jokeapi)
- [go-salesforce](https://github.com/k-capehart/go-salesforce) **star:21** Go client library for interacting with the [Salesforce REST API](https://developer.salesforce.com/docs/atlas.en-us.api_rest.meta/api_rest/resources_list.htm).   [![There was an update last month][G]](https://github.com/k-capehart/go-salesforce)   [![godoc][D]](https://godoc.org/github.com/k-capehart/go-salesforce)
- [brewerydb](https://github.com/naegelejd/brewerydb) **star:19** Go library for accessing the BreweryDB API.   [![It hasn't been updated in recent three years][Y]](https://github.com/naegelejd/brewerydb)   [![godoc][D]](https://godoc.org/github.com/naegelejd/brewerydb)
- [textbelt](https://github.com/dietsche/textbelt) **star:19** Go client for the textbelt.com txt messaging API.   [![It hasn't been updated in recent three years][Y]](https://github.com/dietsche/textbelt)   [![godoc][D]](https://godoc.org/github.com/dietsche/textbelt)
- [codeship-go](https://github.com/codeship/codeship-go) **star:18** Go client library for interacting with Codeship's API v2.   [![It hasn't been updated in recent three years][Y]](https://github.com/codeship/codeship-go)   [![godoc][D]](https://godoc.org/github.com/codeship/codeship-go)
- [go-aws-news](https://github.com/circa10a/go-aws-news) **star:17** Go application and library to fetch what's new from AWS.   [![godoc][D]](https://godoc.org/github.com/circa10a/go-aws-news)
- [go-hacknews](https://github.com/PaulRosset/go-hacknews) **star:17** Tiny Go client for HackerNews API.   [![It hasn't been updated in recent three years][Y]](https://github.com/PaulRosset/go-hacknews)   [![godoc][D]](https://godoc.org/github.com/PaulRosset/go-hacknews)
- [go-openproject](https://github.com/manuelbcd/go-openproject) **star:16** Go client library for interacting with [OpenProject](https://docs.openproject.org/api/) API.   [![godoc][D]](https://godoc.org/github.com/manuelbcd/go-openproject)
- [gopaapi5](https://github.com/utekaravinash/gopaapi5) **star:16** Go Client Library for [Amazon Product Advertising API 5.0](https://webservices.amazon.com/paapi5/documentation/).   [![It hasn't been updated in recent three years][Y]](https://github.com/utekaravinash/gopaapi5)   [![godoc][D]](https://godoc.org/github.com/utekaravinash/gopaapi5)
- [bqwriter](https://github.com/OTA-Insight/bqwriter) **star:15** High Level Go Library to write data into [Google BigQuery](https://cloud.google.com/bigquery) at a high throughout.   [![godoc][D]](https://godoc.org/github.com/OTA-Insight/bqwriter)
- [goami2](https://github.com/staskobzar/goami2) **star:15** AMI v2 library for Asterisk PBX.   [![godoc][D]](https://godoc.org/github.com/staskobzar/goami2)
- [google-analytics](https://github.com/chonthu/go-google-analytics) **star:15** Simple wrapper for easy google analytics reporting.   [![It hasn't been updated in recent three years][Y]](https://github.com/chonthu/go-google-analytics)   [![godoc][D]](https://godoc.org/github.com/chonthu/go-google-analytics)
- [go-here](https://github.com/abdullahselek/go-here) **star:13** Go client library around the HERE location based APIs.   [![It hasn't been updated in recent three years][Y]](https://github.com/abdullahselek/go-here)   [![godoc][D]](https://godoc.org/github.com/abdullahselek/go-here)
- [gomalshare](https://github.com/MonaxGT/gomalshare) **star:13** Go library MalShare API [malshare.com](https://www.malshare.com/)   [![It hasn't been updated in recent three years][Y]](https://github.com/MonaxGT/gomalshare)   [![godoc][D]](https://godoc.org/github.com/MonaxGT/gomalshare)
- [go-sophos](https://github.com/esurdam/go-sophos) **star:12** Go client library for the [Sophos UTM REST API](https://www.sophos.com/en-us/medialibrary/PDFs/documentation/UTMonAWS/Sophos-UTM-RESTful-API.pdf?la=en) with zero dependencies.   [![godoc][D]](https://godoc.org/github.com/esurdam/go-sophos)
- [go-swagger-ui](https://github.com/esurdam/go-swagger-ui) **star:11** Go library containing precompiled [Swagger UI](https://swagger.io/tools/swagger-ui/) for serving swagger json.
- [go-telegraph](https://gitlab.com/toby3d/telegraph)  Telegraph publishing platform API client.
- [rawg-sdk-go](https://github.com/dimuska139/rawg-sdk-go) **star:11** Go library for the [RAWG Video Games Database](https://rawg.io/) API   [![godoc][D]](https://godoc.org/github.com/dimuska139/rawg-sdk-go)
- [smite](https://github.com/sergiotapia/smitego) **star:11** Go package to wraps access to the Smite game API.   [![It hasn't been updated in recent three years][Y]](https://github.com/sergiotapia/smitego)   [![godoc][D]](https://godoc.org/github.com/sergiotapia/smitego)
- [goagi](https://github.com/staskobzar/goagi) **star:10** Go library to build Asterisk PBX agi/fastagi applications.   [![godoc][D]](https://godoc.org/github.com/staskobzar/goagi)
- [ip2location-io-go](https://github.com/ip2location/ip2location-io-go) **star:10** Go wrapper for the IP2Location.io API [IP2Location.io](https://www.ip2location.io/).   [![godoc][D]](https://godoc.org/github.com/ip2location/ip2location-io-go)
- [libgoffi](https://github.com/clevabit/libgoffi) **star:10** Library adapter toolbox for native [libffi](https://sourceware.org/libffi/) integration   [![It hasn't been updated in recent three years][Y]](https://github.com/clevabit/libgoffi)   [![godoc][D]](https://godoc.org/github.com/clevabit/libgoffi)
- [rrdaclient](https://github.com/Omie/rrdaclient) **star:10** Go Library to access statdns.com API, which is in turn RRDA API. DNS Queries over HTTP.   [![It hasn't been updated in recent three years][Y]](https://github.com/Omie/rrdaclient)   [![godoc][D]](https://godoc.org/github.com/Omie/rrdaclient)   [![Archived][Archived]](https://github.com/Omie/rrdaclient)
- [go-chronos](https://github.com/axelspringer/go-chronos) **star:8** Go library for interacting with the [Chronos](https://mesos.github.io/chronos/) Job Scheduler   [![It hasn't been updated in recent three years][Y]](https://github.com/axelspringer/go-chronos)   [![godoc][D]](https://godoc.org/github.com/axelspringer/go-chronos)
- [go-hibp](https://github.com/wneessen/go-hibp) **star:8** Simple Go binding to the "Have I Been Pwned" APIs.   [![godoc][D]](https://godoc.org/github.com/wneessen/go-hibp)
- [google-email-audit-api](https://github.com/ngs/go-google-email-audit-api) **star:8** Go client library for [Google G Suite Email Audit API](https://developers.google.com/admin-sdk/email-audit/).   [![It hasn't been updated in recent three years][Y]](https://github.com/ngs/go-google-email-audit-api)   [![godoc][D]](https://godoc.org/github.com/ngs/go-google-email-audit-api)   [![Archived][Archived]](https://github.com/ngs/go-google-email-audit-api)
- [tumblr](https://github.com/mattcunningham/gumblr) **star:8** Go wrapper for the Tumblr v2 API.   [![It hasn't been updated in recent three years][Y]](https://github.com/mattcunningham/gumblr)   [![godoc][D]](https://godoc.org/github.com/mattcunningham/gumblr)
- [newsapi-go](https://github.com/jellydator/newsapi-go) **star:7** Go client for [NewsAPI](https://newsapi.org/).   [![godoc][D]](https://godoc.org/github.com/jellydator/newsapi-go)
- [zooz](https://github.com/gojuno/go-zooz) **star:7** Go client for the Zooz API.   [![godoc][D]](https://godoc.org/github.com/gojuno/go-zooz)
- [appstore-sdk-go](https://github.com/Kachit/appstore-sdk-go) **star:5** Unofficial Golang SDK for AppStore Connect API.   [![godoc][D]](https://godoc.org/github.com/Kachit/appstore-sdk-go)
- [go-restcountries](https://github.com/chriscross0/go-restcountries) **star:4** Go library for the [REST Countries API](https://countrylayer.com/).   [![godoc][D]](https://godoc.org/github.com/chriscross0/go-restcountries)
- [dusupay-sdk-go](https://github.com/Kachit/dusupay-sdk-go) **star:3** Unofficial Dusupay payment gateway API Client for Go   [![godoc][D]](https://godoc.org/github.com/Kachit/dusupay-sdk-go)
- [fasapay-sdk-go](https://github.com/Kachit/fasapay-sdk-go) **star:2** Unofficial Fasapay payment gateway XML API Client for Golang.   [![godoc][D]](https://godoc.org/github.com/Kachit/fasapay-sdk-go)
- [gopensky](https://github.com/navidys/gopensky) **star:2** Go client implementation for [OpenSKY Network](https://opensky-network.org/) live's API (airspace ADS-B and Mode S data).   [![There was an update last month][G]](https://github.com/navidys/gopensky)   [![godoc][D]](https://godoc.org/github.com/navidys/gopensky)
- [playlyfe](https://github.com/playlyfe/playlyfe-go-sdk) **star:2** The Playlyfe Rest API Go SDK.   [![It hasn't been updated in recent three years][Y]](https://github.com/playlyfe/playlyfe-go-sdk)   [![godoc][D]](https://godoc.org/github.com/playlyfe/playlyfe-go-sdk)
- [TripAdvisor](https://github.com/mrbenosborne/tripadvisor-golang) **star:2** Go wrapper for the TripAdvisor API.   [![It hasn't been updated in recent three years][Y]](https://github.com/mrbenosborne/tripadvisor-golang)   [![godoc][D]](https://godoc.org/github.com/mrbenosborne/tripadvisor-golang)
- [vl-go](https://github.com/verifid/vl-go) **star:2** Go client library around the VerifID identity verification layer API.   [![It hasn't been updated in recent three years][Y]](https://github.com/verifid/vl-go)   [![godoc][D]](https://godoc.org/github.com/verifid/vl-go)

**[⬆ back to top](#contents)**

## Utilities

_General utilities and tools to make your life easier._

- [fzf](https://github.com/junegunn/fzf) **star:63000** Command-line fuzzy finder written in Go.   [![There was an update last month][G]](https://github.com/junegunn/fzf)   [![godoc][D]](https://godoc.org/github.com/junegunn/fzf)
- [dive](https://github.com/wagoodman/dive) **star:44944** A tool for exploring each layer in a Docker image.   [![godoc][D]](https://godoc.org/github.com/wagoodman/dive)
- [hub](https://github.com/github/hub) **star:22757** wrap git commands with additional functionality to interact with github from the terminal.   [![godoc][D]](https://godoc.org/github.com/github/hub)
- [lo](https://github.com/samber/lo) **star:16664** A Lodash like Go library based on Go 1.18+ Generics (map, filter, contains, find...)   [![There was an update last month][G]](https://github.com/samber/lo)   [![godoc][D]](https://godoc.org/github.com/samber/lo)
- [sqlx](https://github.com/jmoiron/sqlx) **star:15845** provides a set of extensions on top of the excellent built-in database/sql package.   [![godoc][D]](https://godoc.org/github.com/jmoiron/sqlx)
- [ctop](https://github.com/bcicen/ctop) **star:15361** [Top-like](https://ctop.sh) interface (e.g. htop) for container metrics.   [![godoc][D]](https://godoc.org/github.com/bcicen/ctop)
- [goreleaser](https://github.com/goreleaser/goreleaser) **star:13505** Deliver Go binaries as fast and easily as possible.   [![There was an update last month][G]](https://github.com/goreleaser/goreleaser)   [![godoc][D]](https://godoc.org/github.com/goreleaser/goreleaser)
- [wuzz](https://github.com/asciimoo/wuzz) **star:10526** Interactive cli tool for HTTP inspection.   [![godoc][D]](https://godoc.org/github.com/asciimoo/wuzz)
- [usql](https://github.com/knq/usql) **star:8852** usql is a universal command-line interface for SQL databases.   [![There was an update last month][G]](https://github.com/knq/usql)   [![godoc][D]](https://godoc.org/github.com/knq/usql)
- [peco](https://github.com/peco/peco) **star:7618** Simplistic interactive filtering tool.   [![godoc][D]](https://godoc.org/github.com/peco/peco)
- [go-funk](https://github.com/thoas/go-funk) **star:4708** Modern Go utility library which provides helpers (map, find, contains, filter, chunk, reverse, ...).   [![godoc][D]](https://godoc.org/github.com/thoas/go-funk)
- [hystrix-go](https://github.com/afex/hystrix-go) **star:4203** Implements Hystrix patterns of programmer-defined fallbacks aka circuit breaker.   [![godoc][D]](https://godoc.org/github.com/afex/hystrix-go)
- [godropbox](https://github.com/dropbox/godropbox) **star:4172** Common libraries for writing Go services/applications from Dropbox.   [![godoc][D]](https://godoc.org/github.com/dropbox/godropbox)
- [lancet](https://github.com/duke-git/lancet) **star:3959** A comprehensive, efficient, and reusable util function library of go.   [![There was an update last month][G]](https://github.com/duke-git/lancet)   [![godoc][D]](https://godoc.org/github.com/duke-git/lancet)   [![Contains Chinese documents][CN]](https://github.com/duke-git/lancet)
- [minify](https://github.com/tdewolff/minify) **star:3675** Fast minifiers for HTML, CSS, JS, XML, JSON and SVG file formats.   [![There was an update last month][G]](https://github.com/tdewolff/minify)   [![godoc][D]](https://godoc.org/github.com/tdewolff/minify)
- [panicparse](https://github.com/maruel/panicparse) **star:3514** Groups similar goroutines and colorizes stack dump.   [![godoc][D]](https://godoc.org/github.com/maruel/panicparse)
- [goreporter](https://github.com/wgliang/goreporter) **star:3121** Golang tool that does static analysis, unit testing, code review and generate code quality report.   [![It hasn't been updated in recent three years][Y]](https://github.com/wgliang/goreporter)   [![godoc][D]](https://godoc.org/github.com/wgliang/goreporter)
- [mergo](https://github.com/imdario/mergo) **star:2830** Helper to merge structs and maps in Golang. Useful for configuration default values, avoiding messy if-statements.   [![There was an update last month][G]](https://github.com/imdario/mergo)   [![godoc][D]](https://godoc.org/github.com/imdario/mergo)
- [mc](https://github.com/minio/mc) **star:2798** Minio Client provides minimal tools to work with Amazon S3 compatible cloud storage and filesystems.   [![There was an update last month][G]](https://github.com/minio/mc)   [![godoc][D]](https://godoc.org/github.com/minio/mc)
- [create-go-app](https://github.com/create-go-app/cli) **star:2396** A powerful CLI for create a new production-ready project with backend (Golang), frontend (JavaScript, TypeScript) & deploy automation (Ansible, Docker) by running one command.   [![godoc][D]](https://godoc.org/github.com/create-go-app/cli)
- [retry-go](https://github.com/avast/retry-go) **star:2341** Simple library for retry mechanism.   [![godoc][D]](https://godoc.org/github.com/avast/retry-go)
- [filetype](https://github.com/h2non/filetype) **star:2072** Small package to infer the file type checking the magic numbers signature.   [![godoc][D]](https://godoc.org/github.com/h2non/filetype)
- [EaseProbe](https://github.com/megaease/easeprobe) **star:2062** A simple, standalone, and lightWeight tool that can do health/status checking daemon, support HTTP/TCP/SSH/Shell/Client/... probes, and Slack/Discord/Telegram/SMS... notification.   [![There was an update last month][G]](https://github.com/megaease/easeprobe)   [![godoc][D]](https://godoc.org/github.com/megaease/easeprobe)
- [Storm](https://github.com/asdine/storm) **star:2055** Simple and powerful toolkit for BoltDB.   [![godoc][D]](https://godoc.org/github.com/asdine/storm)
- [jump](https://github.com/gsamokovarov/jump) **star:1773** Jump helps you navigate faster by learning your habits.   [![godoc][D]](https://godoc.org/github.com/gsamokovarov/jump)
- [boilr](https://github.com/tmrts/boilr) **star:1715** Blazingly fast CLI tool for creating projects from boilerplate templates.   [![godoc][D]](https://godoc.org/github.com/tmrts/boilr)
- [mole](https://github.com/davrodpin/mole) **star:1690** cli app to easily create ssh tunnels.   [![godoc][D]](https://godoc.org/github.com/davrodpin/mole)
- [Failsafe-go](https://github.com/failsafe-go/failsafe-go) **star:1587** Fault tolerance and resilience patterns for Go.   [![There was an update last month][G]](https://github.com/failsafe-go/failsafe-go)   [![godoc][D]](https://godoc.org/github.com/failsafe-go/failsafe-go)
- [mimetype](https://github.com/gabriel-vasile/mimetype) **star:1580** Package for MIME type detection based on magic numbers.   [![There was an update last month][G]](https://github.com/gabriel-vasile/mimetype)   [![godoc][D]](https://godoc.org/github.com/gabriel-vasile/mimetype)
- [gitbatch](https://github.com/isacikgoz/gitbatch) **star:1539** manage your git repositories in one place.   [![godoc][D]](https://godoc.org/github.com/isacikgoz/gitbatch)
- [gitcs](https://github.com/knbr13/gitcs/)  Git Commits Visualizer, CLI tool to visualize your Git commits on your local machine.
- [scany](https://github.com/georgysavva/scany) **star:1251** Library for scanning data from a database into Go structs and more.   [![godoc][D]](https://godoc.org/github.com/georgysavva/scany)
- [circuitbreaker](https://github.com/rubyist/circuitbreaker) **star:1122** Circuit Breakers in Go.   [![godoc][D]](https://godoc.org/github.com/rubyist/circuitbreaker)
- [hostctl](https://github.com/guumaster/hostctl) **star:1056** A CLI tool to manage /etc/hosts with easy commands.   [![godoc][D]](https://godoc.org/github.com/guumaster/hostctl)
- [git-time-metric](https://github.com/git-time-metric/gtm) **star:970** Simple, seamless, lightweight time tracking for Git.   [![godoc][D]](https://godoc.org/github.com/git-time-metric/gtm)
- [upterm](https://github.com/owenthereal/upterm) **star:819** A tool for developers to share terminal/tmux sessions securely over the web. It’s perfect for remote pair programming, accessing computers behind NATs/firewalls, remote debugging, and more.   [![There was an update last month][G]](https://github.com/owenthereal/upterm)   [![godoc][D]](https://godoc.org/github.com/owenthereal/upterm)
- [immortal](https://github.com/immortal/immortal) **star:799** \*nix cross-platform (OS agnostic) supervisor.   [![godoc][D]](https://godoc.org/github.com/immortal/immortal)
- [circuit](https://github.com/cep21/circuit) **star:754** An efficient and feature complete Hystrix like Go implementation of the circuit breaker pattern.   [![godoc][D]](https://godoc.org/github.com/cep21/circuit)
- [changie](https://github.com/miniscruff/changie) **star:645** Automated changelog tool for preparing releases with lots of customization options.   [![There was an update last month][G]](https://github.com/miniscruff/changie)   [![godoc][D]](https://godoc.org/github.com/miniscruff/changie)
- [clockwork](https://github.com/jonboulle/clockwork) **star:636** A simple fake clock for golang.   [![godoc][D]](https://godoc.org/github.com/jonboulle/clockwork)
- [delve](https://github.com/derekparker/delve) **star:633** Go debugger.   [![godoc][D]](https://godoc.org/github.com/derekparker/delve)
- [ergo](https://github.com/cristianoliveira/ergo) **star:621** The management of multiple local services running over different ports made easy.   [![godoc][D]](https://godoc.org/github.com/cristianoliveira/ergo)
- [clipboard](https://github.com/golang-design/clipboard) **star:574** 📋 cross-platform clipboard package in Go.   [![godoc][D]](https://godoc.org/github.com/golang-design/clipboard)
- [htcat](https://github.com/htcat/htcat) **star:555** Parallel and Pipelined HTTP GET Utility.   [![It hasn't been updated in recent three years][Y]](https://github.com/htcat/htcat)   [![godoc][D]](https://godoc.org/github.com/htcat/htcat)
- [scan](https://github.com/blockloop/scan) **star:544** Scan golang `sql.Rows` directly to structs, slices, or primitive types.   [![godoc][D]](https://godoc.org/github.com/blockloop/scan)
- [koazee](https://github.com/wesovilabs/koazee) **star:525** Library inspired in Lazy evaluation and functional programming that takes the hassle out of working with arrays.   [![It hasn't been updated in recent three years][Y]](https://github.com/wesovilabs/koazee)   [![godoc][D]](https://godoc.org/github.com/wesovilabs/koazee)
- [remote-touchpad](https://github.com/Unrud/remote-touchpad) **star:506** Control mouse and keyboard from a smartphone.   [![godoc][D]](https://godoc.org/github.com/Unrud/remote-touchpad)
- [godaemon](https://github.com/VividCortex/godaemon) **star:493** Utility to write daemons.   [![It hasn't been updated in recent three years][Y]](https://github.com/VividCortex/godaemon)   [![godoc][D]](https://godoc.org/github.com/VividCortex/godaemon)
- [go-dry](https://github.com/ungerik/go-dry) **star:491** DRY (don't repeat yourself) package for Go.   [![godoc][D]](https://godoc.org/github.com/ungerik/go-dry)
- [gubrak](https://github.com/novalagung/gubrak) **star:480** Golang utility library with syntactic sugar. It's like lodash, but for golang.   [![godoc][D]](https://godoc.org/github.com/novalagung/gubrak)
- [gopencils](https://github.com/bndr/gopencils) **star:452** Small and simple package to easily consume REST APIs.   [![It hasn't been updated in recent three years][Y]](https://github.com/bndr/gopencils)   [![godoc][D]](https://godoc.org/github.com/bndr/gopencils)
- [Deepcopier](https://github.com/ulule/deepcopier) **star:448** Simple struct copying for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/ulule/deepcopier)   [![godoc][D]](https://godoc.org/github.com/ulule/deepcopier)
- [mani](https://github.com/alajmo/mani) **star:431** CLI tool to help you manage multiple repositories.   [![godoc][D]](https://godoc.org/github.com/alajmo/mani)
- [request](https://github.com/mozillazg/request) **star:427** Go HTTP Requests for Humans™.   [![It hasn't been updated in recent three years][Y]](https://github.com/mozillazg/request)   [![godoc][D]](https://godoc.org/github.com/mozillazg/request)
- [go-rate](https://github.com/beefsack/go-rate) **star:396** Timed rate limiter for Go.   [![godoc][D]](https://godoc.org/github.com/beefsack/go-rate)
- [limiters](https://github.com/mennanov/limiters) **star:385** Rate limiters for distributed applications in Golang with configurable back-ends and distributed locks.   [![There was an update last month][G]](https://github.com/mennanov/limiters)   [![godoc][D]](https://godoc.org/github.com/mennanov/limiters)
- [countries](https://github.com/biter777/countries) **star:383** Full implementation of ISO-3166-1, ISO-4217, ITU-T E.164, Unicode CLDR and IANA ccTLD standards.   [![godoc][D]](https://godoc.org/github.com/biter777/countries)
- [grofer](https://github.com/pesos/grofer) **star:344** A system and resource monitoring tool written in Golang!   [![godoc][D]](https://godoc.org/github.com/pesos/grofer)
- [retry](https://github.com/kamilsk/retry) **star:335** The most advanced functional mechanism to perform actions repetitively until successful.   [![godoc][D]](https://godoc.org/github.com/kamilsk/retry)
- [serve](https://github.com/syntaqx/serve) **star:332** A static http server anywhere you need.   [![godoc][D]](https://godoc.org/github.com/syntaqx/serve)
- [config-file-validator](https://github.com/Boeing/config-file-validator) **star:308** Cross Platform tool to validate configuration files.   [![There was an update last month][G]](https://github.com/Boeing/config-file-validator)   [![godoc][D]](https://godoc.org/github.com/Boeing/config-file-validator)
- [rospo](https://github.com/ferama/rospo) **star:298** Simple and reliable ssh tunnels with embedded ssh server in Golang.   [![There was an update last month][G]](https://github.com/ferama/rospo)   [![godoc][D]](https://godoc.org/github.com/ferama/rospo)
- [gotenv](https://github.com/subosito/gotenv) **star:294** Load environment variables from `.env` or any `io.Reader` in Go.   [![godoc][D]](https://godoc.org/github.com/subosito/gotenv)
- [util](https://github.com/shomali11/util) **star:289** Collection of useful utility functions. (strings, concurrency, manipulations, ...).   [![godoc][D]](https://godoc.org/github.com/shomali11/util)
- [wifiqr](https://github.com/reugn/wifiqr) **star:260** Wi-Fi QR Code Generator.   [![godoc][D]](https://godoc.org/github.com/reugn/wifiqr)
- [gohper](https://github.com/cosiner/gohper) **star:255** Various tools/modules help for development.   [![It hasn't been updated in recent three years][Y]](https://github.com/cosiner/gohper)   [![godoc][D]](https://godoc.org/github.com/cosiner/gohper)   [![Archived][Archived]](https://github.com/cosiner/gohper)
- [go-trigger](https://github.com/sadlil/go-trigger) **star:246** Go-lang global event triggerer, Register Events with an id and trigger the event from anywhere from your project.   [![It hasn't been updated in recent three years][Y]](https://github.com/sadlil/go-trigger)   [![godoc][D]](https://godoc.org/github.com/sadlil/go-trigger)
- [pattern-match](https://github.com/alexpantyukhin/go-pattern-match) **star:244** Pattern matching library.   [![godoc][D]](https://godoc.org/github.com/alexpantyukhin/go-pattern-match)
- [go-sitemap-generator](https://github.com/ikeikeikeike/go-sitemap-generator) **star:217** XML Sitemap generator written in Go.   [![godoc][D]](https://godoc.org/github.com/ikeikeikeike/go-sitemap-generator)
- [Death](https://github.com/vrecan/death) **star:196** Managing go application shutdown with signals.   [![godoc][D]](https://godoc.org/github.com/vrecan/death)
- [toolbox](https://github.com/viant/toolbox) **star:196** Slice, map, multimap, struct, function, data conversion utilities. Service router, macro evaluator, tokenizer.   [![godoc][D]](https://godoc.org/github.com/viant/toolbox)
- [go-bind-plugin](https://github.com/wendigo/go-bind-plugin) **star:184** go:generate tool for wrapping symbols exported by golang plugins (1.8 only).   [![It hasn't been updated in recent three years][Y]](https://github.com/wendigo/go-bind-plugin)   [![godoc][D]](https://godoc.org/github.com/wendigo/go-bind-plugin)
- [moldova](https://github.com/StabbyCutyou/moldova) **star:168** Utility for generating random data based on an input template.   [![It hasn't been updated in recent three years][Y]](https://github.com/StabbyCutyou/moldova)   [![godoc][D]](https://godoc.org/github.com/StabbyCutyou/moldova)
- [rerun](https://github.com/ivpusic/rerun) **star:167** Recompiling and rerunning go apps when source changes.   [![It hasn't been updated in recent three years][Y]](https://github.com/ivpusic/rerun)   [![godoc][D]](https://godoc.org/github.com/ivpusic/rerun)
- [apm](https://github.com/topfreegames/apm) **star:166** Process manager for Golang applications with an HTTP API.   [![It hasn't been updated in recent three years][Y]](https://github.com/topfreegames/apm)   [![godoc][D]](https://godoc.org/github.com/topfreegames/apm)
- [go-bsdiff](https://github.com/gabstv/go-bsdiff) **star:162** Pure Go bsdiff and bspatch libraries and CLI tools.   [![It hasn't been updated in recent three years][Y]](https://github.com/gabstv/go-bsdiff)   [![godoc][D]](https://godoc.org/github.com/gabstv/go-bsdiff)
- [robustly](https://github.com/VividCortex/robustly) **star:157** Runs functions resiliently, catching and restarting panics.   [![godoc][D]](https://godoc.org/github.com/VividCortex/robustly)
- [chyle](https://github.com/antham/chyle) **star:155** Changelog generator using a git repository with multiple configuration possibilities.   [![godoc][D]](https://godoc.org/github.com/antham/chyle)
- [cmd](https://github.com/SimonBaeumer/cmd) **star:154** Library for executing shell commands on osx, windows and linux.   [![godoc][D]](https://godoc.org/github.com/SimonBaeumer/cmd)
- [cryptgo](https://github.com/Gituser143/cryptgo) **star:153** Crytpgo is a TUI based application written purely in Go to monitor and observe cryptocurrency prices in real time!   [![godoc][D]](https://godoc.org/github.com/Gituser143/cryptgo)
- [goval](https://github.com/maja42/goval) **star:152** Evaluate arbitrary expressions in Go.   [![godoc][D]](https://godoc.org/github.com/maja42/goval)
- [filter](https://github.com/gookit/filter) **star:149** provide filtering, sanitizing, and conversion of Go data.   [![godoc][D]](https://godoc.org/github.com/gookit/filter)
- [nostromo](https://github.com/pokanop/nostromo) **star:141** CLI for building powerful aliases.   [![godoc][D]](https://godoc.org/github.com/pokanop/nostromo)
- [onecache](https://github.com/adelowo/onecache) **star:134** Caching library with support for multiple backend stores (Redis, Memcached, filesystem etc).   [![It hasn't been updated in recent three years][Y]](https://github.com/adelowo/onecache)   [![godoc][D]](https://godoc.org/github.com/adelowo/onecache)
- [sorty](https://github.com/jfcg/sorty) **star:132** Fast Concurrent / Parallel Sorting.   [![godoc][D]](https://godoc.org/github.com/jfcg/sorty)
- [mongo-go-pagination](https://github.com/gobeam/mongo-go-pagination) **star:130** Mongodb Pagination for official mongodb/mongo-go-driver package which supports both normal queries and Aggregation pipelines.   [![godoc][D]](https://godoc.org/github.com/gobeam/mongo-go-pagination)
- [lrserver](https://github.com/jaschaephraim/lrserver) **star:125** LiveReload server for Go.
- [go-lock](https://github.com/viney-shih/go-lock) **star:114** go-lock is a lock library implementing read-write mutex and read-write trylock without starvation.   [![godoc][D]](https://godoc.org/github.com/viney-shih/go-lock)
- [goseaweedfs](https://github.com/linxGnu/goseaweedfs) **star:114** SeaweedFS client library with almost full features.   [![godoc][D]](https://godoc.org/github.com/linxGnu/goseaweedfs)
- [cookie](https://github.com/syntaqx/cookie) **star:110** Cookie struct parsing and helper package.   [![godoc][D]](https://godoc.org/github.com/syntaqx/cookie)
- [mssqlx](https://github.com/linxGnu/mssqlx) **star:102** Database client library, proxy for any master slave, master master structures. Lightweight and auto balancing in mind.   [![godoc][D]](https://godoc.org/github.com/linxGnu/mssqlx)
- [xferspdy](https://github.com/monmohan/xferspdy) **star:100** Xferspdy provides binary diff and patch library in golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/monmohan/xferspdy)   [![godoc][D]](https://godoc.org/github.com/monmohan/xferspdy)
- [mimemagic](https://github.com/zRedShift/mimemagic) **star:99** Pure Go ultra performant MIME sniffing library/utility.   [![godoc][D]](https://godoc.org/github.com/zRedShift/mimemagic)
- [go-health](https://github.com/Talento90/go-health) **star:95** Health package simplifies the way you add health check to your services.   [![godoc][D]](https://godoc.org/github.com/Talento90/go-health)
- [go-pattern-match](https://github.com/PhakornKiong/go-pattern-match) **star:91** A Pattern matching library inspired by ts-pattern.   [![godoc][D]](https://godoc.org/github.com/PhakornKiong/go-pattern-match)
- [go-lambda-cleanup](https://github.com/karl-cardenas-coding/go-lambda-cleanup) **star:90** A CLI for removing unused or previous versions of AWS Lambdas.   [![godoc][D]](https://godoc.org/github.com/karl-cardenas-coding/go-lambda-cleanup)
- [countries](https://github.com/pioz/countries) **star:86** All you need when you are working with countries in Go.   [![godoc][D]](https://godoc.org/github.com/pioz/countries)
- [pgo](https://github.com/arthurkushman/pgo) **star:86** Convenient functions for PHP community.   [![godoc][D]](https://godoc.org/github.com/arthurkushman/pgo)
- [repeat](https://github.com/ssgreg/repeat) **star:86** Go implementation of different backoff strategies useful for retrying operations and heartbeating.   [![It hasn't been updated in recent three years][Y]](https://github.com/ssgreg/repeat)   [![godoc][D]](https://godoc.org/github.com/ssgreg/repeat)
- [equalizer](https://github.com/reugn/equalizer) **star:81** Quota manager and rate limiter collection for Go.   [![godoc][D]](https://godoc.org/github.com/reugn/equalizer)
- [handy](https://github.com/miguelpragier/handy) **star:81** Many utilities and helpers like string handlers/formatters and validators.   [![It hasn't been updated in recent three years][Y]](https://github.com/miguelpragier/handy)   [![godoc][D]](https://godoc.org/github.com/miguelpragier/handy)
- [pm](https://github.com/VividCortex/pm) **star:80** Process (i.e. goroutine) manager with an HTTP API.   [![godoc][D]](https://godoc.org/github.com/VividCortex/pm)
- [netbug](https://github.com/e-dard/netbug) **star:73** Easy remote profiling of your services.   [![It hasn't been updated in recent three years][Y]](https://github.com/e-dard/netbug)   [![godoc][D]](https://godoc.org/github.com/e-dard/netbug)
- [multitick](https://github.com/VividCortex/multitick) **star:70** Multiplexor for aligned tickers.   [![godoc][D]](https://godoc.org/github.com/VividCortex/multitick)
- [UNIS](https://github.com/esemplastic/unis) **star:70** Common Architecture™ for String Utilities in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/esemplastic/unis)   [![godoc][D]](https://godoc.org/github.com/esemplastic/unis)
- [goreadability](https://github.com/philipjkim/goreadability) **star:69** Webpage summary extractor using Facebook Open Graph and arc90's readability.   [![It hasn't been updated in recent three years][Y]](https://github.com/philipjkim/goreadability)   [![godoc][D]](https://godoc.org/github.com/philipjkim/goreadability)
- [retry](https://github.com/thedevsaddam/retry) **star:65** Simple and easy retry mechanism package for Go.   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/retry)
- [backscanner](https://github.com/icza/backscanner) **star:64** A scanner similar to bufio.Scanner, but it reads and returns lines in reverse order, starting at a given position and going backward.   [![godoc][D]](https://godoc.org/github.com/icza/backscanner)
- [go-astitodo](https://github.com/asticode/go-astitodo) **star:63** Parse TODOs in your GO code.   [![godoc][D]](https://godoc.org/github.com/asticode/go-astitodo)
- [minquery](https://github.com/icza/minquery) **star:62** MongoDB / mgo.v2 query that supports efficient pagination (cursors to continue listing documents where we left off).   [![godoc][D]](https://godoc.org/github.com/icza/minquery)
- [scan](https://github.com/wroge/scan) **star:62** Scan sql rows into any type powered by generics.   [![godoc][D]](https://godoc.org/github.com/wroge/scan)
- [dbt](https://github.com/nikogura/dbt) **star:61** A framework for running self-updating signed binaries from a central, trusted repository.   [![godoc][D]](https://godoc.org/github.com/nikogura/dbt)
- [golog](https://github.com/mlimaloureiro/golog) **star:61** Easy and lightweight CLI tool to time track your tasks.   [![It hasn't been updated in recent three years][Y]](https://github.com/mlimaloureiro/golog)   [![godoc][D]](https://godoc.org/github.com/mlimaloureiro/golog)
- [shutdown](https://github.com/ztrue/shutdown) **star:58** App shutdown hooks for `os.Signal` handling.   [![godoc][D]](https://godoc.org/github.com/ztrue/shutdown)
- [beyond](https://github.com/wesovilabs/beyond) **star:55** The Go tool that will drive you to the AOP world!   [![godoc][D]](https://godoc.org/github.com/wesovilabs/beyond)
- [golarm](https://github.com/msempere/golarm) **star:53** Fire alarms with system events.   [![It hasn't been updated in recent three years][Y]](https://github.com/msempere/golarm)   [![godoc][D]](https://godoc.org/github.com/msempere/golarm)
- [slice](https://github.com/psampaz/slice) **star:51** Type-safe functions for common Go slice operations.   [![It hasn't been updated in recent three years][Y]](https://github.com/psampaz/slice)   [![godoc][D]](https://godoc.org/github.com/psampaz/slice)
- [copy-pasta](https://github.com/jutkko/copy-pasta) **star:50** Universal multi-workstation clipboard that uses S3 like backend for the storage.   [![It hasn't been updated in recent three years][Y]](https://github.com/jutkko/copy-pasta)   [![godoc][D]](https://godoc.org/github.com/jutkko/copy-pasta)
- [goback](https://github.com/carlescere/goback) **star:49** Go simple exponential backoff package.   [![It hasn't been updated in recent three years][Y]](https://github.com/carlescere/goback)   [![godoc][D]](https://godoc.org/github.com/carlescere/goback)
- [copy](https://github.com/gotidy/copy) **star:48** Package for fast copying structs of different types.   [![It hasn't been updated in recent three years][Y]](https://github.com/gotidy/copy)   [![godoc][D]](https://godoc.org/github.com/gotidy/copy)
- [cvt](https://github.com/shockerli/cvt) **star:48** Easy and safe convert any value to another type.   [![godoc][D]](https://godoc.org/github.com/shockerli/cvt)   [![Contains Chinese documents][CN]](https://github.com/shockerli/cvt)
- [retry-go](https://github.com/rafaeljesus/retry-go) **star:48** Retrying made simple and easy for golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafaeljesus/retry-go)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/retry-go)
- [go-httpheader](https://github.com/mozillazg/go-httpheader) **star:47** Go library for encoding structs into Header fields.   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-httpheader)
- [intrinsic](https://github.com/mengzhuo/intrinsic) **star:47** Use x86 SIMD without writing any assembly code.   [![It hasn't been updated in recent three years][Y]](https://github.com/mengzhuo/intrinsic)   [![godoc][D]](https://godoc.org/github.com/mengzhuo/intrinsic)   [![Archived][Archived]](https://github.com/mengzhuo/intrinsic)
- [set](https://github.com/nofeaturesonlybugs/set) **star:46** Performant and flexible struct mapping and loose type conversion.   [![godoc][D]](https://godoc.org/github.com/nofeaturesonlybugs/set)
- [sshman](https://github.com/shoobyban/sshman) **star:46** SSH Manager for authorized_keys files on multiple remote servers.   [![godoc][D]](https://godoc.org/github.com/shoobyban/sshman)
- [gostrutils](https://github.com/ik5/gostrutils) **star:45** Collections of string manipulation and conversion functions.   [![godoc][D]](https://godoc.org/github.com/ik5/gostrutils)
- [slicer](https://github.com/leaanthony/slicer) **star:45** Makes working with slices easier.   [![It hasn't been updated in recent three years][Y]](https://github.com/leaanthony/slicer)   [![godoc][D]](https://godoc.org/github.com/leaanthony/slicer)
- [ghokin](https://github.com/antham/ghokin) **star:43** Parallelized formatter with no external dependencies for gherkin (cucumber, behat...).   [![There was an update last month][G]](https://github.com/antham/ghokin)   [![godoc][D]](https://godoc.org/github.com/antham/ghokin)
- [pointer](https://github.com/xorcare/pointer) **star:42** Package pointer contains helper routines for simplifying the creation of optional fields of basic type.   [![godoc][D]](https://godoc.org/github.com/xorcare/pointer)
- [yogo](https://github.com/antham/yogo) **star:41** Check yopmail mails from command line.   [![There was an update last month][G]](https://github.com/antham/yogo)
- [gpath](https://github.com/tenntenn/gpath) **star:40** Library to simplify access struct fields with Go's expression in reflection.   [![It hasn't been updated in recent three years][Y]](https://github.com/tenntenn/gpath)   [![godoc][D]](https://godoc.org/github.com/tenntenn/gpath)
- [evaluator](https://github.com/nullne/evaluator) **star:39** Evaluate an expression dynamically based on s-expression. It's simple and easy to extend.   [![godoc][D]](https://godoc.org/github.com/nullne/evaluator)
- [throttle](https://github.com/yudppp/throttle) **star:37** Throttle is an object that will perform exactly one action per duration.   [![It hasn't been updated in recent three years][Y]](https://github.com/yudppp/throttle)   [![godoc][D]](https://godoc.org/github.com/yudppp/throttle)
- [rclient](https://github.com/zpatrick/rclient) **star:35** Readable, flexible, simple-to-use client for REST APIs.   [![It hasn't been updated in recent three years][Y]](https://github.com/zpatrick/rclient)   [![godoc][D]](https://godoc.org/github.com/zpatrick/rclient)
- [tome](https://github.com/cyruzin/tome) **star:35** Tome was designed to paginate simple RESTful APIs.   [![godoc][D]](https://godoc.org/github.com/cyruzin/tome)
- [myhttp](https://github.com/inancgumus/myhttp) **star:34** Simple API to make HTTP GET requests with timeout support.   [![It hasn't been updated in recent three years][Y]](https://github.com/inancgumus/myhttp)   [![godoc][D]](https://godoc.org/github.com/inancgumus/myhttp)   [![Archived][Archived]](https://github.com/inancgumus/myhttp)
- [gofn](https://github.com/tiendc/gofn) **star:33** High performance utility functions written using Generics for Go 1.18+.   [![There was an update last month][G]](https://github.com/tiendc/gofn)   [![godoc][D]](https://godoc.org/github.com/tiendc/gofn)
- [mimesniffer](https://github.com/aofei/mimesniffer) **star:33** A MIME type sniffer for Go.   [![godoc][D]](https://godoc.org/github.com/aofei/mimesniffer)
- [watchhttp](https://github.com/nikolaydubina/watchhttp) **star:32** Run command periodically and expose latest STDOUT or its rich delta as HTTP endpoint.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/watchhttp)
- [generate](https://github.com/go-playground/generate) **star:30** runs go generate recursively on a specified path or environment variable and can filter by regex.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-playground/generate)   [![godoc][D]](https://godoc.org/github.com/go-playground/generate)
- [goplaceholder](https://github.com/michiwend/goplaceholder) **star:29** a small golang lib to generate placeholder images.   [![It hasn't been updated in recent three years][Y]](https://github.com/michiwend/goplaceholder)   [![godoc][D]](https://godoc.org/github.com/michiwend/goplaceholder)
- [just](https://github.com/kazhuravlev/just) **star:29** Just a collection of useful functions for working with generic data structures.   [![godoc][D]](https://godoc.org/github.com/kazhuravlev/just)
- [ptr](https://github.com/gotidy/ptr) **star:27** Package that provide functions for simplified creation of pointers from constants of basic types.   [![godoc][D]](https://godoc.org/github.com/gotidy/ptr)
- [ugo](https://github.com/alxrm/ugo) **star:27** ugo is slice toolbox with concise syntax for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/alxrm/ugo)   [![godoc][D]](https://godoc.org/github.com/alxrm/ugo)   [![Archived][Archived]](https://github.com/alxrm/ugo)
- [graterm](https://github.com/skovtunenko/graterm) **star:26** Provides primitives to perform ordered (sequential/concurrent) GRAceful TERMination (aka shutdown) in Go application.   [![godoc][D]](https://godoc.org/github.com/skovtunenko/graterm)
- [ctxutil](https://github.com/posener/ctxutil) **star:25** A collection of utility functions for contexts.   [![It hasn't been updated in recent three years][Y]](https://github.com/posener/ctxutil)   [![godoc][D]](https://godoc.org/github.com/posener/ctxutil)
- [structs](https://github.com/PumpkinSeed/structs) **star:24** Implement simple functions to manipulate structs.   [![It hasn't been updated in recent three years][Y]](https://github.com/PumpkinSeed/structs)   [![godoc][D]](https://godoc.org/github.com/PumpkinSeed/structs)
- [go-convert](https://github.com/Eun/go-convert) **star:23** Package go-convert enables you to convert a value into another type.   [![godoc][D]](https://godoc.org/github.com/Eun/go-convert)
- [go-qr](https://github.com/piglig/go-qr) **star:23** A native, high-quality and minimalistic QR code generator.   [![godoc][D]](https://godoc.org/github.com/piglig/go-qr)
- [jsend](https://github.com/clevergo/jsend) **star:22** JSend's implementation written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/clevergo/jsend)   [![godoc][D]](https://godoc.org/github.com/clevergo/jsend)
- [filler](https://github.com/yaronsumel/filler) **star:18** small utility to fill structs using "fill" tag.   [![It hasn't been updated in recent three years][Y]](https://github.com/yaronsumel/filler)   [![godoc][D]](https://godoc.org/github.com/yaronsumel/filler)
- [go-type](https://github.com/mikekonan/go-types) **star:18** Library providing Go types for store/validation and transfer of ISO-4217, ISO-3166, and other types.   [![godoc][D]](https://godoc.org/github.com/mikekonan/go-types)
- [dlog](https://github.com/kirillDanshin/dlog) **star:17** Compile-time controlled logger to make your release smaller without removing debug calls.   [![It hasn't been updated in recent three years][Y]](https://github.com/kirillDanshin/dlog)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/dlog)
- [go-problemdetails](https://github.com/mvmaasakkers/go-problemdetails) **star:17** Go package for working with Problem Details.   [![It hasn't been updated in recent three years][Y]](https://github.com/mvmaasakkers/go-problemdetails)   [![godoc][D]](https://godoc.org/github.com/mvmaasakkers/go-problemdetails)
- [contextplus](https://github.com/contextplus/contextplus) **star:16** Package contextplus provide more easy to use functions for contexts.   [![godoc][D]](https://godoc.org/github.com/contextplus/contextplus)
- [okrun](https://github.com/xta/okrun) **star:16** go run error steamroller.   [![It hasn't been updated in recent three years][Y]](https://github.com/xta/okrun)   [![godoc][D]](https://godoc.org/github.com/xta/okrun)
- [rest-go](https://github.com/edermanoel94/rest-go) **star:16** A package that provide many helpful methods for working with rest api.   [![It hasn't been updated in recent three years][Y]](https://github.com/edermanoel94/rest-go)   [![godoc][D]](https://godoc.org/github.com/edermanoel94/rest-go)
- [go-actuator](https://github.com/sinhashubham95/go-actuator) **star:15** Production ready features for Go based web frameworks.   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/go-actuator)
- [command](https://github.com/txgruppi/command) **star:14** Command pattern for Go with thread safe serial and parallel dispatcher.   [![It hasn't been updated in recent three years][Y]](https://github.com/txgruppi/command)   [![godoc][D]](https://godoc.org/github.com/txgruppi/command)   [![Archived][Archived]](https://github.com/txgruppi/command)
- [blank](https://github.com/Henry-Sarabia/blank) **star:13** Verify or remove blanks and whitespace from strings.   [![It hasn't been updated in recent three years][Y]](https://github.com/Henry-Sarabia/blank)   [![godoc][D]](https://godoc.org/github.com/Henry-Sarabia/blank)
- [go-clip](https://github.com/prashantgupta24/go-clip) **star:13** A minimalistic clipboard manager for Mac.   [![It hasn't been updated in recent three years][Y]](https://github.com/prashantgupta24/go-clip)   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/go-clip)
- [go-countries](https://github.com/mikekonan/go-countries) **star:13** Lightweight lookup over ISO-3166 codes.   [![It hasn't been updated in recent three years][Y]](https://github.com/mikekonan/go-countries)   [![godoc][D]](https://godoc.org/github.com/mikekonan/go-countries)
- [silk](https://github.com/chrispassas/silk) **star:13** Read silk netflow files.   [![godoc][D]](https://godoc.org/github.com/chrispassas/silk)
- [retry](https://github.com/shafreeck/retry) **star:12** A pretty simple library to ensure your work to be done.   [![It hasn't been updated in recent three years][Y]](https://github.com/shafreeck/retry)   [![godoc][D]](https://godoc.org/github.com/shafreeck/retry)
- [bleep](https://github.com/sinhashubham95/bleep) **star:11** Perform any number of actions on any set of OS signals in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/sinhashubham95/bleep)   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/bleep)
- [statiks](https://github.com/janiltonmaciel/statiks) **star:11** Fast, zero-configuration, static HTTP filer server.   [![It hasn't been updated in recent three years][Y]](https://github.com/janiltonmaciel/statiks)   [![godoc][D]](https://godoc.org/github.com/janiltonmaciel/statiks)
- [retry](https://github.com/percolate/retry) **star:10** A simple but highly configurable retry package for Go.
- [sliceconv](https://github.com/Henry-Sarabia/sliceconv) **star:10** Slice conversion between primitive types.   [![It hasn't been updated in recent three years][Y]](https://github.com/Henry-Sarabia/sliceconv)   [![godoc][D]](https://godoc.org/github.com/Henry-Sarabia/sliceconv)
- [goctx](https://github.com/zerosnake0/goctx) **star:9** Get your context value with high performance.   [![It hasn't been updated in recent three years][Y]](https://github.com/zerosnake0/goctx)   [![godoc][D]](https://godoc.org/github.com/zerosnake0/goctx)
- [loncha](https://github.com/kazu/loncha) **star:9** A high-performance slice Utilities.   [![godoc][D]](https://godoc.org/github.com/kazu/loncha)
- [nfdump](https://github.com/chrispassas/nfdump) **star:9** Read nfdump netflow files.   [![godoc][D]](https://godoc.org/github.com/chrispassas/nfdump)
- [lets-go](https://github.com/aplescia-chwy/lets-go) **star:7** Go module that provides common utilities for Cloud Native REST API development. Also contains AWS Specific utilities.   [![It hasn't been updated in recent three years][Y]](https://github.com/aplescia-chwy/lets-go)   [![godoc][D]](https://godoc.org/github.com/aplescia-chwy/lets-go)
- [reflectutils](https://github.com/muir/reflectutils) **star:7** Helpers for working with reflection: struct tag parsing; recursive walking; fill value from string.   [![godoc][D]](https://godoc.org/github.com/muir/reflectutils)
- [go-pkg](https://github.com/chenquan/go-pkg) **star:6** A go toolkit.   [![godoc][D]](https://godoc.org/github.com/chenquan/go-pkg)   [![Contains Chinese documents][CN]](https://github.com/chenquan/go-pkg)
- [olaf](https://github.com/btnguyen2k/olaf) **star:6** Twitter Snowflake implemented in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/btnguyen2k/olaf)   [![godoc][D]](https://godoc.org/github.com/btnguyen2k/olaf)
- [tik](https://github.com/andy2046/tik) **star:5** Simple and easy timing wheel package for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/andy2046/tik)   [![godoc][D]](https://godoc.org/github.com/andy2046/tik)
- [objwalker](https://github.com/rekby/objwalker) **star:2** Walk by go objects with reflection.   [![godoc][D]](https://godoc.org/github.com/rekby/objwalker)

**[⬆ back to top](#contents)**

## UUID

_Libraries for working with UUIDs._

- [uuid](https://github.com/google/uuid) **star:5202** Go package for UUIDs based on RFC 4122 and DCE 1.1: Authentication and Security Services.   [![There was an update last month][G]](https://github.com/google/uuid)   [![godoc][D]](https://godoc.org/github.com/google/uuid)
- [ulid](https://github.com/oklog/ulid) **star:4393** Go implementation of ULID (Universally Unique Lexicographically Sortable Identifier).   [![godoc][D]](https://godoc.org/github.com/oklog/ulid)
- [uniq](https://gitlab.com/skilstak/code/go/uniq)  No hassle safe, fast unique identifiers with commands.
- [xid](https://github.com/rs/xid) **star:3835** Xid is a globally unique id generator library, ready to be safely used directly in your server code.   [![There was an update last month][G]](https://github.com/rs/xid)   [![godoc][D]](https://godoc.org/github.com/rs/xid)
- [uuid](https://github.com/gofrs/uuid) **star:1556** Implementation of Universally Unique Identifier (UUID). Supports both creation and parsing of UUIDs. Actively maintained fork of satori uuid.   [![There was an update last month][G]](https://github.com/gofrs/uuid)   [![godoc][D]](https://godoc.org/github.com/gofrs/uuid)
- [wuid](https://github.com/edwingeng/wuid) **star:530** An extremely fast globally unique number generator.   [![godoc][D]](https://godoc.org/github.com/edwingeng/wuid)
- [sno](https://github.com/muyo/sno) **star:90** Compact, sortable and fast unique IDs with embedded metadata.   [![godoc][D]](https://godoc.org/github.com/muyo/sno)
- [nanoid](https://github.com/aidarkhanov/nanoid) **star:61** A tiny and efficient Go unique string ID generator.   [![godoc][D]](https://godoc.org/github.com/aidarkhanov/nanoid)   [![Archived][Archived]](https://github.com/aidarkhanov/nanoid)
- [goid](https://github.com/jakehl/goid) **star:41** Generate and Parse RFC4122 compliant V4 UUIDs.   [![It hasn't been updated in recent three years][Y]](https://github.com/jakehl/goid)   [![godoc][D]](https://godoc.org/github.com/jakehl/goid)
- [gouid](https://github.com/twharmon/gouid) **star:23** Generate cryptographically secure random string IDs with just one allocation.   [![godoc][D]](https://godoc.org/github.com/twharmon/gouid)
- [uuid](https://github.com/agext/uuid) **star:18** Generate, encode, and decode UUIDs v1 with fast or cryptographic-quality random node identifier.   [![It hasn't been updated in recent three years][Y]](https://github.com/agext/uuid)   [![godoc][D]](https://godoc.org/github.com/agext/uuid)

**[⬆ back to top](#contents)**

## Validation

_Libraries for validation._

- [govalidator](https://github.com/asaskevich/govalidator) **star:5990** Validators and sanitizers for strings, numerics, slices and structs.   [![godoc][D]](https://godoc.org/github.com/asaskevich/govalidator)
- [govalidator](https://github.com/thedevsaddam/govalidator) **star:1304** Validate Golang request data with simple rules. Highly inspired by Laravel's request validation.   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/govalidator)
- [checkdigit](https://github.com/osamingo/checkdigit) **star:111** Provide check digit algorithms (Luhn, Verhoeff, Damm) and calculators (ISBN, EAN, JAN, UPC, etc.).   [![godoc][D]](https://godoc.org/github.com/osamingo/checkdigit)
- [gody](https://github.com/guiferpa/gody) **star:68** :balloon: A lightweight struct validator for Go.   [![godoc][D]](https://godoc.org/github.com/guiferpa/gody)
- [govalid](https://github.com/twharmon/govalid) **star:40** Fast, tag-based validation for structs.   [![godoc][D]](https://godoc.org/github.com/twharmon/govalid)
- [go-validator](https://github.com/tiendc/go-validator) **star:8** Validation library using Generics.   [![There was an update last month][G]](https://github.com/tiendc/go-validator)   [![godoc][D]](https://godoc.org/github.com/tiendc/go-validator)
- [hvalid](https://github.com/lyonnee/hvalid) hvalid is a lightweight validation library written in Go language. It provides a custom validator interface and a series of common validation functions to help developers quickly implement data validation.
- [validator](https://github.com/go-playground/validator) **star:16291** Go Struct and Field validation, including Cross Field, Cross Struct, Map, Slice and Array diving.   [![There was an update last month][G]](https://github.com/go-playground/validator)   [![godoc][D]](https://godoc.org/github.com/go-playground/validator)
- [ozzo-validation](https://github.com/go-ozzo/ozzo-validation) **star:3664** Supports validation of various data types (structs, strings, maps, slices, etc.) with configurable and extensible validation rules specified in usual code constructs instead of struct tags.   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-validation)
- [validate](https://github.com/gookit/validate) **star:1041** Go package for data validation and filtering. support validate Map, Struct, Request(Form, JSON, url.Values, Uploaded Files) data and more features.   [![godoc][D]](https://godoc.org/github.com/gookit/validate)   [![Contains Chinese documents][CN]](https://github.com/gookit/validate)
- [jio](https://github.com/faceair/jio) **star:109** jio is a json schema validator similar to [joi](https://github.com/hapijs/joi).   [![godoc][D]](https://godoc.org/github.com/faceair/jio)   [![Contains Chinese documents][CN]](https://github.com/faceair/jio)
- [validate](https://github.com/gobuffalo/validate) **star:95** This package provides a framework for writing validations for Go applications.   [![godoc][D]](https://godoc.org/github.com/gobuffalo/validate)
- [Validator](https://github.com/go-the-way/validator) **star:7** A lightweight model validator written in Go.Contains VFs:Min, Max, MinLength, MaxLength, Length, Enum, Regex.   [![godoc][D]](https://godoc.org/github.com/go-the-way/validator)
- [valix](https://github.com/marrow16/valix) Go package for validating requests

**[⬆ back to top](#contents)**

## Version Control

_Libraries for version control._

- [go-git](https://github.com/go-git/go-git) **star:5753** highly extensible Git implementation in pure Go.   [![There was an update last month][G]](https://github.com/go-git/go-git)   [![godoc][D]](https://godoc.org/github.com/go-git/go-git)
- [hercules](https://github.com/src-d/hercules) **star:2198** gaining advanced insights from Git repository history.   [![godoc][D]](https://godoc.org/github.com/src-d/hercules)
- [git2go](https://github.com/libgit2/git2go) **star:1924** Go bindings for libgit2.   [![godoc][D]](https://godoc.org/github.com/libgit2/git2go)
- [githooks](https://github.com/gabyx/githooks) **star:103** Per-repo and shared Git hooks with version control and auto update.   [![godoc][D]](https://godoc.org/github.com/gabyx/githooks)
- [gh](https://github.com/rjeczalik/gh) **star:82** Scriptable server and net/http middleware for GitHub Webhooks.   [![It hasn't been updated in recent three years][Y]](https://github.com/rjeczalik/gh)   [![godoc][D]](https://godoc.org/github.com/rjeczalik/gh)
- [go-vcs](https://github.com/sourcegraph/go-vcs) **star:80** manipulate and inspect VCS repositories in Go.   [![godoc][D]](https://godoc.org/github.com/sourcegraph/go-vcs)
- [froggit-go](https://github.com/jfrog/froggit-go) **star:45** Froggit-Go is a Go library, allowing to perform actions on VCS providers.   [![godoc][D]](https://godoc.org/github.com/jfrog/froggit-go)
- [hgo](https://github.com/beyang/hgo) **star:17** Hgo is a collection of Go packages providing read-access to local Mercurial repositories.   [![It hasn't been updated in recent three years][Y]](https://github.com/beyang/hgo)   [![godoc][D]](https://godoc.org/github.com/beyang/hgo)
- [cli](https://gitlab.com/gitlab-org/cli)  An open-source GitLab command line tool bringing GitLab's cool features to your command line.

**[⬆ back to top](#contents)**

## Video

_Libraries for manipulating video._

- [goav](https://github.com/giorgisio/goav) **star:2084** Comprehensive Go bindings for FFmpeg.   [![godoc][D]](https://godoc.org/github.com/giorgisio/goav)
- [m3u8](https://github.com/grafov/m3u8) **star:1209** Parser and generator library of M3U8 playlists for Apple HLS.   [![godoc][D]](https://godoc.org/github.com/grafov/m3u8)
- [gmf](https://github.com/3d0c/gmf) **star:884** Go bindings for FFmpeg av\* libraries.   [![godoc][D]](https://godoc.org/github.com/3d0c/gmf)
- [gortsplib](https://github.com/aler9/gortsplib) **star:650** Pure Go RTSP server and client library.   [![There was an update last month][G]](https://github.com/aler9/gortsplib)   [![godoc][D]](https://godoc.org/github.com/aler9/gortsplib)
- [go-astisub](https://github.com/asticode/go-astisub) **star:565** Manipulate subtitles in GO (.srt, .stl, .ttml, .webvtt, .ssa/.ass, teletext, .smi, etc.).   [![godoc][D]](https://godoc.org/github.com/asticode/go-astisub)
- [go-astits](https://github.com/asticode/go-astits) **star:537** Parse and demux MPEG Transport Streams (.ts) natively in GO.   [![godoc][D]](https://godoc.org/github.com/asticode/go-astits)
- [libvlc-go](https://github.com/adrg/libvlc-go) **star:421** Go bindings for libvlc 2.X/3.X/4.X (used by the VLC media player).   [![godoc][D]](https://godoc.org/github.com/adrg/libvlc-go)
- [go-astiav](https://github.com/asticode/go-astiav) **star:230** Better C bindings for ffmpeg in GO.   [![godoc][D]](https://godoc.org/github.com/asticode/go-astiav)
- [gst](https://github.com/ziutek/gst) **star:168** Go bindings for GStreamer.   [![It hasn't been updated in recent three years][Y]](https://github.com/ziutek/gst)   [![godoc][D]](https://godoc.org/github.com/ziutek/gst)
- [v4l](https://github.com/korandiz/v4l) **star:79** Video capture library for Linux, written in Go.   [![godoc][D]](https://godoc.org/github.com/korandiz/v4l)
- [go-m3u8](https://github.com/etherlabsio/go-m3u8) **star:29** Parser and generator library for Apple m3u8 playlists. Actively maintained version of quangngotan95/go-m3u8 with improvements and latest HLS playlist parsing compatibility.   [![godoc][D]](https://godoc.org/github.com/etherlabsio/go-m3u8)
- [libgosubs](https://github.com/wargarblgarbl/libgosubs) **star:26** Subtitle format support for go. Supports .srt, .ttml, and .ass.   [![It hasn't been updated in recent three years][Y]](https://github.com/wargarblgarbl/libgosubs)   [![godoc][D]](https://godoc.org/github.com/wargarblgarbl/libgosubs)
- [go-mpd](https://github.com/unki2aut/go-mpd) **star:23** Parser and generator library for MPEG-DASH manifest files.   [![godoc][D]](https://godoc.org/github.com/unki2aut/go-mpd)

**[⬆ back to top](#contents)**

## Web Frameworks

_Full stack web frameworks._

- [Gin](https://github.com/gin-gonic/gin) **star:77379** Gin is a web framework written in Go! It features a martini-like API with much better performance, up to 40 times faster. If you need performance and good productivity.   [![There was an update last month][G]](https://github.com/gin-gonic/gin)   [![godoc][D]](https://godoc.org/github.com/gin-gonic/gin)
- [Fiber](https://github.com/gofiber/fiber) **star:32568** An Express.js inspired web framework build on Fasthttp.   [![There was an update last month][G]](https://github.com/gofiber/fiber)   [![godoc][D]](https://godoc.org/github.com/gofiber/fiber)
- [Beego](https://github.com/beego/beego) **star:31309** beego is an open-source, high-performance web framework for the Go programming language.   [![There was an update last month][G]](https://github.com/beego/beego)   [![godoc][D]](https://godoc.org/github.com/beego/beego)
- [Buffalo](https://gobuffalo.io)  Bringing the productivity of Rails to Go!
- [Confetti Framework](https://confetti-framework.github.io/docs/)  Confetti is a Go web application framework with an expressive, elegant syntax. Confetti combines the elegance of Laravel and the simplicity of Go.
- [Echo](https://github.com/labstack/echo) **star:29211** High performance, minimalist Go web framework.   [![There was an update last month][G]](https://github.com/labstack/echo)   [![godoc][D]](https://godoc.org/github.com/labstack/echo)
- [Revel](https://github.com/revel/revel) **star:13137** High-productivity web framework for the Go language.   [![godoc][D]](https://godoc.org/github.com/revel/revel)
- [GoFrame](https://github.com/gogf/gf) **star:11243** GoFrame is a modular, powerful, high-performance and enterprise-class application development framework of Golang.   [![There was an update last month][G]](https://github.com/gogf/gf)   [![godoc][D]](https://godoc.org/github.com/gogf/gf)
- [Goa](https://github.com/goadesign/goa) **star:5582** Goa provides a holistic approach for developing remote APIs and microservices in Go.   [![There was an update last month][G]](https://github.com/goadesign/goa)   [![godoc][D]](https://godoc.org/github.com/goadesign/goa)
- [Hertz](https://github.com/cloudwego/hertz) **star:4946** A high-performance and strong-extensibility Go HTTP framework that helps developers build microservices.   [![There was an update last month][G]](https://github.com/cloudwego/hertz)   [![godoc][D]](https://godoc.org/github.com/cloudwego/hertz)   [![Contains Chinese documents][CN]](https://github.com/cloudwego/hertz)
- [Gizmo](https://github.com/NYTimes/gizmo) **star:3764** Microservice toolkit used by the New York Times.   [![godoc][D]](https://godoc.org/github.com/NYTimes/gizmo)
- [go-json-rest](https://github.com/ant0ine/go-json-rest) **star:3514** Quick and easy way to setup a RESTful JSON API.   [![It hasn't been updated in recent three years][Y]](https://github.com/ant0ine/go-json-rest)   [![godoc][D]](https://godoc.org/github.com/ant0ine/go-json-rest)
- [Macaron](https://github.com/go-macaron/macaron) **star:3495** Macaron is a high productive and modular design web framework in Go.   [![godoc][D]](https://godoc.org/github.com/go-macaron/macaron)
- [utron](https://github.com/gernest/utron) **star:2216** Lightweight MVC framework for Go(Golang).   [![It hasn't been updated in recent three years][Y]](https://github.com/gernest/utron)   [![godoc][D]](https://godoc.org/github.com/gernest/utron)   [![Archived][Archived]](https://github.com/gernest/utron)
- [Goyave](https://github.com/go-goyave/goyave) **star:1568** Feature-complete REST API framework aimed at clean code and fast development, with powerful built-in functionalities.   [![godoc][D]](https://godoc.org/github.com/go-goyave/goyave)
- [GoFr](https://github.com/gofr-dev/gofr) **star:1548** Gofr is an opinionated microservice development framework.   [![There was an update last month][G]](https://github.com/gofr-dev/gofr)   [![godoc][D]](https://godoc.org/github.com/gofr-dev/gofr)
- [REST Layer](https://github.com/rs/rest-layer) **star:1258** Framework to build REST/GraphQL API on top of databases with mostly configuration over code.   [![godoc][D]](https://godoc.org/github.com/rs/rest-layer)
- [Atreugo](https://github.com/savsgio/atreugo) **star:1222** High performance and extensible micro web framework with zero memory allocations in hot paths.   [![godoc][D]](https://godoc.org/github.com/savsgio/atreugo)
- [tigertonic](https://github.com/rcrowley/go-tigertonic) **star:997** Go framework for building JSON web services inspired by Dropwizard.   [![It hasn't been updated in recent three years][Y]](https://github.com/rcrowley/go-tigertonic)   [![godoc][D]](https://godoc.org/github.com/rcrowley/go-tigertonic)
- [tango](https://github.com/lunny/tango) **star:832** Micro & pluggable web framework for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/lunny/tango)   [![godoc][D]](https://godoc.org/github.com/lunny/tango)   [![Contains Chinese documents][CN]](https://github.com/lunny/tango)   [![Archived][Archived]](https://github.com/lunny/tango)
- [Gearbox](https://github.com/abahmed/gearbox) **star:753** A web framework written in Go with a focus on high performance and memory optimization.   [![godoc][D]](https://godoc.org/github.com/abahmed/gearbox)
- [Fuego](https://github.com/go-fuego/fuego) **star:703** The framework for busy Go developers! Web framework generating OpenAPI 3 spec from source code.   [![godoc][D]](https://godoc.org/github.com/go-fuego/fuego)
- [Aero](https://github.com/aerogo/aero) **star:572** High-performance web framework for Go, reaches top scores in Lighthouse.   [![godoc][D]](https://godoc.org/github.com/aerogo/aero)   [![Archived][Archived]](https://github.com/aerogo/aero)
- [rk-boot](https://github.com/rookie-ninja/rk-boot) **star:509** A bootstrapper library for building enterprise go microservice with Gin and gRPC quickly and easily.   [![godoc][D]](https://godoc.org/github.com/rookie-ninja/rk-boot)
- [gongular](https://github.com/mustafaakin/gongular) **star:502** Fast Go web framework with input mapping/validation and (DI) Dependency Injection.   [![It hasn't been updated in recent three years][Y]](https://github.com/mustafaakin/gongular)   [![godoc][D]](https://godoc.org/github.com/mustafaakin/gongular)
- [Flamingo Commerce](https://github.com/i-love-flamingo/flamingo-commerce) **star:495** Providing e-commerce features using clean architecture like DDD and ports and adapters, that you can use to build flexible e-commerce applications.   [![There was an update last month][G]](https://github.com/i-love-flamingo/flamingo-commerce)   [![godoc][D]](https://godoc.org/github.com/i-love-flamingo/flamingo-commerce)
- [Flamingo](https://github.com/i-love-flamingo/flamingo) **star:443** Framework for pluggable web projects. Including a concept for modules and offering features for DI, Configareas, i18n, template engines, graphql, observability, security, events, routing & reverse routing etc.   [![There was an update last month][G]](https://github.com/i-love-flamingo/flamingo)   [![godoc][D]](https://godoc.org/github.com/i-love-flamingo/flamingo)
- [Air](https://github.com/aofei/air) **star:441** An ideally refined web framework for Go.   [![godoc][D]](https://godoc.org/github.com/aofei/air)
- [neo](https://github.com/ivpusic/neo) **star:419** Neo is minimal and fast Go Web Framework with extremely simple API.   [![godoc][D]](https://godoc.org/github.com/ivpusic/neo)
- [mango](https://github.com/paulbellamy/mango) **star:372** Mango is a modular web-application framework for Go, inspired by Rack, and PEP333.   [![It hasn't been updated in recent three years][Y]](https://github.com/paulbellamy/mango)   [![godoc][D]](https://godoc.org/github.com/paulbellamy/mango)
- [Yokai](https://github.com/ankorstore/yokai) **star:348** Simple, modular, and observable Go framework for backend applications.   [![There was an update last month][G]](https://github.com/ankorstore/yokai)   [![godoc][D]](https://godoc.org/github.com/ankorstore/yokai)
- [uAdmin](https://github.com/uadmin/uadmin) **star:334** Fully featured web framework for Golang, inspired by Django.   [![There was an update last month][G]](https://github.com/uadmin/uadmin)   [![godoc][D]](https://godoc.org/github.com/uadmin/uadmin)
- [Gondola](https://github.com/rainycape/gondola) **star:312** The web framework for writing faster sites, faster.   [![It hasn't been updated in recent three years][Y]](https://github.com/rainycape/gondola)   [![godoc][D]](https://godoc.org/github.com/rainycape/gondola)
- [WebGo](https://github.com/bnkamalesh/webgo) **star:303** A micro-framework to build web apps; with handler chaining, middleware and context injection. With standard library compliant HTTP handlers(i.e. http.HandlerFunc).   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/webgo)
- [Ginrpc](https://github.com/xxjwxc/ginrpc) **star:288** Gin parameter automatic binding tool,gin rpc tools.   [![godoc][D]](https://godoc.org/github.com/xxjwxc/ginrpc)   [![Contains Chinese documents][CN]](https://github.com/xxjwxc/ginrpc)
- [Golf](https://github.com/dinever/golf) **star:269** Golf is a fast, simple and lightweight micro-web framework for Go. It comes with powerful features and has no dependencies other than the Go Standard Library.   [![It hasn't been updated in recent three years][Y]](https://github.com/dinever/golf)   [![godoc][D]](https://godoc.org/github.com/dinever/golf)
- [Fastschema](https://github.com/fastschema/fastschema) **star:193** A flexible Go web framework and Headless CMS.   [![There was an update last month][G]](https://github.com/fastschema/fastschema)   [![godoc][D]](https://godoc.org/github.com/fastschema/fastschema)
- [hiboot](https://github.com/hidevopsio/hiboot) **star:181** hiboot is a high performance web application framework with auto configuration and dependency injection support.   [![There was an update last month][G]](https://github.com/hidevopsio/hiboot)   [![godoc][D]](https://godoc.org/github.com/hidevopsio/hiboot)   [![Contains Chinese documents][CN]](https://github.com/hidevopsio/hiboot)
- [Huma](https://github.com/danielgtaylor/huma/)  Framework for modern REST/GraphQL APIs with built-in OpenAPI 3, generated documentation, and a CLI.
- [appy](https://github.com/appist/appy) **star:132** An opinionated productive web framework that helps scaling business easier.   [![godoc][D]](https://godoc.org/github.com/appist/appy)
- [go-rest](https://github.com/ungerik/go-rest) **star:128** Small and evil REST framework for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/ungerik/go-rest)   [![godoc][D]](https://godoc.org/github.com/ungerik/go-rest)
- [patron](https://github.com/beatlabs/patron) **star:123** Patron is a microservice framework following best cloud practices with a focus on productivity.   [![There was an update last month][G]](https://github.com/beatlabs/patron)   [![godoc][D]](https://godoc.org/github.com/beatlabs/patron)
- [Pnutmux](https://gitlab.com/fruitygo/pnutmux)  Pnutmux is a powerful Go web framework that uses regex for matching and handling HTTP requests. It offers features such as CORS handling, structured logging, URL parameters extraction, middlewares, and concurrency limiting.
- [Microservice](https://github.com/claygod/microservice) **star:114** The framework for the creation of microservices, written in Golang.   [![godoc][D]](https://godoc.org/github.com/claygod/microservice)
- [Gone](https://github.com/gone-io/gone) **star:112** A lightweight dependency injection and web framework inspired by Spring.   [![godoc][D]](https://godoc.org/github.com/gone-io/gone)   [![Contains Chinese documents][CN]](https://github.com/gone-io/gone)
- [rux](https://github.com/gookit/rux) **star:97** Simple and fast web framework for build golang HTTP applications.   [![godoc][D]](https://godoc.org/github.com/gookit/rux)   [![Contains Chinese documents][CN]](https://github.com/gookit/rux)
- [vox](https://github.com/aisk/vox) **star:84** A golang web framework for humans, inspired by Koa heavily.   [![godoc][D]](https://godoc.org/github.com/aisk/vox)
- [aah](https://aahframework.org)  Scalable, performant, rapid development Web framework for Go.
- [Golax](https://github.com/fulldump/golax) **star:75** A non Sinatra fast HTTP framework with support for Google custom methods, deep interceptors, recursion and more.   [![godoc][D]](https://godoc.org/github.com/fulldump/golax)
- [YARF](https://github.com/yarf-framework/yarf) **star:67** Fast micro-framework designed to build REST APIs and web services in a fast and simple way.   [![It hasn't been updated in recent three years][Y]](https://github.com/yarf-framework/yarf)   [![godoc][D]](https://godoc.org/github.com/yarf-framework/yarf)
- [Fireball](https://github.com/zpatrick/fireball) **star:60** More "natural" feeling web framework.   [![It hasn't been updated in recent three years][Y]](https://github.com/zpatrick/fireball)   [![godoc][D]](https://godoc.org/github.com/zpatrick/fireball)
- [Don](https://github.com/abemedia/go-don) **star:50** A highly performant and simple to use API framework.   [![godoc][D]](https://godoc.org/github.com/abemedia/go-don)
- [goa](https://github.com/goa-go/goa) **star:49** goa is just like koajs for golang, it is a flexible, light, high-performance and extensible web framework based on middleware.   [![It hasn't been updated in recent three years][Y]](https://github.com/goa-go/goa)   [![godoc][D]](https://godoc.org/github.com/goa-go/goa)
- [GoTuna](https://github.com/gotuna/gotuna) **star:48** Minimalistic web framework for Go with mux router, middlewares, sessions, templates, embedded views and static files.   [![godoc][D]](https://godoc.org/github.com/gotuna/gotuna)
- [goweb](https://github.com/twharmon/goweb) **star:37** Web framework with routing, websockets, logging, middleware, static file server (optional gzip), and automatic TLS.   [![godoc][D]](https://godoc.org/github.com/twharmon/goweb)
- [Pulse](https://github.com/gopulse/pulse) **star:37** Pulse is an HTTP web framework written in Go (Golang)   [![godoc][D]](https://godoc.org/github.com/gopulse/pulse)
- [Resoursea](https://github.com/resoursea/api) **star:34** REST framework for quickly writing resource based services.   [![It hasn't been updated in recent three years][Y]](https://github.com/resoursea/api)   [![godoc][D]](https://godoc.org/github.com/resoursea/api)
- [rex](https://github.com/goanywhere/rex) **star:33** Rex is a library for modular development built upon gorilla/mux, fully compatible with `net/http`.   [![It hasn't been updated in recent three years][Y]](https://github.com/goanywhere/rex)   [![godoc][D]](https://godoc.org/github.com/goanywhere/rex)
- [Banjo](https://github.com/nsheremet/banjo) **star:24** Very simple and fast web framework for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/nsheremet/banjo)   [![godoc][D]](https://godoc.org/github.com/nsheremet/banjo)
- [Lit](https://github.com/jvcoutinho/lit) **star:24** Highly performant declarative web framework for Golang, aiming for simplicity and quality of life.   [![godoc][D]](https://godoc.org/github.com/jvcoutinho/lit)
- [golamb](https://github.com/twharmon/golamb) **star:7** Golamb makes it easier to write API endpoints for use with AWS Lambda and API Gateway.   [![godoc][D]](https://godoc.org/github.com/twharmon/golamb)
- [anoweb](https://github.com/go-the-way/anoweb) **star:5** The lightweight and powerful web framework using the new way for Go.Another go the way.   [![godoc][D]](https://godoc.org/github.com/go-the-way/anoweb)

**[⬆ back to top](#contents)**

### Middlewares

#### Actual middlewares

- [Tollbooth](https://github.com/didip/tollbooth) **star:2643** Rate limit HTTP request handler.   [![godoc][D]](https://godoc.org/github.com/didip/tollbooth)
- [CORS](https://github.com/rs/cors) **star:2615** Easily add CORS capabilities to your API.   [![godoc][D]](https://godoc.org/github.com/rs/cors)
- [Limiter](https://github.com/ulule/limiter) **star:2033** Dead simple rate limit middleware for Go.   [![godoc][D]](https://godoc.org/github.com/ulule/limiter)
- [go-server-timing](https://github.com/mitchellh/go-server-timing) **star:862** Add/parse Server-Timing header.   [![godoc][D]](https://godoc.org/github.com/mitchellh/go-server-timing)   [![Archived][Archived]](https://github.com/mitchellh/go-server-timing)
- [go-fault](https://github.com/github/go-fault) **star:500** Fault injection middleware for Go.   [![There was an update last month][G]](https://github.com/github/go-fault)   [![godoc][D]](https://godoc.org/github.com/github/go-fault)
- [ln-paywall](https://github.com/philippgille/ln-paywall) **star:146** Go middleware for monetizing APIs on a per-request basis with the Lightning Network (Bitcoin).   [![It hasn't been updated in recent three years][Y]](https://github.com/philippgille/ln-paywall)   [![godoc][D]](https://godoc.org/github.com/philippgille/ln-paywall)
- [XFF](https://github.com/sebest/xff) **star:98** Handle `X-Forwarded-For` header and friends.   [![godoc][D]](https://godoc.org/github.com/sebest/xff)
- [rk-grpc](https://github.com/rookie-ninja/rk-grpc) **star:73** Middleware for gRPC with logging, metrics, auth, tracing etc.   [![godoc][D]](https://godoc.org/github.com/rookie-ninja/rk-grpc)
- [rk-gin](https://github.com/rookie-ninja/rk-gin) **star:44** Middleware for Gin framework with logging, metrics, auth, tracing etc.   [![godoc][D]](https://godoc.org/github.com/rookie-ninja/rk-gin)
- [formjson](https://github.com/rs/formjson) **star:39** Transparently handle JSON input as a standard form POST.   [![It hasn't been updated in recent three years][Y]](https://github.com/rs/formjson)   [![godoc][D]](https://godoc.org/github.com/rs/formjson)
- [client-timing](https://github.com/posener/client-timing) **star:24** An HTTP client for Server-Timing header.   [![It hasn't been updated in recent three years][Y]](https://github.com/posener/client-timing)   [![godoc][D]](https://godoc.org/github.com/posener/client-timing)
- [echo-middleware](https://github.com/faabiosr/echo-middleware) **star:15** Middleware for Echo framework with logging and metrics.   [![There was an update last month][G]](https://github.com/faabiosr/echo-middleware)   [![godoc][D]](https://godoc.org/github.com/faabiosr/echo-middleware)
- [mid](https://github.com/bobg/mid) **star:9** Miscellaneous HTTP middleware features: idiomatic error return from handlers; receive/respond with JSON data; request tracing; and more.   [![godoc][D]](https://godoc.org/github.com/bobg/mid)

#### Libraries for creating HTTP middlewares

- [negroni](https://github.com/urfave/negroni) **star:7436** Idiomatic HTTP middleware for Golang.   [![godoc][D]](https://godoc.org/github.com/urfave/negroni)   [![Contains Chinese documents][CN]](https://github.com/urfave/negroni)
- [alice](https://github.com/justinas/alice) **star:3061** Painless middleware chaining for Go.   [![godoc][D]](https://godoc.org/github.com/justinas/alice)
- [render](https://github.com/unrolled/render) **star:1921** Go package for easily rendering JSON, XML, and HTML template responses.   [![godoc][D]](https://godoc.org/github.com/unrolled/render)
- [stats](https://github.com/thoas/stats) **star:595** Go middleware that stores various information about your web application.   [![godoc][D]](https://godoc.org/github.com/thoas/stats)
- [interpose](https://github.com/carbocation/interpose) **star:294** Minimalist net/http middleware for golang.   [![It hasn't been updated in recent three years][Y]](https://github.com/carbocation/interpose)   [![godoc][D]](https://godoc.org/github.com/carbocation/interpose)
- [renderer](https://github.com/thedevsaddam/renderer) **star:261** Simple, lightweight and faster response (JSON, JSONP, XML, YAML, HTML, File) rendering package for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/thedevsaddam/renderer)   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/renderer)
- [muxchain](https://github.com/stephens2424/muxchain) **star:208** Lightweight middleware for net/http.   [![It hasn't been updated in recent three years][Y]](https://github.com/stephens2424/muxchain)   [![godoc][D]](https://godoc.org/github.com/stephens2424/muxchain)
- [gores](https://github.com/alioygur/gores) **star:102** Go package that handles HTML, JSON, XML and etc. responses. Useful for RESTful APIs.   [![It hasn't been updated in recent three years][Y]](https://github.com/alioygur/gores)   [![godoc][D]](https://godoc.org/github.com/alioygur/gores)
- [rye](https://github.com/InVisionApp/rye) **star:102** Tiny Go middleware library (with canned Middlewares) that supports JWT, CORS, Statsd, and Go 1.7 context.   [![godoc][D]](https://godoc.org/github.com/InVisionApp/rye)
- [mediary](https://github.com/HereMobilityDevelopers/mediary) **star:88** add interceptors to `http.Client` to allow dumping/shaping/tracing/... of requests/responses.   [![It hasn't been updated in recent three years][Y]](https://github.com/HereMobilityDevelopers/mediary)   [![godoc][D]](https://godoc.org/github.com/HereMobilityDevelopers/mediary)
- [chain](https://github.com/codemodus/chain) **star:63** Handler wrapper chaining with scoped data (net/context-based "middleware").   [![It hasn't been updated in recent three years][Y]](https://github.com/codemodus/chain)   [![godoc][D]](https://godoc.org/github.com/codemodus/chain)
- [catena](https://github.com/codemodus/catena) **star:9** http.Handler wrapper catenation (same API as "chain").   [![It hasn't been updated in recent three years][Y]](https://github.com/codemodus/catena)   [![godoc][D]](https://godoc.org/github.com/codemodus/catena)

**[⬆ back to top](#contents)**

### Routers

- [mux](https://github.com/gorilla/mux) **star:20568** Powerful URL router and dispatcher for golang.   [![godoc][D]](https://godoc.org/github.com/gorilla/mux)
- [chi](https://github.com/go-chi/chi) **star:17862** Small, fast and expressive HTTP router built on net/context.   [![There was an update last month][G]](https://github.com/go-chi/chi)   [![godoc][D]](https://godoc.org/github.com/go-chi/chi)
- [httprouter](https://github.com/julienschmidt/httprouter) **star:16496** High performance router. Use this and the standard http handlers to form a very high performance web framework.   [![godoc][D]](https://godoc.org/github.com/julienschmidt/httprouter)
- [gocraft/web](https://github.com/gocraft/web) **star:1512** Mux and middleware package in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/gocraft/web)   [![godoc][D]](https://godoc.org/github.com/gocraft/web)
- [Bone](https://github.com/go-zoo/bone) **star:1292** Lightning Fast HTTP Multiplexer.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-zoo/bone)   [![godoc][D]](https://godoc.org/github.com/go-zoo/bone)
- [Goji](https://github.com/goji/goji) **star:960** Goji is a minimalistic and flexible HTTP request multiplexer with support for `net/context`.   [![godoc][D]](https://godoc.org/github.com/goji/goji)
- [fasthttprouter](https://github.com/buaazp/fasthttprouter) **star:877** High performance router forked from `httprouter`. The first router fit for `fasthttp`.   [![It hasn't been updated in recent three years][Y]](https://github.com/buaazp/fasthttprouter)   [![godoc][D]](https://godoc.org/github.com/buaazp/fasthttprouter)
- [httptreemux](https://github.com/dimfeld/httptreemux) **star:617** High-speed, flexible tree-based HTTP router for Go. Inspiration from httprouter.   [![godoc][D]](https://godoc.org/github.com/dimfeld/httptreemux)
- [xujiajun/gorouter](https://github.com/xujiajun/gorouter) **star:533** A simple and fast HTTP router for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/xujiajun/gorouter)   [![godoc][D]](https://godoc.org/github.com/xujiajun/gorouter)
- [ozzo-routing](https://github.com/go-ozzo/ozzo-routing) **star:452** An extremely fast Go (golang) HTTP router that supports regular expression route matching. Comes with full support for building RESTful APIs.   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-routing)
- [lars](https://github.com/go-playground/lars) **star:387** Is a lightweight, fast and extensible zero allocation HTTP router for Go used to create customizable frameworks.   [![It hasn't been updated in recent three years][Y]](https://github.com/go-playground/lars)   [![godoc][D]](https://godoc.org/github.com/go-playground/lars)
- [Siesta](https://github.com/VividCortex/siesta) **star:350** Composable framework to write middleware and handlers.   [![godoc][D]](https://godoc.org/github.com/VividCortex/siesta)
- [vestigo](https://github.com/husobee/vestigo) **star:268** Performant, stand-alone, HTTP compliant URL Router for go web applications.   [![It hasn't been updated in recent three years][Y]](https://github.com/husobee/vestigo)   [![godoc][D]](https://godoc.org/github.com/husobee/vestigo)
- [gowww/router](https://github.com/gowww/router) **star:185** Lightning fast HTTP router fully compatible with the net/http.Handler interface.   [![godoc][D]](https://godoc.org/github.com/gowww/router)
- [GoRouter](https://github.com/vardius/gorouter) **star:153** GoRouter is a Server/API micro framework, HTTP request router, multiplexer, mux that provides request router with middleware supporting `net/context`.   [![godoc][D]](https://godoc.org/github.com/vardius/gorouter)
- [pure](https://github.com/go-playground/pure) **star:149** Is a lightweight HTTP router that sticks to the std "net/http" implementation.   [![godoc][D]](https://godoc.org/github.com/go-playground/pure)
- [alien](https://github.com/gernest/alien) **star:131** Lightweight and fast http router from outer space.   [![godoc][D]](https://godoc.org/github.com/gernest/alien)
- [violetear](https://github.com/nbari/violetear) **star:107** Go HTTP router.   [![godoc][D]](https://godoc.org/github.com/nbari/violetear)
- [Bxog](https://github.com/claygod/Bxog) **star:103** Simple and fast HTTP router for Go. It works with routes of varying difficulty, length and nesting. And he knows how to create a URL from the received parameters.   [![godoc][D]](https://godoc.org/github.com/claygod/Bxog)
- [xmux](https://github.com/rs/xmux) **star:98** High performance muxer based on `httprouter` with `net/context` support.   [![It hasn't been updated in recent three years][Y]](https://github.com/rs/xmux)   [![godoc][D]](https://godoc.org/github.com/rs/xmux)
- [goblin](https://github.com/bmf-san/goblin) **star:78** A golang http router based on trie tree.   [![godoc][D]](https://godoc.org/github.com/bmf-san/goblin)
- [ngamux](https://github.com/ngamux/ngamux) **star:66** Simple HTTP router for Go.   [![godoc][D]](https://godoc.org/github.com/ngamux/ngamux)
- [bellt](https://github.com/GuilhermeCaruso/bellt) **star:54** A simple Go HTTP router.   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/bellt)
- [FastRouter](https://github.com/razonyang/fastrouter) **star:23** a fast, flexible HTTP router written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/razonyang/fastrouter)   [![godoc][D]](https://godoc.org/github.com/razonyang/fastrouter)
- [GoLobby/Router](https://github.com/golobby/router) **star:22** GoLobby Router is a lightweight yet powerful HTTP router for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/golobby/router)
- [nchi](https://github.com/muir/nchi) **star:13** chi-like router built on httprouter with dependency injection based middleware wrappers   [![There was an update last month][G]](https://github.com/muir/nchi)   [![godoc][D]](https://godoc.org/github.com/muir/nchi)
- [goroute](https://github.com/goroute/route) **star:9** Simple yet powerful HTTP request multiplexer.   [![It hasn't been updated in recent three years][Y]](https://github.com/goroute/route)   [![godoc][D]](https://godoc.org/github.com/goroute/route)

**[⬆ back to top](#contents)**

## WebAssembly

- [tinygo](https://github.com/tinygo-org/tinygo) **star:14863** Go compiler for small places. Microcontrollers, WebAssembly, and command-line tools. Based on LLVM.   [![There was an update last month][G]](https://github.com/tinygo-org/tinygo)   [![godoc][D]](https://godoc.org/github.com/tinygo-org/tinygo)
- [dom](https://github.com/dennwc/dom) **star:486** DOM library.   [![It hasn't been updated in recent three years][Y]](https://github.com/dennwc/dom)   [![godoc][D]](https://godoc.org/github.com/dennwc/dom)
- [go-canvas](https://github.com/markfarnan/go-canvas) **star:240** Library to use HTML5 Canvas, with all drawing within go code.   [![It hasn't been updated in recent three years][Y]](https://github.com/markfarnan/go-canvas)   [![godoc][D]](https://godoc.org/github.com/markfarnan/go-canvas)
- [wasmbrowsertest](https://github.com/agnivade/wasmbrowsertest) **star:186** Run Go WASM tests in your browser.   [![There was an update last month][G]](https://github.com/agnivade/wasmbrowsertest)   [![godoc][D]](https://godoc.org/github.com/agnivade/wasmbrowsertest)
- [webapi](https://github.com/gowebapi/webapi) **star:171** Bindings for DOM and HTML generated from WebIDL.   [![godoc][D]](https://godoc.org/github.com/gowebapi/webapi)
- [vert](https://github.com/norunners/vert) **star:100** Interop between Go and JS values.   [![godoc][D]](https://godoc.org/github.com/norunners/vert)
- [Extism Go SDK](https://github.com/extism/go-sdk) **star:65** Universal, cross-language WebAssembly framework for building plug-in systems and polyglot apps.   [![There was an update last month][G]](https://github.com/extism/go-sdk)   [![godoc][D]](https://godoc.org/github.com/extism/go-sdk)

**[⬆ back to top](#contents)**

## Windows

- [go-ole](https://github.com/go-ole/go-ole) **star:1151** Win32 OLE implementation for golang.   [![godoc][D]](https://godoc.org/github.com/go-ole/go-ole)
- [d3d9](https://github.com/gonutz/d3d9) **star:158** Go bindings for Direct3D9.   [![godoc][D]](https://godoc.org/github.com/gonutz/d3d9)
- [gosddl](https://github.com/MonaxGT/gosddl) **star:11** Converter from SDDL-string to user-friendly JSON. SDDL consist of four part: Owner, Primary Group, DACL, SACL.   [![It hasn't been updated in recent three years][Y]](https://github.com/MonaxGT/gosddl)   [![godoc][D]](https://godoc.org/github.com/MonaxGT/gosddl)

**[⬆ back to top](#contents)**

## XML

_Libraries and tools for manipulating XML._

- [zek](https://github.com/miku/zek) **star:743** Generate a Go struct from XML.   [![godoc][D]](https://godoc.org/github.com/miku/zek)
- [xpath](https://github.com/antchfx/xpath) **star:672** XPath package for Go.   [![godoc][D]](https://godoc.org/github.com/antchfx/xpath)
- [xquery](https://github.com/antchfx/xquery) **star:158** XQuery lets you extract data from HTML/XML documents using XPath expression.   [![It hasn't been updated in recent three years][Y]](https://github.com/antchfx/xquery)   [![godoc][D]](https://godoc.org/github.com/antchfx/xquery)   [![Archived][Archived]](https://github.com/antchfx/xquery)
- [xml2map](https://github.com/sbabiv/xml2map) **star:63** XML to MAP converter written Golang.   [![godoc][D]](https://godoc.org/github.com/sbabiv/xml2map)
- [xmlwriter](https://github.com/shabbyrobe/xmlwriter) **star:28** Procedural XML generation API based on libxml2's xmlwriter module.   [![godoc][D]](https://godoc.org/github.com/shabbyrobe/xmlwriter)
- [XML-Comp](https://github.com/xml-comp/xml-comp) **star:21** Simple command line XML comparer that generates diffs of folders, files and tags.   [![It hasn't been updated in recent three years][Y]](https://github.com/xml-comp/xml-comp)   [![godoc][D]](https://godoc.org/github.com/xml-comp/xml-comp)

## Zero Trust

_Libraries and tools to implement Zero Trust architectures._

- [Cosign](https://github.com/sigstore/cosign) **star:4306** Container Signing, Verification and Storage in an OCI registry.   [![There was an update last month][G]](https://github.com/sigstore/cosign)   [![godoc][D]](https://godoc.org/github.com/sigstore/cosign)
- [Spire](https://github.com/spiffe/spire) **star:1751** SPIRE (the SPIFFE Runtime Environment) is a toolchain of APIs for establishing trust between software systems across a wide variety of hosting platforms.   [![There was an update last month][G]](https://github.com/spiffe/spire)   [![godoc][D]](https://godoc.org/github.com/spiffe/spire)
- [in-toto](https://github.com/in-toto/in-toto-golang) **star:123** Go implementation of the in-toto (provides a framework to protect the integrity of the software supply chain) python reference implementation.   [![There was an update last month][G]](https://github.com/in-toto/in-toto-golang)   [![godoc][D]](https://godoc.org/github.com/in-toto/in-toto-golang)
- [Spiffe-Vault](https://github.com/philips-labs/spiffe-vault) **star:81** Utilizes Spiffe JWT authentication with Hashicorp Vault for secretless authentication.   [![godoc][D]](https://godoc.org/github.com/philips-labs/spiffe-vault)

## Code Analysis

_Source code analysis tools, also known as Static Application Security Testing (SAST) Tools._

- [errcheck](https://github.com/kisielk/errcheck) **star:2316** Errcheck is a program for checking for unchecked errors in Go programs.   [![godoc][D]](https://godoc.org/github.com/kisielk/errcheck)
- [go-critic](https://github.com/go-critic/go-critic) **star:1818** source code linter that brings checks that are currently not implemented in other linters.   [![There was an update last month][G]](https://github.com/go-critic/go-critic)   [![godoc][D]](https://godoc.org/github.com/go-critic/go-critic)
- [gcvis](https://github.com/davecheney/gcvis) **star:1098** Visualise Go program GC trace data in real time.   [![It hasn't been updated in recent three years][Y]](https://github.com/davecheney/gcvis)   [![godoc][D]](https://godoc.org/github.com/davecheney/gcvis)   [![Archived][Archived]](https://github.com/davecheney/gcvis)
- [go-cleanarch](https://github.com/roblaszczak/go-cleanarch) **star:842** go-cleanarch was created to validate Clean Architecture rules, like a The Dependency Rule and interaction between packages in your Go projects.   [![godoc][D]](https://godoc.org/github.com/roblaszczak/go-cleanarch)
- [goast-viewer](https://github.com/yuroyoro/goast-viewer) **star:764** Web based Golang AST visualizer.
- [goimports](https://pkg.go.dev/golang.org/x/tools/cmd/goimports)  Tool to fix (add, remove) your Go imports automatically.
- [go-mod-outdated](https://github.com/psampaz/go-mod-outdated) **star:647** An easy way to find outdated dependencies of your Go projects.   [![godoc][D]](https://godoc.org/github.com/psampaz/go-mod-outdated)
- [Chronos](https://github.com/amit-davidson/Chronos) **star:425** Detects race conditions statically   [![godoc][D]](https://godoc.org/github.com/amit-davidson/Chronos)
- [dupl](https://github.com/mibk/dupl) **star:341** Tool for code clone detection.   [![godoc][D]](https://godoc.org/github.com/mibk/dupl)
- [apicompat](https://github.com/bradleyfalzon/apicompat) **star:178** Checks recent changes to a Go project for backwards incompatible changes.   [![It hasn't been updated in recent three years][Y]](https://github.com/bradleyfalzon/apicompat)   [![godoc][D]](https://godoc.org/github.com/bradleyfalzon/apicompat)
- [go-checkstyle](https://github.com/qiniu/checkstyle) **star:129** checkstyle is a style check tool like java checkstyle. This tool inspired by java checkstyle, golint. The style referred to some points in Go Code Review Comments.   [![It hasn't been updated in recent three years][Y]](https://github.com/qiniu/checkstyle)   [![godoc][D]](https://godoc.org/github.com/qiniu/checkstyle)
- [asty](https://github.com/asty-org/asty) **star:78** Converts golang AST to JSON and JSON to AST.   [![godoc][D]](https://godoc.org/github.com/asty-org/asty)
- [blanket](https://gitlab.com/verygoodsoftwarenotvirus/blanket)  blanket is a tool that helps you catch functions which don't have direct unit tests in your Go packages.
- [ChainJacking](https://github.com/Checkmarx/chainjacking) **star:55** Find which of your Go lang direct GitHub dependencies is susceptible to ChainJacking attack.
- [go-outdated](https://github.com/firstrow/go-outdated) **star:43** Console application that displays outdated packages.   [![It hasn't been updated in recent three years][Y]](https://github.com/firstrow/go-outdated)   [![godoc][D]](https://godoc.org/github.com/firstrow/go-outdated)   [![Archived][Archived]](https://github.com/firstrow/go-outdated)
- [golang-ifood-sdk](https://github.com/arxdsilva/golang-ifood-sdk) **star:11** iFood API SDK.   [![godoc][D]](https://godoc.org/github.com/arxdsilva/golang-ifood-sdk)
- [golangci-lint](https://github.com/golangci/golangci-lint) – A fast Go linters runner. It runs linters in parallel, uses caching, supports `yaml` config, has integrations with all major IDE and has dozens of linters included.
- [GoPlantUML](https://github.com/jfeliu007/goplantuml) **star:1790** Library and CLI that generates text plantump class diagram containing information about structures and interfaces with the relationship among them.   [![There was an update last month][G]](https://github.com/jfeliu007/goplantuml)   [![godoc][D]](https://godoc.org/github.com/jfeliu007/goplantuml)
- [goreturns](https://sourcegraph.com/github.com/sqs/goreturns)  Adds zero-value return statements to match the func return types.
- [php-parser](https://github.com/z7zmey/php-parser) **star:936** A Parser for PHP written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/z7zmey/php-parser)   [![godoc][D]](https://godoc.org/github.com/z7zmey/php-parser)
- [golines](https://github.com/segmentio/golines) **star:880** Formatter that automatically shortens long lines in Go code.   [![There was an update last month][G]](https://github.com/segmentio/golines)   [![godoc][D]](https://godoc.org/github.com/segmentio/golines)
- [gostatus](https://github.com/shurcooL/gostatus) **star:244** Command line tool, shows the status of repositories that contain Go packages.   [![godoc][D]](https://godoc.org/github.com/shurcooL/gostatus)
- [lint](https://github.com/surullabs/lint) **star:67** Run linters as part of go test.   [![It hasn't been updated in recent three years][Y]](https://github.com/surullabs/lint)   [![godoc][D]](https://godoc.org/github.com/surullabs/lint)
- [revive](https://github.com/mgechev/revive) – ~6x faster, stricter, configurable, extensible, and beautiful drop-in replacement for `golint`.
- [staticcheck](https://github.com/dominikh/go-tools/tree/master/cmd/staticcheck)  staticcheck is `go vet` on steroids, applying a ton of static analysis checks you might be used to from tools like ReSharper for C#.
- [testifylint](https://github.com/Antonboom/testifylint) – A linter that checks usage of [github.com/stretchr/testify](https://github.com/stretchr/testify).
- [vacuum](https://github.com/daveshanley/vacuum) **star:527** An ultra-super-fast, lightweight OpenAPI linter and quality checking tool.   [![There was an update last month][G]](https://github.com/daveshanley/vacuum)   [![godoc][D]](https://godoc.org/github.com/daveshanley/vacuum)
- [todocheck](https://github.com/preslavmihaylov/todocheck) **star:421** Static code analyser which links TODO comments in code with issues in your issue tracker.   [![godoc][D]](https://godoc.org/github.com/preslavmihaylov/todocheck)
- [unconvert](https://github.com/mdempsky/unconvert) **star:376** Remove unnecessary type conversions from Go source.   [![godoc][D]](https://godoc.org/github.com/mdempsky/unconvert)
- [tickgit](https://github.com/augmentable-dev/tickgit) **star:322** CLI and go package for surfacing code comment TODOs (in any language) and applying a `git blame`to identify the author.   [![godoc][D]](https://godoc.org/github.com/augmentable-dev/tickgit)
- [validate](https://github.com/mccoyst/validate) **star:61** Automatically validates struct fields with tags.   [![godoc][D]](https://godoc.org/github.com/mccoyst/validate)
- [usestdlibvars](https://github.com/sashamelentyev/usestdlibvars) **star:43** A linter that detect the possibility to use variables/constants from the Go standard library.   [![godoc][D]](https://godoc.org/github.com/sashamelentyev/usestdlibvars)

**[⬆ back to top](#contents)**

## Editor Plugins

_Plugin for text editors and IDEs._

- [vim-go](https://github.com/fatih/vim-go) **star:15931** Go development plugin for Vim.
- [gocode](https://github.com/nsf/gocode) **star:5006** Autocompletion daemon for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/nsf/gocode)
- [vscode-go](https://github.com/golang/vscode-go) **star:3814** Extension for Visual Studio Code (VS Code) which provides support for the Go language.   [![There was an update last month][G]](https://github.com/golang/vscode-go)
- [GoSublime](https://github.com/DisposaBoy/GoSublime) **star:3415** Golang plugin collection for the text editor SublimeText 3 providing code completion and other IDE-like features.   [![It hasn't been updated in recent three years][Y]](https://github.com/DisposaBoy/GoSublime)   [![godoc][D]](https://godoc.org/github.com/DisposaBoy/GoSublime)
- [go-plus](https://github.com/joefitzgerald/go-plus) **star:1510** Go (Golang) Package For Atom That Adds Autocomplete, Formatting, Syntax Checking, Linting and Vetting.   [![It hasn't been updated in recent three years][Y]](https://github.com/joefitzgerald/go-plus)   [![Archived][Archived]](https://github.com/joefitzgerald/go-plus)
- [go-mode](https://github.com/dominikh/go-mode.el) **star:1377** Go mode for GNU/Emacs.
- [goimports-reviser](https://github.com/incu6us/goimports-reviser) **star:575** Formatting tool for imports.   [![godoc][D]](https://godoc.org/github.com/incu6us/goimports-reviser)
- [goprofiling](https://marketplace.visualstudio.com/items?itemName=MaxMedia.go-prof)  This extension adds benchmark profiling support for the Go language to VS Code.
- [coc-go language server extension for Vim/Neovim](https://github.com/josa42/coc-go) **star:564** This plugin adds [gopls](https://github.com/golang/tools/blob/master/gopls/README.md) features to Vim/Neovim.
- [Watch](https://github.com/eaburns/Watch) **star:201** Runs a command in an acme win on file changes.   [![godoc][D]](https://godoc.org/github.com/eaburns/Watch)
- [vim-compiler-go](https://github.com/rjohnsondev/vim-compiler-go) **star:89** Vim plugin to highlight syntax errors on save.   [![It hasn't been updated in recent three years][Y]](https://github.com/rjohnsondev/vim-compiler-go)
- [go-language-server](https://github.com/theia-ide/go-language-server) **star:32** A wrapper to turn the VSCode go extension into a language server supporting the language-server-protocol.   [![It hasn't been updated in recent three years][Y]](https://github.com/theia-ide/go-language-server)   [![Archived][Archived]](https://github.com/theia-ide/go-language-server)
- [gounit-vim](https://github.com/hexdigest/gounit-vim) **star:23** Vim plugin for generating Go tests based on the function's or method's signature.   [![It hasn't been updated in recent three years][Y]](https://github.com/hexdigest/gounit-vim)
- [theia-go-extension](https://github.com/theia-ide/theia-go-extension) **star:15** Go language support for the Theia IDE.   [![It hasn't been updated in recent three years][Y]](https://github.com/theia-ide/theia-go-extension)   [![Archived][Archived]](https://github.com/theia-ide/theia-go-extension)
- [Go Doc](https://github.com/msyrus/vscode-go-doc) **star:8** A Visual Studio Code extension for showing definition in output and generating go doc.
- [Go plugin for JetBrains IDEs](https://plugins.jetbrains.com/plugin/9568-go)  Go plugin for JetBrains IDEs.

**[⬆ back to top](#contents)**

## Go Generate Tools

- [gotests](https://github.com/cweill/gotests) **star:4918** Generate Go tests from your source code.   [![godoc][D]](https://godoc.org/github.com/cweill/gotests)
- [genny](https://github.com/cheekybits/genny) **star:1705** Elegant generics for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/cheekybits/genny)   [![godoc][D]](https://godoc.org/github.com/cheekybits/genny)
- [xgen](https://github.com/xuri/xgen) **star:311** XSD (XML Schema Definition) parser and Go/C/Java/Rust/TypeScript code generator.   [![godoc][D]](https://godoc.org/github.com/xuri/xgen)
- [hasgo](https://github.com/DylanMeeus/hasgo) **star:139** Generate Haskell inspired functions for your slices.   [![It hasn't been updated in recent three years][Y]](https://github.com/DylanMeeus/hasgo)   [![godoc][D]](https://godoc.org/github.com/DylanMeeus/hasgo)
- [gonerics](https://github.com/bouk/gonerics) **star:114** Idiomatic Generics in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/bouk/gonerics)   [![godoc][D]](https://godoc.org/github.com/bouk/gonerics)
- [gocontracts](https://github.com/Parquery/gocontracts) **star:109** brings design-by-contract to Go by synchronizing the code with the documentation.   [![It hasn't been updated in recent three years][Y]](https://github.com/Parquery/gocontracts)   [![godoc][D]](https://godoc.org/github.com/Parquery/gocontracts)
- [sqlgen](https://github.com/anqiansong/sqlgen) **star:81** Generate gorm, xorm, sqlx, bun, sql code from SQL file or DSN.   [![godoc][D]](https://godoc.org/github.com/anqiansong/sqlgen)   [![Contains Chinese documents][CN]](https://github.com/anqiansong/sqlgen)
- [TOML-to-Go](https://xuri.me/toml-to-go)  Translates TOML into a Go type in the browser instantly.
- [gounit](https://github.com/hexdigest/gounit) **star:80** Generate Go tests using your own templates.   [![It hasn't been updated in recent three years][Y]](https://github.com/hexdigest/gounit)   [![godoc][D]](https://godoc.org/github.com/hexdigest/gounit)
- [options-gen](https://github.com/kazhuravlev/options-gen) **star:75** Functional options described by Dave Cheney's post "Functional options for friendly APIs".   [![godoc][D]](https://godoc.org/github.com/kazhuravlev/options-gen)
- [re2dfa](https://gitlab.com/opennota/re2dfa)  Transform regular expressions into finite state machines and output Go source code.
- [envdoc](https://github.com/g4s8/envdoc) **star:49**  generate documentation for environment variables from Go source files.   [![godoc][D]](https://godoc.org/github.com/g4s8/envdoc)
- [generic](https://github.com/usk81/generic) **star:48** flexible data type for Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/usk81/generic)   [![godoc][D]](https://godoc.org/github.com/usk81/generic)
- [godal](https://github.com/mafulong/godal) **star:18** Generate orm models corresponding to golang by specifying sql ddl file, which can be used by gorm.   [![godoc][D]](https://godoc.org/github.com/mafulong/godal)

**[⬆ back to top](#contents)**

## Go Tools

- [go-swagger](https://github.com/go-swagger/go-swagger) **star:9417** Swagger 2.0 implementation for go. Swagger is a simple yet powerful representation of your RESTful API.   [![godoc][D]](https://godoc.org/github.com/go-swagger/go-swagger)
- [go-callvis](https://github.com/TrueFurby/go-callvis) **star:5872** Visualize call graph of your Go program using dot format.   [![godoc][D]](https://godoc.org/github.com/TrueFurby/go-callvis)
- [OctoLinker](https://github.com/OctoLinker/browser-extension) **star:5265** Navigate through go files efficiently with the OctoLinker browser extension for GitHub.
- [depth](https://github.com/KyleBanks/depth) **star:906** Visualize dependency trees of any package by analyzing imports.   [![godoc][D]](https://godoc.org/github.com/KyleBanks/depth)
- [richgo](https://github.com/kyoh86/richgo) **star:841** Enrich `go test` outputs with text decorations.   [![godoc][D]](https://godoc.org/github.com/kyoh86/richgo)
- [go-size-analyzer](https://github.com/Zxilly/go-size-analyzer) **star:831** Analyze and visualize the size of dependencies in compiled Golang binaries, providing insight into their impact on the final build.   [![There was an update last month][G]](https://github.com/Zxilly/go-size-analyzer)   [![godoc][D]](https://godoc.org/github.com/Zxilly/go-size-analyzer)   [![Contains Chinese documents][CN]](https://github.com/Zxilly/go-size-analyzer)
- [rts](https://github.com/galeone/rts) **star:250** RTS: response to struct. Generates Go structs from server responses.   [![godoc][D]](https://godoc.org/github.com/galeone/rts)
- [godbg](https://github.com/tylerwince/godbg) **star:202** Implementation of Rusts `dbg!` macro for quick and easy debugging during development.   [![It hasn't been updated in recent three years][Y]](https://github.com/tylerwince/godbg)   [![godoc][D]](https://godoc.org/github.com/tylerwince/godbg)
- [gomodrun](https://github.com/dustinblackman/gomodrun/)  Go tool that executes and caches binaries included in go.mod files.
- [gotemplate.io](https://gotemplate.io/)  Online tool to preview `text/template` templates live.
- [typex](https://github.com/dtgorski/typex) **star:197** Examine Go types and their transitive dependencies, alternatively export results as TypeScript value objects (or types) declaration.   [![godoc][D]](https://godoc.org/github.com/dtgorski/typex)
- [roumon](https://github.com/becheran/roumon) **star:180** Monitor current state of all active goroutines via a command line interface.   [![godoc][D]](https://godoc.org/github.com/becheran/roumon)
- [gothanks](https://github.com/psampaz/gothanks) **star:124** GoThanks automatically stars your go.mod github dependencies, sending this way some love to their maintainers.   [![godoc][D]](https://godoc.org/github.com/psampaz/gothanks)
- [colorgo](https://github.com/songgao/colorgo) **star:112** Wrapper around `go` command for colorized `go build` output.   [![It hasn't been updated in recent three years][Y]](https://github.com/songgao/colorgo)   [![godoc][D]](https://godoc.org/github.com/songgao/colorgo)
- [gotestdox](https://github.com/bitfield/gotestdox) **star:106** Show Go test results as readable sentences.   [![godoc][D]](https://godoc.org/github.com/bitfield/gotestdox)
- [igo](https://github.com/rocketlaunchr/igo) **star:66** An igo to go transpiler (new language features for Go language!)   [![It hasn't been updated in recent three years][Y]](https://github.com/rocketlaunchr/igo)   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/igo)
- [docs](https://github.com/go-oas/docs) **star:39** Automatically generate RESTful API documentation for GO projects - aligned with Open API Specification standard.   [![godoc][D]](https://godoc.org/github.com/go-oas/docs)
- [decouple](https://github.com/bobg/decouple) **star:21** Find “overspecified” function parameters that could be generalized with interface types.   [![godoc][D]](https://godoc.org/github.com/bobg/decouple)
- [modver](https://github.com/bobg/modver) **star:18** Compare two versions of a Go module to check the version-number change required (major, minor, or patchlevel), according to [semver](https://semver.org/) rules.   [![godoc][D]](https://godoc.org/github.com/bobg/modver)
- [textra](https://github.com/ravsii/textra) **star:6** Extract Go struct field names, types and tags for filtering and exporting.   [![godoc][D]](https://godoc.org/github.com/ravsii/textra)


**[⬆ back to top](#contents)**

## Software Packages

_Software written in Go._

**[⬆ back to top](#contents)**

### DevOps Tools

- [kubernetes](https://github.com/kubernetes/kubernetes) **star:109102** Container Cluster Manager from Google.   [![There was an update last month][G]](https://github.com/kubernetes/kubernetes)   [![godoc][D]](https://godoc.org/github.com/kubernetes/kubernetes)
- [Moby](https://github.com/moby/moby) **star:68319** Collaborative project for the container ecosystem to assemble container-based systems.   [![There was an update last month][G]](https://github.com/moby/moby)   [![godoc][D]](https://godoc.org/github.com/moby/moby)
- [traefik](https://github.com/containous/traefik) **star:49561** Reverse proxy and load balancer with support for multiple backends.   [![There was an update last month][G]](https://github.com/containous/traefik)   [![godoc][D]](https://godoc.org/github.com/containous/traefik)
- [Gitea](https://github.com/go-gitea/gitea) **star:43609** Fork of Gogs, entirely community driven.   [![There was an update last month][G]](https://github.com/go-gitea/gitea)   [![godoc][D]](https://godoc.org/github.com/go-gitea/gitea)   [![Contains Chinese documents][CN]](https://github.com/go-gitea/gitea)
- [gitea-github-migrator](https://git.jonasfranz.software/JonasFranzDEV/gitea-github-migrator)  Migrate all your GitHub repositories, issues, milestones and labels to your Gitea instance.
- [minikube](https://github.com/kubernetes/minikube) **star:28962** Run Kubernetes locally.   [![There was an update last month][G]](https://github.com/kubernetes/minikube)   [![godoc][D]](https://godoc.org/github.com/kubernetes/minikube)
- [k3s](https://github.com/k3s-io/k3s) **star:27274** Lightweight Kubernetes.   [![There was an update last month][G]](https://github.com/k3s-io/k3s)   [![godoc][D]](https://godoc.org/github.com/k3s-io/k3s)
- [k6](https://github.com/grafana/k6) **star:24158** A modern load testing tool, using Go and JavaScript.   [![There was an update last month][G]](https://github.com/grafana/k6)   [![godoc][D]](https://godoc.org/github.com/grafana/k6)
- [Vegeta](https://github.com/tsenart/vegeta) **star:23135** HTTP load testing tool and library. It's over 9000!   [![godoc][D]](https://godoc.org/github.com/tsenart/vegeta)
- [Hey](https://github.com/rakyll/hey) **star:17799** Hey is a tiny program that sends some load to a web application.   [![There was an update last month][G]](https://github.com/rakyll/hey)   [![godoc][D]](https://godoc.org/github.com/rakyll/hey)
- [Packer](https://github.com/mitchellh/packer) **star:15004** Packer is a tool for creating identical machine images for multiple platforms from a single source configuration.   [![There was an update last month][G]](https://github.com/mitchellh/packer)   [![godoc][D]](https://godoc.org/github.com/mitchellh/packer)
- [kind](https://github.com/kubernetes-sigs/kind) **star:13152** Kubernetes IN Docker - local clusters for testing Kubernetes.   [![There was an update last month][G]](https://github.com/kubernetes-sigs/kind)   [![godoc][D]](https://godoc.org/github.com/kubernetes-sigs/kind)
- [kubeshark](https://github.com/kubeshark/kubeshark) **star:10821** API traffic analyzer for Kubernetes, inspired by Wireshark, purposely built for Kubernetes.   [![There was an update last month][G]](https://github.com/kubeshark/kubeshark)   [![godoc][D]](https://godoc.org/github.com/kubeshark/kubeshark)
- [webhook](https://github.com/adnanh/webhook) **star:10138** Tool which allows user to create HTTP endpoints (hooks) that execute commands on the server.   [![godoc][D]](https://godoc.org/github.com/adnanh/webhook)
- [Wide](https://wide.b3log.org/login)  Web-based IDE for Teams using Golang.
- [GVM](https://github.com/moovweb/gvm) **star:9984** GVM provides an interface to manage Go versions.   [![There was an update last month][G]](https://github.com/moovweb/gvm)
- [Flannel](https://github.com/flannel-io/flannel) **star:8679** Flannel is a network fabric for containers, designed for Kubernetes.   [![There was an update last month][G]](https://github.com/flannel-io/flannel)   [![godoc][D]](https://godoc.org/github.com/flannel-io/flannel)
- [Ddosify](https://github.com/ddosify/ddosify) **star:8293** High-performance load testing tool, written in Golang.   [![There was an update last month][G]](https://github.com/ddosify/ddosify)   [![godoc][D]](https://godoc.org/github.com/ddosify/ddosify)
- [ko](https://github.com/google/ko) **star:7479** Command line tool for building and deploying Go applications on Kubernetes   [![There was an update last month][G]](https://github.com/google/ko)   [![godoc][D]](https://godoc.org/github.com/google/ko)
- [KubeVela](https://github.com/kubevela/kubevela) **star:6314** Cloud native application delivery.   [![There was an update last month][G]](https://github.com/kubevela/kubevela)   [![godoc][D]](https://godoc.org/github.com/kubevela/kubevela)
- [bombardier](https://github.com/codesenberg/bombardier) **star:5519** Fast cross-platform HTTP benchmarking tool.   [![godoc][D]](https://godoc.org/github.com/codesenberg/bombardier)
- [podinfo](https://github.com/stefanprodan/podinfo) **star:5310** Podinfo is a tiny web application made with Go that showcases best practices of running microservices in Kubernetes. Podinfo is used by CNCF projects like Flux and Flagger for end-to-end testing and workshops.   [![godoc][D]](https://godoc.org/github.com/stefanprodan/podinfo)
- [k3d](https://github.com/k3d-io/k3d) **star:5285** Little helper to run CNCF's k3s in Docker.   [![There was an update last month][G]](https://github.com/k3d-io/k3d)   [![godoc][D]](https://godoc.org/github.com/k3d-io/k3d)
- [script](https://github.com/bitfield/script) **star:5265** Making it easy to write shell-like scripts in Go for DevOps and system administration tasks.   [![There was an update last month][G]](https://github.com/bitfield/script)   [![godoc][D]](https://godoc.org/github.com/bitfield/script)
- [gaia](https://github.com/gaia-pipeline/gaia) **star:5187** Build powerful pipelines in any programming language.   [![godoc][D]](https://godoc.org/github.com/gaia-pipeline/gaia)
- [gox](https://github.com/mitchellh/gox) **star:4596** Dead simple, no frills Go cross compile tool.   [![godoc][D]](https://godoc.org/github.com/mitchellh/gox)   [![Archived][Archived]](https://github.com/mitchellh/gox)
- [Pomerium](https://github.com/pomerium/pomerium) **star:3983** Pomerium is an identity-aware access proxy.   [![There was an update last month][G]](https://github.com/pomerium/pomerium)   [![godoc][D]](https://godoc.org/github.com/pomerium/pomerium)
- [bosun](https://github.com/bosun-monitor/bosun) **star:3394** Time Series Alerting Framework.   [![godoc][D]](https://godoc.org/github.com/bosun-monitor/bosun)
- [tau](https://github.com/taubyte/tau) **star:2945** Easily build Cloud Computing Platforms with features like Serverless WebAssembly Functions, Frontend Hosting, CI/CD, Object Storage, K/V Database, and Pub-Sub Messaging.   [![There was an update last month][G]](https://github.com/taubyte/tau)   [![godoc][D]](https://godoc.org/github.com/taubyte/tau)
- [Fleet device management](https://github.com/fleetdm/fleet) **star:2856** Lightweight, programmable telemetry for servers and workstations.   [![There was an update last month][G]](https://github.com/fleetdm/fleet)   [![godoc][D]](https://godoc.org/github.com/fleetdm/fleet)
- [s5cmd](https://github.com/peak/s5cmd) **star:2509** Blazing fast S3 and local filesystem execution tool.   [![godoc][D]](https://godoc.org/github.com/peak/s5cmd)
- [kala](https://github.com/ajvb/kala) **star:2116** Simplistic, modern, and performant job scheduler.   [![godoc][D]](https://godoc.org/github.com/ajvb/kala)
- [kubeblocks](https://github.com/apecloud/kubeblocks) **star:1971** KubeBlocks is an open-source control plane that runs and manages databases, message queues and other data infrastructure on K8s.   [![There was an update last month][G]](https://github.com/apecloud/kubeblocks)   [![godoc][D]](https://godoc.org/github.com/apecloud/kubeblocks)
- [fac](https://github.com/mkchoi212/fac) **star:1836** Command-line user interface to fix git merge conflicts.   [![godoc][D]](https://godoc.org/github.com/mkchoi212/fac)
- [goxc](https://github.com/laher/goxc) **star:1677** build tool for Go, with a focus on cross-compiling and packaging.   [![It hasn't been updated in recent three years][Y]](https://github.com/laher/goxc)   [![godoc][D]](https://godoc.org/github.com/laher/goxc)   [![Archived][Archived]](https://github.com/laher/goxc)
- [StatusOK](https://github.com/sanathp/statusok) **star:1617** Monitor your Website and REST APIs.Get Notified through Slack, E-mail when your server is down or response time is more than expected.   [![It hasn't been updated in recent three years][Y]](https://github.com/sanathp/statusok)   [![godoc][D]](https://godoc.org/github.com/sanathp/statusok)
- [ghorg](https://github.com/gabrie30/ghorg) **star:1518** Quickly clone an entire org/users repositories into one directory - Supports GitHub, GitLab, Gitea, and Bitbucket.   [![godoc][D]](https://godoc.org/github.com/gabrie30/ghorg)
- [go-selfupdate](https://github.com/sanbornm/go-selfupdate) **star:1485** Enable your Go applications to self update.   [![godoc][D]](https://godoc.org/github.com/sanbornm/go-selfupdate)
- [tlm](https://github.com/yusufcanb/tlm) **star:1162** Local cli copilot, powered by CodeLLaMa   [![godoc][D]](https://godoc.org/github.com/yusufcanb/tlm)
- [s3gof3r](https://github.com/rlmcpherson/s3gof3r) **star:1145** Small utility/library optimized for high speed transfer of large objects into and out of Amazon S3.   [![godoc][D]](https://godoc.org/github.com/rlmcpherson/s3gof3r)
- [uTask](https://github.com/ovh/utask) **star:1143** Automation engine that models and executes business processes declared in yaml.   [![godoc][D]](https://godoc.org/github.com/ovh/utask)
- [PipeCD](https://github.com/pipe-cd/pipecd) **star:1034** A GitOps-style continuous delivery platform that provides consistent deployment and operations experience for any applications.   [![There was an update last month][G]](https://github.com/pipe-cd/pipecd)   [![godoc][D]](https://godoc.org/github.com/pipe-cd/pipecd)
- [kwatch](https://github.com/abahmed/kwatch) **star:953** Monitor & detect crashes in your Kubernetes(K8s) cluster instantly.   [![godoc][D]](https://godoc.org/github.com/abahmed/kwatch)
- [skm](https://github.com/TimothyYe/skm) **star:947** SKM is a simple and powerful SSH Keys Manager, it helps you to manage your multiple SSH keys easily!   [![godoc][D]](https://godoc.org/github.com/TimothyYe/skm)
- [Scaleway-cli](https://github.com/scaleway/scaleway-cli) **star:878** Manage BareMetal Servers from Command Line (as easily as with Docker).   [![There was an update last month][G]](https://github.com/scaleway/scaleway-cli)   [![godoc][D]](https://godoc.org/github.com/scaleway/scaleway-cli)
- [KusionStack](https://github.com/KusionStack/kusion) **star:846** A unified programmable configuration techstack to deliver modern app in 'platform as code' and 'infra as code' approach.   [![There was an update last month][G]](https://github.com/KusionStack/kusion)   [![godoc][D]](https://godoc.org/github.com/KusionStack/kusion)   [![Contains Chinese documents][CN]](https://github.com/KusionStack/kusion)
- [cassowary](https://github.com/rogerwelin/cassowary) **star:753** Modern cross-platform HTTP load-testing tool written in Go.   [![godoc][D]](https://godoc.org/github.com/rogerwelin/cassowary)   [![Contains Chinese documents][CN]](https://github.com/rogerwelin/cassowary)
- [kool](https://github.com/kool-dev/kool) **star:660** Command line tool for managing Docker environments as an easy way.   [![godoc][D]](https://godoc.org/github.com/kool-dev/kool)
- [aurora](https://github.com/xuri/aurora) **star:594** Cross-platform web-based Beanstalkd queue server console.   [![It hasn't been updated in recent three years][Y]](https://github.com/xuri/aurora)
- [govvv](https://github.com/ahmetalpbalkan/govvv) **star:537** “go build” wrapper to easily add version information into Go binaries.   [![godoc][D]](https://godoc.org/github.com/ahmetalpbalkan/govvv)
- [KubeVPN](https://github.com/kubenetworks/kubevpn) **star:497** KubeVPN offers a Cloud-Native Dev Environment that seamlessly connects to your Kubernetes cluster network.   [![godoc][D]](https://godoc.org/github.com/kubenetworks/kubevpn)   [![Contains Chinese documents][CN]](https://github.com/kubenetworks/kubevpn)
- [Pewpew](https://github.com/bengadbois/pewpew) **star:416** Flexible HTTP command line stress tester.   [![godoc][D]](https://godoc.org/github.com/bengadbois/pewpew)
- [jcli](https://github.com/jenkins-zh/jenkins-cli) **star:386** Jenkins CLI allows you manage your Jenkins as an easy way.   [![There was an update last month][G]](https://github.com/jenkins-zh/jenkins-cli)   [![godoc][D]](https://godoc.org/github.com/jenkins-zh/jenkins-cli)   [![Contains Chinese documents][CN]](https://github.com/jenkins-zh/jenkins-cli)
- [gobrew](https://github.com/kevincobain2000/gobrew) **star:361** Go version manager. Super simple tool to install and manage Go versions. Install go without root. Gobrew doesn't require shell rehash.   [![There was an update last month][G]](https://github.com/kevincobain2000/gobrew)   [![godoc][D]](https://godoc.org/github.com/kevincobain2000/gobrew)
- [gonative](https://github.com/inconshreveable/gonative) **star:339** Tool which creates a build of Go that can cross compile to all platforms while still using the Cgo-enabled versions of the stdlib packages.   [![It hasn't been updated in recent three years][Y]](https://github.com/inconshreveable/gonative)   [![godoc][D]](https://godoc.org/github.com/inconshreveable/gonative)
- [trubka](https://github.com/xitonix/trubka) **star:330** A CLI tool to manage and troubleshoot Apache Kafka clusters with the ability of generically publishing/consuming protocol buffer and plain text events to/from Kafka.   [![godoc][D]](https://godoc.org/github.com/xitonix/trubka)
- [lstags](https://github.com/ivanilves/lstags) **star:326** Tool and API to sync Docker images across different registries.   [![godoc][D]](https://godoc.org/github.com/ivanilves/lstags)
- [easyssh-proxy](https://github.com/appleboy/easyssh-proxy) **star:319** Golang package for easy remote execution through SSH and SCP downloading via `ProxyCommand`.   [![godoc][D]](https://godoc.org/github.com/appleboy/easyssh-proxy)
- [Mora](https://github.com/emicklei/mora) **star:315** REST server for accessing MongoDB documents and meta data.   [![godoc][D]](https://godoc.org/github.com/emicklei/mora)
- [Balerter](https://github.com/balerter/balerter) **star:299** A self-hosted script-based alerting manager.   [![godoc][D]](https://godoc.org/github.com/balerter/balerter)
- [manssh](https://github.com/xwjdsh/manssh) **star:296** manssh is a command line tool for managing your ssh alias config easily.   [![godoc][D]](https://godoc.org/github.com/xwjdsh/manssh)
- [s3-proxy](https://github.com/oxyno-zeta/s3-proxy) **star:287** S3 Proxy with GET, PUT and DELETE methods and authentication (OpenID Connect and Basic Auth).   [![There was an update last month][G]](https://github.com/oxyno-zeta/s3-proxy)   [![godoc][D]](https://godoc.org/github.com/oxyno-zeta/s3-proxy)
- [terraform-provider-openapi](https://github.com/dikhan/terraform-provider-openapi) **star:274** Terraform provider plugin that dynamically configures itself at runtime based on an OpenAPI document (formerly known as swagger file) containing the definitions of the APIs exposed.   [![godoc][D]](https://godoc.org/github.com/dikhan/terraform-provider-openapi)
- [dogo](https://github.com/liudng/dogo) **star:266** Monitoring changes in the source file and automatically compile and run (restart).   [![It hasn't been updated in recent three years][Y]](https://github.com/liudng/dogo)   [![godoc][D]](https://godoc.org/github.com/liudng/dogo)   [![Contains Chinese documents][CN]](https://github.com/liudng/dogo)
- [godbg](https://github.com/sirnewton01/godbg) **star:229** Web-based gdb front-end application.   [![It hasn't been updated in recent three years][Y]](https://github.com/sirnewton01/godbg)
- [Gogs](https://gogs.io/)  A Self Hosted Git Service in the Go Programming Language.
- [Blast](https://github.com/dave/blast) **star:217** A simple tool for API load testing and batch jobs.   [![It hasn't been updated in recent three years][Y]](https://github.com/dave/blast)   [![godoc][D]](https://godoc.org/github.com/dave/blast)
- [abbreviate](https://github.com/dnnrly/abbreviate) **star:215** abbreviate is a tool turning long strings in to shorter ones with configurable separators, for example to embed branch names in to deployment stack IDs.   [![godoc][D]](https://godoc.org/github.com/dnnrly/abbreviate)
- [kcli](https://github.com/cswank/kcli) **star:212** Command line tool for inspecting kafka topics/partitions/messages.   [![It hasn't been updated in recent three years][Y]](https://github.com/cswank/kcli)   [![godoc][D]](https://godoc.org/github.com/cswank/kcli)
- [gobrew](https://github.com/cryptojuice/gobrew) **star:195** gobrew lets you easily switch between multiple versions of go.   [![It hasn't been updated in recent three years][Y]](https://github.com/cryptojuice/gobrew)
- [ostent](https://github.com/ostrost/ostent) **star:179** collects and displays system metrics and optionally relays to Graphite and/or InfluxDB.   [![godoc][D]](https://godoc.org/github.com/ostrost/ostent)
- [Dockerfile-Generator](https://github.com/ozankasikci/dockerfile-generator) **star:167** A go library and an executable that produces valid Dockerfiles using various input channels.   [![godoc][D]](https://godoc.org/github.com/ozankasikci/dockerfile-generator)
- [grapes](https://github.com/yaronsumel/grapes) **star:167** Lightweight tool designed to distribute commands over ssh with ease.   [![There was an update last month][G]](https://github.com/yaronsumel/grapes)   [![godoc][D]](https://godoc.org/github.com/yaronsumel/grapes)
- [winrm-cli](https://github.com/masterzen/winrm-cli) **star:164** Cli tool to remotely execute commands on Windows machines.   [![godoc][D]](https://godoc.org/github.com/masterzen/winrm-cli)
- [tf-profile](https://github.com/datarootsio/tf-profile) **star:147** Profiler for Terraform runs. Generate global stats, resource-level stats or visualizations.   [![godoc][D]](https://godoc.org/github.com/datarootsio/tf-profile)
- [drone-scp](https://github.com/appleboy/drone-scp) **star:142** Copy files and artifacts via SSH using a binary, docker or Drone CI.   [![godoc][D]](https://godoc.org/github.com/appleboy/drone-scp)
- [Mantil](https://github.com/mantil-io/mantil) **star:109** Go specific framework for building serverless applications on AWS that enables you to focus on pure Go code while Mantil takes care of the infrastructure.   [![godoc][D]](https://godoc.org/github.com/mantil-io/mantil)
- [go-rocket-update](https://github.com/mouuff/go-rocket-update) **star:100** A simple way to make self updating Go applications - Supports Github and Gitlab.   [![godoc][D]](https://godoc.org/github.com/mouuff/go-rocket-update)
- [go-furnace](https://github.com/go-furnace/go-furnace) **star:98** Hosting solution written in Go. Deploy your Application with ease on AWS, GCP or DigitalOcean.   [![godoc][D]](https://godoc.org/github.com/go-furnace/go-furnace)
- [decompose](https://github.com/s0rg/decompose) **star:80** tool to generate and process Docker containers connections graphs.   [![godoc][D]](https://godoc.org/github.com/s0rg/decompose)
- [Dropship](https://github.com/chrismckenzie/dropship) **star:64** Tool for deploying code via cdn.   [![It hasn't been updated in recent three years][Y]](https://github.com/chrismckenzie/dropship)   [![godoc][D]](https://godoc.org/github.com/chrismckenzie/dropship)
- [docker-go-mingw](https://github.com/x1unix/docker-go-mingw) **star:44** Docker image for building Go binaries for Windows with MinGW toolchain.
- [drone-jenkins](https://github.com/appleboy/drone-jenkins) **star:38** Trigger downstream Jenkins jobs using a binary, docker or Drone CI.   [![godoc][D]](https://godoc.org/github.com/appleboy/drone-jenkins)
- [httpref](https://github.com/dnnrly/httpref) **star:36** httpref is a handy CLI reference for HTTP methods, status codes, headers, and TCP and UDP ports.   [![godoc][D]](https://godoc.org/github.com/dnnrly/httpref)
- [awsenv](https://github.com/soniah/awsenv) **star:34** Small binary that loads Amazon (AWS) environment variables for a profile.   [![It hasn't been updated in recent three years][Y]](https://github.com/soniah/awsenv)   [![godoc][D]](https://godoc.org/github.com/soniah/awsenv)
- [Rodent](https://github.com/alouche/rodent) **star:33** Rodent helps you manage Go versions, projects and track dependencies.   [![It hasn't been updated in recent three years][Y]](https://github.com/alouche/rodent)
- [lwc](https://github.com/timdp/lwc) **star:32** A live-updating version of the UNIX wc command.   [![godoc][D]](https://godoc.org/github.com/timdp/lwc)
- [DepCharge](https://github.com/centerorbit/depcharge) **star:23** Helps orchestrating the execution of commands across the many dependencies in larger projects.   [![godoc][D]](https://godoc.org/github.com/centerorbit/depcharge)
- [Docker](https://www.docker.com/)  Open platform for distributed applications for developers and sysadmins.
- [wait-for](https://github.com/dnnrly/wait-for) **star:18** Wait for something to happen (from the command line) before continuing. Easy orchestration of Docker services and other things.   [![godoc][D]](https://godoc.org/github.com/dnnrly/wait-for)
- [aptly](https://github.com/smira/aptly) **star:11** aptly is a Debian repository management tool.   [![It hasn't been updated in recent three years][Y]](https://github.com/smira/aptly)   [![godoc][D]](https://godoc.org/github.com/smira/aptly)
- [sg](https://github.com/ChristopherRabotin/sg) **star:8** Benchmarks a set of HTTP endpoints (like ab), with possibility to use the response code and data between each call for specific server stress based on its previous response.   [![It hasn't been updated in recent three years][Y]](https://github.com/ChristopherRabotin/sg)   [![godoc][D]](https://godoc.org/github.com/ChristopherRabotin/sg)

**[⬆ back to top](#contents)**

### Other Software

- [croc](https://github.com/schollz/croc) **star:27145** Easily and securely send files or folders from one computer to another.   [![There was an update last month][G]](https://github.com/schollz/croc)   [![godoc][D]](https://godoc.org/github.com/schollz/croc)
- [restic](https://github.com/restic/restic) **star:25362** De-duplicating backup program.   [![There was an update last month][G]](https://github.com/restic/restic)   [![godoc][D]](https://godoc.org/github.com/restic/restic)
- [Seaweed File System](https://github.com/chrislusf/seaweedfs) **star:22016** Fast, Simple and Scalable Distributed File System with O(1) disk seek.   [![There was an update last month][G]](https://github.com/chrislusf/seaweedfs)   [![godoc][D]](https://godoc.org/github.com/chrislusf/seaweedfs)
- [Gor](https://github.com/buger/gor) **star:18505** Http traffic replication tool, for replaying traffic from production to stage/dev environments in real-time.   [![godoc][D]](https://godoc.org/github.com/buger/gor)
- [toxiproxy](https://github.com/shopify/toxiproxy) **star:10552** Proxy to simulate network and system conditions for automated tests.   [![There was an update last month][G]](https://github.com/shopify/toxiproxy)   [![godoc][D]](https://godoc.org/github.com/shopify/toxiproxy)
- [tsuru](https://tsuru.io/)  Extensible and open source Platform as a Service software.
- [Comcast](https://github.com/tylertreat/Comcast) **star:10279** Simulate bad network connections.   [![godoc][D]](https://godoc.org/github.com/tylertreat/Comcast)
- [confd](https://github.com/kelseyhightower/confd) **star:8319** Manage local application configuration files using templates and data from etcd or consul.   [![godoc][D]](https://godoc.org/github.com/kelseyhightower/confd)
- [LiteIDE](https://github.com/visualfc/liteide) **star:7526** LiteIDE is a simple, open source, cross-platform Go IDE.   [![Contains Chinese documents][CN]](https://github.com/visualfc/liteide)
- [drive](https://github.com/odeke-em/drive) **star:6664** Google Drive client for the commandline.   [![godoc][D]](https://godoc.org/github.com/odeke-em/drive)
- [scc](https://github.com/boyter/scc) **star:6394** Sloc Cloc and Code, a very fast accurate code counter with complexity calculations and COCOMO estimates.   [![There was an update last month][G]](https://github.com/boyter/scc)   [![godoc][D]](https://godoc.org/github.com/boyter/scc)
- [nes](https://github.com/fogleman/nes) **star:5417** Nintendo Entertainment System (NES) emulator written in Go.   [![godoc][D]](https://godoc.org/github.com/fogleman/nes)
- [Duplicacy](https://github.com/gilbertchen/duplicacy) **star:5092** A cross-platform network and cloud backup tool based on the idea of lock-free deduplication.   [![godoc][D]](https://godoc.org/github.com/gilbertchen/duplicacy)
- [blocky](https://github.com/0xERR0R/blocky) **star:4473** Fast and lightweight DNS proxy as ad-blocker for local network with many features.   [![There was an update last month][G]](https://github.com/0xERR0R/blocky)   [![godoc][D]](https://godoc.org/github.com/0xERR0R/blocky)
- [myLG](https://github.com/mehrdadrad/mylg) **star:2692** Command Line Network Diagnostic tool written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/mehrdadrad/mylg)   [![godoc][D]](https://godoc.org/github.com/mehrdadrad/mylg)
- [GoBoy](https://github.com/Humpheh/goboy) **star:2596** Nintendo Game Boy Color emulator written in Go.   [![godoc][D]](https://godoc.org/github.com/Humpheh/goboy)
- [Stack Up](https://github.com/pressly/sup) **star:2480** Stack Up, a super simple deployment tool - just Unix - think of it like 'make' for a network of servers.   [![godoc][D]](https://godoc.org/github.com/pressly/sup)
- [lgo](https://github.com/yunabe/lgo) **star:2403** Interactive Go programming with Jupyter. It supports code completion, code inspection and 100% Go compatibility.   [![It hasn't been updated in recent three years][Y]](https://github.com/yunabe/lgo)   [![godoc][D]](https://godoc.org/github.com/yunabe/lgo)
- [limetext](https://limetext.github.io)  Lime Text is a powerful and elegant text editor primarily developed in Go that aims to be a Free and open-source software successor to Sublime Text.
- [Documize](https://github.com/documize/community) **star:2123** Modern wiki software that integrates data from SaaS tools.
- [Circuit](https://github.com/gocircuit/circuit) **star:1981** Circuit is a programmable platform-as-a-service (PaaS) and/or Infrastructure-as-a-Service (IaaS), for management, discovery, synchronization and orchestration of services and hosts comprising cloud applications.   [![godoc][D]](https://godoc.org/github.com/gocircuit/circuit)
- [borg](https://github.com/crufter/borg) **star:1608** Terminal based search engine for bash snippets.   [![It hasn't been updated in recent three years][Y]](https://github.com/crufter/borg)   [![godoc][D]](https://godoc.org/github.com/crufter/borg)
- [Plik](https://github.com/root-gg/plik) **star:1447** Plik is a temporary file upload system (Wetransfer like) in Go.   [![There was an update last month][G]](https://github.com/root-gg/plik)   [![godoc][D]](https://godoc.org/github.com/root-gg/plik)
- [shell2http](https://github.com/msoap/shell2http) **star:1315** Executing shell commands via http server (for prototyping or remote control).   [![godoc][D]](https://godoc.org/github.com/msoap/shell2http)
- [portal](https://github.com/SpatiumPortae/portal) **star:1314** Portal is a quick and easy command-line file transfer utility from any computer to another.   [![godoc][D]](https://godoc.org/github.com/SpatiumPortae/portal)
- [Gokapi](https://github.com/Forceu/gokapi) **star:1173** Lightweight server to share files, which expire after a set amount of downloads or days. Similar to Firefox Send, but without public upload.   [![There was an update last month][G]](https://github.com/Forceu/gokapi)   [![godoc][D]](https://godoc.org/github.com/Forceu/gokapi)
- [GoLand](https://jetbrains.com/go)  Full featured cross-platform Go IDE.
- [vFlow](https://github.com/VerizonDigital/vflow) **star:1074** High-performance, scalable and reliable IPFIX, sFlow and Netflow collector.   [![godoc][D]](https://godoc.org/github.com/VerizonDigital/vflow)
- [Wave Terminal](https://waveterm.dev)  Wave is an open-source, AI-native terminal built for seamless developer workflows with inline rendering, a modern UI, and persistent sessions.
- [peg](https://github.com/pointlander/peg) **star:1000** Peg, Parsing Expression Grammar, is an implementation of a Packrat parser generator.   [![godoc][D]](https://godoc.org/github.com/pointlander/peg)
- [Go Package Store](https://github.com/shurcooL/Go-Package-Store) **star:899** App that displays updates for the Go packages in your GOPATH.   [![godoc][D]](https://godoc.org/github.com/shurcooL/Go-Package-Store)
- [Leaps](https://github.com/jeffail/leaps) **star:748** Pair programming service using Operational Transforms.   [![godoc][D]](https://godoc.org/github.com/jeffail/leaps)
- [gfile](https://github.com/Antonito/gfile) **star:737** Securely transfer files between two computers, without any third party, over WebRTC.   [![godoc][D]](https://godoc.org/github.com/Antonito/gfile)
- [Guora](https://github.com/meloalright/guora) **star:667** A self-hosted Quora like web application written in Go.   [![godoc][D]](https://godoc.org/github.com/meloalright/guora)   [![Contains Chinese documents][CN]](https://github.com/meloalright/guora)
- [sake](https://github.com/alajmo/sake) **star:640** sake is a command runner for local and remote hosts.   [![godoc][D]](https://godoc.org/github.com/alajmo/sake)
- [Gebug](https://github.com/moshebe/gebug) **star:633** A tool that makes debugging of Dockerized Go applications super easy by enabling Debugger and Hot-Reload features, seamlessly.   [![godoc][D]](https://godoc.org/github.com/moshebe/gebug)
- [yai](https://github.com/ekkinox/yai) **star:607** AI powered terminal assistant.   [![godoc][D]](https://godoc.org/github.com/ekkinox/yai)
- [zs](https://git.mills.io/prologic/zs)  an extremely minimal static site generator.
- [gocc](https://github.com/goccmack/gocc) **star:601** Gocc is a compiler kit for Go written in Go.   [![godoc][D]](https://godoc.org/github.com/goccmack/gocc)
- [mockingjay](https://github.com/quii/mockingjay-server) **star:558** Fake HTTP servers and consumer driven contracts from one configuration file. You can also make the server randomly misbehave to help do more realistic performance tests.   [![godoc][D]](https://godoc.org/github.com/quii/mockingjay-server)
- [GoNB](https://github.com/janpfeifer/gonb) **star:492** Interactive Go programming with Jupyter Notebooks (also works in VSCode, Binder and Google's Colab).   [![godoc][D]](https://godoc.org/github.com/janpfeifer/gonb)
- [go-peerflix](https://github.com/Sioro-Neoku/go-peerflix) **star:470** Video streaming torrent client.   [![godoc][D]](https://godoc.org/github.com/Sioro-Neoku/go-peerflix)
- [goblin](https://goblin.reaper.im)  Golang binaries in a curl, built by goblins.
- [woke](https://github.com/get-woke/woke) **star:446** Detect non-inclusive language in your source code.   [![godoc][D]](https://godoc.org/github.com/get-woke/woke)
- [ipe](https://github.com/dimiro1/ipe) **star:366** Open source Pusher server implementation compatible with Pusher client libraries written in GO.   [![It hasn't been updated in recent three years][Y]](https://github.com/dimiro1/ipe)   [![godoc][D]](https://godoc.org/github.com/dimiro1/ipe)   [![Archived][Archived]](https://github.com/dimiro1/ipe)
- [ide](https://github.com/thestrukture/ide) **star:356** Browser accessible IDE. Designed for Go with Go.   [![godoc][D]](https://godoc.org/github.com/thestrukture/ide)
- [tcpprobe](https://github.com/mehrdadrad/tcpprobe) **star:354** TCP tool for network performance and path monitoring, including socket statistics.   [![It hasn't been updated in recent three years][Y]](https://github.com/mehrdadrad/tcpprobe)   [![godoc][D]](https://godoc.org/github.com/mehrdadrad/tcpprobe)
- [hotswap](https://github.com/edwingeng/hotswap) **star:324** A complete solution to reload your go code without restarting your server, interrupting or blocking any ongoing procedure.   [![godoc][D]](https://godoc.org/github.com/edwingeng/hotswap)   [![Contains Chinese documents][CN]](https://github.com/edwingeng/hotswap)
- [hugo](https://gohugo.io/)  Fast and Modern Static Website Engine.
- [wellington](https://github.com/wellington/wellington) **star:303** Sass project management tool, extends the language with sprite functions (like Compass).   [![godoc][D]](https://godoc.org/github.com/wellington/wellington)
- [Cherry](https://github.com/rafael-santiago/cherry) **star:300** Tiny webchat server in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/rafael-santiago/cherry)   [![godoc][D]](https://godoc.org/github.com/rafael-santiago/cherry)
- [Neo-cowsay](https://github.com/Code-Hex/Neo-cowsay) **star:300** 🐮 cowsay is reborn. for a New Era.   [![godoc][D]](https://godoc.org/github.com/Code-Hex/Neo-cowsay)
- [tcpdog](https://github.com/mehrdadrad/tcpdog) **star:253** eBPF based TCP observability.   [![It hasn't been updated in recent three years][Y]](https://github.com/mehrdadrad/tcpdog)   [![godoc][D]](https://godoc.org/github.com/mehrdadrad/tcpdog)
- [crawley](https://github.com/s0rg/crawley) **star:248** Web scraper/crawler for cli.   [![There was an update last month][G]](https://github.com/s0rg/crawley)   [![godoc][D]](https://godoc.org/github.com/s0rg/crawley)
- [joincap](https://github.com/assafmo/joincap) **star:207** Command-line utility for merging multiple pcap files together.   [![godoc][D]](https://godoc.org/github.com/assafmo/joincap)
- [Juju](https://jujucharms.com/)  Cloud-agnostic service deployment and orchestration - supports EC2, Azure, Openstack, MAAS and more.
- [Orbit](https://github.com/gulien/orbit) **star:181** A simple tool for running commands and generating files from templates.   [![It hasn't been updated in recent three years][Y]](https://github.com/gulien/orbit)   [![godoc][D]](https://godoc.org/github.com/gulien/orbit)
- [Better Go Playground](https://goplay.tools)  Go playground with syntax highlight, code completion and other features.
- [vaku](https://github.com/lingrino/vaku) **star:152** CLI & API for folder-based functions in Vault like copy, move, and search.   [![There was an update last month][G]](https://github.com/lingrino/vaku)   [![godoc][D]](https://godoc.org/github.com/lingrino/vaku)
- [stew](https://github.com/marwanhawari/stew) **star:148** An independent package manager for compiled binaries.   [![godoc][D]](https://godoc.org/github.com/marwanhawari/stew)
- [syncthing](https://syncthing.net/)  Open, decentralized file synchronization tool and protocol.
- [fjira](https://github.com/mk-5/fjira) **star:117** A fuzzy-search based terminal UI application for Attlasian Jira   [![godoc][D]](https://godoc.org/github.com/mk-5/fjira)
- [dp](https://github.com/scryinfo/dp) **star:82** Through SDK for data exchange with blockchain, developers can get easy access to DAPP development.   [![godoc][D]](https://godoc.org/github.com/scryinfo/dp)
- [boxed](https://github.com/tejo/boxed) **star:80** Dropbox based blog engine.   [![It hasn't been updated in recent three years][Y]](https://github.com/tejo/boxed)   [![godoc][D]](https://godoc.org/github.com/tejo/boxed)
- [term-quiz](https://github.com/crazcalm/term-quiz) **star:26** Quizzes for your terminal.   [![It hasn't been updated in recent three years][Y]](https://github.com/crazcalm/term-quiz)   [![godoc][D]](https://godoc.org/github.com/crazcalm/term-quiz)
- [naclpipe](https://github.com/unix4fun/naclpipe) **star:23** Simple NaCL EC25519 based crypto pipe tool written in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/unix4fun/naclpipe)   [![godoc][D]](https://godoc.org/github.com/unix4fun/naclpipe)
- [Snitch](https://github.com/lucasgomide/snitch) **star:17** Simple way to notify your team and many tools when someone has deployed any application via Tsuru.   [![It hasn't been updated in recent three years][Y]](https://github.com/lucasgomide/snitch)   [![godoc][D]](https://godoc.org/github.com/lucasgomide/snitch)
- [GoDocTooltip](https://github.com/diankong/GoDocTooltip) **star:13** Chrome extension for Go Doc sites, which shows function description as tooltip at function list.
- [hoofli](https://github.com/dnnrly/hoofli) **star:8** Generate PlantUML diagrams from Chrome or Firefox network inspections.   [![There was an update last month][G]](https://github.com/dnnrly/hoofli)   [![godoc][D]](https://godoc.org/github.com/dnnrly/hoofli)
- [protoncheck](https://github.com/servusdei2018/protoncheck) **star:6** ProtonMail module for waybar/polybar/yabar/i3blocks.   [![godoc][D]](https://godoc.org/github.com/servusdei2018/protoncheck)   [![Archived][Archived]](https://github.com/servusdei2018/protoncheck)

**[⬆ back to top](#contents)**

# Resources

_Where to discover new Go libraries._

**[⬆ back to top](#contents)**

## Benchmarks

- [go-web-framework-benchmark](https://github.com/smallnest/go-web-framework-benchmark) **star:2048** Go web framework benchmark.   [![godoc][D]](https://godoc.org/github.com/smallnest/go-web-framework-benchmark)
- [go-http-routing-benchmark](https://github.com/julienschmidt/go-http-routing-benchmark) **star:1646** Go HTTP request router benchmark and comparison.   [![godoc][D]](https://godoc.org/github.com/julienschmidt/go-http-routing-benchmark)
- [go_serialization_benchmarks](https://github.com/alecthomas/go_serialization_benchmarks) **star:1554** Benchmarks of Go serialization methods.   [![godoc][D]](https://godoc.org/github.com/alecthomas/go_serialization_benchmarks)
- [skynet](https://github.com/atemerev/skynet) **star:1042** Skynet 1M threads microbenchmark.
- [speedtest-resize](https://github.com/fawick/speedtest-resize) **star:237** Compare various Image resize algorithms for the Go language.   [![It hasn't been updated in recent three years][Y]](https://github.com/fawick/speedtest-resize)   [![godoc][D]](https://godoc.org/github.com/fawick/speedtest-resize)
- [go-benchmarks](https://github.com/tylertreat/go-benchmarks) **star:146** Few miscellaneous Go microbenchmarks. Compare some language features to alternative approaches.   [![It hasn't been updated in recent three years][Y]](https://github.com/tylertreat/go-benchmarks)   [![godoc][D]](https://godoc.org/github.com/tylertreat/go-benchmarks)
- [gospeed](https://github.com/feyeleanor/GoSpeed) **star:119** Go micro-benchmarks for calculating the speed of language constructs.   [![godoc][D]](https://godoc.org/github.com/feyeleanor/GoSpeed)
- [autobench](https://github.com/davecheney/autobench) **star:99** Framework to compare the performance between different Go versions.   [![It hasn't been updated in recent three years][Y]](https://github.com/davecheney/autobench)   [![godoc][D]](https://godoc.org/github.com/davecheney/autobench)
- [golang-sql-benchmark](https://github.com/tyler-smith/golang-sql-benchmark) **star:65** Collection of benchmarks for popular Go database/SQL utilities.   [![godoc][D]](https://godoc.org/github.com/tyler-smith/golang-sql-benchmark)
- [gocostmodel](https://github.com/PuerkitoBio/gocostmodel) **star:61** Benchmarks of common basic operations for the Go language.   [![It hasn't been updated in recent three years][Y]](https://github.com/PuerkitoBio/gocostmodel)   [![godoc][D]](https://godoc.org/github.com/PuerkitoBio/gocostmodel)
- [go-ml-benchmarks](https://github.com/nikolaydubina/go-ml-benchmarks) **star:30** benchmarks for machine learning inference in Go.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/go-ml-benchmarks)
- [go-benchmark-app](https://github.com/mrLSD/go-benchmark-app) **star:27** Powerful HTTP-benchmark tool mixed with Аb, Wrk, Siege tools. Gathering statistics and various parameters for benchmarks and comparison results.   [![It hasn't been updated in recent three years][Y]](https://github.com/mrLSD/go-benchmark-app)   [![godoc][D]](https://godoc.org/github.com/mrLSD/go-benchmark-app)
- [kvbench](https://github.com/jimrobinson/kvbench) **star:26** Key/Value database benchmark.   [![It hasn't been updated in recent three years][Y]](https://github.com/jimrobinson/kvbench)   [![godoc][D]](https://godoc.org/github.com/jimrobinson/kvbench)
- [go-json-benchmark](https://github.com/zerosnake0/go-json-benchmark) **star:9** Go JSON benchmark.   [![It hasn't been updated in recent three years][Y]](https://github.com/zerosnake0/go-json-benchmark)   [![godoc][D]](https://godoc.org/github.com/zerosnake0/go-json-benchmark)

**[⬆ back to top](#contents)**

## Conferences

- [GoCon](https://gocon.connpass.com/)  Tokyo, Japan.
- [GoDays](https://www.godays.io/)  Berlin, Germany.
- [GoLab](https://golab.io/)  Florence, Italy.
- [GopherChina](https://gopherchina.org)  Shanghai, China.
- [GopherCon](https://www.gophercon.com/)  Denver, USA.
- [GopherCon Australia](https://gophercon.com.au/)  Sydney, Australia.
- [GopherCon Brazil](https://gopherconbr.org)  Florianópolis, Brazil.
- [GopherCon Europe](https://gophercon.eu/)  Berlin, Germany.
- [GopherCon India](https://gopherconindia.org/)  Pune, India.
- [GopherCon Israel](https://www.gophercon.org.il/)  Tel Aviv, Israel.
- [GopherCon Russia](https://www.gophercon-russia.ru)  Moscow, Russia.
- [GopherCon Singapore](https://gophercon.sg)  Mapletree Business City, Singapore.
- [GopherCon UK](https://www.gophercon.co.uk/)  London, UK.
- [GopherCon Vietnam](https://gophercon.vn/)  Ho Chi Minh City, Vietnam.
- [GoWest Conference](https://www.gowestconf.com/)  Lehi, USA.

**[⬆ back to top](#contents)**

## E-Books

### E-books for purchase

- [100 Go Mistakes: How to Avoid Them](https://www.manning.com/books/100-go-mistakes-how-to-avoid-them)
- [Black Hat Go](https://nostarch.com/blackhatgo)  Go programming for hackers and pentesters.
- [Build an Orchestrator in Go](https://www.manning.com/books/build-an-orchestrator-in-go)
- [Continuous Delivery in Go](https://www.manning.com/books/continuous-delivery-in-go)  This practical guide to continuous delivery shows you how to rapidly establish an automated pipeline that will improve your testing, code quality, and final product.
- [Creative DIY Microcontroller Project With TinyGo and WebAssembly](https://www.packtpub.com/product/creative-diy-microcontroller-projects-with-tinygo-and-webassembly/9781800560208)  An introduction into the TinyGo compiler with projects involving Arduino and WebAssembly.
- [Effective Go: Elegant, efficient, and testable code](https://www.manning.com/books/effective-go)  Unlock Go’s unique perspective on program design, and start writing simple, maintainable, and testable Go code.
- [For the Love of Go](https://bitfieldconsulting.com/books/love)  An introductory book for Go beginners.
- [Go in Practice, Second Edition](https://www.manning.com/books/go-in-practice-second-edition)  - Your practical guide on the ins-and-outs of Go development, covering the standard library and the most important tools from Go’s powerful ecosystem.
- [Know Go: Generics](https://bitfieldconsulting.com/books/generics)  A guide to understanding and using generics in Go.
- [Lets-Go](https://lets-go.alexedwards.net)  A step-by-step guide to creating fast, secure and maintanable web applications with Go.
- [Lets-Go-Further](https://lets-go-further.alexedwards.net)  Advanced patterns for building APIs and web applications in Go.
- [The Power of Go: Tests](https://bitfieldconsulting.com/books/tests)  A guide to testing in Go.
- [The Power of Go: Tools](https://bitfieldconsulting.com/books/tools)  A guide to writing command-line tools in Go.
- [Writing A Compiler In Go](https://compilerbook.com)
- [Writing An Interpreter In Go](https://interpreterbook.com)  Book that introduces dozens of techniques for writing idiomatic, expressive, and efficient Go code that avoids common pitfalls.

### Free e-books

- [A Go Developer's Notebook](https://leanpub.com/GoNotebook/read)
- [An Introduction to Programming in Go](http://www.golang-book.com/)
- [Build Web Application with Golang](https://astaxie.gitbooks.io/build-web-application-with-golang/content/en/)
- [Building Web Apps With Go](https://codegangsta.gitbooks.io/building-web-apps-with-go/content/)
- [GoBooks](https://github.com/dariubs/GoBooks) **star:16545** A curated list of Go books.   [![There was an update last month][G]](https://github.com/dariubs/GoBooks)
- [How To Code in Go eBook](https://www.digitalocean.com/community/books/how-to-code-in-go-ebook)  A 600 page introduction to Go aimed at first time developers.
- [Go AST Book (Chinese)](https://github.com/chai2010/go-ast-book) **star:5304** A book focusing on Go `go/*` packages.   [![There was an update last month][G]](https://github.com/chai2010/go-ast-book)   [![godoc][D]](https://godoc.org/github.com/chai2010/go-ast-book)
- [Go Faster](https://leanpub.com/gofaster)  This book seeks to shorten your learning curve and help you become a proficient Go programmer, faster.
- [Go 101](https://go101.org)  A book focusing on Go syntax/semantics and all kinds of details.
- [Go Succinctly](https://github.com/thedevsir/gosuccinctly) **star:22** in Persian.   [![It hasn't been updated in recent three years][Y]](https://github.com/thedevsir/gosuccinctly)   [![godoc][D]](https://godoc.org/github.com/thedevsir/gosuccinctly)
- [Go with the domain](https://threedots.tech/go-with-the-domain/)  A book showing how to apply DDD, Clean Architecture, and CQRS by practical refactoring.
- [Learning Go](https://www.miek.nl/downloads/Go/Learning-Go-latest.pdf)
- [Network Programming With Go](https://jan.newmarch.name/golang/)
- [Practical Go Lessons](https://www.practical-go-lessons.com/)
- [Spaceship Go A Journey to the Standard Library](https://blasrodri.github.io/spaceship-go-gh-pages/)
- [The Go Programming Language](https://www.gopl.io/)
- [The Golang Standard Library by Example (Chinese)](https://github.com/polaris1119/The-Golang-Standard-Library-by-Example)
- [Web Application with Go the Anti-Textbook](https://github.com/thewhitetulip/web-dev-golang-anti-textbook/)

**[⬆ back to top](#contents)**

## Gophers

- [Free Gophers Pack](https://github.com/MariaLetta/free-gophers-pack) **star:3358** Gopher graphics pack by Maria Letta with illustrations and emotional characters in vector and raster.   [![godoc][D]](https://godoc.org/github.com/MariaLetta/free-gophers-pack)
- [gopher-logos](https://github.com/GolangUA/gopher-logos) **star:124** adorable gopher logos.   [![It hasn't been updated in recent three years][Y]](https://github.com/GolangUA/gopher-logos)
- [Go-gopher-Vector](https://github.com/keygx/Go-gopher-Vector) **star:69** Go gopher Vector Data [.ai, .svg].   [![It hasn't been updated in recent three years][Y]](https://github.com/keygx/Go-gopher-Vector)
- [gopher-stickers](https://github.com/tenntenn/gopher-stickers)
- [gophericons](https://github.com/shalakhin/gophericons)
- [gophers](https://github.com/egonelbre/gophers) **star:3422** Free gophers.   [![godoc][D]](https://godoc.org/github.com/egonelbre/gophers)
- [gophers](https://github.com/ashleymcnamara/gophers) **star:2931** Gopher artworks by Ashley McNamara.   [![It hasn't been updated in recent three years][Y]](https://github.com/ashleymcnamara/gophers)   [![godoc][D]](https://godoc.org/github.com/ashleymcnamara/gophers)
- [gopherize.me](https://github.com/matryer/gopherize.me) **star:696** Gopherize yourself.   [![It hasn't been updated in recent three years][Y]](https://github.com/matryer/gopherize.me)
- [gophers](https://github.com/sillecelik/go-gopher) **star:142** Gopher amigurumi toy pattern.
- [gophers](https://github.com/rogeralsing/gophers) **star:58** random gopher graphics.   [![It hasn't been updated in recent three years][Y]](https://github.com/rogeralsing/gophers)
- [gophers](https://github.com/scraly/gophers) **star:32** Gophers by Aurélie Vache.

**[⬆ back to top](#contents)**

## Meetups

- [Basel Go Meetup](https://www.meetup.com/Basel-Go-Meetup/)
- [Belfast Gophers](https://www.meetup.com/Belfast-Gophers/)
- [Belgrade Golang Meetup](https://www.meetup.com/golang-serbia/)
- [Berlin Golang](https://www.meetup.com/golang-users-berlin/)
- [Brisbane Gophers](https://www.meetup.com/Brisbane-Golang-Meetup/)
- [Bärner Go Meetup - Berne, Switzerland](https://www.meetup.com/berner-go-meetup/)
- [Canberra Gophers](https://www.meetup.com/Canberra-Gophers/)
- [Go Language NYC](https://www.meetup.com/golanguagenewyork/)
- [Go London User Group](https://www.meetup.com/Go-London-User-Group/)
- [Go Remote Meetup](https://www.meetup.com/Go-Remote-Meetup/)
- [Go Toronto](https://www.meetup.com/go-toronto/)
- [Go User Group Atlanta](https://www.meetup.com/Go-Users-Group-Atlanta/)
- [GoBandung](https://www.meetup.com/GoBandung/)
- [GoBridge, San Francisco, CA](https://www.meetup.com/gobridge/)
- [GoCracow - Krakow, Poland](https://www.meetup.com/GoCracow/)
- [GoJakarta](https://www.meetup.com/GoJakarta/)
- [Golang Amsterdam](https://www.meetup.com/golang-amsterdam/)
- [Golang Argentina](https://www.meetup.com/Golang-Argentina/)
- [Golang Athens](https://www.meetup.com/Athens-Gophers/)
- [Golang Baltimore, MD](https://www.meetup.com/BaltimoreGolang/)
- [Golang Bangalore](https://www.meetup.com/Golang-Bangalore/)
- [Golang Belo Horizonte - Brazil](https://www.meetup.com/go-belo-horizonte/)
- [Golang Boston](https://www.meetup.com/bostongo/)
- [Golang Bulgaria](https://www.meetup.com/Golang-Bulgaria/)
- [Golang Cardiff, UK](https://www.meetup.com/Cardiff-Go-Meetup/)
- [Golang Copenhagen](https://www.meetup.com/Go-Cph/)
- [Golang Curitiba - Brazil](https://www.meetup.com/GolangCWB/)
- [Golang DC, Arlington, VA](https://www.meetup.com/Golang-DC/)
- [Golang Dorset, UK](https://www.meetup.com/golang-dorset/)
- [Golang Estonia](https://www.meetup.com/Golang-Estonia/)
- [Golang Gurgaon, India](https://www.meetup.com/Gurgaon-Go-Meetup/)
- [Golang Hamburg - Germany](https://www.meetup.com/Go-User-Group-Hamburg/)
- [Golang Israel](https://www.meetup.com/Go-Israel/)
- [Golang Kathmandu](https://www.meetup.com/Golang-Kathmandu/)
- [Golang Korea](https://www.meetup.com/GDG-Golang-Korea/)
- [Golang Lima - Peru](https://www.meetup.com/Golang-Peru/)
- [Golang Lyon](https://www.meetup.com/Golang-Lyon/)
- [Golang Marseille](https://www.meetup.com/fr-FR/Golang-Marseille/)
- [Golang Melbourne](https://www.meetup.com/golang-mel/)
- [Golang North East](https://www.meetup.com/en-AU/Golang-North-East/)
- [Golang Paris](https://www.meetup.com/Golang-Paris/)
- [Golang Poland](https://www.meetup.com/Golang-Poland/)
- [Golang Pune](https://www.meetup.com/Golang-Pune/)
- [Golang Rotterdam](https://www.meetup.com/golang-rotterdam/)
- [Golang Singapore](https://www.meetup.com/golangsg/)
- [Golang Stockholm](https://www.meetup.com/Go-Stockholm/)
- [Golang Sydney, AU](https://www.meetup.com/golang-syd/)
- [Golang São Paulo - Brazil](https://www.meetup.com/golangbr/)
- [Golang Taipei](https://www.meetup.com/golang-taipei-meetup/)
- [Golang Thessaloniki](https://www.meetup.com/thessaloniki-golang-meetup/)
- [Golang Turkey](https://kommunity.com/goturkiye)
- [Golang Vancouver, BC](https://www.meetup.com/golangvan/)
- [Golang Vienna, Austria](https://www.meetup.com/viennago/)
- [Golang Москва](https://www.meetup.com/Golang-Moscow/)
- [GoSF - San Francisco, CA](https://www.meetup.com/golangsf)
- [Istanbul Golang](https://www.meetup.com/Istanbul-Golang/)
- [Lagos Gophers](https://www.meetup.com/GolangNigeria/)
- [Seattle Go Programmers](https://www.meetup.com/golang/)
- [Ukrainian Golang User Groups](https://www.meetup.com/uagolang/)
- [Utah Go User Group](https://www.meetup.com/utahgophers/)
- [Women Who Go - San Francisco, CA](https://www.meetup.com/Women-Who-Go/)
- [Zürich Gophers - Zurich, Switzerland](https://www.meetup.com/zurich-gophers/)

_Add the group of your city/country here (send **PR**)_

**[⬆ back to top](#contents)**

## Style Guides

- [bahlo/go-styleguide](https://github.com/bahlo/go-styleguide)
- [CockroachDB](https://github.com/cockroachdb/cockroach/blob/master/docs/style.md)
- [GitLab](https://docs.gitlab.com/ee/development/go_guide/)
- [Google](https://google.github.io/styleguide/go/)
- [Hyperledger](https://github.com/hyperledger/fabric/blob/release-1.4/docs/source/style-guides/go-style.rst)
- [Magnetico](https://github.com/boramalper/magnetico/wiki/magnetico-Design-Specification)
- [Sourcegraph](https://docs.sourcegraph.com/dev/background-information/languages/go)
- [Thanos](https://thanos.io/tip/contributing/coding-style-guide.md/)
- [Trybe](https://github.com/betrybe/playbook-go/blob/main/README_EN.md)
- [Uber](https://github.com/uber-go/guide/blob/master/style.md)

**[⬆ back to top](#contents)**

## Social Media

### Twitter

- [@GoDiscussions](https://twitter.com/GoDiscussions)
- [@golang](https://twitter.com/golang)
- [@golang_news](https://twitter.com/golang_news)
- [@golangch](https://twitter.com/golangch)
- [@golangflow](https://twitter.com/golangflow)
- [@golangweekly](https://twitter.com/golangweekly)

**[⬆ back to top](#contents)**

### Reddit

- [r/golang](https://www.reddit.com/r/golang/)

**[⬆ back to top](#contents)**

## Websites

- [awesome-awesomeness](https://github.com/bayandin/awesome-awesomeness) **star:31539** List of other amazingly awesome lists.
- [Awesome Remote Job](https://github.com/lukasz-madon/awesome-remote-job) **star:28871** Curated list of awesome remote jobs. A lot of them are looking for Go hackers.
- [Awesome Golang Workshops](https://github.com/amit-davidson/awesome-golang-workshops) **star:502** A curated list of awesome golang workshops.   [![It hasn't been updated in recent three years][Y]](https://github.com/amit-davidson/awesome-golang-workshops)
- [golang-graphics](https://github.com/mholt/golang-graphics) **star:139** Collection of Go images, graphics, and art.   [![It hasn't been updated in recent three years][Y]](https://github.com/mholt/golang-graphics)   [![Archived][Archived]](https://github.com/mholt/golang-graphics)
- [golang-nuts](https://groups.google.com/forum/#!forum/golang-nuts)  Go mailing list.
- [Google Plus Community](https://plus.google.com/communities/114112804251407510571)  The Google+ community for #golang enthusiasts.
- [Gopher Community Chat](https://invite.slack.golangbridge.org)  Join Our New Slack Community For Gophers ([Understand how it came](https://blog.gopheracademy.com/gophers-slack-community/)).
- [Gophercises](https://gophercises.com/)  Free coding exercises for budding gophers.
- [json2go](https://m-zajac.github.io/json2go)  Advanced JSON to Go struct conversion - online tool.
- [justforfunc](https://www.youtube.com/c/justforfunc)  Youtube channel dedicated to Go programming language tips and tricks, hosted by Francesc Campoy [@francesc](https://twitter.com/francesc).
- [Learn Go Programming](https://blog.learngoprogramming.com)  Learn Go concepts with illustrations.
- [gocryforhelp](https://github.com/ninedraft/gocryforhelp) **star:41** Collection of Go projects that needs help. Good place to start your open-source way in Go.   [![It hasn't been updated in recent three years][Y]](https://github.com/ninedraft/gocryforhelp)
- [Golang Developer Jobs](https://golangjob.xyz)  Developer Jobs exclusively for Golang related Roles.
- [Golang Flow](https://golangflow.io)  Post Updates, News, Packages and more.
- [Golang News](https://golangnews.com)  Links and news about Go programming.
- [Golang Resources](https://golangresources.com)  A curation of the best articles, exercises, talks and videos to learn Go.
- [Golang Weekly](https://discu.eu/weekly/golang/)  Each monday projects, tutorials and articles about Go.
- [Awesome Go @LibHunt](https://go.libhunt.com)  Your go-to Go Toolbox.
- [awesome-go-extra](https://github.com/xwjdsh/awesome-go-extra) **star:22** Parse awesome-go README file and generate a new README file with repo info.   [![godoc][D]](https://godoc.org/github.com/xwjdsh/awesome-go-extra)   [![Contains Chinese documents][CN]](https://github.com/xwjdsh/awesome-go-extra)
- [Code with Mukesh](https://codewithmukesh.com/blog/category/golang)  Software Engineer and Blogs @ codewithmukesh.com.
- [Coding Mystery](https://codingmystery.com)  Solve exciting escape-room-inspired programming challenges using Go.
- [CodinGame](https://www.codingame.com/)  Learn Go by solving interactive tasks using small games as practical examples.
- [Explore Go Libraries & Projects](https://kandi.openweaver.com/explore/go)  Discover & find a curated list of popular & new Go libraries, top authors, trending project kits, discussions, tutorials & learning resources on kandi.
- [Go Blog](https://blog.golang.org)  The official Go blog.
- [Go Code Club](https://www.youtube.com/watch?v=nvoIPQYdx9g&list=PLEcwzBXTPUE_YQR7R0BRtHBYJ0LN3Y0i3)  A group of Gophers read and discuss a different Go project every week.
- [Go Community on Hashnode](https://hashnode.com/n/go)  Community of Gophers on Hashnode.
- [Go Forum](https://forum.golangbridge.org)  Forum to discuss Go.
- [Go Projects](https://github.com/golang/go/wiki/Projects)  List of projects on the Go community wiki.
- [Go Proverbs](https://go-proverbs.github.io/)  Go Proverbs by Rob Pike.
- [Go Report Card](https://goreportcard.com)  A report card for your Go package.
- [go.dev](https://go.dev/)  A hub for Go developers.
- [Made with Golang](https://madewithgolang.com/?ref=awesome-go)
- [pkg.go.dev](https://pkg.go.dev/)  Documentation for open source Go packages.
- [r/Golang](https://www.reddit.com/r/golang)  News about Go.
- [studygolang](https://studygolang.com)  The community of studygolang in China.
- [Trending Go repositories on GitHub today](https://github.com/trending?l=go)  Good place to find new Go libraries.
- [TutorialEdge - Golang](https://tutorialedge.net/course/golang/)

**[⬆ back to top](#contents)**

### Tutorials

- [Build web application with Golang](https://github.com/astaxie/build-web-application-with-golang) **star:43154** Golang ebook intro how to build a web app with golang.   [![godoc][D]](https://godoc.org/github.com/astaxie/build-web-application-with-golang)   [![Contains Chinese documents][CN]](https://github.com/astaxie/build-web-application-with-golang)
- [Building and Testing a REST API in Go with Gorilla Mux and PostgreSQL](https://semaphoreci.com/community/tutorials/building-and-testing-a-rest-api-in-go-with-gorilla-mux-and-postgresql)  We’ll write an API with the help of the powerful Gorilla Mux.
- [Building Go Web Applications and Microservices Using Gin](https://semaphoreci.com/community/tutorials/building-go-web-applications-and-microservices-using-gin)  Get familiar with Gin and find out how it can help you reduce boilerplate code and build a request handling pipeline.
- [Caching Slow Database Queries](https://medium.com/@rocketlaunchr.cloud/caching-slow-database-queries-1085d308a0c9)  How to cache slow database queries.
- [Canceling MySQL](https://medium.com/@rocketlaunchr.cloud/canceling-mysql-in-go-827ed8f83b30)  How to cancel MySQL queries.
- [CodeCrafters Golang Track](https://app.codecrafters.io/tracks/go)  Achieve mastery in advanced Go by building your own Redis, Docker, Git, and SQLite. Featuring goroutines, systems programming, file I/O, and more.
- [Go Cheat Sheet](https://github.com/a8m/go-lang-cheat-sheet) **star:8205** Go's reference card.
- [Go database/sql tutorial](http://go-database-sql.org/)  Introduction to database/sql.
- [Ethereum Development with Go](https://github.com/miguelmota/ethereum-development-with-go-book) **star:1724** A little e-book on Ethereum Development with Go.   [![godoc][D]](https://godoc.org/github.com/miguelmota/ethereum-development-with-go-book)   [![Contains Chinese documents][CN]](https://github.com/miguelmota/ethereum-development-with-go-book)   [![Archived][Archived]](https://github.com/miguelmota/ethereum-development-with-go-book)
- [Games With Go](https://www.youtube.com/watch?v=9D4yH7e_ea8&list=PLDZujg-VgQlZUy1iCqBbe5faZLMkA3g2x)  A video series teaching programming and game development.
- [Go By Example](https://gobyexample.com/)  Hands-on introduction to Go using annotated example programs.
- [50 Shades of Go](https://devs.cloudimmunity.com/gotchas-and-common-mistakes-in-go-golang/)  Traps, Gotchas, and Common Mistakes for New Golang Devs.
- [A Comprehensive Guide to Structured Logging in Go](https://betterstack.com/community/guides/logging/logging-in-go/)  Delve deep into the world of structured logging in Go with a specific focus on recently accepted slog proposal which aims to bring high performance structured logging with levels to the standard library.
- [A Guide to Golang E-Commerce](https://snipcart.com/blog/golang-ecommerce-ponzu-cms-demo?utm_term=golang-ecommerce-ponzu-cms-demo)  Building a Golang site for e-commerce (demo included).
- [A Tour of Go](https://tour.golang.org/)  Interactive tour of Go.
- [Build a Database in 1000 lines of code]( https://link.medium.com/O9YQlx89Htb)  Build a NoSQL Database From Zero in 1000 Lines of Code.
- [Go in 7 days](https://github.com/harrytran103/7_days_of_go) **star:137** Learn everything about Go in 7 days (from a Nodejs developer).   [![It hasn't been updated in recent three years][Y]](https://github.com/harrytran103/7_days_of_go)   [![godoc][D]](https://godoc.org/github.com/harrytran103/7_days_of_go)
- [Go Language Tutorial](https://www.javatpoint.com/go-tutorial)  Learn Go language Tutorial.
- [Go Tutorial](https://www.tutorialspoint.com/go/index.htm)  Learn Go programming.
- [Design Patterns in Go](https://github.com/shubhamzanwar/design-patterns) **star:115** Collection of programming design patterns implemented in Go.   [![godoc][D]](https://godoc.org/github.com/shubhamzanwar/design-patterns)
- [Debugged.it Go patterns](https://github.com/haveyoudebuggedit/go-patterns) **star:12** Advanced Go patterns with ready-to-run examples.   [![It hasn't been updated in recent three years][Y]](https://github.com/haveyoudebuggedit/go-patterns)   [![godoc][D]](https://godoc.org/github.com/haveyoudebuggedit/go-patterns)   [![Archived][Archived]](https://github.com/haveyoudebuggedit/go-patterns)
- [Go WebAssembly Tutorial - Building a Simple Calculator](https://tutorialedge.net/golang/go-webassembly-tutorial/)
- [go-patterns](https://github.com/tmrts/go-patterns) **star:24788** Curated list of Go design patterns, recipes and idioms.   [![godoc][D]](https://godoc.org/github.com/tmrts/go-patterns)
- [Learn Go with TDD](https://github.com/quii/learn-go-with-tests) **star:21840** Learn Go with test-driven development.   [![There was an update last month][G]](https://github.com/quii/learn-go-with-tests)   [![godoc][D]](https://godoc.org/github.com/quii/learn-go-with-tests)   [![Contains Chinese documents][CN]](https://github.com/quii/learn-go-with-tests)
- [Learning Go by examples](https://dev.to/aurelievache/learning-go-by-examples-introduction-448n)  Series of articles in order to learn Golang language by concrete applications as example.
- [Microservices with Go](https://www.youtube.com/playlist?list=PLmD8u-IFdreyh6EUfevBcbiuCKzFk0EW_)  Dive deep into building microservices using Go, including gRPC.
- [package main](https://www.youtube.com/packagemain)  YouTube channel about Programming in Go.
- [Programming with Google Go](https://www.coursera.org/specializations/google-golang)  Coursera Specialization to learn about Go from scratch.
- [Saving a Third of Our Memory by Re-ordering Go Struct Fields](https://qvault.io/golang/struct-field-ordering-memory/)  How inefficient field ordering in Go structs.
- [Scaling Go Applications](https://betterstack.com/community/guides/scaling-go/)  Everything about building, deploying and scaling Go applications in production.
- [Learn Go with 1000+ Exercises](https://github.com/inancgumus/learngo) **star:18682** Learn Go with thousands of examples, exercises, and quizzes.   [![godoc][D]](https://godoc.org/github.com/inancgumus/learngo)
- [go-clean-template](https://github.com/evrone/go-clean-template) **star:6167** Clean Architecture template for Golang services.   [![There was an update last month][G]](https://github.com/evrone/go-clean-template)   [![godoc][D]](https://godoc.org/github.com/evrone/go-clean-template)
- [Golang for Node.js Developers](https://github.com/miguelmota/golang-for-nodejs-developers) **star:4571** Examples of Golang compared to Node.js for learning.   [![godoc][D]](https://godoc.org/github.com/miguelmota/golang-for-nodejs-developers)
- [Golang Tutorial Guide](https://www.freecodecamp.org/news/golang-tutorial-list-free-courses-learn-go-programming-language/)  A List of Free Courses to Learn the Go Programming Language.
- [Golangbot](https://golangbot.com/learn-golang-series/)  Tutorials to get started with programming in Go.
- [GopherCoding](https://gophercoding.com/)  Collection of code snippets and tutorials to help tackle every day issues.
- [GopherSnippets](https://gophersnippets.com/)  Code snippets with tests and testable examples for the Go programming language.
- [Gosamples](https://gosamples.dev/)  Collection of code snippets that let you solve everyday code problems.
- [Hackr.io](https://hackr.io/tutorials/learn-golang)  Learn Go from the best online golang tutorials submitted & voted by the golang programming community.
- [goapp](https://github.com/bnkamalesh/goapp) **star:813** An opinionated guideline to structure & develop a Go web application/service.   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/goapp)
- [Hex Monscape](https://github.com/Haraj-backend/hex-monscape) **star:64** Getting started guidelines in writing maintainable code using Hexagonal Architecture.   [![godoc][D]](https://godoc.org/github.com/Haraj-backend/hex-monscape)
- [How to Benchmark: dbq vs sqlx vs GORM](https://medium.com/@rocketlaunchr.cloud/how-to-benchmark-dbq-vs-sqlx-vs-gorm-e814caacecb5)  Learn how to benchmark in Go. As a case-study, we will benchmark dbq, sqlx and GORM.
- [How To Deploy a Go Web Application with Docker](https://semaphoreci.com/community/tutorials/how-to-deploy-a-go-web-application-with-docker)  Learn how to use Docker for Go development and how to build production Docker images.
- [How to Use Godog for Behavior-driven Development in Go](https://semaphoreci.com/community/tutorials/how-to-use-godog-for-behavior-driven-development-in-go)  Get started with Godog — a Behavior-driven development framework for building and testing Go applications.
- [The world’s easiest introduction to WebAssembly with Golang](https://medium.com/@martinolsansky/webassembly-with-golang-is-fun-b243c0e34f02)
- [Understanding Go in a visual way](https://dev.to/aurelievache/series/26234)  Learn Go visually
- [W3basic Go Tutorials](https://www.w3basic.com/golang/)  W3Basic provides an in-depth tutorial and well-organized content to learn Golang programming.
- [Working with Go](https://github.com/mkaz/working-with-go) **star:1153** Intro to go for experienced programmers.   [![It hasn't been updated in recent three years][Y]](https://github.com/mkaz/working-with-go)   [![Archived][Archived]](https://github.com/mkaz/working-with-go)
- [Your basic Go](https://yourbasic.org/golang)  Huge collection of tutorials and how to's.

**[⬆ back to top](#contents)**

### Guided Learning

- [The Go Developer Roadmap](https://roadmap.sh/golang)  A visual roadmap that new Go developers can follow through to help them learn Go.
- [The Go Learning Path](https://tutorialedge.net/paths/golang/)  A guided learning path containing a mix of free and premium resources.

**[⬆ back to top](#contents)**

